function [result_tag]=queryLabel(qnames , gvalue_names )
% {}=queryLabel(names,gvalue/names)

if nargin < 1
    
    
    
    error('queryLabel(qnames , gvalue )');
end

if isa(gvalue_names,'struct')
    allNames = gvalue_names.names; 
else
    allNames=gvalue_names;
end

result_tag={};

if isa(qnames,'cell')
    
    for i=1:numel(qnames)
        obj_tag = qnames(i);
        
        res = cellfun(@(tag) strcmp(obj_tag,tag) , allNames); 
        rid=find( res );
        
        if isempty(rid)
            fprintf('WARNING: unmatched label:%s \n' , obj_tag{:} );
            rid=-1;
        end
        
        result_tag{end+1}=rid;
    end
    result_tag=cell2mat(result_tag);
    
elseif isa(qnames,'char')
    
    res = cellfun(@(tag) strcmp(qnames,tag) , allNames);
    result_tag{end+1}=find( res );    
    result_tag=cell2mat(result_tag);    
    
elseif isnumeric(qnames);
    
    result_tag={};
    for i=1:numel(qnames)
        obj_id = qnames(i); 
        if obj_id >0
            result_tag{end+1}=allNames{obj_id};        
        else
            result_tag{end+1}='undef.';    
        end
    end 
    
    if numel(result_tag)==1
        result_tag=result_tag{:};
    end
        
end

end