function [ minRad ] = boxAngle( box1 ,box2 )
% [ cosrad ] = vecAngle( v1 ,v2 )
%
if nargin < 2
    error('invalid');
end
 
% 4x3
b1_dir=boxEDirVec(box1);
b2_dir=boxEDirVec(box2);

% due to no regular box
% we re-expanding data

b1_dir=cat(1,b1_dir,-b1_dir);
b2_dir=cat(1,b2_dir,-b2_dir);


% Nx3 * 3xN = NxN
alldot = b1_dir*b2_dir' ;

allrad = acos(abs(alldot));


minRad = min(min(allrad));

end


function [alle]=boxEDirVec(box)
% 4x3

b1_e1 = box(1,:)-box(2,:);
b1_e2 = box(2,:)-box(3,:);
b1_e3 = box(3,:)-box(4,:);
b1_e4 = box(4,:)-box(1,:);

% remove Y
b1_e1(2)=0;
b1_e2(2)=0;
b1_e3(2)=0;
b1_e4(2)=0;

b1_e1=b1_e1./norm(b1_e1);
b1_e2=b1_e2./norm(b1_e2);
b1_e3=b1_e3./norm(b1_e3);
b1_e4=b1_e4./norm(b1_e4);

alle = cat(1,b1_e1,b1_e2,b1_e3,b1_e4);

end

function [rad]=vecAbsAngle(v1,v2)

assert(numel(v1)==3 && numel(v2)==3);

v1=v1./norm(v1,2);
v2=v2./norm(v2,2);

cosrad = dot(v1,v2);

rad=acos(abs(cosrad));

end