%
%
%
% test rel script 
% 

sa_tool.load_dataset


% load a output data (ZIP\output_data\)
pathstr='..\..\output_data\us1\annores_label\img_1030.mymat';

scelog=sa_tool.load_mymat(pathstr);


%%  visualize

sa_tool.supdef
sa_tool.def_cppbox
 
scelog=sa_tool.load_mymat(pathstr);

img = gValue.matobj.images(:,:,:,scelog.sce_id);

wall_arror_color = [0.7,0.4,1];
boxsup_arror_color = 'c';

drawArrow=@(ss,ee,cc)arrow(ss,ee,'Length',15,'edgecolor',cc,'linewidth',2);

f2d=figure;
imshow(img);

% DRAW each boxes
for ib=1:numel(scelog.box_gtUID)

    uid = scelog.box_gtUID(ib);
    our_box_w= scelog.box3d_world{ib};

    sa_tool.drawBox3dOnImg(our_box_w,f2d,'LW',1.5 ,'color',[0,0.8,0]);

end % for each box in the scene


scelog.our_b2d={};

% initial 2d box
for ib=1:numel(scelog.box_gtUID)

    % our
    uid = scelog.box_gtUID(ib);
    our_box_w= scelog.box3d_world{ib};
    
    scelog.our_b2d{ib}=sa_tool.drawBox3dOnImg(our_box_w);
    
end % for each box in the scene

bcenter=zeros( numel(scelog.box_gtUID) ,2);

% calculate center for each boxes
for ib=1:numel(scelog.box_gtUID)
    % our
    uid = scelog.box_gtUID(ib);

    %if gt_eff_flag(ib)
    our_box_2d= scelog.our_b2d{ib};
    bcenter(ib,:) = int32(floor(mean(our_box_2d))); 
end % for each box in the scene

% support arrow
for ib=1:numel(scelog.box_gtUID)

    if scelog.box_supType(ib) == cppdef.BOX
        % draw with parent
        pidx = scelog.sup_parent_idx(ib) + 1;
        ss = bcenter(pidx,:);
        ee = bcenter(ib,:);
        cc = boxsup_arror_color;
        drawArrow(ss,ee,cc);

    elseif scelog.box_supType(ib) == cppdef.FLOOR
        % draw with floor
        %plot(bcenter(ib,1),bcenter(ib,2),'+','color',[0,0,0],'markersize',12,'linewidth',2);
        ss=bcenter(ib,:)+[0,110];
        ee=bcenter(ib,:);
        drawArrow(ss,ee,'y');

    elseif scelog.box_supType(ib) == cppdef.WALL
        % draw with wall
        iw_idx=scelog.allwall_idx(ib);
        %plot(bcenter(ib,1),bcenter(ib,2),'+','color',[0,0,0],'markersize',12,'linewidth',2);
        ss=bcenter(ib,:)+[50,0];
        ee=bcenter(ib,:);
        drawArrow(ss,ee,wall_arror_color);

    elseif scelog.box_supType(ib) == cppdef.FLOAT
       
    end
end

% label
for ib=1:numel(scelog.box_gtUID)
    
    lid=scelog.box_lid(ib);
    
    lname = gValue.names{lid};
    sx=numel('xxx')/2;
    
    textborder(bcenter(ib,1)-sx,bcenter(ib,2),lname,0.9*[1,1,1],[0,0,0],...
        'FontWeight','bold','fontsize',15);
end


%% visualize gt box 


gtBoxData=load(sa_tool.path_def().gt_mat);
 
f2d=2;
f3d=3;

for i=1%1:numel(gtBoxData.boxData)
    
    ydx = gtBoxData.boxData{i}.layout.floor{1}.plane ;
    ydx = +ydx(4)./ydx(2);
    
    figure(f2d);
    imshow(gValue.matobj.images(:,:,:,gtBoxData.boxData{i}.sid));

    figure(f3d);clf
    for k=1:numel( gtBoxData.boxData{i}.allobj )
        
        if gtBoxData.boxData{i}.isGoodObjFlag(k)    
            
            b3d=gtBoxData.boxData{i}.allobj{k}.box3d_fr;
            b3d(:,2)=b3d(:,2)+ydx;
            figure(f3d);
            if  gtBoxData.boxData{i}.allobj{k}.isInlier
                
                if gtBoxData.boxData{i}.supType(k) == SUP_BY_FLOOR
                    sa_tool.showBBox3D(b3d,'swapYZ',true ,'lineColor','g');  hold on;
                elseif gtBoxData.boxData{i}.supType(k) == SUP_BY_WALL
                    sa_tool.showBBox3D(b3d,'swapYZ',true ,'lineColor','c');  hold on;
                elseif gtBoxData.boxData{i}.supType(k) == SUP_BY_OBJ  
                    sa_tool.showBBox3D(b3d,'swapYZ',true ,'lineColor','b');  hold on;
                elseif gtBoxData.boxData{i}.supType(k) == SUP_BY_OBJ 
                    sa_tool.showBBox3D(b3d,'swapYZ',true ,'lineColor',[0.5,0,1]);  hold on;
                else
                    sa_tool.showBBox3D(b3d,'swapYZ',true ,'lineColor',[1,0.1,1]);  hold on;
                end
            else
                sa_tool.showBBox3D(b3d,'swapYZ',true ,'lineColor','black');  hold on;
            end
            figure(f2d);
            hold on;
            
            sa_tool.draw2dBBox(gtBoxData.boxData{i}.allobj{k}.box2d);
        end
    end
    
    figure(f3d);
    view(-151,40);
    axis equal

    xx=input('any');
end 

      


