function []=draw2dBBox( re_bbox2d ,  varargin )
% draw 2d bbox on the figure
% (re_bbox2d ,  re_bbox2d , {  color , drawOrder , LW , figureHandle } )');
if nargin <1
    error( 'invalid  :  re_bbox2d , {  color , drawOrder , LW , figureHandle } )');
end  

    p = inputParser;
    p.CaseSensitive=true;
    
    addRequired( p , 're_bbox2d' , @(x)size(x,2)==2 );
    addParamValue( p, 'figureHandle' , get( 0 , 'CurrentFigure')  , @(x)x>=0 );
    %addParamValue( p, 'colorGroup' , 15 , @(x)isnumeric(x) && x <=9 && x>=1);     
    addParamValue( p, 'color' , [0,1,0] , @(x)isnumeric(x) && numel(x)==3 );     
    addParamValue( p, 'LW', 1  );    

    % length should be a even 
    addParamValue( p, 'drawOrder', sa_tool.getDrawOrder() , @(x) mod(length(x),2) == 0 );    
    
    parse( p, re_bbox2d,  varargin{:} );
    
    figureHandle = p.Results.figureHandle ;
    LW = p.Results.LW ;
    color =p.Results.color ;
    drawOrder = p.Results.drawOrder ;
    
    clear p;
    
%---------END of varargin parsing------------------
    
% setup color 
 
far_color = color;
link_color = color;
near_color = color; 

% draw bbox 

preHandle = get( 0 , 'CurrentFigure' );
set(0,'CurrentFigure',figureHandle );

hold on;
r_x_b2d = re_bbox2d( : , 1);
r_y_b2d = re_bbox2d( : , 2);

% draw vertex of bbox
%plot( r_x_b2d , r_y_b2d , '+', 'Color' , 'black' );

% draw line of bbox
for i=1:length(drawOrder)/2
    k=(i-1)*2+1;
    %fprintf( '%d   %d \n' , k, k+1 );
    if( i < 5 ) % top faces
        plot(r_x_b2d(drawOrder(k:k+1 )) , r_y_b2d(drawOrder( k:k+1)) , 'Color' , near_color , 'LineWidth' , LW );
    elseif ( i < 9 ) % vertical
        plot(r_x_b2d(drawOrder(k:k+1 )) , r_y_b2d(drawOrder( k:k+1)) , 'Color' , link_color  , 'LineWidth' , LW );
    else % bot faces
        plot(r_x_b2d(drawOrder(k:k+1 )) , r_y_b2d(drawOrder( k:k+1)) , 'Color' ,  far_color  , 'LineWidth' , LW );
    end
end


set(0,'CurrentFigure',preHandle );

end