%
% calculate the approximate error
% 
function [res ]=eval_boxquality_adp_inn( our_scelog, gtsce , gtsce_idList , selectLids ,quiteMode)

if nargin < 4
    error('invalid');
elseif nargin == 4
    quiteMode=0;
end


sa_tool.load_dataset

%%

[ mData_sceid, mDataFPath , mGeo_gtsceid , mGeolist ] = sa_tool.get_gt_path_def( );

%%

% gt def
sa_tool.supdef

sa_tool.def_cppbox

%%
all_box_sce_id=[];
our_box_lid=[];
gt_box_lid=[];

all_our_box_vol=[];
all_gt_box_vol=[];

all_centx=[];
all_centx_vec=[];

all_comp_centx_norm=[];

all_diff_boxRad=[];
comp_our_gt_vol=[];

all_our_edges=[];
all_gt_edges=[];

verbase = 0;

for k=1:numel(our_scelog) 

    imid = our_scelog{k}.sce_id;
    
    % find correspond gt 
    gidx=find(gtsce_idList==imid,1);
     
    if isempty(gidx) 
       cprintf('cyan','**CANNOT LOAD GT MAT at sce.[%d]  ',imid );  
       continue;
    end
    
    fr_ydx = gtsce{gidx}.layout.floor{1}.plane ;
    fr_ydx = +fr_ydx(4)./fr_ydx(2);
    
    %mGTBox = load(fullfile(mGTRoot,mGeolist{mGeo_gtsceid==imid})); 
    %Rmat = mGTBox.model.camera.R;
    
    Rmat = gtsce{gidx}.camera_R;
    txMat = Rmat'*diag([1,1,-1]);
    
    % this should equal = |Box| , if all box are good
    supEdgeNum=0;

    floor_num=0;
    wall_num=0; 
    obj_num=0;  
    gt_ourEType_num=0;
    our_float_num=0;

    floor_hit_num=0;
    wall_hit_num=0;
    obj_hit_num=0; 
    
    if verbase
        figure;
        axis equal;
    end    
    
    %% for each boxes in this scene
    for ib=1:numel(our_scelog{k}.box_gtUID)
        
        uid = our_scelog{k}.box_gtUID(ib); 
        
        % use fr box and comparing with gt box
        gt_ib=find(uid==gtsce{gidx}.box_uid,1); 
        
        if ~isempty(gt_ib) && gtsce{gidx}.allobj{gt_ib}.isgood
            % check quality 
            
            %---------------------------------------------------------------
            % box - vol & diagonal length 
            
            
            % our
            our_box_aabb= our_scelog{k}.box3d_aabb{ib};
            %our_box_fr2= our_scelog{k}.box3d_fr{ib};
            our_box_w= our_scelog{k}.box3d_world{ib};             
            
            our_box_fr2 = sa_tool.cenTx(txMat,our_box_w,[0,0,0]);
            our_box_fr2(:,2) = our_box_fr2(:,2) + fr_ydx;
            
            our_h = max(our_box_fr2(:,2))-min(our_box_fr2(:,2));
            our_vol = prod(max(our_box_aabb)-min(our_box_aabb));
            our_cen = mean(our_box_fr2);
            
            % gt box -- NOTE to add fr_ydx
            gt_box_fr = gtsce{gidx}.allobj{gt_ib}.box3d_fr;
            gt_box_fr(:,2) = gt_box_fr(:,2) + fr_ydx;

            gt_box_h = max(gt_box_fr(:,2))-min(gt_box_fr(:,2));
            gt_box_e1 = (gt_box_fr(1,:)-gt_box_fr(2,:));
            gt_box_e2 = (gt_box_fr(2,:)-gt_box_fr(3,:));
           
            gt_box_vol = gt_box_h*norm(gt_box_e1)*norm(gt_box_e2);            
            gt_cen = mean(gt_box_fr); 
                                   
            % center TX 
            cen_Dx = our_cen - gt_cen;
            
            % theta
            box_rad = sa_tool.boxAngle(our_box_fr2,gt_box_fr);
            
            %---------------------------------------------------
            % align vertex index of 2 boxes
            
            our_gt1_idx=0;
            our_gt2_idx=0;
            our_gt3_idx=0;
            
            min_gt1_vdist=inf;
            min_gt2_vdist=inf;
            min_gt3_vdist=inf;
            
            for iv=1:8
                
                v1dist = norm( gt_box_fr(1,:) - our_box_fr2(iv,:) );
                v2dist = norm( gt_box_fr(2,:) - our_box_fr2(iv,:) );
                v3dist = norm( gt_box_fr(3,:) - our_box_fr2(iv,:) );
                
                if v1dist < min_gt1_vdist
                    min_gt1_vdist = v1dist;
                    our_gt1_idx = iv;
                end
                if v2dist < min_gt2_vdist
                    min_gt2_vdist = v2dist;
                    our_gt2_idx = iv;
                end
                if v3dist < min_gt3_vdist
                    min_gt3_vdist = v3dist;
                    our_gt3_idx = iv;
                end
                
            end
            
            
            % -> our_h , gt_box_h
            gt_e12 = norm( gt_box_fr(1,:) - gt_box_fr(2,:) );
            gt_e23 = norm( gt_box_fr(2,:) - gt_box_fr(3,:) );
            
            our_e12 = norm( our_box_fr2(our_gt1_idx,:) - our_box_fr2(our_gt2_idx,:) );
            our_e23 = norm( our_box_fr2(our_gt2_idx,:) - our_box_fr2(our_gt3_idx,:) );
            
            %---------------------------------------------------
            % [SAVE]
            all_box_sce_id(end+1)=imid;
            
            our_box_lid(end+1)=our_scelog{k}.box_lid(ib);
            gt_box_lid(end+1)=gtsce{gidx}.box_lid(gt_ib);
                        
            all_our_box_vol(end+1)=our_vol;
            all_gt_box_vol(end+1)=gt_box_vol; 
            comp_our_gt_vol(end+1) = our_vol./gt_box_vol;
            
            all_centx = cat(1,all_centx,cen_Dx);
            
            all_comp_centx_norm(end+1)=norm(cen_Dx);
            
            all_diff_boxRad(end+1)=box_rad;
            
            %------
            
            all_gt_edges  = cat(1,all_gt_edges ,[gt_e12  ,gt_e23  ,gt_box_h] );
            all_our_edges = cat(1,all_our_edges,[our_e12 ,our_e23 ,our_h   ] );
            
            
            %--------------------------------------------------
            if verbase
                sa_tool.showBBox3D(gt_box_fr); hold on;
                sa_tool.showBBox3D(our_box_fr2,'lineColor',[0,1,0]);hold on;
            end
            
        else            
            % cprintf('cyan','**gt box not found --sce.[%d] box.[%d] uid.[%d]\n',imid,ib,uid);
        end
        
        
    end % for each box in the scene 
     
    %---------------------------------------------------
    
    if verbase
        figure(4);
        clf;
        imshow(gValue.matobj.images(:,:,:,imid));
    end
    
    %fprintf('pass - sce.[%d] \n',imid );
end

%% adptive ratio


res = struct;
res.gt_edges = all_gt_edges;
res.our_edges = all_our_edges;
res.box_imid = all_box_sce_id;
res.gtbox_lid = gt_box_lid;
res.ourbox_lid = our_box_lid;
res.boxRadDiff = all_diff_boxRad;

%%
% final number
 
if ~quiteMode
    
fprintf('---------------------------\n');

eflag=  ~isinf(comp_our_gt_vol);

fprintf('mean vol: [%.3f] m^3\n',mean(comp_our_gt_vol(eflag)) );
var(comp_our_gt_vol(eflag));

fprintf('mean deg: [%.3f] deg\n' , sa_tool.rad2deg( mean(all_diff_boxRad(eflag) ) ) );
var(all_diff_boxRad(eflag) );

fprintf('mean ctx: %s meter\n' , mat2str( mean(all_centx(eflag,:) ) , 3) );
var(all_centx(eflag) );


fprintf('mean ctx: [%.3f] meter\n' ,  mean(all_comp_centx_norm(eflag))  );
var( all_comp_centx_norm(eflag) );

fprintf('---------------------------\n\n');


end

%% print

if 0
    % [selectLids,majorlids]=my_module.data_tool.get_eff_lidv520();

    lnames=nyutool.queryLabel(selectLids,gValue);

    for k=1:numel(selectLids)

        lid=selectLids(k);
        lname = lnames{k};

        plid_flag = (lid==gt_box_lid);
        eflag= plid_flag & ~isinf(comp_our_gt_vol);

        m_vol = mean(comp_our_gt_vol(eflag));
        m_deg = rad2deg( mean(comp_boxTheta(eflag) ) );
        m_ctx = mat2str( mean(all_centx(eflag,:) ) , 3);

        m_norm = mean( all_comp_centx_norm(eflag) );


        var_vol = var(comp_our_gt_vol(eflag));
        var_deg = rad2deg( var(comp_boxTheta(eflag) ) );
        var_ctx = mat2str( var(all_centx(eflag,:) ) , 3);

        var_norm = var( all_comp_centx_norm(eflag) );

        fprintf('%15s (x%3d) - vol:[%4.2f] m^3 (var:[%6.2f] m^3) , deg:[%5.1f] deg (var:[%5.1f] deg) ,translate:[%5.4f]m (var:[%5.4f]m) , translate: %s (var:%s)\n',...
                 lname , nnz(eflag) , ...
                 m_vol,var_vol, ...
                 m_deg,var_deg, ...
                 m_norm,var_norm, ...
                 m_ctx,var_ctx ...        
             );
    end
end



end




