function [ info_struct ]=eval_structure_inn( ...
    our_scelog, gtsce , gtsce_idList ,...
    selectLids , ...
    out_fname , classMode , ...
    verbase )

% []=eval_gtbox_inn_text( our_scelog, gtsce , gtsce_idList , sup2d_idList , selectLids , out_fname , supMode )

if nargin < 6
    error('invalid');
elseif nargin == 6
    verbase=false;
end


%%

sa_tool.load_dataset

%%

[ mData_sceid, mDataFPath , mGeo_gtsceid , mGeolist ] = sa_tool.get_gt_path_def( );

%%

% gt def
sa_tool.supdef

sa_tool.def_cppbox

%%
all_box_sce_id=[];

our_box_lid=[];
gt_box_lid=[];

%---------------------------
all_gt_supType=[];
all_our_supType=[];

all_hit_log=[];

all_gt_lid=[];
all_our_lid=[];
support_log={};


% parsing state (our & gt )
for k=1:numel(our_scelog)
    
    imid = our_scelog{k}.sce_id;
    
    % find correspond gt
    gidx=find(gtsce_idList==imid,1);
    
    % find corresponding 2d
    % s2d_idx = find(sup2d_idList==imid,1);    
    % assert(~isempty(s2d_idx),'s2d_idx not found in sup2d_idList');
    
    if isempty(gidx)
        cprintf('cyan','**CANNOT LOAD GT MAT at sce.[%d]\n',imid );
        continue;
    end
      
    % -- use gdef
    gt_sup_type=[];
    our_sup_type=[];

    obj_gtlid=[];
    obj_ourlid=[];
    
    hit_log=[];
    
    %% for each boxes in this scene
    for ib=1:numel(our_scelog{k}.box_gtUID)
        
        uid = our_scelog{k}.box_gtUID(ib);
        
        % use fr box and comparing with gt box
        gt_ib=find(uid==gtsce{gidx}.box_uid,1);
        
        % s2d_ib = find( all_2dsup{s2d_idx}.all_uid == uid , 1 );        
        
        % assert( ~isempty(s2d_ib) , '~isempty(s2d_ib)' );
        
        if ~isempty(gt_ib) && gtsce{gidx}.allobj{gt_ib}.isgood % && ~isempty(s2d_ib) 
                                   
            %---------------------------------------------------
            % support EVAL
            our_byBox   = our_scelog{k}.box_supType(ib) == cppdef.BOX   ;
            our_byFloor = our_scelog{k}.box_supType(ib) == cppdef.FLOOR ;
            our_byWall  = our_scelog{k}.box_supType(ib) == cppdef.WALL  ;
            our_float   = our_scelog{k}.box_supType(ib) == cppdef.FLOAT ;
            
            our_p_idx = our_scelog{k}.sup_parent_idx(ib);
            
            if our_p_idx ~= -1 && our_byBox
                % matlab index start from 1
                our_parent_uid = our_scelog{k}.box_gtUID( our_p_idx + 1 );
            else
                our_parent_uid = -1;
            end
            
            gs_byBox   = gtsce{gidx}.supType(gt_ib) == gdef.SUP_BY_OBJ   ;
            gs_byFloor = gtsce{gidx}.supType(gt_ib) == gdef.SUP_BY_FLOOR ;
            gs_byWall  = gtsce{gidx}.supType(gt_ib) == gdef.SUP_BY_WALL  ;
            
            gs_parent_uid =  gtsce{gidx}.parent_UID(gt_ib);
            
            % gt sup is exist 
            eff_sup_data = gs_byBox || gs_byFloor || gs_byWall ;
            
            if(eff_sup_data) 
                
                obj_ourlid(end+1)=our_scelog{k}.box_lid(ib);
                obj_gtlid(end+1)=gtsce{gidx}.box_lid(gt_ib);
                
                % log support type
                % use gdef
                gt_sup_type(end+1)=gtsce{gidx}.supType(gt_ib) ;
                
                if our_byBox
                    our_sup_type(end+1)= gdef.SUP_BY_OBJ ; 
                elseif our_byFloor
                    our_sup_type(end+1)= gdef.SUP_BY_FLOOR ;
                elseif our_byWall
                    our_sup_type(end+1)= gdef.SUP_BY_WALL ;
                elseif our_float
                    our_sup_type(end+1)= gdef.SUP_UNKNOWN;
                else
                    error('unexp');
                end                   
                
                
                % check support hit                
                if our_byBox && gs_byBox
                    % check parent uid
                    
                    if gs_parent_uid == our_parent_uid
                        % succ
                        hit_log(end+1) = 1;
                    else
                        hit_log(end+1) = 0;
                    end
                    
                elseif our_byFloor && gs_byFloor
                    hit_log(end+1) = 1;
                    
                elseif our_byWall && gs_byWall
                    hit_log(end+1) = 1;
                    
                else
                    % fail
                    hit_log(end+1) = 0;

                end
                
                
            else%-----------
                %   skip this one
                if verbase
                    fprintf('[sup eval] - skip this one\n');
                end
            end
             
        else
            if verbase
                cprintf('cyan','**gt box not found --sce.[%d]   uid.[%d]\n',imid, uid);
            end
        end
        
        
    end % for each box in the scene
    
    %% 
    %---------------------------------------------------
    % [SAVE SUPPORT EVAL] 
    all_gt_lid=cat(1,all_gt_lid,obj_gtlid(:));
    all_our_lid=cat(1,all_our_lid,obj_ourlid(:));
    
    all_gt_supType=cat(1,all_gt_supType   , gt_sup_type(:));
    all_our_supType=cat(1,all_our_supType , our_sup_type(:));
    
    
    all_hit_log = cat(1, all_hit_log , hit_log(:) );
    
    
    support_log{end+1}=struct;
    
    support_log{end}.obj_ourlid=obj_ourlid;
    support_log{end}.obj_gtlid=obj_gtlid;
    
    support_log{end}.gt_sup_type=gt_sup_type;
    support_log{end}.our_sup_type=our_sup_type;
    
    support_log{end}.hit_log = hit_log;
    
    %if mod(k,100)==0
    %    fprintf('pass - sce.[%d] (%d/%d)\n',imid ,k,numel(our_scelog));
    %end
    
end


%% prepare statics

if out_fname ~= 1
    fout = fopen(out_fname,'w');
else
    fout = 1;
end


our_hit_num = nnz( all_hit_log );
our_hit_ratio = our_hit_num / numel(all_hit_log);

fprintf(fout,'our hit #=%d / %d , ratio=%f \n' , our_hit_num , numel(all_hit_log) , our_hit_ratio );
  
info_struct = struct;
info_struct.our_hit_ratio=our_hit_ratio;
info_struct.all_our_supType = all_our_supType;

our_allnum = numel(info_struct.all_our_supType );
fl_num = nnz(info_struct.all_our_supType == gdef.SUP_UNKNOWN );

fprintf(fout,'our total # = %d \n' , our_allnum );
fprintf(fout,'our floating # = %d \n' , fl_num );
fprintf(fout,'our hit  # = %d \n' , our_hit_num );

fprintf(fout,'GT total # = %d \n' , numel(all_gt_supType) );

p = our_hit_num / numel(all_gt_supType) ;
r = our_hit_num / (our_allnum-fl_num) ; 
f1 = 200*p*r/(p+r);

fprintf(fout,'\nP = %f  \n' , p );
fprintf(fout,'R = %f \n' , r );
fprintf(fout,'F (200pr/p+r) = %f \n' , f1  );

%% class based

if classMode

    lname = nyutool.queryLabel(selectLids,gValue);
    
    all_our_hit_num = [];
    all_our_hit_ratio = []; 
    
    all_box_num=[];
    
    for i=1:numel(selectLids)

        lid = selectLids(i);
        % use all_gt_lid
        eflag = all_gt_lid==lid;
        
        
        our_hit_num = nnz( all_hit_log(eflag) );
        our_hit_ratio = our_hit_num / numel(all_hit_log(eflag));
         
        
        all_our_hit_num(i) = our_hit_num;
        all_our_hit_ratio(i) = our_hit_ratio;
        
        all_box_num(i) = numel(all_gt_supType(eflag));
        
        fprintf(fout,'%15s- :\t',lname{i});
        fprintf(fout,'our hit #=%3d /%d , ratio=[%.3f]  , \n' , our_hit_num ,all_box_num(i), our_hit_ratio );
        %fprintf(fout,' 2d based hit #=%3d /%d , ratio=[%.3f] \n' , s2d_hit_num ,all_box_num(i), s2d_hit_ratio );
    end
    
info_struct.class=struct;
info_struct.class.all_our_hit_num=all_our_hit_num;
info_struct.class.all_our_hit_ratio=all_our_hit_ratio;

info_struct.class.all_box_num=all_box_num;



info_struct.class.lname=lname;

end

if fout~=1
    fclose(fout);
end

end