function [ sce_stru ] = load_mymat( dpath )
% [ struct ] = load_mymat( dpath )


if nargin < 1
    error('invalid');
end

if ~exist(dpath,'file');
    error('file not exist');
    
end
 
len_type='int32';
flname_type='char';
data_type='float64';
fin=fopen(dpath,'rb');
 
NUM_FIELDS=fread(fin,1,len_type);

% ini output struct
sce_stru=struct;

sce_stru.datapath = dpath;

for i=1:NUM_FIELDS
   
    % read field name
	f_len=fread(fin,1,len_type);
    fl_name=fread(fin,f_len,flname_type);
    fl_name=char(fl_name(:)');
    
    % read data
    rsize=fread(fin,1,len_type);
    csize=fread(fin,1,len_type);
    
    data=fread(fin,rsize*csize,data_type);
    
    data_2d = reshape(data,rsize,csize);
    
    % set 
    sce_stru=setfield(sce_stru,fl_name,data_2d);
end

fclose(fin);

% final

%fprintf('parsing done :\n');
%disp(sce_stru);

%------------------------------------------------------
% post-processing

sce_stru.box3d_fr={};
sce_stru.box3d_world={};
sce_stru.box3d_aabb={};

for i=1:size(sce_stru.all_b3d_fr,1)
    
    abox=sce_stru.all_b3d_fr(i,:);
    abox=reshape(abox,3,8);
    sce_stru.box3d_fr{i}=abox';

    
    abox=sce_stru.all_b3d_world(i,:);
    abox=reshape(abox,3,8);
    sce_stru.box3d_world{i}=abox';
    
    
    abox=sce_stru.all_b3d_aabb(i,:);
    abox=reshape(abox,3,8);
    sce_stru.box3d_aabb{i}=abox';

end



end

