function []=showBBox3D(bboxPts3D ,  varargin )%drawOrder)
% (bbox3d ,{ "lineColor" , "drawOrder" , "swapYZ=true" })' );

if nargin < 1
    error('invalid: (bbox3d ,{ "lineColor" , "drawOrder" })' );
end

    p = inputParser;
    p.CaseSensitive=true;
    
    addRequired( p , 'bboxPts3D' , @(x)size(x,2)==3 );
    addParamValue( p, 'lineColor', 'blue' );    
    addParamValue( p, 'drawOrder', sa_tool.getDrawOrder() );    
    addParamValue( p, 'LW', 1.5 );    
    addParamValue( p, 'swapYZ', true );    
    
    parse(p, bboxPts3D,  varargin{:} );
    
    lineColor =p.Results.lineColor;
    drawOrder = p.Results.drawOrder;
    swapYZ = p.Results.swapYZ;
    LW = p.Results.LW;
    clear p;
    
%---------END of varargin parsing--------------------------
    

%----------------------------------------------------------

if swapYZ,
    %fprintf('**showBBox3D this drawing will swap z and y axis to allow better control \n');
end

% test plot in 3d 
hold on;
%plot3( bboxPts3D(:,1) , bboxPts3D(:,3) , bboxPts3D(:,2) );
assert( mod(length(drawOrder),2)==0 );

for i=1:length(drawOrder)/2
    k=(i-1)*2+1;

    if swapYZ
        plot3( bboxPts3D(drawOrder(k:k+1 ),1) , bboxPts3D(drawOrder( k:k+1),3) , ...
            bboxPts3D(drawOrder(k:k+1),2) , 'Color' , lineColor ,'LineWidth' , LW );
    else
        plot3( bboxPts3D(drawOrder(k:k+1 ),1) , bboxPts3D(drawOrder( k:k+1),2) , ...
            bboxPts3D(drawOrder(k:k+1),3) , 'Color' , lineColor ,'LineWidth' , LW );
    end
end

hold off;

end