#pragma once

#include <fstream>
#include <iostream>
#include <vector>
 
#include "boxdatav2.h"
#include "geoobj.h"

struct STypes 
{
public:

	static const int BOX=1; 
	static const int SCENE=2; 
	static const int FLOOR_INI=3; 
	static const int FLOOR_FR=4; 
	static const int WALLS_FR=5; 
	static const int END=99; 

};

void saveSceneANDBoxes( const char* FNAME , NaiveSceneCTX * SCTX , PlaneData const & FL_INI ,PlaneData const & FL_FR , std::vector<PlaneData> const & WALLS , std::vector<BoxDataV2> const & ALLBOXES );

void loadSceneANDBoxes( const char* FNAME , NaiveSceneCTX & sctx , PlaneData & floor_ini , PlaneData & floor_fr, std::vector<PlaneData> & walls, std::vector<BoxDataV2> & allboxes , bool reportMode=false );

void copyMatrix_CLM( Eigen::MatrixXf mat , float * pmat , const int PMAT_SIZE);

void copyVector_CLM( Eigen::VectorXf vec , float * pmat , const int PMAT_SIZE);

void conv_NBox_to_BoxDataV2(NaiveBox const & NBOX , BoxDataV2 & boxv );

void convNPlane2PlaneData(NaivePlane const & NPL , PlaneData & pldata );

void convPlData2NPL( PlaneData const & PLDATA , NaivePlane & NPL );

void convCLM2EMat( float * pmat , Eigen::MatrixXf & mat , const int ROW_SIZE, const int COL_SIZE );


NaiveBox * conv_BoxDataV2_to_NBox(std::vector<BoxDataV2> const & ALLBOXES);


NaiveAnnoBox * conv_BoxDataV2_to_AnooBox(std::vector<BoxDataV2> const & ALLBOXES);

//void saveAnnoToBin( const std::string & FNAME , NaiveSceneCTX * SCTX , PlaneData const & FL_INI , PlaneData const & FL_FR , std::vector<PlaneData> const & WALLS , std::vector<BoxDataV2> const & ALLBOXES );


//void loadAnnoBinData( const char* FNAME , NaiveSceneCTX & sctx , PlaneData & floor_ini , PlaneData & floor_fr, std::vector<PlaneData> & walls, std::vector<NaiveAnnoBox> & allboxes , bool reportMode/*=false */);


//-------------------------------------------------------------------------



void writeMatrix(std::fstream & fout,const char* field_name, double * mat , const int RSIZE , const int CSIZE );

void export_sce2matlab(std::string const&FNAME , std::vector<NaiveAnnoBox> & boxList , std::vector<PlaneData> allwall,AnnoRes & annoRes );

