#pragma once
 

#include "boxdatav2.h"
#include "common_tool.h" 

#include <pcl/io/pcd_io.h>
#include <Eigen/Eigen> 

#include "geo_typedef.h"
#include <boost/geometry/geometries/linestring.hpp>


void proj_world2img( Eigen::MatrixXf const & BOX3D_W , 
			   Eigen::MatrixXf const & TX_WORLD2IMG44 , 
			   Eigen::MatrixXf & out_box2dimg  );

Eigen::Vector3f proj_fr2img( Eigen::Vector3f const & P3 , Eigen::MatrixXf const & TX_WORLD2IMG44 , Eigen::MatrixXf const & TX_FR2WORLD );

Eigen::Vector3f proj_world2img( Eigen::Vector3f const & P3 , Eigen::MatrixXf const & TX_WORLD2IMG44 );

double screenSpaceCuted( BGPolygon const & out_box2dimg , const int SWIDTH , const int SHEIGHT , const int TX, const int TY);


inline
double boxAbsArea(BGPolygon const & POLY){

	return abs(bg::area(POLY));
}

bool isBoxIntersected(BoxDataV2 const & BOX_U ,BoxDataV2 const & BOX_V);

float uIsSupportV(BoxDataV2 const & BOX_U , BoxDataV2 const & BOX_V );

bool uIsSupportV_v2(BoxDataV2 const & BOX_U , BoxDataV2 const & BOX_V ,double & belif);

bool boost_a_containBy_b( BGPolygon & a , BGPolygon & b);

void box_3D_distance( BoxDataV2 const & BOX_U , BoxDataV2 const & BOX_V , double & xz_dist , double & xz_overAreaRatio , double & y_dist , int & good_y );

void box_3D_distance_resolve_wall_obj( BoxDataV2 const & BOX_U , BoxDataV2 const & BOX_V , bool & useObjLabel );


void printALLBoxGeometryInfo(BoxDataV2 const & BOX );

Eigen::Vector3f constrDepthSensorV3(Eigen::VectorXf const & PLANE, int mx , int my , Eigen::MatrixXf const & oglMVP, int panelWidth , int panelHeight);

float box_fr_y_distance( BoxDataV2 const & BOX_U , BoxDataV2 const & BOX_V );

