#include "data_collecter.h"


void saveAnno2File(const std::string & FPATH , AnnoRes & anno)
{
	// create and open a character archive for output
	std::fstream fout(FPATH,std::fstream::out |std::fstream::binary );

	boost::archive::binary_oarchive oa(fout);

	oa << anno;

	fout.close();

}

void loadAnnoFile(const std::string & FPATH, AnnoRes & anno)
{ 
	// create and open a character archive for output
	std::fstream fin(FPATH,std::fstream::in |std::fstream::binary );

	boost::archive::binary_iarchive ia(fin);

	ia >> anno;

	fin.close(); 
}

void collectAnnoData( std::string ppath,std::string logSavPath )
{
	//std::string ppath = "K:/Paper_project/memorability_UCL/MY_CODE/vs12/gui_v3/testData/user_study/trial_naive_v00/annoresult/";
	std::vector<std::string> flist=getFileList(ppath.c_str(),"*.anno");

	std::cout<<"collect :"<<flist.size()<<" files\n";

	AnnoRes anno;

	int verbase=0;

	double sum_edit = 0;
	double sum_locked = 0;
	double sum_switch = 0;
	double sum_confALL = 0;

	double sum_switch_top2 = 0;
	double sum_switch_top3 = 0;
	double sum_switch_other = 0;

	double total_top3hit=0;
	double total_boxes = 0;

	double timeSum=0;

	std::vector<std::pair<int,int>> all_lid_x_hitnum;
	std::vector<int> all_inilid;

	// for each scene
	for( int i=0 ; i < flist.size() ; i++ ){

		std::string fpath = ppath+'/'+flist[i];

		loadAnnoFile(fpath,anno);

		//std::cout<<"SCE - "<<anno.sce_id<<'\n';

		{ // precision
			// initial prediction result
			auto const & INI_PR = anno.action_log[0].predRes;
			// last prediction result
			auto const & FINAL_PR =anno.action_log.back().predRes;
			int hit=0;
			for( int ib=0 ;ib< INI_PR.size() ; ib++){
				if( INI_PR[ib]==FINAL_PR[ib] ){
					hit=hit+1;
				}
			}
			if(verbase){
				std::cout<<"hit:"<<hit<<"/"<<INI_PR.size()<<"\n";
			}
		}

		{ // select rank
			anno.action_log.back().userSelectMenuIdx;

			//printSTD(anno.action_log.back().userSelectMenuIdx,"userSelect rank (start from 0)");

		}
		{ // time
			timeSum+=anno.total_time; 
		}
		{
			// check last state snapshot of each scene

			// access menu log

			auto const & LastLog = anno.action_log.back();

			//auto const & FirstState = anno.action_log.front().boxState;
			auto const & LastState = anno.action_log.back().boxState;

			auto const & iniPredLid = anno.action_log.front().predRes;
			auto const & LastLIDRes = anno.action_log.back().predRes;

			auto const & SelRank = anno.action_log.back().userSelectMenuIdx;
			

			// sel rank start from 0 ?

			int num_edit=0;
			int num_locked=0;
			int num_switch=0;
			int num_confAll=0;

			int num_switch_top2 = 0;
			int num_switch_top3 = 0;
			int num_switch_other = 0;

			// for each box
			for( int ib=0 ; ib < LastState.size() ; ib++ ){

				int box_sel_rank=-1;

				int box_finalLid=LastLIDRes[ib];

				int box_iniLid=iniPredLid[ib];

				// count state
				if( LastState[ib] == BoxStateLog::BSTATE_EDITED ){
					num_edit=num_edit+1;

					box_sel_rank=-1;

				}else if( LastState[ib] == BoxStateLog::BSTATE_LOCKED  ){
					num_locked=num_locked+1;

					num_switch_top2=num_switch_top2+1;
					num_switch_top3=num_switch_top3+1;

					box_sel_rank=0;

				}else if( LastState[ib] == BoxStateLog::BSTATE_SWITCHED  ){
					num_switch=num_switch+1;
					// 0,1,2
					if( 1 >= SelRank[ib] ){
						num_switch_top3=num_switch_top3+1;
						num_switch_top2=num_switch_top2+1;
					}else if(2 >= SelRank[ib] ){
						num_switch_top3=num_switch_top3+1;
					}else{
						num_switch_other=num_switch_other+1;
					}

					box_sel_rank=SelRank[ib];


				}else if( LastState[ib] == BoxStateLog::BSTATE_CONF_ALL  ){
					num_confAll=num_confAll+1;

					num_switch_top2=num_switch_top2+1;
					num_switch_top3=num_switch_top3+1;

					box_sel_rank=0;

				}else if( LastState[ib] == BoxStateLog::BSTATE_UNK  ){
					throw "invalid log - found BASTEA_UNK ";
				}else{
					throw "invalid log - ? ";
				}

				// count selection index
				if(  LastState[ib] == BoxStateLog::BSTATE_SWITCHED  ){

					if( LastLog.userSelectMenuIdx[ib] != -1 &&
						LastLog.userSelectMenuIdx[ib] < 3){
							total_top3hit=total_top3hit+1;
					} 
				}

				// log all lid_x_selrank
				all_lid_x_hitnum.push_back(std::pair<int,int>(box_finalLid,box_sel_rank));

				all_inilid.push_back(box_iniLid);

			}// each box

			//std::cout<<"num_edit="<<num_edit
			//	<<"\n num_locked="<<num_locked
			//	<<"\n num_switch="<<num_switch<<std::endl;

			sum_switch = sum_switch + num_switch;
			sum_locked = sum_locked + num_locked;
			sum_edit = sum_edit + num_edit;
			sum_confALL = sum_confALL + num_confAll;

			sum_switch_top2 = sum_switch_top2 +num_switch_top2;
			sum_switch_top3 = sum_switch_top3 +num_switch_top3;
			sum_switch_other= sum_switch_other+num_switch_other;

			total_boxes = total_boxes + LastState.size();

		} 

		//std::cout<<"------------\n";

	}// loop scene

	//-------------------------------------------------------------------------
	
	// save out
	std::fstream fout(logSavPath+"/log.txt",std::ios::out);

	if( fout ){
		for( int i=0 ; i < all_lid_x_hitnum.size() ;i++ ){

			fout<<all_lid_x_hitnum[i].first<<" "<<all_lid_x_hitnum[i].second << " " << all_inilid[i]<<std::endl;
		}

		fout.close();
		std::cout<<"save log file at :["<<logSavPath<<"]\n";

	}else{
		std::cout<<"ERR log file open failed\n"<<"at :["<<logSavPath<<"]\n";
	 
	}


	//-------------------------------------------------------------------------
	
	// include confALL & lock
	double top3_hit_ratio = 1.0*sum_switch_top3/total_boxes;
	double top2_hit_ratio = 1.0*sum_switch_top2/total_boxes;

	double top_hit_ratio = 1.0*(sum_locked+sum_confALL)/total_boxes; 
	double not_top3_ratio = 1.0*(sum_switch_other+sum_edit)/total_boxes; 
	double switch_otherRatio = 1.0*(sum_switch_other)/total_boxes; 
	double editedRatio = 1.0*(sum_edit)/total_boxes; 
	double confALLRatio = sum_confALL/total_boxes;

	std::cout<<"path:"<<ppath.c_str()<<"\n"
		<<"scelog # :"<<flist.size() <<"\n\n";

	std::cout
		<<"NUM:\n"
		<<"switch:"<<"\t ["<<sum_switch<<"/"<<total_boxes<<"]\n"
		<<"locked:"<<"\t ["<<sum_locked<<"/"<<total_boxes<<"]\n"
		<<"confirm ALL:"<<"\t ["<<sum_confALL<<"/"<<total_boxes<<"]\n"
		<<"top3_hit:"<<"\t ["<<sum_switch_top3<<"/"<<total_boxes<<"]\n"
		<<"not_top3_ratio:"<<"\t ["<<sum_switch_other+sum_edit<<"/"<<total_boxes<<"]\n"
		<<"edited:"<<"\t ["<<sum_edit<<"/"<<total_boxes<<"]\n\n";

	std::cout<<"RESULT:\n"
		<<"top_hit:\t"<<std::setprecision(3)<<std::setw(7)<<top_hit_ratio<<"\t, ["<<sum_locked+sum_confALL<<"/"<<total_boxes<<"]\n"
		<<"top2_hit:\t"<<std::setprecision(3)<<std::setw(7)<<top2_hit_ratio<<"\t, ["<<sum_switch_top2<<"/"<<total_boxes<<"]\n"
		<<"top3_hit:\t"<<std::setprecision(3)<<std::setw(7)<<top3_hit_ratio<<"\t, ["<<sum_switch_top3<<"/"<<total_boxes<<"]\n\n"		
		<<"not_top3_hit:\t"<<std::setprecision(3)<<std::setw(7)<<not_top3_ratio<<"\t, [ ("<<sum_switch_other<<"+"<<sum_edit<<") /"<<total_boxes<<"]\n"
		<<"edit:\t"<<std::setprecision(3)<<std::setw(7)<<editedRatio<<"\t, ["<<sum_edit<<"/"<<total_boxes<<"]\n\n"
		<<"confirm ALL:\t"<<std::setprecision(3)<<std::setw(7)<<confALLRatio<<"\t, ["<<sum_confALL<<"/"<<total_boxes<<"]\n\n";

	//-------------------------------------
	std::cout		
		<<"Total Time(s):"<<timeSum<<std::endl
		<<"Average Time(s):"<<timeSum / flist.size()<<std::endl
		<<"==============================================\n";


}	


void collectAnnoData__v3(std::string ppath , std::string const & SAVEPATH)
{
	// for system version 3
	//
	// time -> (label,support,box)
	//-------------------------------------------------------------------------

	//std::string ppath = "K:/Paper_project/memorability_UCL/MY_CODE/vs12/gui_v3/testData/user_study/trial_naive_v00/annoresult/";

	std::vector<std::string> flist=getFileList(ppath.c_str(),"*.anno");

	std::cout<<"collect :"<<flist.size()<<" files\n";

	AnnoRes anno;

	int verbase=0;

	double sum_edit = 0;
	double sum_locked = 0;
	double sum_switch = 0;
	double sum_confALL = 0;

	double sum_switch_top2 = 0;
	double sum_switch_top3 = 0;
	double sum_switch_other = 0;

	double total_top3hit=0;
	double total_boxes = 0;


	std::fstream fout(SAVEPATH+"\\actionlog.txt",std::ios::out);
	fout<<"sceid box_num top_1_hitnum(lock) sw_top_2_hitnum(<2) sw_top_3_hitnum(<3) sw_notTop3_num typing_num confbyCFALL_num(box)\n";
	
	// for each scene
	for( int i=0 ; i < flist.size() ; i++ ){

		std::string fpath = ppath+'/'+flist[i];

		loadAnnoFile(fpath,anno);

		// check last state snapshot of each scene
		// access menu log

		auto const & LastLog = anno.action_log.back();
		auto const & FirstState = anno.action_log.back().boxState;
		auto const & LastState = anno.action_log.back().boxState;

		auto const & SelRank = anno.action_log.back().userSelectMenuIdx;

		int num_edit=0;
		int num_locked=0;
		int num_switch=0;
		int num_confAll=0;

		int num_switch_top2 = 0;
		int num_switch_top3 = 0;
		int num_switch_other = 0;

		// for each box
		for( int ib=0 ; ib < LastState.size() ; ib++ ){

			// count state
			if( LastState[ib] == BoxStateLog::BSTATE_EDITED ){
				num_edit=num_edit+1;
			}else if( LastState[ib] == BoxStateLog::BSTATE_LOCKED  ){
				num_locked=num_locked+1;

				num_switch_top2=num_switch_top2+1;
				num_switch_top3=num_switch_top3+1;

			}else if( LastState[ib] == BoxStateLog::BSTATE_SWITCHED  ){
				num_switch=num_switch+1;
				// 0,1,2
				if( 1 >= SelRank[ib] ){
					num_switch_top3=num_switch_top3+1;
					num_switch_top2=num_switch_top2+1;
				}else if(2 >= SelRank[ib] ){
					num_switch_top3=num_switch_top3+1;
				}else{
					num_switch_other=num_switch_other+1;
				}

			}else if( LastState[ib] == BoxStateLog::BSTATE_CONF_ALL  ){
				// this record box is confirmed by confALL btu
				num_confAll=num_confAll+1;

				num_switch_top2=num_switch_top2+1;
				num_switch_top3=num_switch_top3+1;

			}else if( LastState[ib] == BoxStateLog::BSTATE_UNK  ){
				throw "invalid log - found BASTEA_UNK ";
			}else{
				throw "invalid log - ? ";
			}

			// count selection index
			if(  LastState[ib] == BoxStateLog::BSTATE_SWITCHED  ){

				if( LastLog.userSelectMenuIdx[ib] != -1 &&
					LastLog.userSelectMenuIdx[ib] < 3){
						total_top3hit=total_top3hit+1;
				} 
			}

		}// each box

		//std::cout<<"num_edit="<<num_edit
		//	<<"\n num_locked="<<num_locked
		//	<<"\n num_switch="<<num_switch<<std::endl;

		sum_switch = sum_switch + num_switch;
		sum_locked = sum_locked + num_locked;
		sum_edit = sum_edit + num_edit;
		sum_confALL = sum_confALL + num_confAll;

		sum_switch_top2 = sum_switch_top2 +num_switch_top2;
		sum_switch_top3 = sum_switch_top3 +num_switch_top3;
		sum_switch_other= sum_switch_other+num_switch_other;

		total_boxes = total_boxes + LastState.size();


		//-------------------------------------------------------------------------

		// sceid  box_num  top_1_hitnum(lock)  sw_top_2_hitnum(<2)  sw_top_3_hitnum(<3) sw_notTop3_num  typing_num  confbyCFALL_num(box)
		fout<<anno.sce_id<<" "
			<<anno.action_log.back().predRes.size()<<" "
			<<num_locked<<" "
			<<num_switch_top2<<" "
			<<num_switch_top3<<" "
			<<num_edit<<" "
			<<num_confAll<<" "
			<<std::endl;

	}// loop scene

	// include confALL & lock
	double top3_hit_ratio = 1.0*sum_switch_top3/total_boxes;
	double top2_hit_ratio = 1.0*sum_switch_top2/total_boxes;

	double top_hit_ratio = 1.0*(sum_locked+sum_confALL)/total_boxes; 
	double not_top3_ratio = 1.0*(sum_switch_other+sum_edit)/total_boxes; 
	double switch_otherRatio = 1.0*(sum_switch_other)/total_boxes; 
	double editedRatio = 1.0*(sum_edit)/total_boxes; 
	double confALLRatio = sum_confALL/total_boxes;

	std::cout<<"path:"<<ppath.c_str()<<"\n"
		<<"scelog # :"<<flist.size() <<"\n\n";

	std::cout
		<<"NUM:\n"
		<<"switch:"<<"\t ["<<sum_switch<<"/"<<total_boxes<<"]\n"
		<<"locked:"<<"\t ["<<sum_locked<<"/"<<total_boxes<<"]\n"
		<<"confirm ALL:"<<"\t ["<<sum_confALL<<"/"<<total_boxes<<"]\n"
		<<"top3_hit:"<<"\t ["<<sum_switch_top3<<"/"<<total_boxes<<"]\n"
		<<"not_top3_ratio:"<<"\t ["<<sum_switch_other+sum_edit<<"/"<<total_boxes<<"]\n"
		<<"edited:"<<"\t ["<<sum_edit<<"/"<<total_boxes<<"]\n\n";

	std::cout<<"RESULT:\n"
		<<"top_hit:\t"<<std::setprecision(3)<<std::setw(7)<<top_hit_ratio<<"\t, ["<<sum_locked+sum_confALL<<"/"<<total_boxes<<"]\n"
		<<"top2_hit:\t"<<std::setprecision(3)<<std::setw(7)<<top2_hit_ratio<<"\t, ["<<sum_switch_top2<<"/"<<total_boxes<<"]\n"
		<<"top3_hit:\t"<<std::setprecision(3)<<std::setw(7)<<top3_hit_ratio<<"\t, ["<<sum_switch_top3<<"/"<<total_boxes<<"]\n\n"		
		<<"not_top3_hit:\t"<<std::setprecision(3)<<std::setw(7)<<not_top3_ratio<<"\t, [ ("<<sum_switch_other<<"+"<<sum_edit<<") /"<<total_boxes<<"]\n"
		<<"edit:\t"<<std::setprecision(3)<<std::setw(7)<<editedRatio<<"\t, ["<<sum_edit<<"/"<<total_boxes<<"]\n\n"
		<<"confirm ALL:\t"<<std::setprecision(3)<<std::setw(7)<<confALLRatio<<"\t, ["<<sum_confALL<<"/"<<total_boxes<<"]\n\n";


}	


void collectAnnoData_time(std::string ppath)
{
	//std::string ppath = "K:/Paper_project/memorability_UCL/MY_CODE/vs12/gui_v3/testData/user_study/trial_naive_v00/annoresult/";
	std::vector<std::string> flist=getFileList(ppath.c_str(),"*.anno");

	std::cout<<"collect :"<<flist.size()<<" files\n";

	AnnoRes anno;

	int verbase=0;

	double sum_edit = 0;			
	double sum_locked = 0;			
	double sum_switch = 0;			
	double sum_confALL = 0;			

	double sum_switch_top2 = 0;		
	double sum_switch_top3 = 0;		
	double sum_switch_other = 0;	

	double total_top3hit=0;			
	double total_boxes = 0;		

	double timeSum=0;

	// for each scene
	for( int i=0 ; i < flist.size() ; i++ ){

		std::string fpath = ppath+'/'+flist[i];

		loadAnnoFile(fpath,anno);


		{ // time
			timeSum+=anno.total_time; 
			auto const & LastLog = anno.action_log.back();

			auto const & FirstState = anno.action_log.back().boxState;
			auto const & LastState = anno.action_log.back().boxState;

			std::cout<<anno.sce_id<<"\t "<<LastState.size()<<"\t "<<anno.total_time<<std::endl;
		}

	}// loop scene


}	

void collectAnnoData_time_v3(std::string ppath , std::string const & SAVEPATH)
{
	// for system version 3
	//
	// time -> (label,support,box)
	//-------------------------------------------------------------------------

	//std::string ppath = "K:/Paper_project/memorability_UCL/MY_CODE/vs12/gui_v3/testData/user_study/trial_naive_v00/annoresult/";
	std::vector<std::string> flist=getFileList(ppath.c_str(),"*.anno");

	std::cout<<"collect :"<<flist.size()<<" files\n";

	AnnoRes anno;

	int verbase=0;

	double totalSum=0;
	double totalLabel=0; 
	double totalSup=0; 
	double totalBox=0;


	//-------------------------------------------------------------------------
	// output time log file
	//  

	std::fstream fout(SAVEPATH+"\\timelog.txt",std::ios::out);

	fout<<"sceid total_time time_label time_sup time_box"<<std::endl;

	for( int i=0 ; i < flist.size() ; i++ ){

		std::string fpath = ppath+'/'+flist[i];

		loadAnnoFile(fpath,anno);

		totalSum = totalSum + anno.total_time; 
		totalLabel = totalLabel +  anno.time_label;
		totalSup = totalSup +  anno.time_support;
		totalBox = totalBox +  anno.time_box;

		fout<<anno.sce_id<<" "<<anno.total_time<<" "<<anno.time_label<<" "<<anno.time_support<<" "<<anno.time_box<<"\n";
	}

	//-------------------------------------------------------------------------
	std::cout<<" total time ="<<totalSum<<std::endl;
	std::cout<<" total LABEL time ="<<totalLabel<<std::endl;
	std::cout<<" total SUPPORT time ="<<totalSup<<std::endl;
	std::cout<<" total BOX time ="<<totalBox<<std::endl;

	//std::cout<<"Average time(prebox)"
}	



/*
void collectAnnoData()
{
bool verbase=1;

std::string root("K:\\Paper_project\\memorability_UCL\\MY_CODE\\vs12\\gui_v3\\testData\\561x427\\processed\\annoresult");
std::vector<std::string> flist=getFileList(root.c_str(),"*.anno");

std::vector<NaiveSceneCTX> allSce;
std::vector<std::vector<NaiveAnnoBox> > allBoxes;
for (int i = 0; i < flist.size() ; i++)
{
if( flist[i].size()<1 ){
continue;
}
std::cout<<flist[i]<<std::endl;

NaiveSceneCTX nctx;
PlaneData floor_ini;
PlaneData floor_fr;
std::vector<PlaneData> walls;
std::vector<NaiveAnnoBox> naBoxes;

std::string ff=root+std::string("\\")+flist[i] ;

loadAnnoBinData( ff.c_str(),nctx,floor_ini,floor_fr,walls,naBoxes,true);

allSce.push_back(nctx);
allBoxes.push_back(naBoxes);

}

int MAX_LNUM=1024;

Eigen::MatrixXf sceneMats;
sceneMats.resize(allSce.size() , MAX_LNUM );
sceneMats.setZero();
//scene object counter
for (int i_sce = 0; i_sce < allSce.size() ; i_sce++){
for( int ib=0 ; ib<allBoxes[i_sce].size() ; ib++){
sceneMats( i_sce , allBoxes[i_sce][ib].labelLid  ) += 1 ;
}
}

// re-counting 
// convert to freq mat 
Eigen::MatrixXf coourMat;
Eigen::MatrixXf coourProb;

coourMat.resize(MAX_LNUM, MAX_LNUM );
coourMat.setZero();
coourProb.resize(MAX_LNUM, MAX_LNUM );
coourProb.setZero();

for( int ix=1 ; ix < MAX_LNUM ;ix++ ){

double ix_exis_num = sceneMats.col(ix).nonZeros();

coourMat(ix,ix)=ix_exis_num;

for( int iy=1 ; iy < MAX_LNUM ;iy++ ){

// scan all scene to count # of co-exist 
int co_num=0;
for( int k=0 ; k < sceneMats.rows() ;k++ ){
if( sceneMats(k,ix)>0 &&  sceneMats(k,iy)>0  ){
co_num=co_num+1;
}				
} 
coourMat(ix,iy)=co_num;
coourProb(ix,iy)=co_num*1.0 / ix_exis_num;
} 
}

if( verbase ){

// show bed and night stand

std::cout
<<"coourMat(157,157) :"<<coourMat(157,157)<<"\n"
<<"coourMat(157,158) :"<<coourMat(157,158)<<"\n"
<<"coourMat(158,158) :"<<coourMat(158,158)<<"\n"
<<"coourMat(158,157) :"<<coourMat(158,157)<<"\n";
std::cout
<<"coourProb(157,157) :"<<coourProb(157,157)<<"\n"
<<"coourProb(157,158) :"<<coourProb(157,158)<<"\n"
<<"coourProb(158,158) :"<<coourProb(158,158)<<"\n"
<<"coourProb(158,157) :"<<coourProb(158,157)<<"\n";
}

}


*/