
#include "fboinsgrenderer.h"

#include <QtGui/QOpenGLFramebufferObject>
#include <QtQuick/QQuickWindow>

FboInSGRenderer::FboInSGRenderer():texNode(NULL),ctx(NULL)
{
    setFlag(ItemHasContents, true);
	fboWidth = 0;
	fboHeight = 0;
}


QSGNode *FboInSGRenderer::updatePaintNode(QSGNode *oldNode, UpdatePaintNodeData *)
{
	// should take care the resize action of the WRAPPED NODE in here
	// don't change the size of fbo textures( which should be fixed in our case )


	if(!oldNode && texNode){
		return texNode;
	}else{
		return oldNode;	 
	}
}

FboInSGRenderer::~FboInSGRenderer()
{
	/*
	if(texNode){
		delete texNode;
		texNode=NULL;
	}
	*/
}

void FboInSGRenderer::iniFBO( int w,int h ,QQuickWindow * win)
{
	fboWidth = w;
	fboHeight = h;

	if(texNode)
	{ // not null
		delete texNode; 
		texNode=NULL;
	}

	texNode= new TextureNode(win);
	texNode->setSize(fboWidth,fboHeight); 
	texNode->initial();
}

Q_INVOKABLE void FboInSGRenderer::iniFBO( int w,int h )
{
	fboWidth = w;
	fboHeight = h;

	if(texNode)
	{ // not null
		delete texNode; 
		texNode=NULL;
	}

	texNode= new TextureNode(window());
	texNode->setSize(fboWidth,fboHeight); 
	texNode->initial();
}
