#include "stdafx.h"
#include "loader.h"



Loader::Loader()
{
	inilized=false;

}

Loader::~Loader()
{

}

void Loader::iniLidMap(  ){

	static char fpath[4096];
	std::memset(fpath,0,sizeof(fpath));
	sprintf(fpath,"%s/../names.txt", rootPath.c_str() );   

	if( !fileisExisted(fpath) ){
		std::cout<<"names.txt not exist :"<<fpath<<'\n';
		throw "names.txt is not existed.";
	}

	std::fstream fin;
	fin.open(fpath,std::ios::in);

	int lid=-1;
	std::string lname;

	nyuLabelMap.clear();
	nyuLabelList.clear();

	nyuLabelList.resize(1024); 

	while( fin>>lid )
	{
		std::getline( fin, lname,'\n');

		lname=lname.substr(1,lname.length());

		nyuLabelMap.insert(std::pair<std::string,int>(lname,lid)); 
		nyuLabelList[lid]=lname;
	}

	fin.close(); 

}

std::string Loader::getlabelPath( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/labels/label_%d.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::getImagePath( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/image/%d_img.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}


std::string Loader::getIni_XYZPCDPath( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/ini_pcd/img-%d_ini_xyz.pcd",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}



std::string Loader::getAutoSegPath( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/auto_%d.png",autosegPath.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::getSegPath( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/seg/%d_seg.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::getRoomSegPath( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/seg/%d_room.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::getProc_FrXYZ_Path( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/processed/fr_xyz_pcd/img-%d__xyz.pcd",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}
std::string Loader::getProc_FrNV_Path( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/processed/fr_nv_pcd/img-%d__nv.pcd",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}


std::string Loader::get_sceini_bin_path(const int IMGID, const std::string SROOT ) 
{
	// img_1030.bin
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/img_%d.bin",SROOT.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::getAnnoBin_SAVEPath( const int IMGID , const std::string SROOT )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/img_%d.anno",SROOT.c_str(),IMGID);  
	return std::string(mstr);

}

std::string Loader::getANSLID_SAVEPath( const int IMGID  )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/gt/gtlabel_sid_%d_uidxlid.txt",rootPath.c_str(),IMGID);  
	return std::string(mstr);

}

std::string Loader::getUserANSLID_SAVEPath( const int IMGID  )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/user/gtlabel_sid_%d_uidxlid.txt",rootPath.c_str(),IMGID);  
	return std::string(mstr);

}

std::string Loader::getGTSUP_SAVEPath( const int IMGID  )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/gt/gtsup_sid_%d_uidxsupxpuid.txt",rootPath.c_str(),IMGID);  
	return std::string(mstr);

}

std::string Loader::getExportMatBin_SAVEPath( const int IMGID , const std::string SROOT )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/img_%d.mymat",SROOT.c_str(),IMGID);  
	return std::string(mstr);

}
std::string Loader::getExportINIMatBin_SAVEPath( const int IMGID , const std::string SROOT )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/img_%d.inimymat",SROOT.c_str(),IMGID);  
	return std::string(mstr);

}

std::string Loader::getResultSceneBin_SAVEPath( const int IMGID , const std::string SROOT )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/img_%d_res.bin",SROOT.c_str(),IMGID);  
	return std::string(mstr);

}

std::string Loader::getSxportMatAs_Path( const int IMGID , const std::string SROOT , int iter )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/img_%d_iter_%d.dexmat",SROOT.c_str(),IMGID,iter);  
	return std::string(mstr);

}

std::string Loader::get_corseg_PATH( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/autogen/compseg/comp_%d.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::get_autoroom_PATH( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/autogen/room/room_%d.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}

std::string Loader::get_finer_PATH( const int IMGID )
{
	std::memset(mstr,0,sizeof(mstr));
	sprintf(mstr,"%s/autogen/compseg/small/comp_%d.png",rootPath.c_str(),IMGID);  
	return std::string(mstr);
}
