#ifndef MY_LOADER
#define MY_LOADER


#include <string>
#include <map>
#include <vector>
#include <fstream>
#include "common_tool.h"

class Loader
{
public:
	Loader();
	~Loader();

	inline
	void setRootAndIni(const std::string RATH , const std::string AUTOSEG_ROOT ){
		
		rootPath=RATH;

		autosegPath=AUTOSEG_ROOT;

		iniLidMap(); 

		inilized=true;
	}

	inline 
	std::map<std::string,int> const & getLidMap(){
		return nyuLabelMap;
	}

	inline
		int queryLID(std::string const & LNAME){
			std::map<std::string,int>::iterator it = nyuLabelMap.find(LNAME);
			if( it!=nyuLabelMap.end() ){
				return it->second;
			}else{
				// not found 
				return -9;
			}
	}

	inline
		std::vector<std::string> const & getLidList(){
		return nyuLabelList;
	}

	//-------------------------------------------------------------------------
	// initial data

	std::string getAutoSegPath(const int IMGID );

	std::string getSegPath(const int IMGID );
	std::string getRoomSegPath(const int IMGID );

	std::string getlabelPath(const int IMGID ); 
	std::string getImagePath(const int IMGID );

	//std::string getFR_XYZPCDPath(const int IMGID ); 
	//std::string getFR_NVPCDPath(const int IMGID );  
	//std::string getGR_XYZPCDPath( const int IMGID );
		
	std::string getIni_XYZPCDPath( const int IMGID );

	//-------------------------------------------------------------------------
	// processed data

	std::string getProc_FrXYZ_Path( const int IMGID );
	std::string getProc_FrNV_Path( const int IMGID );

	std::string get_sceini_bin_path(const int IMGID, const std::string SROOT ); 
	//-------------------------------------------------------------------------
	// annotate

	std::string getAnnoBin_SAVEPath( const int IMGID , const std::string SROOT );
	std::string getExportMatBin_SAVEPath( const int IMGID , const std::string SROOT );
	std::string getResultSceneBin_SAVEPath( const int IMGID , const std::string SROOT );
	std::string getSxportMatAs_Path( const int IMGID , const std::string SROOT , int );
	std::string getExportINIMatBin_SAVEPath( const int IMGID , const std::string SROOT );
	std::string getANSLID_SAVEPath( const int IMGID  );
	std::string getGTSUP_SAVEPath( const int IMGID  );
	std::string getUserANSLID_SAVEPath( const int IMGID );
	std::string get_corseg_PATH( const int IMGID );
	std::string get_autoroom_PATH( const int IMGID );
	std::string get_finer_PATH( const int IMGID );

private:

	void Loader::iniLidMap();
	//--------------------------------------

	char mstr[4096];

	std::string rootPath;
	std::string autosegPath;
	 

	bool inilized;
	//--------------------------------------
	// NYU
	std::map<std::string,int>  nyuLabelMap; 
	std::vector<std::string>  nyuLabelList;
};


#endif