#include "myquickwin.h"

MyQuickWin::MyQuickWin(QWindow *parent /*=0*/)
	: QQuickView(parent)
{
	// Tell Qt we will use OpenGL for this window
	setSurfaceType( OpenGLSurface );

	// Specify the format and create platform-specific surface
	QSurfaceFormat format;
	format.setDepthBufferSize( 24 );
	format.setMajorVersion( 4 );
	format.setMinorVersion( 3 );
	format.setSamples( 4 );
	format.setProfile( QSurfaceFormat::CoreProfile );
	setFormat( format );
	create();

	// Create an OpenGL context
	m_context = new QOpenGLContext();
	m_context->setFormat( format );
	m_context->create();

	// Make the context current on this window
	m_context->makeCurrent( this );

	// Obtain a functions object and resolve all entry points
	// m_funcs is declared as: QOpenGLFunctions_4_3_Core* m_funcs
	m_funcs = m_context->versionFunctions();
	if ( !m_funcs ) {
		qWarning( "&quot;Could not obtain OpenGL versions object&quot;" );
		exit( 1 );
	}

	
	m_funcs->initializeOpenGLFunctions();
}

MyQuickWin::~MyQuickWin()
{
	
	delete m_funcs;
	delete m_context;
}
