#include "stdafx.h"
#include "mytrackball.h"
//#include "scene.h"


static const float MY_PI = 3.141592653589793;

void MyTrackBall::trackball_ptov( int x, int y, int width, int height, float v[3] )
{
	float d, a;

	/* project x,y onto a hemi-sphere centered within width, height */
	v[0] = (2.0F*x - width) / width;
	v[1] = (height - 2.0F*y) / height;
	d = (float) sqrt(v[0]*v[0] + v[1]*v[1]);
	v[2] = (float) cos((M_PI/2.0F) * ((d < 1.0F) ? d : 1.0F));
	a = 1.0F / (float) sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
	v[0] *= a;
	v[1] *= a;
	v[2] *= a;
}

void MyTrackBall::mouseMotion( int x, int y )
{
	float curPos[3], dx, dy, dz;

	trackball_ptov(x, y, winWidth, winHeight, curPos);
	if(trackingMouse)
	{
		dx = curPos[0] - lastPos[0];
		dy = curPos[1] - lastPos[1];
		dz = curPos[2] - lastPos[2];
		if (dx || dy || dz)
		{
			angle = 90.0F * sqrt(dx*dx + dy*dy + dz*dz);
			axis[0] = lastPos[1]*curPos[2] - lastPos[2]*curPos[1];
			axis[1] = lastPos[2]*curPos[0] - lastPos[0]*curPos[2];
			axis[2] = lastPos[0]*curPos[1] - lastPos[1]*curPos[0];
			lastPos[0] = curPos[0];
			lastPos[1] = curPos[1];
			lastPos[2] = curPos[2];
		}
	}
}

void MyTrackBall::startMotion( int x, int y )
{
	trackingMouse = true;
	redrawContinue = false;
	startX = x; startY = y;
	curx = x; cury = y;
	trackball_ptov(x, y, winWidth, winHeight, lastPos);
	trackballMove=true;
}

void MyTrackBall::stopMotion( int x, int y )
{
	trackingMouse = false;
	if (startX != x || startY != y)
	{
		redrawContinue = true;
	}
	else
	{
		angle = 0.0F;
		redrawContinue = false;
		trackballMove = false;
	}
}

QQuaternion MyTrackBall::rotation()
{
	sumRotate = QQuaternion::fromAxisAndAngle(axis[0], axis[1], axis[2],angle)*sumRotate;
	return sumRotate;
}

MyTrackBall::MyTrackBall():angle(0),
	winWidth(0),
	winHeight(0)
{
	memset(lastPos,0,sizeof(lastPos)); 
	memset(axis,0,sizeof(axis));
	memset(trans,0,sizeof(trans));

	trackingMouse=false;
	redrawContinue=false;
	trackingMouse=false;
}

void MyTrackBall::reset()
{
	sumRotate=QQuaternion();
	angle=0;
	memset(lastPos,0,sizeof(lastPos)); 
	memset(axis,0,sizeof(axis));
	memset(trans,0,sizeof(trans));
	trackingMouse=false;
	redrawContinue=false;
	trackingMouse=false;
}
