 #ifndef MY_TRACKBALL_H
 #define MY_TRACKBALL_H

 #include <QtGui>

 #include <QtGui/qvector3d.h>
 #include <QtGui/qquaternion.h>

 class MyTrackBall
 {
 public:
     
	 MyTrackBall();


	 inline void setWidth(int w){ winWidth=w;}
	 inline void setHeight(int h){ winHeight=h;}

	 void trackball_ptov(int x, int y, int width, int height, float v[3]);

	 void mouseMotion(int x, int y);

	 void startMotion(int x, int y);

	 void stopMotion(int x, int y);

	 QQuaternion rotation();

	 void reset();
 private:

	 int curx, cury;
	 int startX, startY;

	 int  winWidth, winHeight;
	 float angle;
	 float axis[3];
	 float trans[3];
	 float lastPos[3];

	 bool trackingMouse ; 
	 bool redrawContinue ;
	 bool trackballMove;

	 QQuaternion sumRotate;
 };

 #endif