#ifndef MY_PCABOX 
#define MY_PCABOX

#include "boxdatav2.h"
#include "common_tool.h"
#include "geoobj.h"

#include <pcl/io/pcd_io.h>
#include <Eigen/Eigen>
#include <QImage>

#include "geo_typedef.h"

#include <pcl/sample_consensus/msac.h>
#include <pcl/sample_consensus/mlesac.h>
#include <pcl/sample_consensus/prosac.h>

#include "pcd_tools.h"

void pca_box(const int TID  , cv::Mat const &  indImg ,
		PointCloudXYZ::Ptr f_xyzPcd , PointCloudXYZ::Ptr f_nvPcd ,
		Eigen::MatrixXf const& fr2worldMat,
		BoxDataV2 & resBox   );

void plane_by_pca( const int TID , cv::Mat const & indImg, PointCloudXYZ::Ptr f_xyzPcd , Eigen::Vector3f const & REF_CAM0, PlaneData & res );

void plane_by_lsq( const int TID , cv::Mat const & indImg, PointCloudXYZ::Ptr f_xyzPcd , Eigen::Vector3f const & REF_CAM0, PlaneData & res );


#endif