#include "stdafx.h"
#include "qglpanel.h"

#define MY_DEBUG_MSG(M,X) std::cout<<(M)<<(X)<<std::endl;

using namespace std;
//#define UI_MODE 

Tirth::QGLPanel::QGLPanel(QQuickItem  * parent/*=0*/) : QQuickPaintedItem(parent),
	m_program(NULL)
{

	bool USE_GT=true;
	//-------------------------------------------------------------------------------------------

	this->setRenderTarget(QQuickPaintedItem::Image);
	this->setAntialiasing(true);
	this->setMipmap(true);
	this->setSmooth(true);

	resetStateCtx(ctx);

	ctx.panelWidth  = 600;
	ctx.panelHeight = 480;

	//ctx.finalSavPath = "K:\\Paper_project\\memorability_UCL\\MY_CODE\\results\\01_09\\final_save";
	//ctx.mixmodelPath = "K:\\Paper_project\\memorability_UCL\\MY_CODE\\results\\[train_data]\\model\\t4_env.mat";S
	ctx.finalSavPath = "K:\\Paper_project\\memorability_UCL\\MY_CODE\\results\\[res_mat_rebuttal]\\final_save\\";
	
	//ctx.mixmodelPath = "K:\\Paper_project\\memorability_UCL\\MY_CODE\\results\\[train_data]\\model\\t4_env.mat";
	ctx.mixmodelPath = "K:\\Paper_project\\memorability_UCL\\MY_CODE\\results\\[train_data_reb]\\living_room\\initial\\livr_v3_env.mat";
	 
	//'K:/Paper_project/memorability_UCL/MY_CODE/results/01_09/box_presave')");
	ctx.boxPreSavPath = "K:\\Paper_project\\memorability_UCL\\MY_CODE\\results\\[res_mat_rebuttal]\\presave_box";
	
	connect(this, SIGNAL(windowChanged(QQuickWindow*)), this, SLOT(handleWindowChanged(QQuickWindow*)));

	//-------------------------------------------------------------------------------------------
	//initial signal table
	//setup UI signals handler for specific STATE
	updateTable[StateMag::S_INI][StateMag::U_BtuOpenImg]  = &QGLPanel::openImageByIMID;
	updateTable[StateMag::S_IDLE][StateMag::U_BtuOpenImg]  = &QGLPanel::reopenImageByIMID;

	//[IDLE] --> SWITCH mode entry
	updateTable[StateMag::S_IDLE][StateMag::U_BtuRoomMode] = &QGLPanel::roomMode_switch2Room;

	if(USE_GT){
		updateTable[StateMag::S_IDLE][StateMag::U_BtuCutSPMode]  = &QGLPanel::cutSP_switch2CutSP_gt;
		updateTable[StateMag::S_IDLE][StateMag::U_BtuFIlterSPMode] = &QGLPanel::filterSPbyNum_gt;   //[gt]
	}else{
		updateTable[StateMag::S_IDLE][StateMag::U_BtuCutSPMode]  = &QGLPanel::cutSP_switch2CutSP;
		updateTable[StateMag::S_IDLE][StateMag::U_BtuFIlterSPMode]  = &QGLPanel::filterSPbyNum;
	}

	updateTable[StateMag::S_IDLE][StateMag::U_BtuExtrBoxesMode]  = &QGLPanel::box_switch2ExBox;
	updateTable[StateMag::S_IDLE][StateMag::U_BtuPredictMode]  = &QGLPanel::predict_switch2PD;
	updateTable[StateMag::S_IDLE][StateMag::U_BtuRefineBoxMode]  = &QGLPanel::refbox_switch2RefBox;
	updateTable[StateMag::S_ROOM][StateMag::U_MRelease] = &QGLPanel::room_mRelease;

	//[ROOM]
	if(USE_GT){
		updateTable[StateMag::S_ROOM][StateMag::U_BtuActionDone] = &QGLPanel::room_isDone_gt;  //[gt]
	}else{
		updateTable[StateMag::S_ROOM][StateMag::U_BtuActionDone] = &QGLPanel::room_isDone;
	}
	 
	//[CUT SP] 
	updateTable[StateMag::S_CUTSP][StateMag::U_BtuLineTool] = &QGLPanel::sp_switch2Line;   
	updateTable[StateMag::S_CUTSP][StateMag::U_BtuActionDone] = &QGLPanel::simpleActionDone;
	 
	//[DRAW_LINE]
	updateTable[StateMag::S_CUTS_DRAWLINE][StateMag::U_MMove] = &QGLPanel::lineTool_mMove;
	updateTable[StateMag::S_CUTS_DRAWLINE][StateMag::U_MPress] = &QGLPanel::lineTool_mPress;
	updateTable[StateMag::S_CUTS_DRAWLINE][StateMag::U_MRelease] = &QGLPanel::lineTool_mRelease;

	if(USE_GT){
		updateTable[StateMag::S_CUTS_DRAWLINE][StateMag::U_BtuActionDone] = &QGLPanel::lineToolActDone_gt; //[gt]
	}else{		
		updateTable[StateMag::S_CUTS_DRAWLINE][StateMag::U_BtuActionDone] = &QGLPanel::lineToolActDone; //[gt] 
	}

	//[EXBOX]
	//updateTable[StateMag::S_EXBOX][StateMag::U_MRelease] = &QGLPanel::exbox_mRelease_gt;  // [gt]
	//updateTable[StateMag::S_EXBOX][StateMag::U_MRelease] = &QGLPanel::exbox_mRelease;     // use gen ver for support cut edge
	updateTable[StateMag::S_EXBOX][StateMag::U_MMove] = &QGLPanel::exbox_mMove;
	updateTable[StateMag::S_EXBOX][StateMag::U_MRelease] = &QGLPanel::exbox_mRelease_gt_cut;       // use gen ver for support cut edge
	updateTable[StateMag::S_EXBOX][StateMag::U_BtuActionDone] = &QGLPanel::exbox_actionDone;
	
	//[PREDICT]
	updateTable[StateMag::S_PREDICT][StateMag::U_BtuActionDone] = &QGLPanel::simpleActionDone; 
	//re-predict action
	updateTable[StateMag::S_PREDICT][StateMag::U_BtuRePredBtu]  = &QGLPanel::predict_rePred; 
	updateTable[StateMag::S_PREDICT][StateMag::U_BtuConfAllBtu] = &QGLPanel::predict_confirmAll; 

	updateTable[StateMag::S_PREDICT][StateMag::U_MMove]  = &QGLPanel::predict_mMove;
	updateTable[StateMag::S_PREDICT][StateMag::U_MPress] = &QGLPanel::predict_mPress;
	updateTable[StateMag::S_PREDICT][StateMag::U_MRelease] = &QGLPanel::predict_mRelease; 

	//[REFINE_BOX]- no used
	updateTable[StateMag::S_REFINE_BOX][StateMag::U_BtuActionDone] = &QGLPanel::simpleActionDone; 
	updateTable[StateMag::S_REFINE_BOX][StateMag::U_BtuRunAction] = &QGLPanel::refbox_doref; 
	updateTable[StateMag::S_REFINE_BOX][StateMag::U_MMove] = &QGLPanel::refbox_mMove;
	updateTable[StateMag::S_REFINE_BOX][StateMag::U_MPress] = &QGLPanel::refbox_mPress;
	updateTable[StateMag::S_REFINE_BOX][StateMag::U_MRelease] = &QGLPanel::refbox_mRelease; 


	//[FINAL] tx from last act in re-prediction
	updateTable[StateMag::S_FINAL][StateMag::U_BtuSaveLabelBtu] = &QGLPanel::final_saveFinalLabel; 
	updateTable[StateMag::S_FINAL][StateMag::U_BtuActionDone] = &QGLPanel::final_actionDone; 

	//-------------------------------------------------------------------------------------------
 	//initial NYU label LIST
	const char * ALL_LNAME_FPATH = "K:/Paper_project/memorability_UCL/MY_CODE/results/[11_23]/allname.txt";
	std::cout<<"initial label LIST\n";

	fstream fin;
	fin.open(ALL_LNAME_FPATH,std::ios::in);
	int lid=-1;
	std::string lname;

	ctx.nyuLabelMap.clear();
	ctx.nyuLabelList.clear();
	char wsp=0;

	while (fin>>lid)
	{
		std::getline(fin,lname,'\n');

		lname=lname.substr(1,lname.length());
		ctx.nyuLabelMap.insert(std::pair<std::string,int>(lname,lid)); 
	}

	// test
	std::map<std::string,int>::iterator fres = ctx.nyuLabelMap.find("bed");
	std::cout<<fres->second<<std::endl;

	// reset to head
	fin.seekg(0,fin.beg);

	ctx.nyuLabelList.resize( ctx.nyuLabelMap.size()+1);


	while (fin>>lid)
	{
		std::getline(fin,lname,'\n');
		lname=lname.substr(1,lname.length());
		ctx.nyuLabelList[lid]=(lname); 
	}

	fin.close();
	//-------------------------------------------------------------------------------------------
	// State to State
	// default: direct transform
	// transTable[][]
	// eng ini is moved to OPENIMG func

	//iniDebugUIBox();

	connect(this,&QGLPanel::boxDataChanged,this,&QGLPanel::boxDataChangedSlot);

	//-------------------------------------------------------------------------

	tball.setWidth(width());
	tball.setHeight(height());
}

Tirth::QGLPanel::~QGLPanel()
{	
	 
}

//-------------------------------------------------------------------------
#pragma region DRAW_UTILITY

void Tirth::QGLPanel::drawBackground( QPainter *painter )
{
	qreal oriAlpha = painter->opacity();

	painter->setRenderHint(QPainter::Antialiasing, true);



	if( ctx.currentState == StateMag::S_CUTS_DRAWLINE || ctx.currentState == StateMag::S_CUTSP ){

		if(ctx.gt_objMapIsLoaded){

			if(ctx.imageIsLoaded){
				painter->setPen(Qt::NoPen); 
				painter->drawImage(0,0,ctx.inputQImg);
				painter->setOpacity(0.5);
			} 
			painter->drawImage(0,0,ctx.objLabelImg_gt);
			painter->setOpacity(oriAlpha);
		}

	}else{

		if(ctx.imageIsLoaded){
			painter->setPen(Qt::NoPen); 
			painter->drawImage(0,0,ctx.inputQImg);
		} 
		// SP series
		if( ctx.spIsFilted ){ 

			// draw SP block
			//static int mode = QPainter::CompositionMode_DestinationAtop;
			//painter->setCompositionMode((QPainter::CompositionMode)mode);
			//painter->setOpacity(0.5);
			//painter->drawImage(0,0,ctx.objLabelImg_gt); 

			//painter->setCompositionMode(QPainter::CompositionMode_DestinationAtop);
			painter->setOpacity(0.6);
			painter->drawImage(0,0,ctx.objVisBK_gt);

		}else {

			if(ctx.layoutIsLoaded){
				painter->setPen(Qt::NoPen); 
				painter->setOpacity(0.85);
				painter->setRenderHint(QPainter::Antialiasing, true);
				painter->drawImage(0,0,ctx.layMaskQimg);

			}else{

				if( ctx.floorImgIsLoaded){
					painter->setPen(Qt::NoPen);
					painter->setOpacity(0.5);
					painter->setRenderHint(QPainter::Antialiasing, true);
					painter->drawImage(0,0,ctx.floorQimg);
				}
				if( ctx.wallImgIsLoaded ){
					painter->setPen(Qt::NoPen);
					painter->setOpacity(0.7);
					painter->setRenderHint(QPainter::Antialiasing, true);
					painter->drawImage(0,0,ctx.allWallQimg);
				}
			}


		}

	}


	painter->setOpacity(oriAlpha);

}

void Tirth::QGLPanel::drawBackground_mixedogl( QPainter *painter )
{
	qreal oriAlpha = painter->opacity();

	painter->setRenderHint(QPainter::Antialiasing, true);

	// dest :ogl , src:painter
	static int cmode=10; 

	if(ctx.currentState == StateMag::S_EXBOX ){

		// draw SP block
		static int mode = QPainter::CompositionMode_DestinationAtop;
		painter->setCompositionMode((QPainter::CompositionMode)mode);
		painter->setOpacity(0.5);
		painter->drawImage(0,0,ctx.objLabelImg_gt);

		painter->setCompositionMode(QPainter::CompositionMode_DestinationAtop);
		painter->setOpacity(0.6);
		painter->drawImage(0,0,ctx.objVisBK_gt);

	}else{
		if( ctx.gt_objMapIsLoaded ){ 
			painter->setOpacity(1);
			painter->setCompositionMode(QPainter::CompositionMode_DestinationAtop);
			painter->drawImage(0,0,ctx.objVisBK_gt);
		}


	}


	painter->setOpacity(oriAlpha);

}

void Tirth::QGLPanel::drawLegend( QPainter *painter )
{ 
	const int Margin = 11;
	const int Padding = 3;

	static QTextDocument textDocument;
	static char htmlStrs[2048] = {0};

	memset(htmlStrs,0,sizeof(htmlStrs));
	sprintf(htmlStrs, 
		"<table width=\"100%\">"	
		"<tr><td>[%s]</td></tr>"
		"<tr><td>%d, %d</td></tr>"
		"</table>",
		Tirth::MODESTRS[ctx.currentState], ctx.lastPos.x(), ctx.lastPos.y()
		);

	textDocument.setDefaultStyleSheet("* { color: #FFEFEF }");
	textDocument.setHtml(htmlStrs);
	textDocument.setTextWidth(textDocument.size().width());

	QRect rect(QPoint(0, 0), textDocument.size().toSize()
		+ QSize(2 * Padding, 2 * Padding));

	painter->translate( ctx.panelWidth - rect.width() - Margin,
		ctx.panelHeight - rect.height() - Margin);

	painter->setPen(QColor(255, 239, 239));
	painter->setBrush(QColor(255, 0, 0, 31));
	painter->drawRect(rect);

	painter->translate(Padding, Padding);
	textDocument.drawContents(painter);

	painter->translate(0, 0);
}

//dedicated called by GT signal handler
void Tirth::QGLPanel::paint_ogl_bef()
{ 

	glClearColor(0.4, 0.4, 0.4, 1); 

	glViewport(0,0,window()->width(),window()->height());  
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	// do real drawing in after-ogl call

	if( ctx.currentState == Tirth::StateMag::S_EXBOX  || ctx.currentState == Tirth::StateMag::S_PREDICT ||  ctx.currentState == Tirth::StateMag::S_FINAL ){
		renderBox();
	}
}

void  Tirth::QGLPanel::renderBox()
{
	if (!m_program) {
		m_program = new QOpenGLShaderProgram();
		m_program->addShaderFromSourceCode(QOpenGLShader::Vertex,
			"uniform mat4 mvp_matrix;"
			"attribute vec4 a_position;"
			"void main() {"
			"    gl_Position = mvp_matrix * a_position; "
			"    gl_FrontColor = gl_Color;  "
			"}");
		m_program->addShaderFromSourceCode(QOpenGLShader::Fragment, 
			"void main() {"
			"    gl_FragColor = gl_Color;"
			"}");

		m_program->link();

		connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
			this, SLOT(ogl_cleanup()), Qt::DirectConnection);
	}

	static int mvpLoc = m_program->uniformLocation("mvp_matrix");
	int vecsattrLoc = m_program->attributeLocation("a_position");
	//int lineULoc = m_program->attributeLocation("lineColor");

	// shift one in C++
	static GLubyte ind2[] = { 
		1-1,2-1,   2-1,3-1,  3-1,4-1,  4-1,1-1,  
		1-1,5-1,   2-1,6-1,  3-1,7-1,  4-1,8-1, 
		5-1,6-1,   6-1,7-1,  7-1,8-1,  8-1,5-1 
	}; 

	m_program->bind();  
	glEnable(GL_DEPTH_TEST); 	 

	glViewport(0,window()->height()-480,640,480);  
	glEnable(GL_BLEND);
	glLineWidth(2.5);
	//-------------------------------------------------------------------------
	QMatrix4x4 mvp;
	mvp.setToIdentity();
	mvp.setRow(0,QVector4D(1.621430941170319 ,0 , 0.017445000000000 , 0));
	mvp.setRow(1,QVector4D(0  , -2.164456713005312 , -0.057234166666667, 0));
	mvp.setRow(2,QVector4D(0 , 0 , 1.222222222222222  , -2.222222222222222));
	mvp.setRow(3,QVector4D(0 , 0 , 1 ,   0));

	// a rotation center
	QMatrix4x4 txMat;
	txMat.translate( -0.472242157051288,-0.185038202903424, 3.107067983732776);
	QMatrix4x4 txMat_inv;
	txMat.translate( 0.472242157051288,0.185038202903424, -3.107067983732776);

	QMatrix4x4 rmat;
	rmat.setToIdentity();
	rmat.rotate(tball.rotation());

	mvp = mvp *txMat*rmat*txMat_inv;

	// sent to shader
	m_program->setUniformValue(mvpLoc, mvp);

	static QVector4D lineColor_bef(1,0,0,1);
	static QVector4D lineColor_refed(0,1,0,1);

	//-------------------------------------------------------------------------
	m_program->enableAttributeArray(vecsattrLoc); 
	//-------------------------------------------------------------------------
	//start draw boxes

	// draw original boxes
	//m_program->setAttributeValue(lineULoc,0,1,1,1);		
	//glColor3f(1,0,0);
	for(int k=0 ; k< ctx.boxVertices_bef.size() ; k++ ){
		if( ctx.boxVertices_bef[k].size() ){
			m_program->setAttributeArray(vecsattrLoc, GL_FLOAT , ctx.boxVertices_bef[k].data() ,3 );
			glDrawElements(GL_LINES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 
		}
	} 

	// draw RE-fined boxes
	//glColor3f(0,1,0); 
	for(int k=0 ; k< ctx.boxVertices_aft.size() ; k++ ){
		if( ctx.boxVertices_aft[k].size() ){
			m_program->setAttributeArray(vecsattrLoc, GL_FLOAT , ctx.boxVertices_aft[k].data() ,3 );
			glDrawElements(GL_LINES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 
		}
	} 
	//-------------------------------------------------------------------------
	m_program->disableAttributeArray(vecsattrLoc);
	//------------------------------------------------------------------------- 

	m_program->release();

}

//dedicated called by GT signal handler
void Tirth::QGLPanel::paint_ogl_aft()
{


}

void Tirth::QGLPanel::paint( QPainter * painter )
{

	//QPaintDevice * dev = painter->device();
	//2d context
	//painter->begin(dev);

	if( ctx.currentState == Tirth::StateMag::S_PREDICT ||  ctx.currentState == Tirth::StateMag::S_EXBOX  
		|| ctx.currentState == Tirth::StateMag::S_FINAL ){

			// handle by paint_ogl
			drawBackground_mixedogl(painter);

	}else{ 
		drawBackground(painter);

	}

	//painter->end();
	//painter->begin(dev);

	drawUI(*painter);
	//painter->end();
	//painter->begin(dev);
	//drawLegend(painter);
	//painter->end();

}

//-------------------------------------------------------------------------
#pragma region VIS

void Tirth::QGLPanel::drawUI( QPainter& painter)
{ 
	//drawCutLine(&painter); 

	/*
	if( ctx.currentState == StateMag::S_ROOM ){
	int mx=ctx.lastPos.x();
	int my=ctx.lastPos.y();

	static QPen pen = QPen(QBrush(Qt::SolidPattern),1.5,Qt::SolidLine);
	pen.setColor(QColor::fromRgb(50,150,150));
	painter.setPen(pen);		
	painter.drawLine(mx-20,my,mx+20,my);
	painter.drawLine(mx,my-20,mx,my+20);

	}
	*/

	if( ctx.predicIsMaded  ){

		int lx=0,ly=0;
		/*
		for( int k=0 ; k< ctx.boxPredictTag.size() ; k++ ){

		lx = ctx.boxCenters(k,0);		
		ly = ctx.boxCenters(k,1);	
		//painter.setPen(QColor::fromRgb(250,152,91));
		//painter.setFont( QApplication::font() );
		//painter.drawText(lx,ly,ctx.boxPredictTag[k].c_str());

		}
		*/
	}

	//painter.drawText(500,500,"TEST");


}

void Tirth::QGLPanel::drawCutLine( QPainter *painter )
{
	if(ctx.currentState == StateMag::S_CUTS_DRAWLINE || ctx.currentState == StateMag::S_CUTSP ){
		if(ctx.lineDrawCtx.line_isPressed){
			painter->drawLine(ctx.lineDrawCtx.line_LeftStartPos , ctx.lineDrawCtx.line_MovePos);
		}

		//------------------------------------------------------------------------
		//draw LINES
		painter->setPen(QColor(255, 0, 239));
		//travel all lines
		// [ [v0 v1] v2 v3 ...]
		for( int i=0 ; i < ctx.lineDrawCtx.line_allLines.size() ; i=i+2 ){
			painter->drawLine(ctx.lineDrawCtx.line_allLines[i],ctx.lineDrawCtx.line_allLines[i+1]);
		}

	}

}

#pragma endregion VIS

#pragma endregion DRAW_UTILITY
//------------------------------------------------------------------------------
#pragma region UI_EVENTS

void Tirth::QGLPanel::wheelEvent(  )
{

}

void Tirth::QGLPanel::mouseMoveEvent( int x, int y )
{
	//update log info
	ctx.lastPos.setX(x);
	ctx.lastPos.setY(y); 

	//update major logic
	dispatch(ctx.currentState , StateMag::U_MMove );
}

void Tirth::QGLPanel::mouseReleaseEvent(int x, int y){

	//update log info
	ctx.lastPos.setX(x);
	ctx.lastPos.setY(y);

	//update major logic
	dispatch(ctx.currentState , StateMag::U_MRelease );
}

void Tirth::QGLPanel::mousePressEvent(int x, int y, int btu)
{  
	//update log info
	ctx.lastPos.setX(x);
	ctx.lastPos.setY(y);
	ctx.lastBtu = static_cast<Qt::MouseButton>(btu);

	//update major logic
	dispatch(ctx.currentState , StateMag::U_MPress );
}

void Tirth::QGLPanel::mouseEnter()
{
	//std::cout<<"mouseEnter\n";
}

void Tirth::QGLPanel::mouseLeave()
{
	//std::cout<<"mouseLeave\n";

}

//-------------------------------------------------------------------------
//DISPATCH function
void Tirth::QGLPanel::dispatch( StateMag::State fromS1 , StateMag::UISignal usignal )
{
	// check transition function
	auto stepHandler = updateTable[fromS1][usignal];

	if( stepHandler ){

		//perform action
		StateMag::State nextState = stepHandler(*this);

		//check update state or not
		if( ctx.currentState != nextState ){
			// change to the new state

			ctx.currentState = nextState;

			emit stateStrChange(getCurStateStr());
			/*
			auto tranHandler = transTable[fromS1][nextState];
			//check trivial transition or not
			if(tranHandler){
			tranHandler(*this);
			ctx.currentState = nextState;
			}else{
			ctx.currentState = nextState;
			}
			*/
		}

	}else{
		if( usignal !=StateMag::U_MMove ){
			std::cout<<getCurStateStr().toStdString()<<": empty step\n";
		}
	}


	this->update();
}

//-------------------------------------------------------------------------

// SLOTS for UI control
// a adapter interface - call dispatch function to determine handler
// simple functions
void Tirth::QGLPanel::openImgSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuOpenImg );
}

void Tirth::QGLPanel::drawLineModeSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuLineTool );

}

void Tirth::QGLPanel::idleModeSlot()
{

}

void Tirth::QGLPanel::debugTestSlot()
{

	ctx.exBoxIsDone=true;
	ctx.predicIsMaded=true;

	//*
	std::string mName ;
	int mid;

	for( int i=0 ; i < ctx.boxDatas.size() ; i++ ){
		ctx.boxDatas[i].getMainTag(mid,mName);

		std::cout<<"["<<i<<"]"<<"  mid="<<mid<<" --"
			<<"  cx,cy="<<ctx.boxDatas[i].getBoxCx()<<","<<ctx.boxDatas[i].getBoxCy()<<'\n'
			<<" \t"<<mName<<'\n';

		QStringList llist= ctx.boxDatas[i].getPredTags();
		QList<int> ltag =ctx.boxDatas[i].getPredTagLIDs();

		std::cout<<"\t>";

		for( int k=0 ; k<llist.size() ;k++ ){
			std::cout<<llist[k].toStdString()<<" ;";
			std::cout<<ltag[k]<<" ;";
		}
		std::cout<<"\n";
	}
	//*/


	/*
	//this->debugPMap;
	std::cout<<"test sending image\n";

	//debugPMap.fromImage()
	if(QImage::Format_RGB888==ctx.inputQImg.format()){
	std::cout<<"QImage::Format_RGB888 24-bit RGB format \n bytePL:"<<ctx.inputQImg.bytesPerLine()<<std::endl;
	}else{
	std::cout<<"other Format NOT 888 "<<std::endl;
	}

	int hs = ctx.inputQImg.height();
	int ws = ctx.inputQImg.width(); 

	for(int i=0; i<hs ;i++){
	for(int j=0; j<ws ;j++){ 
	// h indexing

	//QRgb *line = (QRgb *)ctx.inputQImg.scanLine(i);
	//line[j]=qRgb(qRed(255), qGreen(line[j]), qBlue(line[j]));
	uchar* line = ctx.inputQImg.scanLine(i);
	//rgb
	line[j*3]=0;
	}
	}

	// row indexing
	// ctx.inputQImg.scanLine
	// return d->data + i_h * d->bytes_per_line; 	
	const uchar *bits = ctx.inputQImg.bits();
	uchar *newData = new uchar[ctx.inputQImg.byteCount()];
	memcpy( newData, bits, ctx.inputQImg.byteCount() );

	// QImage use row major
	Eigen::MatrixXf eimg = Eigen::Map< Eigen::Matrix<uchar,Eigen::Dynamic,1> >(newData,ctx.inputQImg.byteCount(),1).cast<float>();

	//matEng.sendMat("eimg", eimg );
	//matEng.exec("eimg2d=uint8(reshape(eimg,3,640,480));"
	"eimg2d=permute(eimg2d,[3,2,1]);"
	"fimshow(eimg2d);"); 
	*/

}

void Tirth::QGLPanel::roomModeSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuRoomMode ); 
}

void Tirth::QGLPanel::actionDoneSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuActionDone ); 
}

void Tirth::QGLPanel::predictModeSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuPredictMode ); 

}

void Tirth::QGLPanel::cutSPModeSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuCutSPMode ); 

}

void Tirth::QGLPanel::extrBoxModeSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuExtrBoxesMode ); 

}

void Tirth::QGLPanel::filterSPModeSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuFIlterSPMode ); 

}

void Tirth::QGLPanel::boxDataChangedSlot()
{
	debugPrint("boxDataChangedSlot");
}

void Tirth::QGLPanel::rePredBtuSlot()
{
	std::cout<<"[SLOT - Re-Prediction ]\n";
	dispatch(ctx.currentState , StateMag::U_BtuRePredBtu ); 

}

void Tirth::QGLPanel::refineBoxSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuRefineBoxMode ); 

}

void Tirth::QGLPanel::delBoxSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuDelBtu ); 

}

void Tirth::QGLPanel::confAllBtuSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuConfAllBtu ); 
}

void Tirth::QGLPanel::runBtuSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuRunAction ); 
}


void Tirth::QGLPanel::finalSavBtuSlot()
{
	dispatch(ctx.currentState , StateMag::U_BtuSaveLabelBtu ); 
}


void Tirth::QGLPanel::saveMatStateSlot()
{	

	if( ctx.currentState != StateMag::S_IDLE  ){ 
		std::cout<<"not on S_IDLE state -- exit\n";
		return;
	}


	if( ctx.exBoxIsDone ){
		static char scmd[1024]={0};


	}else{

		std::cout<<"box not ready\n";
	}

}

void Tirth::QGLPanel::loadMatStateSlot( )
{

	if( ctx.currentState != StateMag::S_INI  ){ 
		std::cout<<"not on S_INI state -- reset\n";

		resetStateCtx(ctx);
	}

	std::cout<<"start loading pre-boxes img data:"<<ctx.targetImgID <<std::endl;

	static char scmd[1024]={0};

	memset(scmd,0,sizeof(scmd));

	std::cout<<"RELOAD ...mix model\n";

	static char cmdstr2[2048]={0};

	memset(cmdstr2,0,sizeof(cmdstr2));

	sprintf(cmdstr2,"load('%s');",ctx.mixmodelPath);

	//reload bk
	loadByteImg(ctx.inputQImg,"inp",QImage::Format_RGB888);	 

	loadByteU8Mask(ctx.objGroupImg,"objmask"); 
	if(!ctx.objGroupImg.hasAlphaChannel()){
		ctx.objGroupImg=ctx.objGroupImg.convertToFormat(QImage::Format_ARGB32);
	} 
	setAlpha(ctx.objGroupImg, 0 , 200);  

	loadByteImg(ctx.boxes2dQImg,"box2d",QImage::Format_RGB888);

	if(!ctx.boxes2dQImg.hasAlphaChannel()){
		ctx.boxes2dQImg=ctx.boxes2dQImg.convertToFormat(QImage::Format_ARGB32);
	} 
	setAlpha(ctx.boxes2dQImg, 0 , 0);   

	ctx.imageIsLoaded=true;
	ctx.spIsFilted=true; 
	ctx.exBoxIsDone=true;
	ctx.spIsFilted=true; 

	loadByteImg(ctx.objVisBK_gt,"visBK",QImage::Format_ARGB32);
	ctx.gt_objMapIsLoaded=true;

	ctx.currentState = StateMag::S_IDLE; 
	emit stateStrChange(getCurStateStr());
	this->update();
}

#pragma endregion UI_EVENTS

//===========================================================================================
#pragma region CONTROL_FUNC

// STATE:[S_IDLE] - [Btu LineTool]:switch2line
Tirth::StateMag::State Tirth::QGLPanel::sp_switch2Line()
{
	//reset line data
	ctx.lineDrawCtx.line_isPressed=false;
	ctx.lineDrawCtx.line_allLines.clear();

	return StateMag::S_CUTS_DRAWLINE;
}

// STATE:[S_IDLE] - [Btu RoomMode]:switch2Room
Tirth::StateMag::State Tirth::QGLPanel::roomMode_switch2Room()
{
	if( ctx.layoutIsLoaded ){
		debugPrint("layout is loaded");
		return StateMag::S_IDLE;

	}else{

		return StateMag::S_ROOM;
	}
}

// STATE:[S_IDLE] - [Btu CUTSP]:switch2CUTSP
Tirth::StateMag::State Tirth::QGLPanel::cutSP_switch2CutSP()
{
	if( ctx.spIsFilted ){
		return StateMag::S_CUTSP; 
	}else{
		return StateMag::S_IDLE;
	}
}

// STATE:[S_IDLE] - [Btu CUTSP]:switch2CUTSP
Tirth::StateMag::State Tirth::QGLPanel::cutSP_switch2CutSP_gt()
{
	if( ctx.spIsFilted ){ 

		return StateMag::S_CUTSP; 
	}else{
		return StateMag::S_IDLE;
	}
}

// STATE:[*] - [Btu Action_done]
Tirth::StateMag::State Tirth::QGLPanel::simpleActionDone()
{
	return Tirth::StateMag::S_IDLE;
}

//-------------------------------------------------------------------------------------
// Major Control logic
// STATE:[S_DRAWLINE] - [Mouse Press]
Tirth::StateMag::State Tirth::QGLPanel::lineTool_mPress()
{
	// [START] Action
	ctx.lineDrawCtx.line_isPressed = true;

	if( ctx.lastBtu == Qt::LeftButton ){ 
		//record start pts
		ctx.lineDrawCtx.line_LeftStartPos = ctx.lastPos;
		ctx.lineDrawCtx.line_MovePos = ctx.lastPos;
		//log path
		//ctx.line_ppath.push_back(ctx.lastMEvent.pos());

		// ALSO CHANGE THE COLOR in MOVE
		// ALSO CHANGE THE COLOR in MOVE
		// ALSO CHANGE THE COLOR in MOVE
		cv::circle(ctx.objGroupCvImg, cv::Point(ctx.lastPos.x(),ctx.lastPos.y()),  ctx.spBrushSize  , cv::Scalar(0,0,0,0),-1, 8,0);
		//cv::circle(ctx.objGroupCvImg, cv::Point(ctx.lastPos.x(),ctx.lastPos.y()),  ctx.spBrushSize  , cv::Scalar(0,0,0,200),-1, 8,0);
	}else if(ctx.lastBtu == Qt::RightButton){ 

		//record start pts
		ctx.lineDrawCtx.line_LeftStartPos = ctx.lastPos;
		ctx.lineDrawCtx.line_MovePos = ctx.lastPos;

		cv::circle(ctx.objGroupCvImg, cv::Point(ctx.lastPos.x(),ctx.lastPos.y()),  ctx.spBrushSize  , cv::Scalar(255,255,255,55),-1, 8,0);

	}

	return Tirth::StateMag::S_CUTS_DRAWLINE;
}

// STATE:[S_DRAWLINE] - [Mouse Move]
Tirth::StateMag::State Tirth::QGLPanel::lineTool_mMove()
{ 

	//log path
	ctx.lineDrawCtx.line_MovePos = ctx.lastPos;

	// directly mask on image
	if( ctx.lineDrawCtx.line_isPressed && ctx.lastBtu == Qt::LeftButton ){

		// ALSO CHANGE THE COLOR in PRESS
		// ALSO CHANGE THE COLOR in PRESS
		// ALSO CHANGE THE COLOR in PRESS
		cv::circle(ctx.objGroupCvImg, cv::Point(ctx.lastPos.x(),ctx.lastPos.y()), ctx.spBrushSize , cv::Scalar(0,0,0,0),-1, 8,0);

	}else if( ctx.lineDrawCtx.line_isPressed && ctx.lastBtu == Qt::RightButton){ 

		cv::circle(ctx.objGroupCvImg, cv::Point(ctx.lastPos.x(),ctx.lastPos.y()),  ctx.spBrushSize , cv::Scalar(255,255,255,55),-1, 8,0);

	}

	return Tirth::StateMag::S_CUTS_DRAWLINE;
}

// STATE:[S_DRAWLINE] - [Mouse Release]
Tirth::StateMag::State Tirth::QGLPanel::lineTool_mRelease()
{
	ctx.lineDrawCtx.line_isPressed = false;

	//JUST RECORD
	// [END] Action 
	// make on real panel
	if( ctx.lastBtu == Qt::LeftButton || ctx.lastBtu == Qt::RightButton ){
		ctx.lineDrawCtx.line_EndPos = ctx.lastPos;
		//record
		ctx.lineDrawCtx.line_allLines.push_back(ctx.lineDrawCtx.line_LeftStartPos);
		ctx.lineDrawCtx.line_allLines.push_back(ctx.lineDrawCtx.line_EndPos); 
		//reset
		ctx.lineDrawCtx.line_LeftStartPos.setX(-1);
		ctx.lineDrawCtx.line_LeftStartPos.setY(-1);

	}

	return Tirth::StateMag::S_CUTS_DRAWLINE;	
}

// STATE:[S_CUTS_DRAWLINE] - [Btu ActionDone]
Tirth::StateMag::State Tirth::QGLPanel::lineToolActDone()
{   
	std::cout<<"sending cut line.."<<ctx.inputQImg.width()<<ctx.inputQImg.height() <<"\n";

	//QImage drawImg = pixmap.toImage().convertToFormat(QImage::Format_RGB888);  
	QImage newObjGImg = ctx.objGroupImg.copy();

	sendQImg(newObjGImg,"cutEdgeImg");  
	//matEng.exec("[cspl3_mid , cspl3_vis]=g7_hy.applyCutEdgeV3(sce,cutEdgeImg);");

	loadByteU8Mask(ctx.cutSPL3_mid,"cspl3_mid"); 

	return StateMag::S_IDLE;
}

// STATE:[S_CUTS_DRAWLINE] - [Btu ActionDone]
Tirth::StateMag::State Tirth::QGLPanel::lineToolActDone_gt()
{
	std::cout<<"sending cut line.."<<ctx.objGroupImg.width()<<ctx.objGroupImg.height() <<"\n";

	ctx.objLabelImg_gt.save("test_re_objGroupImg.png");

	QImage newObjGImg = ctx.objLabelImg_gt.copy();

	sendQImg(newObjGImg,"newObjRGBAMap"); 

	//matEng.exec("[cspl3_mid,rgbaLidMap,visBK ]=g9_se.applyGTSeg_and_ref(sce,newObjRGBAMap);");

	loadByteU8Mask(ctx.cutSPL3_mid,"cspl3_mid"); 
	loadByteImg(ctx.objVisBK_gt,"visBK",QImage::Format_ARGB32);
	loadByteImg(ctx.objLabelImg_gt,"rgbaLidMap",QImage::Format_ARGB32);

	//re-vbinding ? 
	bindQImage2cvmat(ctx.objLabelImg_gt , ctx.objGroupCvImg ); 


	return StateMag::S_IDLE;
}

Tirth::StateMag::State Tirth::QGLPanel::testSave()
{

	QPixmap pixmap(ctx.inputQImg.size());
	QPainter painter(&pixmap); 

	painter.setPen(QColor(255, 0, 239));
	//travel all lines
	// [ [v0 v1] v2 v3 ...]
	for( int i=0 ; i < ctx.lineDrawCtx.line_allLines.size() ; i=i+2 ){
		painter.drawLine(ctx.lineDrawCtx.line_allLines[i],ctx.lineDrawCtx.line_allLines[i+1]);
	}

	painter.end();
	pixmap.save("./test.png");

	std::cout<<" -->save PNG test.png "<<std::endl;


	return Tirth::StateMag::S_CUTS_DRAWLINE;	
}

// STATE:[S_ROOM] - [Mouse Release]
Tirth::StateMag::State Tirth::QGLPanel::room_mRelease()
{
	// receive CLICK action
	int ix=ctx.lastPos.x();
	int iy=ctx.lastPos.y();

	if( ctx.lastBtu == Qt::LeftButton ){
		std::cout<<"Extract Floor at "<<ix<<','<<iy<<std::endl;
		Eigen::MatrixXd aClick(1,2);
		aClick<<ix,iy ;
		//matEng.sendMat("aClick",aClick);
		//matEng.exec( "sce.extrFloor(aClick(1),aClick(2));"	
		//	"floorMask = g7_hy.floorVisDataV2(sce);"	);

		loadByteU8Mask(ctx.floorQimg,"floorMask");
		ctx.floorImgIsLoaded=true;

	}else if (ctx.lastBtu == Qt::RightButton ){

		// wall mode	 
		std::cout<<"Extract WALL at "<<ix<<','<<iy<<std::endl;
		Eigen::MatrixXd aClick(1,2);
		aClick<<ix,iy ;
		//matEng.sendMat("aClick",aClick);
		//matEng.exec( "sce.extrWall(aClick(1),aClick(2)) ; "	
		//	"allWallMask = g7_hy.wallsVisDataV2(sce);"	);

		loadByteU8Mask(ctx.allWallQimg,"allWallMask"); 
		std::cout<<"loading done\n";
		ctx.wallImgIsLoaded=true;

	}
	return Tirth::StateMag::S_ROOM;	
}

// STATE:[S_ROOM] - [ROOM is DONE]-bind with Btu_Actdone
Tirth::StateMag::State Tirth::QGLPanel::room_isDone()
{
	std::cout<<"Finalize Layout...\n";

	//matEng.exec( "sce.roomIsDone();"	
	//	"layMask = g7_hy.getLayoutMask(sce);"
	//	"spEdgeMask =g7_hy.getSPEdgesV2(sce);"
	//	);
	loadByteU8Mask(ctx.layMaskQimg,"layMask");
	std::cout<<"load layout\n";
	ctx.layoutIsLoaded=true;

	loadByteU8Mask(ctx.spEdgeMatQimg,"spEdgeMask");
	std::cout<<"load obj SP\n";

	ctx.spIsLoaded=true;

	std::cout<<"post-process done\n";
	return Tirth::StateMag::S_IDLE;	
}

// STATE:[S_ROOM] - [ROOM is DONE]-bind with Btu_Actdone
Tirth::StateMag::State Tirth::QGLPanel::room_isDone_gt()
{
	std::cout<<"Finalize Layout...\n";

	//matEng.exec( "sce.roomIsDone();"
	//	"[lidmap,rgbaMap,visBK,NUM_SP]=g9_se.getGLabelMap(sce);"
	//	);

	// colored sp map 
	loadByteImg(ctx.objLabelImg_gt,"rgbaMap",QImage::Format_ARGB32);
	ctx.gt_objMapIsLoaded=true; 

	// would tx to rgb (r=g=b) , =>sce.cutGSP_l3
	loadByteU8Mask(ctx.objLabelGidImg_gt,"lidmap");  
	//fill alpha value 
	//setAlpha(ctx.objLabelGidImg_gt, 0 , 0);

	loadByteImg(ctx.objVisBK_gt,"visBK",QImage::Format_ARGB32);

	//ctx.objLabelGidImg_gt.save("objLabelGidImg_gt.png");
	//ctx.objLabelImg_gt.save("objLabelImg_gt.png");//vis rgba map


	std::cout<<"post-process done\n";
	return Tirth::StateMag::S_IDLE;	
}

// STATE:[S_IDLE] - [Btu openIMG]
Tirth::StateMag::State Tirth::QGLPanel::openImage()
{

	//initialMEng();

	/*
	QString fileName = QFileDialog::getOpenFileName( 
	this , 
	QString("Open Image"), ".", QString("Image Files (*.png *.jpg *.jpeg *.bmp *.tif)"));  

	inputImg.openImage2RGB(fileName.toStdString().c_str());
	inputImg.setAlpha(0.5);

	//create(nrows, ncols, type)
	//inputLabelMat.scaled(inputImg.getQImage().size());
	//std::cout<< "loaded img:"<<inputImg.getQImage().width()<<","<<inputImg.getQImage().height()<<"\n";

	this->setMinimumSize(QSize(inputImg.getQImage().width(),inputImg.getQImage().height()));
	this->setMaximumSize(QSize(inputImg.getQImage().width()*2,inputImg.getQImage().height()*2));

	ctx.imageIsLoaded=true;
	*/
	return StateMag::S_IDLE;
}

// STATE:[S_IDLE] - [Btu openIMG]
Tirth::StateMag::State Tirth::QGLPanel::openImageByIMID()
{
	std::cout<<"start loading img:"<<ctx.targetImgID <<std::endl;

	Eigen::MatrixXd tarimid(1,1);
	tarimid<<ctx.targetImgID ;

	//matEng.sendMat("tarImgId",tarimid);
	//matEng.exec( "[sce,validinpImg]=g9_se.iniLoader(tarImgId,gValue);"
	//	"inp = validinpImg; "
	//	);
	loadByteImg(ctx.inputQImg,"inp",QImage::Format_RGB888);

	ctx.imageIsLoaded=true;

	return StateMag::S_IDLE;

}

// STATE:[S_IDLE] - [Btu REopenIMG]
Tirth::StateMag::State Tirth::QGLPanel::reopenImageByIMID()
{

	resetStateCtx(ctx);

	std::cout<<"start loading img:"<<ctx.targetImgID <<std::endl;

	Eigen::MatrixXd tarimid(1,1);
	tarimid<<ctx.targetImgID ;

	//matEng.sendMat("tarImgId",tarimid);
	//matEng.exec( 
	//	"clear sce pstate;"
	//	"[sce,validinpImg]=g9_se.iniLoader(tarImgId,gValue);"
	//	"inp = validinpImg;"
	//	);

	loadByteImg(ctx.inputQImg,"inp",QImage::Format_RGB888);

	ctx.imageIsLoaded=true;

	return StateMag::S_IDLE;

}
 
// STATE:[S_IDLE] - [Btu FilterSP]
Tirth::StateMag::State Tirth::QGLPanel::filterSPbyNum()
{ 
	//filter
	// check loaded
	if( ctx.spIsLoaded ){

		//retrieve bigger group
		// at now, direct retrieve object mask 
		//matEng.exec("objmask=g7_hy.g7_getObjMask(sce);");

		loadByteU8Mask(ctx.objGroupImg,"objmask");

		if(!ctx.objGroupImg.hasAlphaChannel()){
			//edgeMask.fromImage(test_segImg.createMaskFromColor(QRgb(0xffffffff)));
			ctx.objGroupImg=ctx.objGroupImg.convertToFormat(QImage::Format_ARGB32);
		}

		//ctx.objGroupImg.save("pre_qimg.png");

		setAlpha(ctx.objGroupImg, 0 , 200);

		bindQImage2cvmat(ctx.objGroupImg , ctx.objGroupCvImg );

		ctx.spIsFilted=true;
	}
	return StateMag::S_IDLE;
}

// STATE:[S_IDLE] - [Btu FilterSP]
Tirth::StateMag::State Tirth::QGLPanel::filterSPbyNum_gt()
{ 
	// BIND objLabelGidImg_gt

	// check loaded
	if( ctx.gt_objMapIsLoaded ){ 
		//reset 
		room_isDone_gt(); 
		if(!ctx.objLabelGidImg_gt.hasAlphaChannel()){
			//edgeMask.fromImage(test_segImg.createMaskFromColor(QRgb(0xffffffff)));
			ctx.objLabelGidImg_gt=ctx.objLabelGidImg_gt.convertToFormat(QImage::Format_ARGB32);
		}

		//bind to rgba map
		bindQImage2cvmat(ctx.objLabelImg_gt , ctx.objGroupCvImg ); 

		ctx.spIsFilted=true;

		std::cout<<"spfilled: binded\n";
	}
	return StateMag::S_IDLE;
}

// STATE:[S_IDLE] - [Btu EXBox]:switch2ExBox
Tirth::StateMag::State Tirth::QGLPanel::box_switch2ExBox()
{

	if(ctx.spIsFilted){
		//ctx.boxes2dQImg.save("beffill.png");
		ctx.boxes2dQImg.fill(0x0000000);
		//ctx.boxes2dQImg.save("aftfill.png");
		ctx.exBoxIsDone=false; 
		ctx.exBoxLoaded=false;
		ctx.boxVertices_aft.clear();
		ctx.boxVertices_bef.clear();
		static char matCmd[512]={0}; 
		//matEng.exec("clear exbVis ;sce.boxes={};");
		return StateMag::S_EXBOX; 

	}else{
		return StateMag::S_IDLE;
	}

}


// STATE:[S_EXBOX] - [Mouse Release]
Tirth::StateMag::State Tirth::QGLPanel::exbox_mRelease()
{   
	static char matCmd[512]={0};
	// receive CLICK action
	int ix=ctx.lastPos.x();
	int iy=ctx.lastPos.y();

	if( ctx.lastBtu == Qt::LeftButton ){

		// sample gid map
		if(ctx.cutSPL3_mid.valid(ix,iy)){

			int mid = qRed(ctx.cutSPL3_mid.pixel(ix,iy));
			std::cout<<"box gid="<<mid<<std::endl;

			memset(matCmd,0,sizeof(matCmd));

			if( !ctx.exBoxLoaded ){
				sprintf(matCmd,"exbVis=g9_se.g9_exboxhelper(sce,%d);",mid); 
			}else{
				sprintf(matCmd,"exbVis=g9_se.g9_exboxhelper(sce,%d,exbVis);",mid); 
			}

			//matEng.exec(matCmd);

			try{
				loadByteImg(ctx.boxes2dQImg,"exbVis",QImage::Format_RGB888);
				ctx.exBoxLoaded=true;
			}catch(const char* msg){
				printf("excep: %s\n",msg);
			}
		}
	}

	return StateMag::S_EXBOX;
}

// STATE:[S_EXBOX] - [Mouse Release]
Tirth::StateMag::State Tirth::QGLPanel::exbox_mRelease_gt_cut()
{
	static char matCmd[512]={0};

	// receive CLICK action
	int ix=ctx.lastPos.x();
	int iy=ctx.lastPos.y();

	if( ctx.lastBtu == Qt::LeftButton ){ 
		// sample gid map
		if(ctx.cutSPL3_mid.valid(ix,iy)){

			int mid = qRed(ctx.cutSPL3_mid.pixel(ix,iy));
			std::cout<<"box gid="<<mid<<std::endl;

			if(mid==0){	
				std::cout<<"leave\n";
				return StateMag::S_EXBOX;

			}


			memset(matCmd,0,sizeof(matCmd));

			if( !ctx.exBoxLoaded ){
				sprintf(matCmd,"exbVis=g9_se.g9_exboxhelper_gt(sce,%d);",mid); 
			}else{
				sprintf(matCmd,"exbVis=g9_se.g9_exboxhelper_gt(sce,%d,exbVis);",mid); 
			}

			//matEng.exec(matCmd);

			try{
				//loadByteImg(ctx.boxes2dQImg,"exbVis",QImage::Format_RGB888);
				getBox3DVerts();
				ctx.exBoxLoaded=true;

			}catch(const char* msg){
				printf("excep: %s\n",msg);
			}
		}
	}

	return StateMag::S_EXBOX;
}
// STATE:[S_EXBOX] - [Mouse Release]
Tirth::StateMag::State Tirth::QGLPanel::exbox_mRelease_gt()
{
	static char matCmd[512]={0};

	// receive CLICK action
	int ix=ctx.lastPos.x();
	int iy=ctx.lastPos.y();

	if( ctx.lastBtu == Qt::LeftButton ){ 
		// sample gid map
		if(ctx.objLabelGidImg_gt.valid(ix,iy) && ctx.objLabelGidImg_gt.pixel(ix,iy) ){

			int mid = qRed(ctx.objLabelGidImg_gt.pixel(ix,iy));
			std::cout<<"box gid="<<mid<<std::endl;

			memset(matCmd,0,sizeof(matCmd));

			if( !ctx.exBoxLoaded ){
				sprintf(matCmd,"exbVis=g9_se.g9_exboxhelper_gt(sce,%d);",mid); 
			}else{
				sprintf(matCmd,"exbVis=g9_se.g9_exboxhelper_gt(sce,%d,exbVis);",mid); 
			}

			//matEng.exec(matCmd);

			try{
				//loadByteImg(ctx.boxes2dQImg,"exbVis",QImage::Format_RGB888);
				getBox3DVerts();
				ctx.exBoxLoaded=true;

			}catch(const char* msg){
				printf("excep: %s\n",msg);
			}
		}
	}

	return StateMag::S_EXBOX;
}

// STATE:[S_EXBOX] - [Mouse Move]
Tirth::StateMag::State Tirth::QGLPanel::exbox_mMove()
{
	return StateMag::S_EXBOX;
}

// STATE:[SEX_BOX] - [EXBOX is DONE]-bind with Btu_Actdone
Tirth::StateMag::State Tirth::QGLPanel::exbox_actionDone()
{
	std::cout<<"calculate boxes features..";
	//matEng.exec("sce.extractOBBFeatuers_V2(); sce=g9_se.g9_exsgraph(sce);");
	std::cout<<"---done\n";

	ctx.exBoxIsDone=true;
	return StateMag::S_IDLE;
}

// STATE:[S_IDLE] - [Btu PREDICT]:switch2Predict
Tirth::StateMag::State Tirth::QGLPanel::predict_switch2PD()
{

	if( ctx.exBoxIsDone && !ctx.predicIsMaded ){

		//start initial prediction 
		ctx.predicIsMaded = false;
		std::cout<<"start prediction..\n";

		//matEng.exec("pstate=g9_se.predictHelper_tC_ini(sce,[],[],[],mixModel,gValue);"
		//	"; boxCenter=pstate.boxCenter; resultXlid=pstate.resultXlid ; resDesStr=pstate.resDesStr ; resultCost=pstate.resultCost ; "
		//	); 
		try{
			//Nx2
			Eigen::MatrixXi mbCenters;
			Eigen::MatrixXi mPredLIDs;
			Eigen::MatrixXd currentCost; 

			//string split by '^'
			Eigen::MatrixXi ansStrs;

			//matEng.receiveMat( "boxCenter",mbCenters );

			// 6xN
			//matEng.receiveMat( "resultXlid",mPredLIDs );

			// 1x6 global cost
			//matEng.receiveMat( "resultCost",currentCost );

			//charing 
			//matEng.receiveMat( "resDesStr",ansStrs );

			// -------------------------------------------------------------------------  
			// handle parsing and save to CTX
			inner_predict(mbCenters,mPredLIDs,currentCost,ansStrs);

			// update box vps
			getBox3DVerts();

			// -------------------------------------------------------------------------  
			// DONE
			ctx.predicIsMaded = true; 
			emit requestClearLabel();
			emit tagIsReady(); 

		}catch (const char* emsg){
			std::cout<<emsg<<std::endl;
			//early exit
		}

		return StateMag::S_PREDICT;  

	}else if ( ctx.predicIsMaded ){

		emit tagIsReady();  
		return StateMag::S_PREDICT;  

	}else{
		return StateMag::S_IDLE;
	}
}

// original use for refined func.
// the main task is same as in re_pred
void Tirth::QGLPanel::getBoxLIDStuff(){

	/*// extract FIXED list
	// std::vector<int>  changedFlag;
	Eigen::MatrixXf eLockFlag;
	eLockFlag.resize(1,ctx.boxDatas.size());
	for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

	int iniLid = ctx.boxDatas[k].getIniLID();

	int locked = ctx.boxDatas[k].getConfirmed();

	int touched = ctx.boxDatas[k].getTouched(); //swapped

	//changedFlag.push_back(iniLid!=newLIDs[k]);
	eLockFlag(0,k) = static_cast<float>( locked || touched );

	} 

	// re-collect data touch by USER
	std::vector<int> newLIDs;
	Eigen::MatrixXf eNewLIDs;
	Eigen::MatrixXf excludeLabelFlag;

	excludeLabelFlag.resize(1,ctx.boxDatas.size());
	eNewLIDs.resize(1,ctx.boxDatas.size());

	debugPrint("START checking new label...");
	for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

	QList<int> const & lidlist  = ctx.boxDatas[k].getPredTagLIDs();

	//the first one is the current selected IDs
	int k_lid = lidlist[0];

	// if it's edited ID --check this is NEW label or not
	if(k_lid== ctx.NEW_LABEL_LID ){
	//check the label is NEW LABEL or the existed one

	std::string ltag= ctx.boxDatas[k].getTagStr(0).toStdString();
	auto tmpResIter = ctx.nyuLabelMap.find(ltag);

	if( ctx.nyuLabelMap.end() != tmpResIter ){
	// existed label
	k_lid = tmpResIter->second; //str,int
	excludeLabelFlag(0,k)=(0);
	debugPrint("get a existed label");

	}else{
	k_lid= ctx.NEW_LABEL_LID ;
	// this is the new label**
	excludeLabelFlag(0,k)=(1);
	debugPrint("get a new label");
	} 

	// mark FIXED --since this is user's input
	eLockFlag(0,k)=1;

	}else{
	excludeLabelFlag(0,k)=(0);
	}

	newLIDs.push_back(k_lid); 
	eNewLIDs(0,k)=k_lid;
	}


	std::cout<<"lid :"<<eNewLIDs<<std::endl;
	std::cout<<"lock flag:"<<eLockFlag<<std::endl; 

	// sent to Matlab
	//matEng.sendMat("rep_newlids",eNewLIDs);
	//matEng.sendMat("rep_newFixedFlag",eLockFlag);
	//matEng.sendMat("rep_newLabelFlag",excludeLabelFlag);  */
}
   
    
// STATE:[PREDICTION] - [predict_rePred] 
Tirth::StateMag::State Tirth::QGLPanel::predict_rePred() 
{
	if( ctx.exBoxIsDone && ctx.predicIsMaded ){ 
		// extract FIXED list
		// std::vector<int>  changedFlag;
		Eigen::MatrixXf eLockFlag;
		eLockFlag.resize(1,ctx.boxDatas.size());

		for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

			int iniLid = ctx.boxDatas[k].getIniLID(); 
			int locked = ctx.boxDatas[k].getConfirmed(); 
			int touched = ctx.boxDatas[k].getTouched(); //swapped

			//changedFlag.push_back(iniLid!=newLIDs[k]);
			eLockFlag(0,k) = static_cast<float>( locked || touched ); 
		}

		//guard - early exit
		//if( eLockFlag.sum() == ctx.boxDatas.size() ){
		//	// all lock -- early exit
		//	std::cout<<"all fixed \n";
		//	emit tagIsReady();
		//	return StateMag::S_PREDICT;  
		//}

		// re-collect data touch by USER
		std::vector<int> newLIDs;
		Eigen::MatrixXf eNewLIDs;
		Eigen::MatrixXf excludeLabelFlag;

		excludeLabelFlag.resize(1,ctx.boxDatas.size());
		eNewLIDs.resize(1,ctx.boxDatas.size());

		debugPrint("START checking new label...");
		for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

			QList<int> const & lidlist  = ctx.boxDatas[k].getPredTagLIDs();

			//the first one is the current selected IDs
			int k_lid = lidlist[0];

			// if it's edited ID --check this is NEW label or not
			if( k_lid == BoxData::EDITED_LABEL_LID ){
				//check the label is NEW LABEL or the existed one

				std::string ltag= ctx.boxDatas[k].getTagStr(0).toStdString();
				auto tmpResIter = ctx.nyuLabelMap.find(ltag);

				if( ctx.nyuLabelMap.end() != tmpResIter ){
					// existed label
					k_lid = tmpResIter->second; //str,int
					excludeLabelFlag(0,k)=(0);
					//debugPrint("get a existed label");

				}else{
					k_lid = BoxData::NEW_LABEL_LID;

					// this is the new label
					excludeLabelFlag(0,k)=(1);
					debugPrint("get a new label");
				} 

				// mark FIXED --since this is user's input
				eLockFlag(0,k)=1;

			}else if( k_lid == BoxData::FLOATING_LID ){ 
				excludeLabelFlag(0,k)=(0); 
			}else{
				excludeLabelFlag(0,k)=(0);
			}

			newLIDs.push_back(k_lid); 
			eNewLIDs(0,k)=k_lid;
		}


		//debug print
		std::cout<<"boxCenter:";
		for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){
			std::cout<<ctx.boxDatas[k].getBoxCx()<<","<<ctx.boxDatas[k].getBoxCy()<<" | ";

		}

		std::cout<<"lid :"<<eNewLIDs<<std::endl;
		std::cout<<"lock flag:"<<eLockFlag<<std::endl;

		// sent to Matlab
		//matEng.sendMat("rep_newlids",eNewLIDs);
		//matEng.sendMat("rep_newFixedFlag",eLockFlag);
		//matEng.sendMat("rep_newLabelFlag",excludeLabelFlag);

		//-------------------------------------------------------------------------

		//start initial prediction 
		ctx.predicIsMaded = false;
		std::cout<<"start prediction..\n";

		////matEng.exec("[resultXlid,resultCost,resDesStr,boxCenter]=g7_hy.g7_randPredictREDO(sce,rep_newlids,rep_newFixedFlag,rep_newLabelFlag,ikea_model , nyu_model , attr_model , gValue);");
		////matEng.exec("[resultXlid, resultCost, resDesStr, boxCenter]=g8_sl.predictHelperV2(rep_newlids ,sce ,rep_newFixedFlag , rep_newLabelFlag,  nyuModel , gValue);");

		//matEng.exec("close all;"
		//	"pstate=g9_se.predictHelper_tC_re( pstate, sce, rep_newlids, rep_newFixedFlag , rep_newLabelFlag, mixModel ,gValue);"
		//	"boxCenter=pstate.boxCenter; resultXlid=pstate.resultXlid ; resDesStr=pstate.resDesStr ; resultCost=pstate.resultCost ; "
		//	"allDone = double(pstate.alldone);"
		//	);
		//Nx2
		Eigen::MatrixXi mbCenters;
		Eigen::MatrixXi mPredLIDs;
		Eigen::MatrixXd currentCost; 
		Eigen::MatrixXd allDone;

		//string split by '^'
		Eigen::MatrixXi ansStrs;

		try{
			//matEng.receiveMat("boxCenter",mbCenters);
			// 6xN
			//matEng.receiveMat("resultXlid",mPredLIDs ); 
			// 1x6 global cost
			//matEng.receiveMat("resultCost",currentCost); 
			//charing 
			//matEng.receiveMat("resDesStr",ansStrs); 
			//
			//matEng.receiveMat("allDone",allDone); 
			//-------------------------------------------------------------------------
			// handle parsing and save to CTX
			inner_predict(mbCenters,mPredLIDs,currentCost,ansStrs);

			//update box 3d vpts
			getBox3DVerts(); 

			//-------------------------------------------------------------------------
			// DONE
			ctx.predicIsMaded = true; 

			emit requestClearLabel();
			emit tagIsReady(); 

			if(allDone(0)==1){
				//all done
				printf("ENTER final mdoe\n");
				return StateMag::S_FINAL;  
			}else{
				return StateMag::S_PREDICT;
			}

		}catch (const char* emsg){
			std::cout<<emsg<<std::endl;
			//early exit
			return StateMag::S_PREDICT;
		} 

	}else{
		return StateMag::S_IDLE;
	} 

}

void Tirth::QGLPanel::inner_predict(Eigen::MatrixXi& bcenter ,Eigen::MatrixXi& preBoxLid , Eigen::MatrixXd& gCost ,Eigen::MatrixXi& lStrs)
{ 
	//--------------------------------------------------
	// [convert DesString]
	std::string ansSTDStr(lStrs.count(),0);
	int * pd = lStrs.data();
	for(int i=0 ; i< lStrs.count() ; i++){
		ansSTDStr[i]=static_cast<char>(pd[i]);
	}

	// split each global solution
	istringstream iss0(ansSTDStr); 
	std::string token;
	std::vector<string> tagDesList;
	while (std::getline(iss0, token, '|')) 
	{
		tagDesList.push_back(token);   
	}

	std::vector<std::vector<std::string> > gsol_boxTagDesList;

	// convert ans string == 6 ? 6xN=1
	for(int i=0 ; i < tagDesList.size() ; i++){ 
		istringstream iss(tagDesList[i]); 
		std::string token;  
		std::vector<std::string> tlist ;  
		while (std::getline(iss, token, '^')){ 
			tlist.push_back(token);  
		} 
		gsol_boxTagDesList.push_back(tlist);
	}

	//to QSTring [N][K=6]
	std::vector< QStringList  > pre_boxTagDesList;

	const int NGSOL=gsol_boxTagDesList[0].size();
	const int NBOX=gsol_boxTagDesList.size();

	for( int i=0; i<NBOX ;i++ ){
		pre_boxTagDesList.push_back( QStringList() );

		for( int k=0; k<NGSOL ; k++ ){ 
			pre_boxTagDesList[i].push_back( QString::fromStdString(gsol_boxTagDesList[i][k]) );
		}

	}

	//-------------------------------------------------- 
	// convert data : bcenter, boxTagDesList
	// convert LID 
	std::vector< std::vector<int> > pre_boxLIDs;

	// 6 x N --  LID
	for( int i=0 ; i < preBoxLid.cols() ; i++ ){
		pre_boxLIDs.push_back(std::vector<int>());
		for( int j=0; j < preBoxLid.rows() ; j ++ ){
			pre_boxLIDs[i].push_back( preBoxLid(j,i) );
		}
	}

	// Nx2 -- convert boxes center
	std::vector< std::vector<int> > boxCenters;
	for(int i=0 ; i < bcenter.rows() ; i++ ){

		boxCenters.push_back(std::vector<int>());
		boxCenters[i].push_back( bcenter(i,0) );
		boxCenters[i].push_back( bcenter(i,1) );

	}
	// convert global solution cost
	QList<float> boxPGCost ;

	// 1D global cost list
	for( int i=0 ; i < gCost.rows() ;i++ ){
		//boxPCost.push_back(std::vector<float>());
		for( int j=0; j < gCost.cols() ; j ++ ){
			boxPGCost.push_back( gCost(i,j) );
		}
	}

	//---------------------------------------------------------
	// n^2
	//remove duplicate AND keep LIDs & strs Consistent
	std::vector< std::vector<int> > boxLIDs;
	std::vector< QStringList > boxTagDesList;

	for( int k=0; k<pre_boxTagDesList.size() ;k++ ){

		boxTagDesList.push_back(QStringList());
		boxLIDs.push_back(std::vector<int>() );

		for( int i=0; i < pre_boxTagDesList[k].size() ; i++){

			QString curStr = pre_boxTagDesList[k][i];
			int curLID = pre_boxLIDs[k][i];

			bool isUnique=true;
			for( int v=0; v<boxTagDesList[k].size();v++ ){
				if( boxTagDesList[k][v]==curStr ){
					isUnique=false;
					break;
				}
			}
			//========================================================
			// hacking
			//========================================================
			if(isUnique){
				//QString shorter(1,curStr[0]);
				//boxTagDesList[k].push_back(shorter);
				boxTagDesList[k].push_back(curStr);
				boxLIDs[k].push_back(curLID);
			} 
			//========================================================
			//========================================================

		}
	}


	// SAVE into CTX
	bool sizeIsGood = (boxCenters.size() ==  boxLIDs.size() 
		&& boxCenters.size() == boxTagDesList.size() 
		&& boxPGCost.size()  == boxTagDesList[0].size() 
		&& boxPGCost.size()  == boxLIDs[0].size() );

	if( !sizeIsGood ){
		std::cout
			<<"SIZE CHEKC******"
			<<"boxCenters "   <<boxCenters.size()<<"\n"
			<<"boxTagDesList "<<boxTagDesList.size()<<"\n"
			<<"boxLIDs "  <<boxLIDs.size()<<"\n"
			<<"boxPGCost "<<boxPGCost.size()<<"\n";
	}


	// initial ctx storage data
	ctx.predicIsMaded=false;

	//debugPrint("------PRE-CLEAR boxDatas-------");
	vector<BoxData> mirror(ctx.boxDatas);
	ctx.boxDatas.clear(); 
	debugPrint("------AFT-CLEAR boxDatas-------");

	// initial all BOXDATA
	for( int i=0; i < boxCenters.size() ; i++ ){

		if( boxLIDs[i][0] != BoxData::NEW_LABEL_LID ){
			// normal case
			ctx.boxDatas.push_back( 
				BoxData( boxCenters[i][0],boxCenters[i][1],
				boxLIDs[i], boxPGCost ,boxTagDesList[i]) );  
		}else{
			//ctx.boxDatas.push_back(
			//	BoxData( boxCenters[i][0],boxCenters[i][1],
			//	boxLIDs[i], mirror[i].getPredCost() ,mirror[i].getPredTags()) ); // excluded -> not change
			GCOST_TYPE newCost;
			newCost.push_back(mirror[i].getPredCost()[0]);
			QList<QString> newDesList;
			newDesList.push_back(mirror[i].getPredTags()[0]);

			ctx.boxDatas.push_back(
				BoxData( boxCenters[i][0],boxCenters[i][1],
				boxLIDs[i],  newCost , newDesList) ); // excluded -> not change
		}
		//keep editing record 
		if( mirror.size() ){ 
			ctx.boxDatas[i].setTouched(mirror[i].getTouched());
			ctx.boxDatas[i].setConfirmed(mirror[i].getConfirmed());
			ctx.boxDatas[i].setEdited(mirror[i].getEdited());
		}
	}


}

Tirth::StateMag::State Tirth::QGLPanel::predict_confirmAll()
{
	if( ctx.exBoxIsDone && ctx.predicIsMaded ){ 
		// extract FIXED list
		// std::vector<int>  changedFlag;
		Eigen::MatrixXf eLockFlag;
		eLockFlag.resize(1,ctx.boxDatas.size());
		eLockFlag.setOnes();

		// re-collect data touch by USER
		std::vector<int> newLIDs;
		Eigen::MatrixXf eNewLIDs;
		Eigen::MatrixXf excludeLabelFlag;

		excludeLabelFlag.resize(1,ctx.boxDatas.size());
		eNewLIDs.resize(1,ctx.boxDatas.size());

		debugPrint("START checking new label...");
		for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

			QList<int> const & lidlist  = ctx.boxDatas[k].getPredTagLIDs();

			//the first one is the current selected IDs
			int k_lid = lidlist[0];

			// if it's edited ID --check this is NEW label or not
			if( k_lid == BoxData::EDITED_LABEL_LID ){
				//check the label is NEW LABEL or the existed one

				std::string ltag= ctx.boxDatas[k].getTagStr(0).toStdString();
				auto tmpResIter = ctx.nyuLabelMap.find(ltag);

				if( ctx.nyuLabelMap.end() != tmpResIter ){
					// existed label
					k_lid = tmpResIter->second; //str,int
					excludeLabelFlag(0,k)=(0);
					//debugPrint("get a existed label");

				}else{
					k_lid = BoxData::NEW_LABEL_LID;

					// this is the new label
					excludeLabelFlag(0,k)=(1);
					debugPrint("get a new label");
				} 

				// mark FIXED --since this is user's input
				eLockFlag(0,k)=1;

			}else if( k_lid == BoxData::FLOATING_LID ){ 
				excludeLabelFlag(0,k)=(0); 
			}else{
				excludeLabelFlag(0,k)=(0);
			}

			newLIDs.push_back(k_lid); 
			eNewLIDs(0,k)=k_lid;
		}


		//debug print
		std::cout<<"boxCenter:";
		for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){
			std::cout<<ctx.boxDatas[k].getBoxCx()<<","<<ctx.boxDatas[k].getBoxCy()<<" | ";

		}

		std::cout<<"lid :"<<eNewLIDs<<std::endl;
		std::cout<<"lock flag:"<<eLockFlag<<std::endl;

		// sent to Matlab
		//matEng.sendMat("rep_newlids",eNewLIDs);
		//matEng.sendMat("rep_newFixedFlag",eLockFlag);
		//matEng.sendMat("rep_newLabelFlag",excludeLabelFlag);

		//-------------------------------------------------------------------------

		//start  prediction 
		ctx.predicIsMaded = false;
		std::cout<<"start prediction..\n";
		////matEng.exec("[resultXlid,resultCost,resDesStr,boxCenter]=g7_hy.g7_randPredictREDO(sce,rep_newlids,rep_newFixedFlag,rep_newLabelFlag,ikea_model , nyu_model , attr_model , gValue);");
		////matEng.exec("[resultXlid, resultCost, resDesStr, boxCenter]=g8_sl.predictHelperV2(rep_newlids ,sce ,rep_newFixedFlag , rep_newLabelFlag,  nyuModel , gValue);");
		//matEng.exec("pstate=g9_se.predictHelper_tC_re( pstate, sce, rep_newlids, rep_newFixedFlag , rep_newLabelFlag, mixModel ,gValue);"
		//	"boxCenter=pstate.boxCenter; resultXlid=pstate.resultXlid ; resDesStr=pstate.resDesStr ; resultCost=pstate.resultCost ; "
		//	"allDone = double(pstate.alldone);"
		//	);
		//Nx2
		Eigen::MatrixXi mbCenters;
		Eigen::MatrixXi mPredLIDs;
		Eigen::MatrixXd currentCost; 

		//string split by '^'
		Eigen::MatrixXi ansStrs;

		try{
			//matEng.receiveMat("boxCenter",mbCenters);
			// 6xN
			//matEng.receiveMat("resultXlid",mPredLIDs ); 
			// 1x6 global cost
			//matEng.receiveMat("resultCost",currentCost); 
			//charing 
			//matEng.receiveMat("resDesStr",ansStrs); 
			//-------------------------------------------------------------------------
			// handle parsing and save to CTX
			inner_predict(mbCenters,mPredLIDs,currentCost,ansStrs);

			//update box 3d vpts
			getBox3DVerts();

			//-------------------------------------------------------------------------
			// DONE
			ctx.predicIsMaded = true; 
			emit requestClearLabel();
			emit tagIsReady(); 

			return StateMag::S_FINAL;

		}catch (const char* emsg){
			std::cout<<emsg<<std::endl;
			//early exit
			return StateMag::S_PREDICT;  
		} 

	}else{

		// normal EXIT
		std::cout<<"-- LABELING DONE -- \n";

		return StateMag::S_IDLE;
	} 

}

// STATE:[S_IDLE] - [Btu PREDICT]:predict_actionDone
Tirth::StateMag::State Tirth::QGLPanel::predict_actionDone()
{
	/*
	if( YNDialog("are you sure to LEACE predict mode?") ){

	return StateMag::S_IDLE;

	} 
	else
	{

	return StateMag::S_PREDICT;
	}
	*/
	return StateMag::S_PREDICT;

}


Tirth::StateMag::State Tirth::QGLPanel::predict_mPress()
{
	if( ctx.lastBtu == Qt::LeftButton ){
		tball.startMotion(ctx.lastPos.x(),ctx.lastPos.y());
	}else{
		tball.reset();
	} 
	return StateMag::S_PREDICT;

}

Tirth::StateMag::State Tirth::QGLPanel::predict_mMove()
{
	if( ctx.lastBtu == Qt::LeftButton ){
		tball.mouseMotion(ctx.lastPos.x(),ctx.lastPos.y());

	}
	return StateMag::S_PREDICT;

}

Tirth::StateMag::State Tirth::QGLPanel::predict_mRelease()
{

	if( ctx.lastBtu == Qt::LeftButton ){
		tball.stopMotion(ctx.lastPos.x(),ctx.lastPos.y());

	}
	return StateMag::S_PREDICT;

}


void Tirth::QGLPanel::getBox3DVerts()
{
	//matEng.exec("[vlist]=toolkit_g8_sl.getBoxVertices(sce) ;");

	// retrieve vertices data
	Eigen::MatrixXd boxVpMat;

	//matEng.receiveMat("vlist",boxVpMat);
	std::cout<<"vlist :"<<boxVpMat.rows()<<","<<boxVpMat.cols() <<std::endl;

	// watch out for the array being reallocated  
	//tx vertices to flat data                         
	if( ctx.boxVertices_aft.size() ){
		ctx.boxVertices_bef=ctx.boxVertices_aft;
	}

	ctx.boxVertices_aft.clear();
	ctx.boxVertices_bef.clear();

	// push original boxes
	for( int i=0 ; i<boxVpMat.cols() ;i++ ){
		std::vector<GLfloat> boxv; 

		for( int j=0 ; j < boxVpMat.rows() ; j ++){
			boxv.push_back(boxVpMat(j,i));
		}
		ctx.boxVertices_aft.push_back(boxv);
	} 

	//matEng.exec("clear vlist;"); 
}


Tirth::StateMag::State Tirth::QGLPanel::refbox_doref()
{
	// perform refinement action
	if( ctx.exBoxIsDone ){
		/* DISABLE

		getBoxLIDStuff();

		//"if ~exist('rep_newLabelFlag','var') rep_newLabelFlag=[];end; "

		//matEng.exec(
		" [sce,vlist]=g8_sl.refine_box(sce,rep_newLabelFlag,nyuModel,rep_newlids);"
		"");

		// retrieve vertices data
		Eigen::MatrixXd boxVpMats;

		//matEng.receiveMat("vlist",boxVpMats);

		// watch out for the array being reallocated  

		// tx vertices to flat data
		ctx.boxVertices_aft.clear();
		for( int i=0 ; i<boxVpMats.cols() ;i++ ){
		std::vector<GLfloat> boxv; 

		for( int j=0 ; j < boxVpMats.rows() ; j ++){
		boxv.push_back(boxVpMats(j,i));
		}

		ctx.boxVertices_aft.push_back(boxv);
		}

		//matEng.exec("clear vlist;");
		*/

	}

	return StateMag::S_REFINE_BOX;
}

Tirth::StateMag::State Tirth::QGLPanel::refbox_switch2RefBox()
{

	// dep 

	//exec refine boxes

	tball.setHeight(480);
	tball.setWidth(640);

	// get vertices
	if( ctx.exBoxIsDone ){
		getBox3DVerts();
	}

	return StateMag::S_REFINE_BOX;

}

Tirth::StateMag::State Tirth::QGLPanel::refbox_mPress()
{
	if( ctx.lastBtu == Qt::LeftButton ){
		tball.startMotion(ctx.lastPos.x(),ctx.lastPos.y());
	}else{
		tball.reset();
	}

	return StateMag::S_REFINE_BOX;
}

Tirth::StateMag::State Tirth::QGLPanel::refbox_mMove()
{
	if( ctx.lastBtu == Qt::LeftButton ){
		tball.mouseMotion(ctx.lastPos.x(),ctx.lastPos.y());

	}
	return StateMag::S_REFINE_BOX;

}

Tirth::StateMag::State Tirth::QGLPanel::refbox_mRelease()
{

	if( ctx.lastBtu == Qt::LeftButton ){
		tball.stopMotion(ctx.lastPos.x(),ctx.lastPos.y());

	}
	return StateMag::S_REFINE_BOX;

}

// STATE:[S_IDLE] - [Btu PREDICT]:predict_actionDone
Tirth::StateMag::State Tirth::QGLPanel::final_actionDone()
{

	//if( YNDialog("auto SAVE labeling result ?") ){

	//	final_saveFinalLabel();

	//} 
	return StateMag::S_IDLE;
}

Tirth::StateMag::State Tirth::QGLPanel::final_saveFinalLabel()
{ 
	static char savPath[2048]={0};
	static char scmd[2048]={0};

	if( ctx.currentState == StateMag::S_FINAL && ctx.finalSavPath != NULL ){

		// get all des tag
		int lid;
		std::string tag;
		std::string allTag;
		for( int k=0; k < ctx.boxDatas.size() ; k++ ){
			tag.clear();
			ctx.boxDatas[k].getMainTag(lid,tag);
			allTag.append(tag);
			allTag.append("|");
		}

		float *resTag=new float[allTag.size()];

		for( int i=0 ; i < allTag.size() ; i++ ){
			resTag[i]=allTag[i];
		}

		Eigen::MatrixXf e_resTags = Eigen::Map<Eigen::MatrixXf>(resTag,1,allTag.size());
		//matEng.sendMat("resBoxTags",e_resTags);

		float *editFlag=new float[ctx.boxDatas.size()];
		for( int i=0 ; i < ctx.boxDatas.size() ; i++ ){
			editFlag[i]=ctx.boxDatas[i].getEdited();
		}

		Eigen::MatrixXf e_editLog = Eigen::Map<Eigen::MatrixXf>(editFlag,1,ctx.boxDatas.size());
		//matEng.sendMat("editedLog",e_editLog);

		float *touchFlag=new float[ctx.boxDatas.size()];
		for( int i=0 ; i < ctx.boxDatas.size() ; i++ ){
			touchFlag[i]=ctx.boxDatas[i].getTouched();
		}

		Eigen::MatrixXf e_touchLog = Eigen::Map<Eigen::MatrixXf>(touchFlag,1,ctx.boxDatas.size());
		//matEng.sendMat("touchLog",e_touchLog);

		//---------------------------------------------------
		memset(savPath,0,sizeof(savPath));
		memset(scmd,0,sizeof(savPath));

		sprintf(savPath,"%s/f_sce_%d.mat",ctx.finalSavPath,ctx.targetImgID); 
		sprintf(scmd,
			"pstate.log.resBoxTags=char(resBoxTags);"
			"pstate.log.editedLog=editedLog;"
			"pstate.log.touchLog=touchLog;"
			"save('%s','sce','pstate');",savPath);

		//matEng.exec(scmd);
		std::cout<<"SAVE SCE MAT DONE\n";
		//---------------------------------------------------
		delete [] touchFlag;
		delete [] editFlag;
		delete [] resTag; 
	}

	return StateMag::S_FINAL;
}

//===========================================================================================
//
// reset all state 
void Tirth::QGLPanel::resetStateCtx(StateMag& ctx)
{
	ctx.lastBtu = Qt::NoButton;

	ctx.currentState = StateMag::S_INI;
	ctx.imageIsLoaded = false;
	ctx.floorImgIsLoaded=false;
	ctx.wallImgIsLoaded=false;

	ctx.layoutIsLoaded=false;
	ctx.spIsLoaded=false;
	ctx.spIsFilted=false;
	ctx.exBoxLoaded=false;
	ctx.exBoxIsDone=false;
	ctx.predicIsMaded = false;

	ctx.gt_objMapIsLoaded=false;

	ctx.lineDrawCtx = StateMag::LineDrawContext();

	ctx.lastPos.setX(-1);
	ctx.lastPos.setY(-1);

	ctx.objLabelGidImg_gt.fill(0);
	ctx.objLabelImg_gt.fill(0);
	ctx.inputQImg.fill(0);
	ctx.boxes2dQImg.fill(0);
	ctx.layMaskQimg.fill(0);

	ctx.boxVertices_aft.clear();
	ctx.boxVertices_bef.clear();

	ctx.panelHeight=0;
	ctx.panelWidth=0;
	ctx.boxDatas.clear(); 

	emit requestClearLabel();
}

#pragma endregion CONTROL_FUNC



//-------------------------------------------------------------------------
#pragma region MISC

void Tirth::QGLPanel::handleWindowChanged( QQuickWindow *win )
{ 
	if (win) {
		//! [1]
		// Connect the beforeRendering signal to our paint function.
		// Since this call is executed on the rendering thread it must be
		// a Qt::DirectConnection
		//! [2]
		connect(win, SIGNAL(afterRendering()), this, SLOT(paint_ogl_aft()), Qt::DirectConnection);
		connect(win, SIGNAL(beforeRendering()), this, SLOT(paint_ogl_bef()), Qt::DirectConnection);
		connect(win, SIGNAL(beforeSynchronizing()), this, SLOT(stateSYNC_3drendering()), Qt::DirectConnection);
		//! [2]

		// If we allow QML to do the clearing, they would clear what we paint
		// and nothing would show.
		//! [3]
		win->setClearBeforeRendering(false);
	}
}


void Tirth::QGLPanel::ogl_cleanup()
{ 
	delete m_program;
	m_program = 0;
}


void Tirth::QGLPanel::stateSYNC_3drendering()
{
	//printf("sync\n");
}

// MISC
void Tirth::QGLPanel::warnDialog( const char* MSG)const
{
	//int ret = QMessageBox::warning(this, QString("WARNING"),QString(MSG),QMessageBox::Ok);
}
// MISC
bool Tirth::QGLPanel::YNDialog( const char* MSG)const
{
	//int ret = QMessageBox::warning(this->parent(),QString("WARNING"),QString(MSG),QMessageBox::Yes,QMessageBox::No);
	//return ret>0;
	return true;
}

void Tirth::QGLPanel::debugPrint( const char* msg,const int errlevel/*=0*/ )const
{
	if( errlevel==0 ){
		std::cout<<msg<<std::endl;
	}else{
		std::cout<<msg<<std::endl; 
	}
}


// GL utility
Eigen::Vector2i Tirth::QGLPanel::getImg2dPts( Eigen::Vector3d const & V3 )
{
	Eigen::Vector4d v4;
	v4<<V3,1; 

	Eigen::Matrix4d projMat(this->proj.get());
	Eigen::Matrix4d mvMat(this->mv.get());

	Eigen::Vector4d ndcV4 = projMat*mvMat*v4;

	Eigen::Vector3d ndcV3 = (ndcV4 / ndcV4.w() ).head(3);

	//{0,0,this.imgwidth,this.imgheight};
	Eigen::Vector2i imgV2;

	int* viewMat = viewportMat.get();

	imgV2[0]=static_cast<int>(viewMat[0] + 1.0*viewMat[2]*(ndcV3.x() + 1.0)/2.0 );
	imgV2[1]=static_cast<int>(viewMat[1] + 1.0*viewMat[3]*(ndcV3.y() + 1.0)/2.0 );

	//flip y axis
	imgV2[1] = viewMat[3]-1 - imgV2.y();

	return imgV2;
}

double Tirth::QGLPanel::getDepth( Eigen::Vector3d const & V3 )
{
	double p3[3]={0};

	//int *viewport = new int[4];// {0,0,this.imgwidth,this.imgheight};
	//double x, y, z;	
	//glGetIntegerv( GL_VIEWPORT, viewport);
	//double * MV_MAT = mv.get() ;
	//double * PROJ_MAT = proj.get();
	//gluProject(V3.x() , V3.y() , V3.z() , MV_MAT  , PROJ_MAT, viewport , p3 , p3+1 ,p3+2 );
	//delete viewport;

	Eigen::Matrix4d mv(this->mv.get());
	Eigen::Matrix4d proj(this->proj.get());
	Eigen::Vector4d v4;

	v4 << V3 ,1;

	Eigen::Vector4d v = proj*mv*v4; 
	v = v / v.w();

	return (v.z()+1)/2.0;
}

void Tirth::QGLPanel::loadByteImg( QImage& qimg , const char* VARNAME , QImage::Format FORMAT)
{
	static char matCmd[1024]={0};
	static char varName_tmp[256]={0};
	static char varName_size[256]={0};


	if(FORMAT==QImage::Format_RGB888){

		memset(matCmd,0,sizeof(matCmd));
		memset(varName_tmp,0,sizeof(varName_tmp));
		memset(varName_size,0,sizeof(varName_size));

		sprintf(matCmd,"%s_size=size(%s); %s_tmp1d_qimg=permute(%s,[3,1,2]);"
			"%s_tmp1d_qimg=%s_tmp1d_qimg(:);",VARNAME,VARNAME,VARNAME,VARNAME,VARNAME,VARNAME);
		//matEng.exec(matCmd);

		sprintf(varName_tmp,"%s_tmp1d_qimg",VARNAME);
		sprintf(varName_size,"%s_size",VARNAME);

		// receive 1d data
		Eigen::MatrixXi emat;
		//matEng.receiveMat(varName_tmp,emat);

		// receive data size info
		Eigen::MatrixXf esize;
		//matEng.receiveMat(varName_size,esize);

		Eigen::Matrix<uchar,Eigen::Dynamic,1> emat_2 = emat.cast<uchar>();

		int hs=esize(0);
		int ws=esize(1);
		int nch=esize(2);
		//*
		qimg =QImage(ws,hs,QImage::Format_RGB888);
		qimg.fill(0);

		for( int i=0;i<ws;i++){
			for( int j=0;j<hs;j++){

				// use permute(%s,[3,1,2])
				// EIGEN is column major so..(i,j,3)= change major by 1d addressing
				qimg.setPixel(i,j, qRgb(emat_2(i*hs*3+j*3+0),emat_2(i*hs*3+j*3+1),emat_2(i*hs*3+j*3+2)) );

			}
		}
		/*/
		//Map<MatrixXd>(arrayd, n, n) = matrix 
		//* 
		//inputImgBuff = emat.cast<uchar>();
		//Eigen::Matrix<uchar,Eigen::Dynamic,Eigen::Dynamic> emat_2 = emat.cast<uchar>();

		//binding : Y,X
		qimg =QImage(emat_2.data(),ws,hs,ws*3, QImage::Format_RGB888);
		//*/
		//std::cout<<"img size:"<<esize<<"\nqsize:"<<qimg.width()<<','<<qimg.height()<<":is valid"<<qimg.valid(ws-1,hs-1)<<std::endl;

		//uchar* pp=qimg.bits();

	}else if(FORMAT==QImage::Format_ARGB32 ){

		memset(matCmd,0,sizeof(matCmd));
		memset(varName_tmp,0,sizeof(varName_tmp));
		memset(varName_size,0,sizeof(varName_size));

		sprintf(matCmd,"%s_size=size(%s); %s_tmp1d_qimg=permute(%s,[3,1,2]);"
			"%s_tmp1d_qimg=%s_tmp1d_qimg(:);",VARNAME,VARNAME,VARNAME,VARNAME,VARNAME,VARNAME);
		//matEng.exec(matCmd);

		sprintf(varName_tmp,"%s_tmp1d_qimg",VARNAME);
		sprintf(varName_size,"%s_size",VARNAME);

		// receive 1d data
		Eigen::MatrixXi emat;
		//matEng.receiveMat(varName_tmp,emat);

		// receive data size info
		Eigen::MatrixXf esize;
		//matEng.receiveMat(varName_size,esize);

		Eigen::Matrix<uchar,Eigen::Dynamic,1> emat_2 = emat.cast<uchar>();

		int hs=esize(0);
		int ws=esize(1);
		int nch=esize(2);
		//*
		qimg =QImage(ws,hs,QImage::Format_ARGB32);
		qimg.fill(0);

		for( int i=0;i<ws;i++){
			for( int j=0;j<hs;j++){

				// use permute(%s,[3,1,2])
				// EIGEN is column major so..(i,j,3)= change major by 1d addressing

				qimg.setPixel(i,j, qRgba(emat_2(i*hs*nch+j*nch+0),emat_2(i*hs*nch+j*nch+1),emat_2(i*hs*nch+j*nch+2),emat_2(i*hs*nch+j*nch+3)) );

			}
		}


	}else{
		std::cout<<"FORMAT NOT SUPPORT!\n";
	}
}

void Tirth::QGLPanel::sendQImg( QImage const& qimg, const char* VARNAME ,const char* POST_MCMD)
{ 
	static char matCmd[1024]={0};

	if(std::strlen(POST_MCMD)>700){
		std::cout<<"ERROR -- POSTCMD too long: \n\t["<<POST_MCMD<<"]"<<std::endl;
		return;
	}

	if(QImage::Format_RGB888==qimg.format()){
		std::cout<<"sendQImg: QImage::Format_RGB888 24-bit RGB format \n bytePL:"<<ctx.inputQImg.bytesPerLine()<<std::endl;
	}else{
		std::cout<<"sendQImg: auto convert to RGB , ** QImage is NOT Format_RGB888 :"<<qimg.format()<<std::endl;
		//this->warnDialog("sendQImg: *** QImage is NOT Format_RGB888 :");
		qimg.convertToFormat(QImage::Format_RGB888);
	}

	// row indexing
	// ctx.inputQImg.scanLine
	// return d->data + i_h * d->bytes_per_line; 	
	const uchar *bits = qimg.bits();

	std::unique_ptr<uchar>newData(new uchar[qimg.byteCount()]);
	memcpy( newData.get(), bits, qimg.byteCount() );

	// Note that QImage is row major
	Eigen::MatrixXf eData1d = Eigen::Map< Eigen::Matrix<uchar,Eigen::Dynamic,1> >(newData.get(), qimg.byteCount(),1).cast<float>();

	memset(matCmd,0,sizeof(matCmd));
	sprintf(matCmd,"%s=uint8(reshape(%s,[],%d,%d));"
		"%s=permute(%s,[3,2,1]);"
		"%s",VARNAME,VARNAME,qimg.width(),qimg.height(),VARNAME,VARNAME,POST_MCMD);

	//matEng.sendMat(VARNAME, eData1d );
	//matEng.exec(matCmd); 

}

void Tirth::QGLPanel::loadByteU8Mask( QImage& qimg , const char* VARNAME  )
{
	// MASK version
	//
	static char matCmd[1024]={0};
	static char varName_tmp[256]={0};
	static char varName_size[256]={0}; 

	memset(matCmd,0,sizeof(matCmd));
	memset(varName_tmp,0,sizeof(varName_tmp));
	memset(varName_size,0,sizeof(varName_size));

	// convert to 1d by COL-major addressing
	sprintf(matCmd,"%s_size=[size(%s,1),size(%s,2),size(%s,3)]; %s_tmp1d_mask=permute(%s,[3,1,2]);"
		"%s_tmp1d_mask=%s_tmp1d_mask(:);",VARNAME,VARNAME,VARNAME,VARNAME,VARNAME,VARNAME,VARNAME,VARNAME);

	//matEng.exec(matCmd);

	sprintf(varName_tmp,"%s_tmp1d_mask",VARNAME);
	sprintf(varName_size,"%s_size",VARNAME);

	// receive 1d data
	Eigen::MatrixXi emat;
	//matEng.receiveMat(varName_tmp,emat);

	// receive data size info
	Eigen::MatrixXf esize;
	//matEng.receiveMat(varName_size,esize);

	Eigen::Matrix<uchar,Eigen::Dynamic,1> emat_2 = emat.cast<uchar>();

	int hs=esize(0);
	int ws=esize(1);
	int nch=esize(2);

	if( nch != 1 ){
		std::cout<<"ERR [loadByteMask] - number of channel :"<<nch<<std::endl;
	}
	std::cout<<"recv: hs,ws,nch="<<hs<<","<<ws<<","<<nch<<std::endl;

	//*
	qimg =QImage(ws,hs,QImage::Format_RGB888);
	qimg.fill(0);

	for( int i=0;i<ws;i++){
		for( int j=0;j<hs;j++){

			// use permute(%s,[3,1,2])
			// EIGEN is column major so..(i,j,3)= change major by 1d addressing
			// mask 2 grayRGB
			qimg.setPixel(i,j, qRgb(emat_2(i*hs*nch+j*nch+0),emat_2(i*hs*nch+j*nch+0),emat_2(i*hs*nch+j*nch+0)) );

		}
	} 

}


void Tirth::QGLPanel::setAlpha( QImage& img , int rgbFlag , int alphaVal/*=0*/)
{
	//0xffffff00

	// 0 alpha = transparent

	//set alpha
	QRgb pixelval =0; //uint
	QColor colorVal;

	unsigned int alphaValue = (alphaVal)<<24;
	unsigned int inv_alphaValue = (0xff-alphaVal)<<24;

	for( int u=0 ; u< img.width() ; u++ ){
		for( int v=0; v< img.height() ; v++ ){

			colorVal=img.pixel(u,v);
			//QRgb rgb=colorVal.rgb();
			QRgb rgba=colorVal.rgba();

			if( (rgba & 0xffffff ) == rgbFlag ){
				//it's pure white 

				rgba = (rgba & 0xffffff) | alphaValue;

				img.setPixel(u,v,rgba);
			}else{

				rgba = (rgba & 0xffffff) | inv_alphaValue;

				img.setPixel(u,v,rgba);
			}
		}
	}


}

#pragma endregion MISC


#pragma region BINDING
//UI BINDING
void Tirth::QGLPanel::imidValueChanged( int newID )
{
	ctx.targetImgID = newID;
}

void Tirth::QGLPanel::showBoxCHBSlot(bool val ){
	ctx.ui_showBox=val;
}

void Tirth::QGLPanel::showPredCHBSlot(bool val ){
	ctx.ui_showPredRes=val;
}

void Tirth::QGLPanel::showSegCHBSlot(bool val ){
	ctx.ui_showSeg=val;
}

//-------------------------------------------------------------------------
void Tirth::QGLPanel::setImgID( int imid )
{
	ctx.targetImgID=imid;
}

int Tirth::QGLPanel::getImgID( void )
{
	return ctx.targetImgID;
}

// pass boxes_ptr to QML
QList<QObject*> Tirth::QGLPanel::getBoxData()
{
	ctx.boxDataQList.clear();

	for( int k=0 ; k<ctx.boxDatas.size() ; k++ ){

		ctx.boxDataQList.push_back( &ctx.boxDatas[k] );

	}


	return ctx.boxDataQList;
}

void Tirth::QGLPanel::iniDebugUIBox(){

}


void Tirth::QGLPanel::drawBrushOnImage( QPixmap& img , int x,int y , int rad )
{
	//QPainter painter(img);
	//painter.setBrush(QColor::white);
	//painter.drawEllipse(x,y,rad)

}

QImage Tirth::QGLPanel::cvmat2qimage( cv::Mat const& src )
{

	if( src.channels() == 3 ){

		cv::Mat temp; // make the same cv::Mat
		cvtColor(src, temp,CV_BGR2RGB); // cvtColor Makes a copt, that what i need
		QImage dest((uchar*) temp.data, temp.cols, temp.rows, temp.step, QImage::Format_RGB888);
		QImage dest2(dest);
		dest2.detach(); // enforce deep copy
		return dest2;

	}else if(src.channels() == 4){

		cv::Mat temp; // make the same cv::Mat
		cvtColor(src, temp,CV_BGRA2RGBA); // cvtColor Makes a copt, that what i need
		QImage dest((uchar*) temp.data, temp.cols, temp.rows, temp.step, QImage::Format_ARGB32);
		QImage dest2(dest);

		dest2.detach(); // enforce deep copy
		return dest2;

	}else{

		throw("err");
	}
}

cv::Mat Tirth::QGLPanel::qimage2cvmat( QImage const& src )
{
	cv::Mat result;
	// deep copy just in case (my lack of knowledge with open cv)

	if( src.hasAlphaChannel() ){

		cv::Mat tmp(src.height(),src.width(),CV_8UC4,(uchar*)src.bits(),src.bytesPerLine());
		cvtColor(tmp, result,CV_BGRA2RGBA);

	}else {
		cv::Mat tmp(src.height(),src.width(),CV_8UC3,(uchar*)src.bits(),src.bytesPerLine());
		cvtColor(tmp, result,CV_BGR2RGB);

	}


	return result;
}

void Tirth::QGLPanel::bindCvmat2qimage( cv::Mat & src , QImage & qimg)
{

	if( src.channels() == 3 ){

		cv::Mat temp; // make the same cv::Mat
		cvtColor(src, temp,CV_BGR2RGB); // cvtColor Makes a copy, that what i need
		qimg=QImage((uchar*) temp.data, temp.cols, temp.rows, temp.step, QImage::Format_RGB888);

	}else if(src.channels() == 4){

		cv::Mat temp; // make the same cv::Mat
		cvtColor(src, temp,CV_BGRA2RGBA); // cvtColor Makes a copy, that what i need
		qimg=QImage((uchar*) temp.data, temp.cols, temp.rows, temp.step, QImage::Format_ARGB32);

	}else{

		throw("err");
	}
}

void Tirth::QGLPanel::bindQImage2cvmat( QImage & src , cv::Mat & cvimg)
{ 
	if( src.hasAlphaChannel() || src.format() ==  QImage::Format_ARGB32  ){
		//ARGB
		cvimg=cv::Mat(src.height(),src.width(),CV_8UC4,(uchar*)src.bits(),src.bytesPerLine());
		//cvtColor(cvimg, cvimg ,CV_BGRA2RGBA);
		
	}else if( src.format() ==  QImage::Format_RGB888 ){
		cv::Mat tmp(src.height(),src.width(),CV_8UC3,(uchar*)src.bits(),src.bytesPerLine());
		//cvtColor(cvimg, cvimg ,CV_BGR2RGB);

	}


}



#pragma endregion BINDING
//-------------------------------------------------------------------------

