#ifndef MYSTDAFX_H
#define MYSTDAFX_H
  
//#define _USE_MATH_DEFINES

#define MY_USE_PCL

//#define OPENGL_ES


#include <memory>
#include <iostream>
#include <vector>
#include <deque>
#include <fstream>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <functional>
#include <sstream> 
#include <cmath> 
#include <iterator>
  
#include <QtWidgets>
#include <QMessageBox>
#include <QImage>
#include <QPainter>
#include <QWidget>
#include <QtQuick/qquickwindow.h>
#include <QtGui/QOpenGLShaderProgram>
#include <QtGui/QOpenGLContext> 
#include <QtGui/QOpenGLFramebufferObject> 
#include <QtWidgets/QApplication>
#include <QtQuick/QQuickView>
#include <QQmlContext>
#include <QQuickItem>
#include <QQmlApplicationEngine>   
#include <QApplication>
#include <QDebug>
#include <QOpenGLContext>
#include <QOpenGLFunctions>
#include <QOpenGLTexture>
 
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp> 

//-------------------------------------------------------------------------

#ifdef _DEBUG

#define DEBUG_PR(msg) printf(msg);


#pragma comment(lib,"opencv_core246d.lib")
#pragma comment(lib,"opencv_imgproc246d.lib")
#pragma comment(lib,"opencv_highgui246d.lib")
#pragma comment(lib,"libsvm.lib")

#pragma comment(lib , "libboost_serialization-vc100-mt-gd-1_49.lib" ) 
#pragma comment(lib , "libboost_thread-vc100-mt-gd-1_49.lib" ) 



#ifdef OPENGL_ES
	#pragma comment(lib,"libGLESv2d.lib")
	#pragma comment(lib,"libEGLd.lib") 
#endif  

#else
 

#define DEBUG_PR(msg) ; 

#pragma comment(lib,"opencv_core246.lib")
#pragma comment(lib,"opencv_imgproc246.lib")
#pragma comment(lib,"opencv_highgui246.lib") 
#pragma comment(lib,"libsvm.lib")

#pragma comment(lib , "libboost_serialization-vc100-mt-1_49.lib" ) 
#pragma comment(lib , "libboost_thread-vc100-mt-1_49.lib" ) 


#endif

#ifdef MY_USE_PCL

#pragma warning( disable : 4263 4996 4819 4482 )
#include <pcl/io/pcd_io.h>
#include <pcl/point_types.h>
#include <pcl/console/parse.h>

#include <pcl/sample_consensus/ransac.h>
#include <pcl/sample_consensus/sac_model_plane.h>
#include <pcl/sample_consensus/sac_model_sphere.h>
#include <pcl/sample_consensus/sac_model_line.h>
#include <pcl/sample_consensus/method_types.h>
#include <pcl/sample_consensus/model_types.h>
#include <pcl/sample_consensus/prosac.h>
#include <pcl/sample_consensus/mlesac.h>
 
#include <pcl/visualization/pcl_visualizer.h>
#include <pcl/visualization/cloud_viewer.h>
#include <pcl/visualization/cloud_viewer.h>

#include <pcl/segmentation/sac_segmentation.h> 
#include <pcl/segmentation/extract_clusters.h>
#include <pcl/segmentation/region_growing.h>

#include <pcl/features/normal_3d.h> 
#include <pcl/features/normal_3d_omp.h>
#include <pcl/features/integral_image_normal.h>

#include <pcl/search/organized.h>
#include <pcl/filters/conditional_removal.h>
#include <pcl/filters/passthrough.h> 
#include <pcl/filters/extract_indices.h>

#include <pcl/kdtree/kdtree_flann.h> 

#include <boost/thread/thread.hpp> 
#include <boost/geometry/geometry.hpp> 
#include <boost/geometry/geometries/point_xy.hpp>
#include <boost/geometry/geometries/polygon.hpp>

#endif 

#ifdef MY_USE_PCL 


#ifdef _DEBUG
#pragma comment(lib , "pcl_io_ply_debug.lib" )
//pcl_visualization_debug
#pragma comment(lib , "pcl_io_debug.lib" )
#pragma comment(lib , "pcl_common_debug.lib" )
#pragma comment(lib , "pcl_sample_consensus_debug.lib" )
#pragma comment(lib , "pcl_visualization_debug.lib" ) 
#pragma comment(lib , "pcl_kdtree_debug.lib" )
#pragma comment(lib , "pcl_keypoints_debug.lib" ) 
#pragma comment(lib , "pcl_search_debug.lib" )
#pragma comment(lib , "pcl_segmentation_debug.lib" )
#pragma comment(lib , "pcl_surface_debug.lib" )
#pragma comment(lib , "pcl_filters_debug.lib" ) 

#pragma comment(lib , "pcl_features_debug.lib" ) 
#pragma comment(lib , "flann_cpp_s-gd.lib" )

#else

#pragma comment(lib , "pcl_io_ply_release.lib" )
//pcl_visualization_debug
#pragma comment(lib , "pcl_io_release.lib" )
#pragma comment(lib , "pcl_common_release.lib" )
#pragma comment(lib , "pcl_sample_consensus_release.lib" )
#pragma comment(lib , "pcl_visualization_release.lib" ) 
#pragma comment(lib , "pcl_kdtree_release.lib" )
#pragma comment(lib , "pcl_keypoints_release.lib" ) 
#pragma comment(lib , "pcl_search_release.lib" )
#pragma comment(lib , "pcl_segmentation_release.lib" )
#pragma comment(lib , "pcl_surface_release.lib" )
#pragma comment(lib , "pcl_filters_release.lib" ) 

#pragma comment(lib , "pcl_features_release.lib" ) 
#pragma comment(lib , "flann_cpp_s.lib" )

#endif

#endif // MY_USE_PCL 

#endif // !MYSTDAFX_H
