#pragma once

#include <map>
#include <string>
#include <vector>
#include <fstream>
#include <iostream>

struct TextCTX
{
public:
	int imid;
	int isUIMode;
	std::string batchFPath;
	std::string freqModelPath;

	std::string all_modelPath;
	std::string floor_modelPath;
	std::string wall_modelPath;
	std::string obj_modelPath;
	std::string annoresSavePath;
	int showStructure;
	std::string targetLIDList;

	std::string us_trial_sidlist;
	std::string black_list;
	int batch_force_rerun;
	int batch_skip_exist;
	 
	std::string db_root;
	std::string rerun_dir;
	std::string rerun_save_dir; 
	
	std::string dirExportSAVPath;

	std::string log_savePath;

	std::string input_bin_dir;
	std::string auto_seg_root;

	int use_auto_seg;

	std::string mode;

	TextCTX(){

		imid=0;
		isUIMode=0;
		showStructure=0;
		batch_force_rerun=0;
		batch_skip_exist=0;
		use_auto_seg=0;
		

	}
};

class TextCtxLoader
{
public:
	 
	
	TextCtxLoader(void);
	~TextCtxLoader(void);

	inline
	const TextCTX & getTCTX(){
		return tctx;
	}

	void load(const char* FPATH);

private:

	TextCTX tctx;

};

