#ifndef TEXTURENODE_H
#define TEXTURENODE_H

#include <QObject>
#include <qsgsimpletexturenode.h>
#include <QOpenGLFramebufferObject>
#include <QOpenGLShaderProgram>
#include <QQuickWindow>


class TextureNode : public QObject, public QSGSimpleTextureNode
{
	Q_OBJECT

public:
	TextureNode(QQuickWindow *window); 
	~TextureNode();

	//initial FBO setting
	void initial();

	void setSize(int w,int h);

public slots:
	void renderFBO(); 

private:
	void render();
	
	void setupShader();
	//-------------------------------------------------------------------------
	QSize fbo_size;

	QOpenGLFramebufferObject *m_fbo;
	QSGTexture *m_texture;
	QQuickWindow *m_window;
	QOpenGLShaderProgram *m_program;

};

#endif // TEXTURENODE_H
