import QtQuick 2.1

import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.0
Item {
    id : root
    width: 100
    height: 100

    // some 'group' property
    property var modelData ;
    property int x0;
    property int y0;
    property real alphaValue:0

    Component {
        id: myDelegator

        Item {
            id: wrapper

            Rectangle{
                //width: 60
                //height: 60
                id: content
                color: "transparent"
                antialiasing: true
                //anchors.fill: parent; anchors.margins: 20; radius: 10
                //Text {
				TextField{
				
                    id: nameText
                    text: name
					readOnly: t_readonly
					//style: touchStyle
					// style: mouseArea.focus? Text.Outline: Text.Normal;
                    font.bold :true
                    font.family:'Helvetica [Cronyx]'
                    font.pointSize: 16
                    style:TextFieldStyle {
						textColor: "#6bf17d"
						background: Rectangle {  
							implicitWidth: 150
							implicitHeight: 50
							color: "transparent" 
						}
					}
                    //styleColor: Qt.rgba(1,0,0.4,1)
                    //color: wrapper.PathView.isCurrentItem ? "#6bf17d" :  Qt.rgba(0.5,0.5,1,root.alphaValue)
					textColor : wrapper.PathView.isCurrentItem ? "#6bf17d" :  Qt.rgba(0.5,0.5,1,root.alphaValue)
                    horizontalAlignment : Text.AlignHCenter;
                    MouseArea {
                        id: mouseArea
                        anchors.fill: parent
                        hoverEnabled: true
                        propagateComposedEvents: true
                        onEntered:{
                            root.alphaValue=1;
                            //nameText.style = Text.Outline;
                        }
                        onExited: {
                            root.alphaValue= 0 ;
                             //nameText.style = Text.Normal;
                        }
						/*
                        onClicked: {
                            console.log("onClicked at:"+name +", cidx="+(wrapper.PathView.view.currentIndex) +'idx='+idx);
                            wrapper.PathView.view.currentIndex = idx;
                            wrapper.forceActiveFocus()
                            console.log("onClicked at:"+name +", cidx="+(wrapper.PathView.view.currentIndex) );
                        }
						*/
                        onWheel: {
                           console.log("onWheel at:"+name +", cidx="+(wrapper.PathView.view.currentIndex) + ', next='+(wrapper.PathView.view.currentIndex+1) % wrapper.PathView.view.count)
                           if (wheel.angleDelta.y > 0){
                                    wrapper.PathView.view.currentIndex = (wrapper.PathView.view.currentIndex+1) % wrapper.PathView.view.count;
                                    wrapper.forceActiveFocus()
                           }else{
                                   wrapper.PathView.view.currentIndex = (wrapper.PathView.view.currentIndex+wrapper.PathView.view.count-1)% wrapper.PathView.view.count;
                                   wrapper.forceActiveFocus()
                           }
                        }
                    }
                }


            }//rect

            transitions: Transition {
                NumberAnimation {target:nameText; properties: "color"; duration: 200 }
            }
            /*states: State {
                name: "active"; when: wrapper.activeFocus
                PropertyChanges { target: content; color: "#FCFFF5"; scale: 1.1 }
                PropertyChanges { target: nameText; font.pointSize: 20 }
            }

            transitions: Transition {
                NumberAnimation { properties: "scale"; duration: 100 }
            }*/
            z:6;
        }//item

    }

    /*
    ListView{
        anchors.fill: parent
        model: modelData
        delegate: myDelegator
        x:root.x0
        y:root.y0
        focus: true
        Keys.onLeftPressed: decrementCurrentIndex()
        Keys.onRightPressed: incrementCurrentIndex()
    }
    */

    //*
    PathView {
        anchors.fill: parent
        model: modelData
        delegate: myDelegator


		path: Path {
            property int radius:100;
            startX: root.x0; startY: root.y0-10
            PathLine { x: root.x0; y: root.y0+100 }
            /*
            startX: root.x0-30; startY: root.y0-10
            PathQuad { x: 50+root.x0; y: 25+root.y0; controlX: 100+root.x0; controlY: 55+root.y0 }
            PathQuad { x: 50+root.x0; y: 50+root.y0; controlX: -30+root.x0; controlY: 55+root.y0 }
            //*/
            /*
            startX: root.x0 ; startY: root.y0
            PathArc {
                    x : root.x0+100
                    y : root.y0-100

                    radiusX: 50
                    radiusY: 50
                    useLargeArc: true

            }
            // */

        }
		
        focus: true
        Keys.onLeftPressed: decrementCurrentIndex()
        Keys.onRightPressed: incrementCurrentIndex()
    }
    // */

}
