import QtQuick 2.0
import QtQuick.Controls 1.2


Rectangle {

    property int arrayIdx : -1
    //property bool show: false;//
    property string textPrefix : ""
    property string textSurfix : ""
    property string label: "default"
    property color textColor :"#6bf17d"
    property var clickHandler: undefined
    property var overHandler: undefined
    property var exitHandler: undefined
    property var releaseHandler: undefined

    property int dataFontSize : 10
    property bool textReadOnly: false

    property bool _entered :false

    property color bkColor :"transparent" //Qt.rgba(0.2, 0.2, 0.2, 0.4)
    //property color bkColor : Qt.rgba(0.2, 0.2, 0.2, 0.4)

    id: tBtuRoot
    width: 80
    height: 15
    color: bkColor //"transparent"
    border.color: Qt.rgba(0.8, 0, 0.6, 1)

    visible: parent.showSuggest !== undefined ? parent.showSuggest : false;


    Component.onCompleted: {
        //self check
        if(arrayIdx==-1){
            console.log("**ERR: arrayIdx==-1");
            console.log("***ERR: arrayIdx==-1");
        }

    }

    Text {
        font.bold :true
        font.family:'Helvetica [Cronyx]'

        font.pixelSize: dataFontSize

        style: Text.Outline;
        styleColor: "#180902"

        text: tBtuRoot.textPrefix+tBtuRoot.label+tBtuRoot.textSurfix
        color: tBtuRoot._entered ?'#cfb9a2':textColor;
        //color: textColor

        anchors.horizontalCenter: tBtuRoot.horizontalCenter
        anchors.verticalCenter: tBtuRoot.verticalCenter

        visible: tBtuRoot.visible


    }
    MouseArea{
        id: mouseHandle
        anchors.fill: parent
        propagateComposedEvents: true;
        onReleased: {
            //console.log(tBtuRoot.arrayIdx+" - onReleased")
            if(releaseHandler !== undefined || !releaseHandler  ){
                tBtuRoot.releaseHandler(tBtuRoot.arrayIdx);
            }
        }
        onClicked: {
            //console.log(tBtuRoot.arrayIdx+" - clicked")
            if(clickHandler !== undefined || clickHandler ){
                tBtuRoot.clickHandler(tBtuRoot.arrayIdx);
            }
        }

        onEntered:{
            tBtuRoot._entered=1;
            tBtuRoot.overHandler(tBtuRoot.arrayIdx);
        }
        onExited: {
            tBtuRoot._entered=0 ;
            tBtuRoot.exitHandler(tBtuRoot.arrayIdx);
        }
        hoverEnabled : true
    }

}

