import QtQuick 2.0
import QtQuick.Controls 1.0

Item {

    // initial by caller
    property var dataModel:undefined
    property var dialogFactory:undefined
    property var repredHandler:undefined

    //--------------------------------------------------------

    property string ctxState:''

    property bool showMainAns: false;

    // main flag for menu
    property bool showSuggest: false;

    //property bool showFixedSuggestMenu: false;
    property bool showOptsBtu: false;

    property bool cflocked: false;
    property bool touched: false;

    property Component textBtuComp : Qt.createComponent("TextButton.qml");

    property var allTextBtu : []

    property bool globalLocked: false

    //-------------------------------------------------------------------------------------------
    // private member

    property int __fontSize: showSuggest ? 21 : 19;
    property color __textColor:showSuggest ? Qt.rgba(1,0.2,0.6,0.9): "#81b7f0"

    property var __txBtuReleaseHandler:function( tBtuIdx ){

        if(!globalLocked){

            if(!cflocked){
                //normal case
                if( showSuggest ){
                    // after a click , close all taps

                    showSuggest=false;
                    tmagRoot.showOptsBtu=false;
                    touch_region.handleExit();
                }else{
                    showSuggest=true;
                    tmagRoot.showOptsBtu=true;
                }
            }else{
                //lock case
                tmagRoot.showOptsBtu=!tmagRoot.showOptsBtu;
            }

            //console.log("btu id="+tBtuIdx);
            //console.log("["+Date.now()+"]click :"+'showSuggest='+showSuggest);

            //switch tag
            if( cflocked === false){
                __switchTag(tBtuIdx,0);
            }
        }
    }

    property var __txBtuOverHandler:function( tBtuIdx ){
        /*
        if(false===showSuggest){
                showSuggest=true;
        }
        */
        //console.log("["+Date.now()+"] btu id="+tBtuIdx+" >over :"+'showSuggest='+showSuggest);
    }

    property var __txBtuExitHandler:function( tBtuIdx ){
        /*
        if(!showFixedSuggestMenu && true ===showSuggest){
            showSuggest=false;
        }
        */
        //console.log("["+Date.now()+"] btu id="+tBtuIdx+" >exit :"+"showSuggest="+showSuggest);
    }

    property var __lockHandler:function(){
        //mark locked
        tmagRoot.cflocked=true;
        tmagRoot.showSuggest=false;

        tmagRoot.showOptsBtu=false;
        allTextBtu[0].textSurfix =  '(locked)';

        dataModel.lockThisBox();

        // do re-predict
        if(repredHandler){
            repredHandler();
        }
    }

    property var __unlockHandler:function(){
        //reset locked

        tmagRoot.cflocked=false;
        tmagRoot.showSuggest=false;
        //tmagRoot.showFixedSuggestMenu=false;
        tmagRoot.showOptsBtu=false;
        allTextBtu[0].textSurfix =  '';

        dataModel.unlockThisBox();
    }

    property var __editHandler:function(){
        //console.log('editHandler');
        dialogFactory({succCallBack:__succEditLabelHandler , iniLabel:tmagRoot.dataModel.getTagStr(0)})
    }

    property var __succEditLabelHandler: function(newLabel){
        //console.log('get new label:'+newLabel);
        var numOfTBtu = allTextBtu.length;
        var curTag='';
        var i;

        //directly change index ?

        //set new label
        tmagRoot.dataModel.setEditedTagStr(newLabel);

        // need to re-sync labels
        for(i=0 ; i< numOfTBtu ; i++)
        {
            curTag = dataModel.getTagStr(i);
            allTextBtu[i].label=dataModel.getTagStr(i);
        }

        showFixedSuggestMenu=false;
        showSuggest=false;
        showOptsBtu=false;

        // do re-predict
        if(repredHandler){
            repredHandler();
        }
    }

    property var __switchTag:function(srcId,dstId){
        //switch textBtu
        //console.log("SWITCH :"+srcId+","+dstId);

        if(srcId===dstId){
            return
        }

        //swap inner strurture
        tmagRoot.dataModel.swapMajorTag(srcId,dstId);

        //update UI data
        allTextBtu[srcId].label =dataModel.getTagStr(srcId);
        allTextBtu[dstId].label =dataModel.getTagStr(dstId);

        if(tmagRoot.touched==false){
            tmagRoot.touched=true;
        }
        // do re-predict
        if(repredHandler){
            repredHandler();
        }

    }

    function my__checkState(){
        if(ctxState !== undefined){
            /*
            S_INI=0,
            S_IDLE,
            S_CUTS_DRAWLINE,
            S_SELECT,
            S_ROOM,

            S_CUTSP,
            S_EXBOX,
            S_PREDICT

            S_FINAL
            */
            //console.log('inner s=['+ctxState+'] , at '+x+','+y);
            //visible=true;
            //globalLocked=false;

            //*
            if( ctxState == 'S_PREDICT')
            {
                //console.log('enable tag');
                visible=true;
                globalLocked=false;

            }else if( ctxState == 'S_FINAL' ){
                globalLocked=true;
                visible=true;

            }else{
                //console.log('disable text btu ,inner s=['+ctxState+'] , at '+x+','+y);
                visible=false;
            }
            //*/
        }
        return;
    }

    //--------------------------------------------------------

    id: tmagRoot
    x: dataModel!==undefined && dataModel.boxCx !== undefined ? dataModel.boxCx : 0
    y: dataModel!==undefined && dataModel.boxCy !== undefined ? dataModel.boxCy : 0


    onCtxStateChanged: {
        if(tmagRoot.my__checkState){
            //console.log('T state change--->'+ctxState);
            tmagRoot.my__checkState();
        }
    }

    onTouchedChanged: {
        if(tmagRoot.touched){
            allTextBtu[0].bkColor=Qt.rgba(0.8, 0.2, 0.2, 0.4);
        }else{
            allTextBtu[0].bkColor=Qt.rgba(0.2, 0.2, 0.2, 0.4);
        }
    }

    // DYNAMIC CREATE suggestion block
    Component.onCompleted: {

        if( textBtuComp.status != Component.Ready ){
            console.debug("Error:"+ textBtuComp.errorString() );
            return;
        }

        var i=0;
        var dx=0,dy=0;
        var newBtu=undefined;
        var numOfTags = dataModel.getNumOfTagStr();
        var curTag='';


        //lockBtu.y=numOfTags*25;
        //editLabelBtu.y=numOfTags*25+25;
        lockBtu.y=-25;
        editLabelBtu.y=-25*2;

        for(i=0 ; i< numOfTags ; i++)
        {
            curTag = dataModel.getTagStr(i);

            //console.log(curTag);
            //local transform
            dx = i>0 ? 0 : 0 ;
            dy = i*25;

            // NOTICE that tmagRoot.dataModel.predTags[i]
            // change > tmagRoot.dataModel.predTags  >> trigger OnChanged
            // change > tmagRoot.dataModel.predTags[i] >> NOT trigger
            if(i==0){
                //main btu
                newBtu=textBtuComp.createObject(tmagRoot,{
                                x:dx, y:dy, z:tmagRoot.z+1,
                                label: curTag ,
                                //visible:true, //overid underly binding to parent
                                visible:Qt.binding(function() { return tmagRoot.showMainAns;}),
                                arrayIdx:i,
                                textColor:Qt.binding(function() { return tmagRoot.__textColor;}),
                                dataFontSize:Qt.binding(function(){return tmagRoot.__fontSize;}),
                                releaseHandler:__txBtuReleaseHandler ,
                                overHandler:__txBtuOverHandler ,
                                exitHandler:__txBtuExitHandler  }
                           );
            }else{
                //suggestion btu
                newBtu=textBtuComp.createObject(tmagRoot,{
                                x:dx, y:dy, z:tmagRoot.z+1,
                                label:curTag ,//label:tmagRoot.dataModel.predTags[i],
                                //visible: Qt.binding(function() { return tmagRoot.showSuggest; }),
                                arrayIdx:i,
                                textColor:Qt.binding(function() { return tmagRoot.__textColor;}),
                                dataFontSize:Qt.binding(function(){return tmagRoot.__fontSize;}),
                                releaseHandler:__txBtuReleaseHandler ,
                                overHandler:__txBtuOverHandler ,
                                exitHandler:__txBtuExitHandler

                                             }
                         );
            }

            allTextBtu.push(newBtu);


        }
        //console.log('box at:'+x+","+y);
        //console.log('# of predTags='+numOfTags);


        var x0=dataModel.ui_x;
        var y0=dataModel.ui_y;
        var w=dataModel.ui_w;
        var h=dataModel.ui_h;

        touch_region.width=w;
        touch_region.height=h;

        // orgion is located at top-left location.

        touch_region.x=x0-dataModel.boxCx;
        touch_region.y=y0-dataModel.boxCy;


        my__checkState();

    }

    Rectangle{
        color:'transparent'
        //color:Qt.rgba(0.2,0.2,0.5,0.4);
        id:touch_region
        z:tmagRoot.z
        function handleExit(){
            if(!allTextBtu[0]._entered && !tmagRoot.showOptsBtu ){
                // real exit
                touch_region.color="transparent";
                tmagRoot.showMainAns= false;
                console.log('exit');
            }
        }
        function handleEnter(){
            //touch_region.color=Qt.rgba(0.2,0.2,0.7,0.3);
            //tmagRoot.showOptsBtu=true;
            tmagRoot.showMainAns=true;
            console.log('ENTER');
        }
        MouseArea{
            hoverEnabled: true
            anchors.fill:parent

            //propagateComposedEvents: true

            onExited: {
                parent.handleExit();
            }
            onEntered: {
                parent.handleEnter();
            }
        }
    }

    // lock btu
    Rectangle{
        id: lockBtu
        width:80
        height:20
        visible: tmagRoot.showOptsBtu
        color:'transparent'

        property string lockStr:"LOCK LABEL"
        property string unlockStr:"cancel LOCK"

        Text{
            id:lockText
            text:lockBtu.lockStr
            color:"#b3d8d8"

            font.bold :true
            font.family:'Helvetica [Cronyx]'
            font.pointSize: 8

            style: Text.Outline;
            styleColor: "black"

            anchors.horizontalCenter: lockBtu.horizontalCenter
            anchors.verticalCenter: lockBtu.verticalCenter

            MouseArea{
                hoverEnabled: true
                anchors.fill:parent
                onExited: {
                    lockText.color='#b3d8d8';
                }
                onEntered: {
                    lockText.color="#cfb9a2";
                }
                onClicked: {
                    if(!tmagRoot.cflocked){
                        //console.log("confirmed - locked");

                        tmagRoot.__lockHandler();

                        lockText.text=lockBtu.unlockStr;

                    }else{
                        //console.log("cancel lock");

                        tmagRoot.__unlockHandler();

                        lockText.text=lockBtu.lockStr;
                    }
                }
            }
        }

    }

    // edit label btu
    Rectangle{
        id: editLabelBtu
        width:80
        height:20
        visible: tmagRoot.showOptsBtu
        color:'transparent'


        Text{
            id:editText

            color:"#b3d8d8";

            style: Text.Outline;
            styleColor: "black"

            font.bold :true
            font.family:'Helvetica [Cronyx]'
            font.pointSize: 8
            anchors.horizontalCenter: editLabelBtu.horizontalCenter
            anchors.verticalCenter: editLabelBtu.verticalCenter

            text:'EDIT LABEL'
            MouseArea{
                id:editMA
                anchors.fill:parent
                hoverEnabled: true
                onExited: {
                    editText.color="#b3d8d8";
                }
                onEntered: {
                    editText.color='#cfb9a2';
                }
                onClicked: {
                    console.log("clicked edit Label");
                    tmagRoot.__editHandler();
                }
            }
        }

    }

}
