import QtQuick 2.0
import QtQuick.Controls 1.2

Item {

    id: tmagRoot

    anchors.fill: parent


    signal menuCloseSignal();

    //--------------------------------------------------------
    property bool verbase:true;
    //--------------------------------------------------------
    // initial by caller
    property int boxIdx:-1
    property var dataModel:undefined
    property var dialogFactory:undefined
    property var repredHandler:undefined

    property int topMenuHeight:0;
    property int menuZVal:z;

    property string ctxState:''

    //--------------------------------------------------------
    property var __editHandler:function(){
        //console.log('editHandler');

        //this would perform self destruction
        dialogFactory({
           //iniLabel:tmagRoot.dataModel.getTagStr(0),
           iniLabel:"",
           succCallBack:__succEditLabelHandler
          })
    }
    property Component textBtuComp : Qt.createComponent("TextButton.qml");

    // main flag for menu
    property bool showMENU: false;

    //property bool globalLocked: false
    //property bool cflocked: false;

    // update by sync with cpp
    property bool touched: false;

    property var allTextBtu : []

    //-------------------------------------------------------------------------------------------
    function __menuOpened(){
        return tmagRoot.showMENU;
    }

    function __openMenu(){
        tmagRoot.showMENU=true;
    }

    function __closeMenu(){

        console.log('[close menu]');

        tmagRoot.showMENU=false;
        menuCloseSignal();
    }

    function __doRePredict(){
        // do re-predict
        if(repredHandler){
            repredHandler();
        }
    }


    function __switchTag(srcId,dstId){
        //switch textBtu
        //console.log("SWITCH :"+srcId+","+dstId);

        //if(srcId !==dstId){
        //
        //}
        //swap inner strurture
        tmagRoot.dataModel.swapMajorTag(srcId,dstId);

        //update UI data
        allTextBtu[srcId].label =dataModel.getTagStr(srcId);
        allTextBtu[dstId].label =dataModel.getTagStr(dstId);

        __doRePredict();
        //close menu
        __closeMenu();
    }


    function __succEditLabelHandler(newLabel){
        //console.log('get new label:'+newLabel);
        var numOfTBtu = allTextBtu.length;
        var curTag='';
        var i;

        //set new label
        tmagRoot.dataModel.setEditedTagStr(newLabel);

        // need to re-sync labels
        for(i=0 ; i< numOfTBtu ; i++)
        {
            curTag = dataModel.getTagStr(i);
            allTextBtu[i].label=dataModel.getTagStr(i);
        }

        __closeMenu();

        __doRePredict();
    }

    property var __confHandler:function( ){

        tmagRoot.dataModel.confirmThisBox();

        __closeMenu();

        __doRePredict();
    }

    //-------------------------------------------------------------------------------------------
    // public SLOTS

    function my__checkState(){
        if(ctxState !== undefined){
            if( ctxState == 'S_PREDICT' || ctxState == 'S_PRE_MENU_FOLD')
            {
                //console.log('enable tag');
                visible=true;

            }else if( ctxState == 'S_FINAL' || ctxState == 'S_DRAW_FINAL' ){
                visible=true;

            }else{
                //console.log('disable text btu ,inner s=['+ctxState+'] , at '+x+','+y);
                visible=false;
            }
        }
        return;
    }

    function btu__segClickHandler( tBtuIdx , btuType ){

        var verbase=0;

        //LeftButton       = 0x00000001,
        //RightButton      = 0x00000002,

        if( tBtuIdx!==undefined  && tBtuIdx !== null ){

            //console.log("["+tBtuIdx+"]-by["+boxIdx+"]enter: __segClickHandler ");

            if(tBtuIdx===boxIdx){
                // effective cases

                if( __menuOpened() && btuType === 2 ){
                    __closeMenu();
                }else{
                    __openMenu();
                }

                if(verbase){
                    console.log("release at:"+allTextBtu[0].label);
                }
            }

        }

    }

    function btu__segMoveFocusCahngeHandler( tBtuIdx ){


        if( tBtuIdx!==undefined  && tBtuIdx !== null ){

            if(tBtuIdx===boxIdx && !tmagRoot.touched){
                // effective cases
                curAns.color=Qt.rgba(0.8,0.2,0.2,0.7);


            }else if(tBtuIdx===boxIdx && tmagRoot.touched){

                curAns.color=Qt.rgba(0.1,0.7,0.55,0.7);

            }else if(tmagRoot.touched){
                curAns.color=Qt.rgba(0,0.7,0,0.7);

            }else{
                //initail case
                curAns.color=Qt.rgba(165,165,165,0.7);
            }
        }
    }
    //-------------------------------------------------------------------------------------------
    // private member

    property int __fontSize: showMENU ? 21 : 19;

    property color __textColor:showMENU ? Qt.rgba(1,0.2,0.6,0.9): "#81b7f0"

    property var __menuBtuPressHandler:function(tBtuIdx){

                    __switchTag(tBtuIdx,0);
            }

    property var __txBtuOverHandler:function( tBtuIdx ){}

    property var __txBtuExitHandler:function( tBtuIdx ){}

    property var __unlockHandler:function(   ){}

    //--------------------------------------------------------

    onCtxStateChanged: {
        if(tmagRoot.my__checkState){
            //console.log('T state change--->'+ctxState);
            tmagRoot.my__checkState();
        }
    }

    onTouchedChanged:  {

        //console.log('onTouchedChanged');
        if(tmagRoot.touched){
            curAns.color=Qt.rgba(0,0.7,0,0.7);
            curAns.font.pointSize=8;
        }else{
            curAns.color=Qt.rgba(165/255,165/255,165/255,0.7);
            curAns.font.pointSize=9;
        }
    }

    onShowMENUChanged: {
        //console.log('onShowMENUChanged='+showMENU);
    }

    // DYNAMIC CREATE suggestion block
    Component.onCompleted: {

        var verbase=0;

        if( textBtuComp.status != Component.Ready ){
            console.debug("Error:"+ textBtuComp.errorString() );
            return;
        }

        var i=0;
        var dx=0,dy=0;
        var newBtu=undefined;
        var numOfTags = dataModel.getNumOfTagStr();
        var curTag='';

        //lockBtu.y=numOfTags*25;
        //editLabelBtu.y=numOfTags*25+25;
        //lockBtu.y=-25;
        //editLabelBtu.y=-25*2;

        var box_dx=dataModel!==undefined && dataModel.boxCx !== undefined ? dataModel.boxCx : 0
        var box_dy=dataModel!==undefined && dataModel.boxCy !== undefined ? dataModel.boxCy : 0
        box_dy=box_dy - topMenuHeight;
        // small adjust
        box_dx=box_dx-20 > 0 ? box_dx-20 : box_dx;
        box_dy=box_dy-20;


        var menu_x=271;
        var menu_y=250;
        //var menu_x=box_dx;
        //var menu_y=box_dy;

        for(i=0 ; i< numOfTags ; i++)
        {
            curTag = dataModel.getTagStr(i);

            //console.log(curTag);
            //local transform
            dx = menu_x;
            dy = menu_y+i*25; // since cpp b2d use window() to calculate

            // NOTICE that tmagRoot.dataModel.predTags[i]
            // change > tmagRoot.dataModel.predTags  >> trigger OnChanged
            // change > tmagRoot.dataModel.predTags[i] >> NOT trigger

            // create menu

            //suggestion btu
            newBtu=textBtuComp.createObject(tmagRoot,{
                    x:dx, y:dy,
                    z:tmagRoot.menuZVal,
                    label:curTag ,
                    visible: Qt.binding(function() { return tmagRoot.showMENU; }),
                    arrayIdx:i,
                    textColor:Qt.binding(function() { return tmagRoot.__textColor;}),
                    dataFontSize:Qt.binding(function(){return tmagRoot.__fontSize;}),
                    releaseHandler:__menuBtuPressHandler,
                    overHandler:__txBtuOverHandler ,
                    exitHandler:__txBtuExitHandler
               }
             );

            allTextBtu.push(newBtu);

        }// loop

        if(verbase){
            console.log('box at:'+box_dx+","+box_dy);
        }

        touched = Qt.binding(function() {
            if(dataModel)
                return dataModel.userModified;
            else
                return true;
        });

        if(touched){
            console.log('bid='+boxIdx+'touched='+touched);
        }

        // create static text
        curAns.text=Qt.binding(function(){
                if(allTextBtu){
                    if(tmagRoot.verbase){
                        return boxIdx+'.'+allTextBtu[0].label;
                    }else{
                        return allTextBtu[0].label;
                    }
                }else{
                    return "";
                }
        });
        curAns.x=box_dx;
        curAns.y=box_dy;

        curAns.visible = Qt.binding(function(){
            if( ctxState == 'S_PRE_MENU_FOLD'){
                return false;
            }else{
                return true;
            }
        });



        editLabelBtu.x = menu_x;
        editLabelBtu.y = menu_y-25*2.5
        editLabelBtu.z = tmagRoot.menuZVal;

        confLabelBtu.x = menu_x;
        confLabelBtu.y = menu_y-25*1.5
        confLabelBtu.z = tmagRoot.menuZVal;


        var x0=dataModel.ui_x;
        var y0=dataModel.ui_y;
        var w=dataModel.ui_w;
        var h=dataModel.ui_h;

        my__checkState();

    }

    // edit label btu
    Rectangle{
        id: editLabelBtu
        width:80
        height:20
        visible: tmagRoot.showMENU
        color:'transparent'
        Text{
            id:editText

            color:"#b3d8d8";

            style: Text.Outline;
            styleColor: "black"

            font.bold :true
            font.family:'Helvetica [Cronyx]'
            font.pointSize: 10
            anchors.horizontalCenter: editLabelBtu.horizontalCenter
            anchors.verticalCenter: editLabelBtu.verticalCenter

            text:'EDIT LABEL'
            MouseArea{
                id:editMA
                anchors.fill:parent
                hoverEnabled: true
                onExited: {
                    editText.color="#b3d8d8";
                }
                onEntered: {
                    editText.color='#cfb9a2';
                }
                onPressed: {
                    console.log("clicked edit Label");
                    tmagRoot.__editHandler();
                }
            }
        }
    }

    // confirm label btu
    Rectangle{
        id: confLabelBtu
        width:80
        height:20
        visible: tmagRoot.showMENU
        color:'transparent'
        Text{
            id:confText

            color:"#b3d8d8";

            style: Text.Outline;
            styleColor: "black"

            font.bold :true
            font.family:'Helvetica [Cronyx]'
            font.pointSize: 10
            anchors.horizontalCenter: confLabelBtu.horizontalCenter
            anchors.verticalCenter: confLabelBtu.verticalCenter

            text:'LOCK'
            MouseArea{
                id:confMA
                anchors.fill:parent
                hoverEnabled: true
                onExited: {
                    confText.color="#b3d8d8";
                }
                onEntered: {
                    confText.color='#cfb9a2';
                }
                onPressed: {
                    console.log("user confirm label");
                    tmagRoot.__confHandler();
                }
            }
        }
    }


    // static text
    Text{
        id: curAns
        color:Qt.rgba(165,165,165,0.7)
        font.bold :true
        font.family:'Helvetica [Cronyx]'
        font.pointSize: 9
        style: Text.Outline;
        styleColor: "#180902"
    }


    // modal warpper
    Rectangle {
        id: overlayRect
        anchors.fill: parent
        opacity: 0.6
        color: visible? "#000000" : 'transperant' ;
        visible:  tmagRoot.showMENU;
        // add a mouse area so that clicks outside
        // the dialog window will not do anything
        //*
        MouseArea {
           anchors.fill: parent
           propagateComposedEvents: false
           onReleased: {
               console.log('modal area + overlayRect.vis='+overlayRect.visible);
               if( __menuOpened && mouse.button === Qt.RightButton ){
                    tmagRoot.__closeMenu();
               }
           }
        }
        //*/
    }


}
