import QtQuick 2.0
import QtQuick.Controls 1.0
import QtQuick.Layouts 1.0
import QtQuick.Controls.Styles 1.0



Item {

    id:root
    width: 200
    height: 700

    property bool demoMode:false;
    property int spaceHeight:demoMode ? 10 :1;

    property int allMargin : 15;
    property var handler: ({})
    property var pre_rePredictAction: function(){}

    property var debugFunc :({})

    function inisync(){

        //root.handler.imgID=spinbox.value;
        //root.handler.brushSize=bsizeSpinbox.value;
    }
    onHandlerChanged: {
        toolPanel.inisync();
    }
    SplitView {
        id : spliter
        orientation : Qt.Vertical
        anchors.fill: parent

        //Column{
            Rectangle{
                id: toolRect
                color: Qt.rgba(0.8,0.9,0.3,1);
                Layout.fillWidth: true
                Layout.fillHeight: true
                Layout.minimumHeight: 200
                Layout.maximumHeight: spliter.height*0.8

                GridLayout{
                    anchors.centerIn: parent
                    rowSpacing:  10
                    columns: 1
                    anchors.margins : root.allMargin

                    Rectangle{
                         //color:'transparent'
                         width:90
                         height:20

                         SpinBox {
                            anchors.fill: parent
                            height:parent.height
                            id: spinbox
                            maximumValue : 1496
                            minimumValue: 1
                            value:1030
                            onValueChanged: {
                                if(root.handler){
                                    root.handler.imgID=value;
                                }
                            }
                            Component.onCompleted: {
                                if(root.handler){
                                    root.handler.imgID=value;
                                }
                            }
                        }
                    }

                    MyButton{
                        id: testBtu
                        text: "testBtu"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.debugTestSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    Rectangle{
                        height: spaceHeight
                        color:'transparent'
                    }
                    MyButton{
                        id: openBtu
                        width: 8
                        height: 35
                        text: "Open Image"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.imgID=spinbox.value;
                                root.handler.openImgSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    MyButton{
                        id: loadBtu
                        text: "Load Image"

                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.loadMatStateSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    MyButton{
                        id: roomBtu
                        text: "roomBtu"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.roomModeSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    MyButton{
                        id: filterSPBtu
                        text: "filterSPBtu"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.filterSPModeSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    MyButton{
                        id: cutSPBtu
                        text: "cutSPBtu"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.cutSPModeSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    MyButton{
                        id: boxesBtu
                        text: "boxesBtu"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.extrBoxModeSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    Rectangle{
                        height:spaceHeight
                        color:'transparent'
                    }
                    MyButton{
                        id: predictBtu
                        text: "Predict Labels"
                        onClicked: {
                            if(root.handler !== undefined){

                                //root.pre_rePredictAction();
                                root.handler.predictModeSlot();

                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    MyButton{
                        id: rePredBtu
                        text: "re-predict"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){

                                //root.pre_rePredictAction();

                                root.handler.rePredBtuSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    Rectangle{
                        height:spaceHeight
                        color:'transparent'
                    }
                    /*
                    MyButton{
                        id: sizeAdjBtu
                        text: "refine box"
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.refineBoxSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    */
                    MyButton{
                        id: finalSavBtu
                        text: "Save Labels"

                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.finalSavBtuSlot();
                            }else{
                                console.log('root.debugFunc not ready');
                            }
                        }
                    }
                    Rectangle{
                        height:spaceHeight
                        color:'transparent'
                    }
                    MyButton{
                        id: caBoxbtu
                        text: "Confirm All"
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.confAllBtuSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    Rectangle{
                        height:spaceHeight
                        color:'transparent'
                    }
                    MyButton{
                        id: actionDoneBtu
                        text: "Action Done"
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.actionDoneSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    MyButton{
                        id: debugBtu
                        text: "DEBUG"
                        visible: false//!demoMode
                        onClicked: {
                            if(root.debugFunc !== undefined){
                                root.debugFunc();
                            }else{
                                console.log('root.debugFunc not ready');
                            }
                        }
                    }
                    Rectangle{
                        height:spaceHeight
                        color:'transparent'
                    }
                    MyButton{
                        id: saveBtu
                        text: "FAST-SAVE"
                        visible: !demoMode
                        idleColor: "red"
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.saveMatStateSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }


                }
            }


            Rectangle{
                id: rectangle2
                color: Qt.rgba(0.8 ,0.8,0.8 ,1);

                Layout.fillWidth: true
                Layout.fillHeight: true
                Layout.minimumHeight: spliter.height*0.2

                GridLayout {

                    anchors.centerIn: parent
                    rowSpacing:  10
                    columns: 1
                    anchors.margins : root.allMargin

                    MyButton{
                        id: drawLineBtu
                        text: "Draw Line"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.drawLineModeSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    /*
                    MyButton{
                        id: doAction
                        text: "Run"
                        visible: !regMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.runBtuSlot();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    MyButton{
                        id: finalSavBtu2
                        text: "Save Labels"

                        visible: !regMode
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.finalSavBtuSlot();
                            }else{
                                console.log('root.debugFunc not ready');
                            }
                        }
                    }
                    */
                    Rectangle{
                         color:'transparent'
                         width:100
                         height:demoMode?30:20

                        SpinBox {
                            anchors.fill: parent

                            visible: !demoMode
                            id: bsizeSpinbox
                            maximumValue : 100
                            minimumValue: 1
                            value:3
                            onValueChanged: {
                                if(root.handler){
                                    root.handler.brushSize=value;
                                }
                            }
                            Component.onCompleted: {
                                if(root.handler){
                                    root.handler.brushSize=value;
                                }
                            }
                        }
                    }
                    /*

                    */
                    /*
                    CheckBox {
                        id: showBoxCBox
                        x: 101
                        y: 586
                        text: "show box"
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.showBoxCHBSlot(checked);
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    CheckBox {
                        id: showPredCBox
                        x: 101
                        y: 586
                        text: "show pred res"

                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.showPredCHBSlot(checked);
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    CheckBox {
                        id: showSegCBox
                        x: 101
                        y: 586
                        text: "show seg"
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.showSegCHBSlot(checked);
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                    */
                }

            }

        //}

    } //split


}
