import QtQuick 2.1
import QtQuick.Controls 1.2
import QtQuick.Layouts 1.0
import QtQuick.Controls.Styles 1.0



Item {

    id:root
    //width: 200
    property bool demoMode:false;
    property int spaceHeight:demoMode ? 20 :1;
    property int spaceWidth:demoMode ? 20 :1;

    property int allMargin : demoMode ? 15 : 3;
    property var handler: ({})
    property var pre_rePredictAction: function(){}

    property var debugFunc :({})
    property var infoUpdateHandler:function(){}

    property string currentState:""

    property int bsize: demoMode? 70 : 50

    function inisync(){


        //root.handler.imgID=spinbox.value;
        //root.handler.brushSize=bsizeSpinbox.value;
    }

    SplitView {
        id : spliter
        orientation : Qt.Horizontal
        anchors.fill: parent


        //-----------------------------------------------------
        // LEFT PANEL
        Rectangle{
            id: toolRect
            color: Qt.rgba(0.8,0.9,0.3,1);
            Layout.fillWidth: true
            Layout.fillHeight: true


            //-----------------------------------------------------
            ColumnLayout{
                anchors.centerIn: parent
                spacing: 20
                //anchors.margins : root.allMargin


                //-----------------------------------------------------
                // advance layer
                RowLayout {
                    spacing:10
                    MyButton{
                        id: openBtu
                        text: "Load \nTCTF mode"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                //root.handler.imgID=spinbox.value;
                                //root.handler.openImgSlot();
                                root.handler.textLoadBtuPress();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    MyButton{
                        id: tpredBtu
                        text: "show wall"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.toggleShowWall();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    MyButton{
                        id: tInstALLBtu
                        text: "toggle Inst"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.toggleInstTest();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    MyButton{
                        id: ui_debugBtu
                        text: "ui debug"
                        visible: !demoMode
                        onClicked: {
                            debugFunc();
                        }
                    }

                    MyButton{
                        id: enterSupAdj
                        text: "adjust Sup"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.supadj_enterSupAdjModePressed();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    MyButton{
                        id: enterBoxMi
                        text: "adjust box"
                        visible: !demoMode
                        onClicked: {
                            if(root.handler !== undefined){
                                var list = root.handler.bxmi_enterBoxMiModePressed();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }
                }


                //-----------------------------------------------------
                RowLayout {
                    spacing:10
                    MyButton{
                        id: annIniListBtu
                        width: root.bsize
                        height: root.bsize
                        implicitWidth: root.bsize
                        implicitHeight: root.bsize

                        text: "Initial\nTrial"
                        visible: true
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.anno_iniListPressed();
                                infoUpdateHandler();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }

                    }

                    MyButton{
                        id: annStartBtu
                        width: root.bsize
                        height: root.bsize
                        implicitWidth: root.bsize
                        implicitHeight: root.bsize

                        text: "Start"
                        visible: true
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.anno_startPressed();
                                infoUpdateHandler();


                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }


                    Rectangle{
                        height:spaceHeight
                        width:spaceWidth
                        color:'transparent'
                        visible: demoMode
                    }
                    Rectangle{
                        height: spaceHeight
                        width:spaceWidth
                        color:'transparent'
                        visible: demoMode
                    }

                    MyButton{
                        id: annAllDoneBtu
                        width: root.bsize
                        height: root.bsize
                        implicitWidth: root.bsize
                        implicitHeight: root.bsize
                        text: root.currentState == 'S_PREDICT' ? "Approve\nAll" : "All\nDone"
                        visible: true
                        c1:Qt.rgba(0.5,0.5,0.8 ,1)
                        c2:Qt.rgba(0.5,0.5,0.7,1)

                        c3:Qt.rgba(0.74,0.74,0.8 ,1)
                        c4:Qt.rgba(0.6,0.6,0.8,1)

                        onClicked: {
                            if(root.handler !== undefined){

                                if(root.currentState == 'S_PREDICT'){
                                    root.handler.anno_allDonePressed();
                                    infoUpdateHandler();
                                }else{
                                    root.handler.actionDoneBtuPressed();
                                }

                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                    Rectangle{
                        height: spaceHeight
                        width:spaceWidth
                        color:'transparent'
                        visible: demoMode
                    }
                    Rectangle{
                        height: spaceHeight
                        width:spaceWidth
                        color:'transparent'
                        visible: demoMode
                    }
                    Rectangle{
                        height: spaceHeight
                        width:spaceWidth
                        color:'transparent'
                        visible: demoMode
                    }
                    Rectangle{
                        height: spaceHeight
                        width:spaceWidth
                        color:'transparent'
                        visible: demoMode
                    }


                    MyButton{
                        id: annNextBtu
                        width: root.bsize
                        height: root.bsize
                        implicitWidth: root.bsize
                        implicitHeight: root.bsize
                        text: "Next\nCase"
                        visible: true
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.anno_nextCasePressed();
                                infoUpdateHandler();

                            }else{
                                console.log('root.handler not ready');
                            }

                            annStartBtu.checked=false;
                        }
                    }

                    MyButton{
                        id: annPrevBtu
                        width: root.bsize
                        height: root.bsize
                        implicitWidth: root.bsize
                        implicitHeight: root.bsize
                        text: "Prev\nCase"
                        visible: true
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.anno_prevCasePressed();
                                infoUpdateHandler();
                            }else{
                                console.log('root.handler not ready');
                            }

                            annStartBtu.checked=false;
                        }
                    }
                    MyButton{
                        id: annResetBtu
                        width: root.bsize
                        height: root.bsize
                        implicitWidth: root.bsize
                        implicitHeight: root.bsize
                        text: "Re-set"
                        visible: demoMode

                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.anno_resetPressed();
                                infoUpdateHandler();


                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                    }

                }
            }


        }

        //-----------------------------------------------------
        // RIGHT PANEL
        Rectangle{
            id: rectangle2
            color: Qt.rgba(0.8 ,0.8,0.8 ,1);
            width :210
            //Layout.fillWidth: true
            //Layout.fillHeight: true
            //Layout.minimumWidth: 100
            visible: true
            RowLayout {

                anchors.centerIn: parent
                spacing:  10
                anchors.margins : root.allMargin
                /*
                MyButton{
                        id: actionDone
                        text: "Action\n Done"
                        onClicked: {
                            if(root.handler !== undefined){
                                root.handler.actionDoneBtuPressed();
                            }else{
                                console.log('root.handler not ready');
                            }
                        }
                }
                
                MyButton{
                    id: debugBtu
                    text: "debug"
                    //visible: !demoMode
                    visible: true
                    onClicked: {
                        if(root.handler !== undefined){
                            var list = root.handler.debugSlot();
                        }else{
                            console.log('root.handler not ready');
                        }
                    }
                }
				*/
				
				MyButton{
                    id: addboxBtu
                    text: "Add Obj"
                    //visible: !demoMode
                    onClicked: {
                        if(root.handler !== undefined){
                            var list = root.handler.addObjSegSlot();
                        }else{
                            console.log('root.handler not ready');
                        }
                    }
                }
                MyButton{
                    id: collectDataBtu
                    text: "Collect\nData"
                    visible: !demoMode

                    c2:"#E28B8B"
                    c1:"#E8D1D1"

                    c3:"#E2A6A6"
                    c4:"#E28B8B"

                    onClicked: {
                        if(root.handler !== undefined){
                            root.handler.collectDataSlot();
                        }else{
                            console.log('root.handler not ready');
                        }
                    }
                }
            }

        }

        //}

    } //split


}
