import QtQuick 2.1
import QtQuick.Controls 1.2
import QtQuick.Layouts 1.0
import QtQuick.Controls.Styles 1.0



Rectangle {

    id:root
    color: Qt.rgba(0.8,0.8,0.8,1)

    property bool demoMode:false;

    property int spaceHeight:demoMode ? 20 :1;
    property int spaceWidth:demoMode ? 20 :1;

    property int allMargin : demoMode ? 15 : 3;
    property var handler: ({})

    property var debugFunc :({})

    property int bsize: demoMode? 70 : 50

    property string currInfo:"initial"
    property string currentState:""

    onCurrInfoChanged: {
        console.log("onCurrInfoChanged="+currInfo)
    }
    onCurrentStateChanged:  {
        console.log("onCurrentStateChanged="+currentState)

        /*
        if(currentState=='S_PRE_INI' || currentState=='S_INI'){
            inimodeMenu.visible=true;
        }else{
            inimodeMenu.visible=false;
        }
        */
    }
    function updateSupCHB(val){
        showSupBox.checked=val;
    }


    function inisync(){

        // connect signal
        root.handler.showSupChange.connect(updateSupCHB);

        //root.handler.onIniModeChanged.connect(inimodeMenu.handleInnerModeChanged);

        // sync
        root.handler.setBoxManiMode( btools.current.tagStr);

        //root.handler.ini_mode=inimodeMenu.getModeFlag();

        showSugBoxCBox.checked=true;
        showSugBoxCBox.checked=false;
        supAdj_showBox.checked=true;
        supAdj_showBox.checked=false;


        useEraCBox.checked=true;
        useEraCBox.checked=false;
    }

    Rectangle{
        id: rectangle2
        color:root.color

        anchors.fill: parent
        anchors.margins : root.allMargin

        //Layout.fillWidth: true
        //Layout.fillHeight: true
        //Layout.minimumWidth: demoMode?70:0
        visible: true

        GridLayout {

            anchors.top: parent.top
            rowSpacing:  10
            columns: 1

            Rectangle{
                color:Qt.rgba(0,0,0,0)
                height: 70
                width: root.width-15
                Text{
                    id:infoPanel

                    anchors.fill: parent
                    //anchors.top: parent.top
                    //anchors.rightMargin: 50
                    //anchors.topMargin: 100
                    color: Qt.rgba(0,0,0.7,1);
                    text: root.currInfo
                    font.pointSize: 11
                    //font.bold: true
                    horizontalAlignment: Text.AlignLeft
                    wrapMode:Text.WordWrap
                }

            }
            GroupBox {
                title: qsTr("label tool")
                Column{
                    Row{
                        Text{
                            text:"Brush size:"
                        }
                        TextField {
                            placeholderText: qsTr("12")
                            width : 45
                        }
                    }
                    CheckBox {
                        id: useEraCBox
                        text: "Use Eraser"
                        checked: false

                        onCheckedChanged: {
                            if(root.handler !== undefined){
                                root.handler.useEraser(checked);

                            }
                        }
                    }
                    CheckBox {
                        id: showBoxCBox
                        text: "Show ALL Box"
                        checked: false

                        onCheckedChanged: {
                            if(root.handler !== undefined){
                                root.handler.paintBox(checked);

                            }
                        }
                    }
                    CheckBox {
                        id: showSugBoxCBox
                        text: "Show Suggestion"
                        checked: false

                        onCheckedChanged: {
                            if(root.handler !== undefined){
                                root.handler.enableSuggest(checked);

                            }
                        }
                    }
                    CheckBox {
                        id: showSupBox
                        text: "Show Structure"
                        checked:false
                        onCheckedChanged: {
                            if(root.handler !== undefined){
                                root.handler.showSupport=checked;

                            }
                        }
                    }
                    /*
                                CheckBox {
                                    id: showBK
                                    text: "Show BK"
                                    checked: false
                                    onCheckedChanged: {
                                        if(root.handler !== undefined){
                                            root.handler.paintBK(checked);
                                        }
                                    }
                                }

                                CheckBox {
                                    id: showCont
                                    text: "Show Contour"
                                    checked: false
                                    onCheckedChanged: {
                                        if(root.handler !== undefined){

                                        }
                                    }
                                }*/
                }
            }

            GroupBox {
                title: qsTr("box tool")
                Column {
                    ExclusiveGroup { id: btools }

                    RadioButton {
                        property string tagStr:"ROT_Y"
                        text: qsTr("Rotate(Y)")
                        exclusiveGroup: btools
                        checked: true

                        onCheckedChanged:{
                            if(checked){
                                if(root.handler !== undefined){
                                    root.handler.setBoxManiMode(tagStr);
                                }else{
                                    console.log('root.handler not ready');
                                }
                            }
                        }
                    }
                    RadioButton {
                        property string tagStr:"VEX_XZ"
                        text: qsTr("FaceArea(XZ)")
                        exclusiveGroup: btools


                        onCheckedChanged:{
                            if(checked){
                                if(root.handler !== undefined){
                                    root.handler.setBoxManiMode(tagStr);
                                    btools.current
                                }else{
                                    console.log('root.handler not ready');
                                }
                            }
                        }
                    }
                    RadioButton {
                        property string tagStr:"VEX_Y"
                        text: qsTr("Height(Y)")
                        exclusiveGroup: btools
                        onCheckedChanged:{
                            if(checked){
                                if(root.handler !== undefined){
                                    root.handler.setBoxManiMode(tagStr);
                                }else{
                                    console.log('root.handler not ready');
                                }
                            }
                        }
                    }

                }
            }

            GroupBox {
                title: qsTr("sup tool")
                Column{
                    CheckBox {
                        id: supAdj_showBox
                        text: "Show Box"
                        checked: false

                        onCheckedChanged: {
                            if(root.handler !== undefined){

                                root.handler.setSupMode_showBox(checked);
                            }
                        }
                    }
                }
            }
            /*
            Item{
                SpinBox {
                    id: spinbox
                }
                Text{
                    text:'X'
                }
            }
            */
            Column{
                id:sgColorTable

                //anchors.right: demoMode? textBoard_anno.right : textBoard.left
                //anchors.top:demoMode? textBoard_anno.bottom :  textBoard.top
                //anchors.rightMargin: 80
                spacing: 10

                property color textColor: Qt.rgba(0,0,0,1)

                //visible: !demoMode
                Rectangle{
                    width:10
                    height:10
                    color:Qt.rgba(1,1,0,1);
                    Text{
                        anchors.left:parent.right
                        anchors.top:parent.top
                        font.pointSize: 8
                        color:sgColorTable.textColor
                        
                        text:':Box Sup'
                        horizontalAlignment: Text.AlignLeft
                    }
                }
                Rectangle{
                    width:10
                    height:10
                    color:Qt.rgba(163/255,73/255,164/255,1);
                    Text{
                        anchors.left:parent.right
                        anchors.top:parent.top
                        font.pointSize: 8
                        color:sgColorTable.textColor
                        text:':Wall'
                        horizontalAlignment: Text.AlignLeft
                    }
                }

                Rectangle{
                    width:10
                    height:10
                    color:Qt.rgba(0,1,1,1);
                    Text{
                        anchors.left:parent.right
                        anchors.top:parent.top
                        font.pointSize: 8
                        color:sgColorTable.textColor
                        text:':Ground'
                        horizontalAlignment: Text.AlignLeft
                    }
                }

            }

            Rectangle{
                height:20
                color:Qt.rgba(0,0,0,1)
            }

            /*
            ComboBox {

                id: inimodeMenu

                visible: false

                currentIndex: 0
                model: ListModel {
                    id: cbItems
                    ListElement { text: "Label";      flag: "label" }
                    ListElement { text: "Structure";  flag: "support" }
                    ListElement { text: "Box";        flag: "box" }
                }
                width: 200
                onCurrentIndexChanged: {
                    console.debug("\nMODE=" + getModeFlag() +"\n" );
                    if(root.handler !== undefined){
                        root.handler.ini_mode=getModeFlag() ;
                    }
                }

                function getModeFlag(){
                    return cbItems.get(currentIndex).flag;
                }
                function handleInnerModeChanged(newMode){

                    if(getModeFlag()!==newMode){
                        for(var i=0 ; i< cbItems.count ; i++){
                                if(cbItems.get(i).flag === newMode){

                                    currentIndex=i
                                    break;
                                }
                        }
                    }

                }
            }
            */


        }//grid layout

    }


}
