import QtQuick 2.1
import QtQuick.Controls 1.0 
import QtQuick.Layouts 1.0
import QtQuick.Dialogs 1.0
import QtQuick.Window 2.1

import "./MyUI" 1.0 as MyUI
import Tirth.GLPanel 1.0

Item {
    id: appwindow

    width : demoMode? 800 : 950
    height : demoMode? 700 : 850

    property bool demoMode: false;

    property var allUIMenuItem : []
    property Component textBtuComp : Qt.createComponent("./MyUI/TextButton.qml");
    property Component textMagComp : Qt.createComponent("./MyUI/TextMag.qml");
    property int zDialog : 8;
    property int zUIBtu : 6;
    property int zGLPanel : 4;
    property int zBK : 1;

    property string ctxStateStr : '';

    function tagIsReadySlot(){
        console.log("tag is ready");
        syncBoxData( mylogicPanel.boxData );
    }

    function editDialogFactory(nvarg){
        nvarg.succCallBack = nvarg.succCallBack || function(){};
        nvarg.iniLabel = nvarg.iniLabel || function(){};

        // setup 'z' at parent object
        Qt.createComponent("./MyUI/Dialogv2.qml").createObject(
                    popupWarp,{iniLabel:nvarg.iniLabel, actionDoneCallBack:nvarg.succCallBack });
        popupWarp.focus=true;

    }
    function handleRePredictSignel(){

        if(mylogicPanel){
            mylogicPanel.rePredBtuSlot();
        }

    }

    function clearOldTextUI(){
        console.log('======clearOldTextUI==========');
        var i =0,j=0;
        //delete old tag
        for(i=0 ; i < allUIMenuItem.length ; i++){
            allUIMenuItem[i].visible=false;
            for(j=0; j <allUIMenuItem[i].allTextBtu.length ; j++){
                allUIMenuItem[i].allTextBtu[j].visible=false;
                allUIMenuItem[i].allTextBtu[j].destroy();
                allUIMenuItem[i].allTextBtu[j]=undefined;
            }
            allUIMenuItem[i].allTextBtu=undefined;
            allUIMenuItem[i].visible=false;
            allUIMenuItem[i].x=0;
            allUIMenuItem[i].y=0;
            allUIMenuItem[i].destroy();
            allUIMenuItem[i]=[];
        }
        //reset array (*must do)
        allUIMenuItem=[];
    }

    function handleRequestClearLabel(){
        clearOldTextUI();
    }
    function syncBoxData(boxData){
        //
        // directly binding cpp.panel.BOXDATA to textMag Component
        //
        var i =0 ;

        if( textMagComp.status !== Component.Ready ){
            if( textMagComp.status === Component.Error )
                console.debug("Error:"+ textMagComp.errorString() );
            return;
        }

        clearOldTextUI();

        // create new one
        console.log("box_data :"+boxData);
        for(i=0 ; i < boxData.length ; i++){

            var newBtu = textMagComp.createObject(
                          mainPanel, {dataModel:boxData[i],
                            dialogFactory:editDialogFactory,
                            repredHandler:handleRePredictSignel,
                            ctxState: Qt.binding(function(){return appwindow.ctxStateStr}) ,z:appwindow.zUIBtu} );

            allUIMenuItem.push(newBtu);
        }

    }

    function updateStateStr(ss){

        ctxStateStr = ss;//mylogicPanel.stateStr;});
        console.log(ss);
    }

    Component.onCompleted: {
        console.log("onCompleted");

        //mylogicPanel.tagIsReady.connect(appwindow.tagIsReadySlot);

        toolPanel.handler = mylogicPanel;
        toolPanel.pre_rePredictAction=appwindow.clearOldTextUI;

        toolPanel.debugFunc = function(){
            //for debug
            //*
            var datas = mylogicPanel.boxData;

            console.log("imid="+mylogicPanel.imgID);
            console.log("datas="+mylogicPanel.boxData);

            //console.log( datas[0].boxCx +','+datas[0].boxCy );
            console.log( datas[0].predTags );
            syncBoxData( datas );
            // */
        };
        //*
        textBoard.text = Qt.binding(function(){
                return appwindow.ctxStateStr+'\nM:'+mainPanelMouseArea.mouseX+','+mainPanelMouseArea.mouseY;});

        mylogicPanel.stateStrChange.connect(appwindow.updateStateStr);

        // mylogicPanel.requestClearLabel.connect(appwindow.handleRequestClearLabel);

        //use debugTestSlot in mylogicPanel to show underlying state
    }

    SplitView {
			
        x: 32
        y: 8
        anchors.rightMargin: 5
        anchors.bottomMargin: 5
        anchors.leftMargin: 0
        anchors.topMargin: 0
        anchors.fill: parent
		
        // LEFT main panel
        Rectangle {
            id: mainPanel
            width: appwindow.width*0.8
            //Layout.minimumWidth: 100
            //Layout.maximumWidth: 300
            color:"transparent"
            //color:"red"
			z : appwindow.zBK

			MouseArea{
                id: mainPanelMouseArea
				anchors.fill: parent
                onPressed: mylogicPanel.mousePressEvent(mouseX,mouseY,pressedButtons)
                onReleased: mylogicPanel.mouseReleaseEvent(mouseX,mouseY)
                onEntered: mylogicPanel.mouseEnter()
                onExited: mylogicPanel.mouseLeave()
                onPositionChanged: mylogicPanel.mouseMoveEvent(mouseX,mouseY)
                cursorShape: Qt.CrossCursor
                propagateComposedEvents : true
                acceptedButtons: Qt.AllButtons
                hoverEnabled : true
			}

			FocusScope{
                id:popupWarp
                anchors.fill: parent
                z : appwindow.zDialog
                //focus:true
            }

			// [EMBEDDING C++ control object]
            MyPanel{
                id: mylogicPanel
                anchors.fill: parent
                width: 640
                height: 480
                z : appwindow.zGLPanel
            }
			
			//state string
            Text{
                id:textBoard
                anchors.left: parent.left
                anchors.bottom: parent.bottom
                anchors.leftMargin: 30
                anchors.bottomMargin: 30
                text:''
            }

            Component.onCompleted: {

            }
        }

		// RIGHT 
        SplitView {
            orientation: Qt.Vertical
            MyUI.ToolPanel{
                id : toolPanel
                height: parent.height*0.75
            }
        }

    }
 
}
