import QtQuick 2.1
import QtQuick.Controls 1.2
import QtQuick.Layouts 1.0
import QtQuick.Dialogs 1.0
import QtQuick.Window 2.1

import "./MyUI" 1.0 as MyUI
import Tirth.GLPanel 1.0

ApplicationWindow {

    property bool demoMode: true;

	id: appwindow
    width  : demoMode? 860:1000
    height : demoMode? 600:780

    minimumHeight: height
    maximumHeight:height

    minimumWidth: width
    maximumWidth: width

    property int topMenuHeight:demoMode? 130 : 200


    property var allUIMenuItem : []
    property Component textBtuComp : Qt.createComponent("./MyUI/TextButton.qml");
    property Component textMagComp : Qt.createComponent("./MyUI/TextMagV3.qml");

    property int zUIMenu : 200; // control buttons
    property int zDialog : 100; // edit dialog
    property int zSuggestMenu : 20;
    property int zGL_MU : 6; // GL Mouse Area
    property int zGLPanel : 4; // GL
    property int zBK : 1; // main panel

    property string ctxStateStr : 'S_INI';

    property int focusBoxLIndex:-1;

    property string panel_info:'';
    property string anno_info:'';

    function editDialogFactory(nvarg){
        nvarg.succCallBack = nvarg.succCallBack || function(){};
        nvarg.iniLabel = nvarg.iniLabel || function(){};


        // callback would be called before destory lanuch

        // setup 'z' at parent object
        Qt.createComponent("./MyUI/Dialogv2.qml").createObject(
                    popupWarp,{
                        iniLabel:nvarg.iniLabel,
                        actionDoneCallBack:function(arg){ nvarg.succCallBack(arg); popupWarp.focus=false; mylogicPanel.focus=true;},
                        actionCancelCallBack:function(){popupWarp.focus=false; mylogicPanel.focus=true;}
                    });

        popupWarp.focus=true;

    }
	
    function handleRePredictSignel(){

        if(mylogicPanel){
            mylogicPanel.qmlRequestRePred();
        }

    }

    function clearOldTextUI(){
        console.log('======clearOldTextUI==========');

        var i =0,j=0;

        //delete old tag
        for(i=0 ; i < allUIMenuItem.length ; i++){

            mylogicPanel.segClick.disconnect(allUIMenuItem[i].btu__segClickHandler);
            mylogicPanel.segMMoveFocusChange.disconnect(allUIMenuItem[i].btu__segMoveFocusCahngeHandler);

            allUIMenuItem[i].visible=false;
            for(j=0; j <allUIMenuItem[i].allTextBtu.length ; j++){
                allUIMenuItem[i].allTextBtu[j].visible=false;
                allUIMenuItem[i].allTextBtu[j].destroy();
                allUIMenuItem[i].allTextBtu[j]=undefined;
            }
            allUIMenuItem[i].allTextBtu=undefined;
            allUIMenuItem[i].visible=false;
            allUIMenuItem[i].x=0;
            allUIMenuItem[i].y=0;
            allUIMenuItem[i].destroy();
            allUIMenuItem[i]=[];
        }
        //reset array (*must do)
        allUIMenuItem=[];

    }

    function handleRequestClearLabel(){
        clearOldTextUI();
    }

    function tagIsReadySlot(){
        console.log("qml:tag is ready");
        syncBoxData( mylogicPanel.boxData );
    }

    // GEN menu
    function syncBoxData(boxData){
        //
        // directly binding cpp.panel.BOXDATA to textMag Component
        //
        var i =0 ;

        if( textMagComp.status !== Component.Ready ){
            if( textMagComp.status === Component.Error )
                console.debug("Error:"+ textMagComp.errorString() );
            return;
        }

        clearOldTextUI();

        // create new one
        console.log("box_data #="+boxData.length);
        for(i=0 ; i < boxData.length ; i++){

            var newBtu = textMagComp.createObject(
                          mainPanel, {
                            boxIdx:i,
                            z:zSuggestMenu,
                            dataModel:boxData[i],
                            dialogFactory:editDialogFactory,
                            repredHandler:handleRePredictSignel,
                            topMenuHeight:topMenuHeight,
                            ctxState: Qt.binding(function(){return appwindow.ctxStateStr})
                        }
                        );

            // remember to delete them

            mylogicPanel.segClick.connect(newBtu.btu__segClickHandler);
            mylogicPanel.segMMoveFocusChange.connect(newBtu.btu__segMoveFocusCahngeHandler);

            newBtu.menuCloseSignal.connect(mylogicPanel.qmlMenuCloseRaise);

            allUIMenuItem.push(newBtu);

        }// loop


    }

    function updateStateStr(ss){

        ctxStateStr = ss;
        panel_info=mylogicPanel.getDisplayInfo();
        anno_info=mylogicPanel.getAnnoInfo();

        //console.log(ss+' , '+Qt.formatDateTime(new Date(), "MM-ss"));

        /*
        if(ss=="S_FINAL"){
            sgColorTable.visible=true;
        }else{
            sgColorTable.visible=false;
        }
        */

        console.log("anno_info="+anno_info);
        console.log("panel_info="+panel_info);

    }

    function updateInfoStr(){

        panel_info=mylogicPanel.getDisplayInfo();
    }

    // ini connect
    Component.onCompleted: {

        console.log("onCompleted");

        toolPanel.demoMode=demoMode;
        toolPanel.handler = mylogicPanel;
        toolPanel.pre_rePredictAction=appwindow.clearOldTextUI;
        toolPanel.infoUpdateHandler = updateInfoStr;
        toolPanel.currentState=Qt.binding(function(){ return appwindow.ctxStateStr});
        toolPanel.debugFunc = function(){
            //for debug
            var datas = mylogicPanel.boxData;

            console.log("imid="+mylogicPanel.imgID);
            console.log("datas="+mylogicPanel.boxData);

            console.log( datas[0].boxCx +','+datas[0].boxCy );
            console.log( datas[0].predTags );
            syncBoxData( datas );
            // */
        };
        toolPanel.inisync();

        //---------------------------------------------------------------------------------


        visOptsPanel.demoMode=demoMode;
        visOptsPanel.handler = mylogicPanel;
        visOptsPanel.inisync();
        visOptsPanel.currInfo = Qt.binding(function(){ return appwindow.anno_info });
        visOptsPanel.currentState=Qt.binding(function(){ return appwindow.ctxStateStr});

        //---------------------------------------------------------------------------------


        textBoard_anno.text = Qt.binding(function(){
            //return appwindow.ctxStateStr+'\nM:'+mainPanelMouseArea.mouseX+','+mainPanelMouseArea.mouseY;
            return anno_info;
         });


        textBoard.text = Qt.binding(function(){
                        //return appwindow.ctxStateStr+'\nM:'+mainPanelMouseArea.mouseX+','+mainPanelMouseArea.mouseY;

                        return appwindow.ctxStateStr+'\n'+panel_info;//+'\nM:'+mainPanelMouseArea.mouseX+','+mainPanelMouseArea.mouseY;
                });

        mylogicPanel.tagIsReady.connect(appwindow.tagIsReadySlot);

        mylogicPanel.stateStrChange.connect(appwindow.updateStateStr);


        anno_info=mylogicPanel.getAnnoInfo();
    }


    onWidthChanged: {
        console.log('[RESIZE]:'+width);

    }

    //TOP AND BOTTOM MAIN PANEL
    SplitView {
        x: 0
        y: 0

        //anchors.rightMargin: 5
        //anchors.bottomMargin: 5
        //anchors.leftMargin: 0
        //anchors.topMargin: 0
        anchors.fill: parent
        orientation: Qt.Vertical

        // TOP TOOL PANEL
        MyUI.ToolPanel_v2{
            id : toolPanel
            //height:parent.height
            height: topMenuHeight
            z:zUIMenu
        }

        //BOTTOM PANEL
        SplitView{

            orientation: Qt.Horizontal

            //anchors.fill:parent

            //left
            Rectangle {
                id: mainPanel
                //height:appwindow.height-200
                width:appwindow.width-visOptsPanel.width
                //Layout.minimumWidth: 100
                //Layout.minimumWidth: 100
                //Layout.maximumWidth: 300
                //color:"transparent"
                color:Qt.rgba(0.2,0.2,0,0.2)
                z : appwindow.zBK

                // [EMBEDDING C++ control object]
                MyPanel{
                    id: mylogicPanel
                    anchors.fill: parent
                    width: 640
                    height: 480
                    z : appwindow.zGLPanel
                    focus: true

                    DropArea {
                        id: dropArea;
                        anchors.fill: parent;
                        //keys: ["text/plain"]
                        onEntered: {
                            console.log("onEntered");
                        }
                        onDropped: {
                            if (drop.hasText) {
                                if (drop.proposedAction == Qt.MoveAction || drop.proposedAction == Qt.CopyAction) {
                                    //console.log ("onDropped :"+ drop.text);
                                    drop.acceptProposedAction();
                                    mylogicPanel.file_drop_slot(drop.urls);
                                }
                            }

                        }
                        onExited: {
                            console.log ("onExited");
                        }
                        Keys.onPressed: { console.log("DropArea:"+event.key); }

                    }


                }

                FocusScope{
                    id:popupWarp
                    anchors.fill: parent
                    z : appwindow.zDialog
                    focus:false
                    Keys.onPressed: { console.log("popupWarp:"+event.key); }

                }


                MouseArea{
                    id: mainPanelMouseArea
                    anchors.fill: parent
                    onPressed: mylogicPanel.mousePressEvent(mouseX,mouseY+topMenuHeight,pressedButtons)
                    onReleased: mylogicPanel.mouseReleaseEvent(mouseX,mouseY+topMenuHeight)
                    onEntered: mylogicPanel.mouseEnter()
                    onExited: mylogicPanel.mouseLeave()
                    onPressAndHold: {}
                    onWheel:{}
                    onPositionChanged: mylogicPanel.mouseMoveEvent(mouseX,mouseY+topMenuHeight)
                    cursorShape: Qt.CrossCursor
                    propagateComposedEvents : true
                    acceptedButtons: Qt.AllButtons
                    hoverEnabled : true
                    z:zGL_MU
                }

                //state string
                Text{
                    id:textBoard_anno
                    anchors.right: parent.right
                    anchors.top: parent.top
                    anchors.rightMargin: 50
                    anchors.topMargin: 100
                    color: Qt.rgba(0.8,0.8,1,1);
                    visible: !demoMode
                    text:''
                    font.pointSize: 13
                    font.bold: true
                    horizontalAlignment: Text.AlignRight
                }
                //state string
                Text{
                    id:textBoard
                    anchors.right: parent.right
                    anchors.top: textBoard_anno.bottom
                    anchors.rightMargin: 50
                    anchors.topMargin: 30
                    color: Qt.rgba(0.7,0.7,0.7,1);
                    visible: !demoMode
                    text:''
                    font.pointSize: 10
                    font.bold: true
                    horizontalAlignment: Text.AlignRight
                }


                Component.onCompleted: {

                }
            }

            MyUI.VisPanel_v2{

                width: 210
                id : visOptsPanel

            }
        }

        //

    }
 
}
