#ifndef MYQTGL_H
#define MYQTGL_H

#include <QtWidgets/QWidget>
#include <QtOpenGL/QGLWidget>
#include <QtOpenGL/QGLFunctions>
#include <QtOpenGL/QGLShaderProgram>
#include <QMouseEvent>
#include <Eigen/Eigen>
#include <iostream>
#include <vector>

#include "ui_myqtgl.h"


class MyQtGL : public QGLWidget
{
	Q_OBJECT

public:
	MyQtGL(QWidget *parent = 0);
	~MyQtGL();


protected:
	 virtual void	initializeGL();
	 virtual void	paintGL();
	 virtual void	resizeGL(int width, int height);
	
	 virtual void	mouseMoveEvent ( QMouseEvent * event );
	 virtual void	mousePressEvent ( QMouseEvent * event );
	 virtual void	mouseReleaseEvent ( QMouseEvent * event );

private:
	QGLFunctions * qglEntery;
	QGLShaderProgram * sp1_test;
	QGLShaderProgram * sp2_nyu;

	QMatrix4x4 oglMVP;


	std::vector<float> vpts;

	std::vector<float> plane_grid;

	int panelWidth;
	int panelHeight;
	//-------------------------------------
	void ini_nyu();
	void ini_sp2_nyu();
	void paintNYU();

	void ini_sp1();
	void paintSimpleTest();

	//-------------------------------------
	void constrDepthSensor(int x,int y);
	void constrDepthSensorV2(int mx , int my);
	Eigen::Vector3d constrDepthSensorV3(int mx , int my);

	void autoConstruct();
private:
	Ui::MyQtGLClass ui;

};

#endif // MYQTGL_H
