#include "stdafx.h"
#include "fcglpanel.h"

Tirth::FCGLPanel::FCGLPanel( QQuickItem * parent/*=0*/ )
{
	// register OPENGL draw call
	connect(this, SIGNAL(windowChanged(QQuickWindow*)), this, SLOT(handleWindowChanged(QQuickWindow*)));

	myassert(FCStateMag::NUM_OF_USIG-1==FCStateMag::U_END_GUARD,"UI enum size error");
	myassert(FCStateMag::NUM_OF_STATE-1==FCStateMag::S_END_GUARD,"State enum size error");

	// set up cTX 
	memset(updateTable,0,sizeof(updateTable));
	//-------------------------------------------------------------------------
	// anno
	updateTable[FCStateMag::S_PRE_INI][FCStateMag::U_DropFileSignal] = &FCGLPanel::_load_config; 
	updateTable[FCStateMag::S_INI][FCStateMag::U_AnnoIniListBtu] = &FCGLPanel::_initial_entry; 


	//label
	updateTable[FCStateMag::S_PREDICT][FCStateMag::U_ReqRepredictBtu] = &FCGLPanel::_anno_rePred;
	updateTable[FCStateMag::S_PRE_MENU_FOLD][FCStateMag::U_ReqRepredictBtu] = &FCGLPanel::_anno_rePred ;
	updateTable[FCStateMag::S_PREDICT][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_anno_reset;

	updateTable[FCStateMag::S_PREDICT][FCStateMag::U_MPress] = &FCGLPanel::_predSegMPressHandler;
	updateTable[FCStateMag::S_PREDICT][FCStateMag::U_MMove] = &FCGLPanel::_predMouseMove; 
	updateTable[FCStateMag::S_PRE_MENU_FOLD][FCStateMag::U_QML_MenuCloseSignal] = &FCGLPanel::_predMenuCloseHandler;
	updateTable[FCStateMag::S_PRE_MENU_FOLD][FCStateMag::U_MPress] = &FCGLPanel::_menuOpen_MPressedHandler ;

	//updateTable[FCStateMag::S_FINAL][FCStateMag::U_AnnoSaveBtu]  = &FCGLPanel::_anno_save;

	// support 
	updateTable[FCStateMag::S_SUP_EDITIDLE][FCStateMag::U_MMove]  = &FCGLPanel::_supadj_mouseMove; 
	updateTable[FCStateMag::S_SUP_EDITIDLE][FCStateMag::U_MPress] = &FCGLPanel::_supadj_mousePressed;
	updateTable[FCStateMag::S_SUP_EDITIDLE][FCStateMag::U_MRelease] = &FCGLPanel::_supadj_mouseReleased;
	updateTable[FCStateMag::S_SUP_EDITIDLE][FCStateMag::U_KeyPress]  = &FCGLPanel::_supadj_keyPressed; 

	//updateTable[FCStateMag::S_SUP_SEL][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_anno_reset;

	updateTable[FCStateMag::S_SUP_ASSIG][FCStateMag::U_MMove]  = &FCGLPanel::_supSel_mouseMove; 
	updateTable[FCStateMag::S_SUP_ASSIG][FCStateMag::U_MPress] = &FCGLPanel::_supSel_mousePressed;
	updateTable[FCStateMag::S_SUP_ASSIG][FCStateMag::U_MRelease] = &FCGLPanel::_supSel_mouseReleased;
	updateTable[FCStateMag::S_SUP_ASSIG][FCStateMag::U_KeyPress]  = &FCGLPanel::_supSel_keyPressed; 

	//box 
	//updateTable[FCStateMag::S_IDLE][FCStateMag::U_EnterSupAdjMode]  = &FCGLPanel::_supadj_enterMode;
	//updateTable[FCStateMag::S_IDLE][FCStateMag::U_BtuActionDoneBtu]  = &FCGLPanel::_actionDoneBack2Idle;
	//updateTable[FCStateMag::S_IDLE][FCStateMag::U_EnterBoxManiMode]  = &FCGLPanel::_bxsel_entermode;

	updateTable[FCStateMag::S_BOXMANI][FCStateMag::U_MPress] = &FCGLPanel::_bxmi_mousePressed;
	updateTable[FCStateMag::S_BOXMANI][FCStateMag::U_MRelease] = &FCGLPanel::_bxmi_mouseReleased;
	updateTable[FCStateMag::S_BOXMANI][FCStateMag::U_MMove]  = &FCGLPanel::_bxmi_mouseMove; 
	updateTable[FCStateMag::S_BOXMANI][FCStateMag::U_KeyPress]  = &FCGLPanel::_bxmi_keyPressed; 

	updateTable[FCStateMag::S_BOX_SEL][FCStateMag::U_MPress] = &FCGLPanel::_bxsel_mousePressed;
	updateTable[FCStateMag::S_BOX_SEL][FCStateMag::U_MRelease] = &FCGLPanel::_bxsel_mouseReleased;
	updateTable[FCStateMag::S_BOX_SEL][FCStateMag::U_MMove]  = &FCGLPanel::_bxsel_mouseMove; 
	updateTable[FCStateMag::S_BOX_SEL][FCStateMag::U_KeyPress]  = &FCGLPanel::_bxsel_keyPressed; 

	// require separated saving process 
	updateTable[FCStateMag::S_BOX_SEL][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_mode_box_reset;

	//----------------
	// mode switch
	//----------------

	//
	// save path is now direct to same dir.
	// 

	// pipeline mode

	updateTable[FCStateMag::S_IDLE][FCStateMag::U_AnnoStartBtu] = &FCGLPanel::_anno_load_aCase;

	updateTable[FCStateMag::S_FINAL][FCStateMag::U_AnnoResetBtu]  = &FCGLPanel::_anno_reset;
	updateTable[FCStateMag::S_FINAL][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_anno_move2Next;
	updateTable[FCStateMag::S_FINAL][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_anno_move2Prev;

	updateTable[FCStateMag::S_IDLE][FCStateMag::U_AnnoResetBtu]  = &FCGLPanel::_anno_reset;
	updateTable[FCStateMag::S_IDLE][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_anno_move2Next; 
	updateTable[FCStateMag::S_IDLE][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_anno_move2Prev; 

	updateTable[FCStateMag::S_PREDICT][FCStateMag::U_AnnoALLDoneBtu] = &FCGLPanel::_anno_allConf_v2;

	//---
	//updateTable[FCStateMag::S_SUPM_IDLE][FCStateMag::U_AnnoStartBtu] = &FCGLPanel::_mode_sup_start; 
	//updateTable[FCStateMag::S_SUPM_IDLE][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_mode_sup_move2Prev;
	//updateTable[FCStateMag::S_SUPM_IDLE][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_mode_sup_move2Next;
	//updateTable[FCStateMag::S_SUPM_IDLE][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_mode_sup_reset;

	//updateTable[FCStateMag::S_SUPM_FINAL][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_mode_sup_move2Next;
	//updateTable[FCStateMag::S_SUPM_FINAL][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_mode_sup_move2Prev;
	//updateTable[FCStateMag::S_SUPM_FINAL][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_mode_sup_reset;

	updateTable[FCStateMag::S_SUP_EDITIDLE][FCStateMag::U_BtuActionDoneBtu]  = &FCGLPanel::_supSel_actionDone; 

	//---
	//updateTable[FCStateMag::S_BOXM_IDLE][FCStateMag::U_AnnoStartBtu] = &FCGLPanel::_mode_box_start; 
	//updateTable[FCStateMag::S_BOXM_IDLE][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_mode_box_move2Prev;
	//updateTable[FCStateMag::S_BOXM_IDLE][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_mode_box_move2Next;
	//updateTable[FCStateMag::S_BOXM_IDLE][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_mode_box_reset;

	//updateTable[FCStateMag::S_BOXM_FINAL][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_mode_box_move2Next;
	//updateTable[FCStateMag::S_BOXM_FINAL][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_mode_box_move2Prev;	
	//updateTable[FCStateMag::S_BOXM_FINAL][FCStateMag::U_AnnoResetBtu] = &FCGLPanel::_mode_box_reset;

	updateTable[FCStateMag::S_BOX_SEL][FCStateMag::U_BtuActionDoneBtu]  = &FCGLPanel::_bxsel_actionDone; 
	//-------------------------------------------------------------------------

	//------------------------------------------------------------------------- 
	// DRAW object segmentation
	//
	updateTable[FCStateMag::S_DRAW_OBJSEG][FCStateMag::U_MMove]    = &FCGLPanel::_drawobj_mouseMove; 
	updateTable[FCStateMag::S_DRAW_OBJSEG][FCStateMag::U_MPress]   = &FCGLPanel::_drawobj_mousePressed;
	updateTable[FCStateMag::S_DRAW_OBJSEG][FCStateMag::U_MRelease] = &FCGLPanel::_drawobj_mouseReleased;
	updateTable[FCStateMag::S_DRAW_OBJSEG][FCStateMag::U_KeyPress] = &FCGLPanel::_drawobj_keyPressed;
	updateTable[FCStateMag::S_DRAW_OBJSEG][FCStateMag::U_BtuActionDoneBtu] = &FCGLPanel::_drawobj_actionDone; 
	updateTable[FCStateMag::S_DRAW_OBJSEG][FCStateMag::U_AddObjPressed] = &FCGLPanel::_drawobj_addObjPressed; 

	updateTable[FCStateMag::S_AFTDRAW_IDLE][FCStateMag::U_AnnoStartBtu] = &FCGLPanel::_anno_load_aCase;
	/*
	updateTable[FCStateMag::S_AFTDRAW_IDLE][FCStateMag::U_AnnoNextBtu] = &FCGLPanel::_draw_next;
	updateTable[FCStateMag::S_AFTDRAW_IDLE][FCStateMag::U_AnnoPrevBtu] = &FCGLPanel::_draw_previous;
	*/
	  

	// no reset
	updateTable[FCStateMag::S_IDLE][FCStateMag::U_AnnoResetBtu]   = nullptr;
	updateTable[FCStateMag::S_FINAL][FCStateMag::U_AnnoResetBtu]  = nullptr;

	updateTable[FCStateMag::S_DRAW_IDLE][FCStateMag::U_AnnoStartBtu]  = &FCGLPanel::_draw_load_aCase;

	updateTable[FCStateMag::S_DRAW_IDLE][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_draw_next;
	updateTable[FCStateMag::S_DRAW_IDLE][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_draw_previous;

	//updateTable[FCStateMag::S_DRAW_FINAL][FCStateMag::U_AnnoStartBtu]  = &FCGLPanel::_draw_load_aCase;
	updateTable[FCStateMag::S_DRAW_FINAL][FCStateMag::U_AnnoNextBtu]  = &FCGLPanel::_draw_next;
	updateTable[FCStateMag::S_DRAW_FINAL][FCStateMag::U_AnnoPrevBtu]  = &FCGLPanel::_draw_previous;


	//------------------------------------------------------------------------- 

	showBox=false;
	showSG=false;
	showBK=true;

	showConfAllBox=false;
	showSupport=false;
	showSuggestion=true;

	m_program_2d=nullptr;
	m_program_3d=nullptr;
	m_program_bxmi_vex=nullptr;
	m_program_bxmi_rot=nullptr;
	m_program_supadj=nullptr;

	ctx.inputImgTex=nullptr;
	ctx.gtsegContourTex=nullptr;
	ctx.segDraw_paperTex=nullptr;
	ctx.labelImgTex=nullptr;
	ctx.supVisTex = nullptr;
	 
	use_eraser=0;

	oglEntry=nullptr;

	resetCtx();


	/*
	// direct load

	tctx  = loadUIConf("./uconf.txt");

	std::cout
	<<"LOAD DONE:\n"
	<<"annoresSavePath="<<tctx.annoresSavePath<<std::endl
	<<"freqModelPath="<<tctx.freqModelPath<<std::endl
	<<"us_trial_sidlist="<<tctx.us_trial_sidlist<<std::endl
	<<"db_root="<<tctx.db_root<<std::endl
	<<"batchFPath="<<tctx.batchFPath<<std::endl
	<<"\nDONE."<<std::endl
	<<std::endl;
	*/
}

Tirth::FCGLPanel::~FCGLPanel()
{
	ogl_cleanup();
}

//--------------------------------------------------------------------------
#pragma region LOGIC

void Tirth::FCGLPanel::debugCheck()
{
	std::cout<<"debug check\n";

	lastFileDropPath="file:\\K:\\Paper_project\\memorability_UCL\\EvalLog\\0827\\test_1\\uiconf_nb.txt";
	lastFileDropPath="file:\\F:\\Paper_project\\nyu_explorer\\EvalLog\\0827\\test_1\\uiconf_pc.txt";

	/*
	//std::cout<<"box idx=";
	int bid=10;
	//std::cin>>bid;

	if (cin && ctx.isReady)
	{
	printALLBoxGeometryInfo(ctx.boxDatas[bid]);
	}

	//print some info
	std::cout<<"fr2world:\n"<<ctx.tx_fr2world<<std::endl;
	std::cout<<"world2fr:\n"<<ctx.tx_world2fr<<std::endl;

	std::cout<<"\n\n"
	<<"floor_fr:\n"<<ctx.floor_fr.model<<std::endl
	<<"floor_world:\n"<<ctx.floor_ini.model<<std::endl;

	*/

	ctx.currentState= _load_config();

	emit stateStrChange( getCurStateStr() );

}

void Tirth::FCGLPanel::resetCtx()
{
	bool verbase=false;
	// 45:471, 41:601

	ctx.isReady=false;

	// Matlab data is column-major
	float mvp[16] = {
		//[640x480] 1.6214309411703185,0,0,0,0,2.1644567130053121,0,0,0.017445154409969854,-0.057234026391685955,1.2222222222222223,1,0,0,-2.2222222222222223,0
		// 1.8497607885008978,0,0,0,0,2.4331129326523411,0,0,0.00029393729479607056,0.0035776752505636278,1.2222222222222223,1,0,0,-2.2222222222222223,0
		1.8497607885008978,0,0,0,0,2.4331129326523411,0,0,0.00029393729479607056,0.0035776752505636278,1.002002002002002,1,0,0,-2.0020020020020022,0
	};

	// this is ..top-left center
	float world2img[16]={
		518.85790117450188,0,0,0,0,-519.46961112127485,0,0,280.58244941119028,212.73616633400468,1.002002002002002,1,0,0,-2.0020020020020022,0
	};

	ctx.TX_world2img=Eigen::Map<Eigen::Matrix4f >(world2img); 

	ctx.oglMVP=QMatrix4x4(mvp);
	// Qmat use row-major order.
	ctx.oglMVP=ctx.oglMVP.transposed();

	// Eigen use column major
	ctx.oglMVP_e=Eigen::Map<Eigen::Matrix4f >(mvp); 

	ctx.viewport_tx=0;
	ctx.viewport_ty=0;

	ctx.panelHeight= 471-45+1; // 427 
	ctx.panelWidth = 601-41+1; // 561

	if( ctx.inputImgTex!=nullptr ){
		delete ctx.inputImgTex;
		ctx.inputImgTex=nullptr;
	} 

	if( ctx.gtsegContourTex!=nullptr ){
		delete ctx.gtsegContourTex;
		ctx.gtsegContourTex=nullptr;
	} 
	 
	ctx.gtsegCvMat_16u.release();
	ctx.gtsegCvMat_8uc4.release();

	ctx.roomImg.release();

	ctx.fr_xyzPcd=PointCloudXYZ::Ptr(new PointCloudXYZ());
	ctx.fr_nvPcd=PointCloudXYZ::Ptr(new PointCloudXYZ()); 
	ctx.ini_xyzPcd=PointCloudXYZ::Ptr(new PointCloudXYZ()); 

	ctx.tx_fr2world.setZero();
	ctx.tx_world2fr.setZero();

	ctx.oglFloor=OGLPlaneData();
	ctx.oglWallPls.clear();

	ctx.cam_fr.setZero();
	ctx.walls_fr.clear();
	ctx.floor_fr=PlaneData();
	ctx.floor_ini=PlaneData(); 

	ctx.boxDatas.clear();

	ctx.annosavePath="";

	ctx.timer.reset();
	ctx.predLog.clear();

	ctx.currentState=FCStateMag::S_PRE_INI;

	ctx.showStructure=false;

	ctx.all_contours.clear();
	ctx.contourUID.clear();

	ctx.bkseg_focus_box_idx=-1;
	ctx.focus_box_uid=0;

	ctx.suggestBOX_LID=-1;

	ctx.all2dBoxPolygon.clear();

	showConfAllBox=false;
	//showSuggestion=false;

	ctx.bxmiCtx.resetControl();

	ctx.lastKeyCode=-1;

	//-------------------------------------

	if( ctx.supVisTex!=nullptr ){
		delete ctx.supVisTex;
		ctx.supVisTex=nullptr;
	} 

	ctx.supVisMat.release();
	ctx.supVisArrIDMat.release();
	ctx.supAdj_focus_box_idx=-1;

	ctx.setSupCtx.resetControl();

	ctx.supVis_roomContour.clear();
	ctx.supVis_roomCTRUid.clear();

	ctx.supVis_showBox=0;

	ctx.segDrawCtx.resetALL();

	setShowSupport(false);
}

void Tirth::FCGLPanel::box2dCenUpdate()
{
	for( int i=0; i < ctx.boxDatas.size(); i++ ){   

		ctx.boxDatas[i].updateBoxWCen2d(ctx.oglMVP_e , window()->height() , ctx.panelWidth , ctx.panelHeight , ctx.viewport_tx , ctx.viewport_ty );
	}

}

void Tirth::FCGLPanel::optimalBoxSize(const int BOX_IDX)
{

	int iw= ctx.boxDatas[BOX_IDX].getClosedWallLIdx();
	if( iw > -1){

		int v1_idx=-1;
		int v2_idx=-1;

		float dist = topfacePlaneDist_fr(ctx.boxDatas[BOX_IDX],ctx.walls_fr[iw],v1_idx,v2_idx);

		if(dist < 0.9 ){

			for( int iv=0 ; iv < 4 ;iv++ ){
				if( iv!=v1_idx && iv!=v2_idx ){
					optimalBoxSize_inn(BOX_IDX,iv); // v0-v1  , v1-v2
				}
			}

		}else{
			optimalBoxSize_inn(BOX_IDX,0); // v0-v1
			optimalBoxSize_inn(BOX_IDX,1); // v1-v2
			optimalBoxSize_inn(BOX_IDX,2); // v2-v3
			optimalBoxSize_inn(BOX_IDX,3); // v3-v4 
		}

	}else{
		optimalBoxSize_inn(BOX_IDX,0); // v0-v1
		optimalBoxSize_inn(BOX_IDX,1); // v1-v2
		optimalBoxSize_inn(BOX_IDX,2); // v2-v3
		optimalBoxSize_inn(BOX_IDX,3); // v3-v4

	}

}

void Tirth::FCGLPanel::optimalBoxSize_inn(const int BOX_IDX,const int IDX_V1)
{
	// require initial seg and 2d boxes

	int numSeg=0;
	int numBox=0;
	int ori_numOver=0;
	float ori_overRatio=0;

	// the original 
	cal2DPixelOverlapp(BOX_IDX,numSeg,numBox,ori_numOver,ori_overRatio); 
	BoxDataV2 oriBox=ctx.boxDatas[BOX_IDX];
	BoxDataV2 resBox=ctx.boxDatas[BOX_IDX];

	cv::Mat const & BOX_SEG = ctx.boxDatas[BOX_IDX].getSegMask();

	//-------------------------------------------------------------------------

	Eigen::MatrixXf boxwn3=resBox.getBox3d_world_n3();

	// 0-1 --> 3-2
	const int IDX_V2 = (IDX_V1+1)%4; 

	int v3_idx = ((IDX_V1-1+4)%4 != IDX_V2) ? (IDX_V1-1+4)%4 : (IDX_V1+1+4)%4;
	int v4_idx = ((IDX_V2-1+4)%4 != IDX_V1) ? (IDX_V2-1+4)%4 : (IDX_V2+1+4)%4;

	float ssedge_len_v01 =(boxwn3.row(v3_idx)-boxwn3.row(v4_idx)).norm();

	int i_numSeg=0;
	int i_numBox=0;
	int i_numOver=0;
	float i_overRatio=0; 

	float ss_v01_step = 0.05/ssedge_len_v01; // 5cm

	if( ss_v01_step < 0.001 ){
		ss_v01_step=0.001;
	}


	std::vector<float> all_adj_ratio;


	float max_sRatio = 1;
	float i_ratio = 1;

	int iter=0;

	// decreasing
	while( i_ratio > 0.1 ){ 
		mBox_EdgeScale(oriBox,i_ratio,IDX_V1,IDX_V2,ctx.tx_fr2world,resBox); 
		// update 2d polygon
		cal2DPixelOverlapp(resBox.getBox3d_world_n3(),BOX_SEG ,i_numSeg,i_numBox,i_numOver,i_overRatio);

		// check overlapping ratio

		// tol:40pixels
		if( i_numOver+40 < ori_numOver  ){
			// become worse stop. 
			break;
		}else{
			// because we are decreasing the size 
			max_sRatio=i_ratio; 
		}

		// step 
		i_ratio=i_ratio-ss_v01_step;
		iter=iter+1;

		if(iter>500){
			break;
		}
	}

	// do action
	mBox_EdgeScale(oriBox,max_sRatio,IDX_V1,IDX_V2,ctx.tx_fr2world,ctx.boxDatas[BOX_IDX]);


	//-------------------------------------------------------------------------
	// 
	//mBox_EdgeScale(abox,s_ratio,1,2,ctx.tx_fr2world);
	//mBox_EdgeScale(abox,s_ratio,2,3,ctx.tx_fr2world);
	//mBox_EdgeScale(abox,s_ratio,3,0,ctx.tx_fr2world);


}

void Tirth::FCGLPanel::genBoxByGT()
{
	bool verbase=0;

	if( ctx.gtsegCvMat_16u.total() > 0 ){
		std::vector<int> uidList;

		findCVMAP_State(ctx.gtsegCvMat_16u , uidList);

		//BoxDataV2 abox;
		//exbox( 16 , ctx.gtsegImg , ctx.fr_xyzPcd , ctx.fr_nvPcd , ctx.tx_fr2world , abox );
		//ctx.boxDatas.push_back(abox);

		//[TEST] try to GEN the bed box 
		for( int i=0; i < uidList.size(); i++ ){  

			BoxDataV2 abox; 
			exbox( uidList[i] , ctx.gtsegCvMat_16u , ctx.fr_xyzPcd , ctx.fr_nvPcd , ctx.tx_fr2world , abox );

			mBoxScale(abox,ctx.tx_fr2world,Eigen::RowVector3f(0.95,1,0.95));

			abox.updateBoxWCen2d(ctx.oglMVP_e , window()->height() , ctx.panelWidth , ctx.panelHeight , ctx.viewport_tx , ctx.viewport_ty );

			ctx.boxDatas.push_back(abox);
		}

		if( verbase ){
			for( int i=0; i < uidList.size(); i++ ){ 
				std::cout<<"box."<<i<<" ="<<uidList[i]<<std::endl;
			}
		}

	}else{
		debugPrint("GT seg is NULL **");
	}

	if( verbase ){

		std::cout<<"tx_fr2world=["<<ctx.tx_fr2world<<"]\n\n";

		std::cout<<"tx_world2fr=["<<ctx.tx_world2fr<<"]\n\n";
	}

}

void Tirth::FCGLPanel::exWalls()
{
	// USE FR pts
	myassert(ctx.fr_xyzPcd,"fr must be ini");

	bool verbase = 0;

	// travel room map
	std::vector<int> uidlist ; 
	findCVMAP_State( ctx.roomImg , uidlist  );

	// assume we must contain floor 
	//  so the remaining non-zeros uid is belong to wall
	//
	const int WNUM = uidlist.size()-1;

	//Eigen::Vector3f refCam(0,ctx.flo
	Eigen::Vector3f frnv;
	frnv<<0,1,0;

	for( int i=0 ; i<uidlist.size() ; i++ ){
		if( uidlist[i] > 1 ){
			// not 0,1
			// extract walls  

			PlaneData aw;

			float avg_err = planeRANSAC_LSE( uidlist[i] ,ctx.roomImg , ctx.fr_xyzPcd ,ctx.cam_fr ,aw  );

			//std::cout<<"EX-WALL--> avg_err:"<<avg_err<<std::endl;

			ctx.walls_fr.push_back(aw);

			if( verbase ){
				float frcos = frnv.dot(aw.model.head(3).normalized());
				std::cout<<"EX-WALL="<<""<<aw.model.transpose()<<" ,cos="<<frcos<<std::endl;
			}
		}
	}

}


void Tirth::FCGLPanel::exWalls_v2()
{
	// USE FR pts
	myassert(ctx.fr_xyzPcd,"fr must be ini");

	bool verbase = 0;

	// travel room map
	std::vector<int> uidlist ; 
	findCVMAP_State( ctx.roomImg , uidlist  );

	// assume we must contain floor 
	//  so the remaining non-zeros uid is belong to wall
	//
	const int WNUM = uidlist.size()-1;

	//Eigen::Vector3f refCam(0,ctx.flo

	for( int i=0 ; i<uidlist.size() ; i++ ){
		if( uidlist[i] > 1 ){
			// not 0,1
			// extract walls  
			PlaneData aw; 
			//planeRANSAC( uidlist[i] ,ctx.roomImg , ctx.fr_xyzPcd ,ctx.cam_fr ,aw); 
			planeRANSAC_byXZLine_room( uidlist[i] ,ctx.roomImg , ctx.fr_xyzPcd ,ctx.cam_fr ,aw); 

			ctx.walls_fr.push_back(aw);
			if( verbase ){
				std::cout<<"EX-WALL."<<ctx.walls_fr.size()<<" :"<<aw.model<<std::endl;
			}
		}
	}

}


void Tirth::FCGLPanel::convOGLPlane()
{
	// prepare glsl data
	bool verbase =1;

	float lineLen=0.5;

	ctx.oglFloor=makePlane(ctx.floor_fr, lineLen ,ctx.floor_fr.pts[0] , ctx.tx_fr2world);

	ctx.oglWallPls.clear();

	for (int iw=0 ; iw < ctx.walls_fr.size() ; iw++)
	{
		ctx.oglWallPls.push_back( makePlane( ctx.walls_fr[iw], lineLen, ctx.walls_fr[iw].pts[0] , ctx.tx_fr2world ) );

	}

}

void Tirth::FCGLPanel::calFRPts()
{ 
	bool verbase=1;
	//------------------------------------------------------------------------
	// calculate the fr matrix 
	Eigen::MatrixXf rmat = rotateV2V(ctx.floor_ini.model.head(3),Eigen::Vector3f(0,1,0));

	ctx.tx_world2fr=Eigen::Matrix4f::Identity();
	ctx.tx_world2fr.block(0,0,3,3)=rmat;

	//-------------------------------------------------------------------------
	// cal FHeight TX & update floor

	Eigen::Vector3f p0=ctx.tx_world2fr.block(0,0,3,3) * ctx.floor_ini.pts[0];

	float fHeight = p0.y();
	p0.y()=0;

	// [get the 4x4 TX mat]	
	Eigen::Matrix4f txmat=Eigen::Matrix4f::Identity();
	txmat(2-1,4-1)=-1*fHeight;

	ctx.tx_world2fr = txmat*ctx.tx_world2fr;

	//-------------------------------------------------------------------------

	//update fr_floor pts
	for (int iv=0; iv < PlaneData::CSS_VNUM ; iv++)
	{
		Eigen::Vector4f v4 ;
		v4<<ctx.floor_ini.pts[iv],1;

		v4=(ctx.tx_world2fr*v4);
		ctx.floor_fr.pts[iv]=v4.hnormalized(); 
	}

	// update floor_fr model
	Eigen::VectorXf newFPL;
	newFPL.resize(4,1);
	newFPL<<0,1,0,0;

	ctx.floor_fr.model=newFPL; 
	//-------------------------------------------------------------------------
	// cal FR2World

	//bool isInvet=false; 
	//Eigen::Matrix3f obbMat = rmat;
	//Eigen::Matrix3f invMat;
	//obbMat.computeInverseWithCheck(invMat,isInvet);

	//if(isInvet) {
	//	//std::cout << "It is invertible, and its inverse is: " << invMat << std::endl;
	//}else {
	//	throw  "FloorMat is not invertible.";
	//} 

	//Eigen::Matrix4f inv_txmat=Eigen::Matrix4f::Identity();
	//inv_txmat(2-1,4-1)=fHeight;
	//
	//ctx.tx_fr2world =Eigen::Matrix4f::Identity();
	//ctx.tx_fr2world.block(0,0,3,3)=invMat;

	//ctx.tx_fr2world = ctx.tx_fr2world*inv_txmat;
	// 

	ctx.tx_fr2world = ctx.tx_world2fr.inverse(); 

	if(verbase){

		std::cout<<"I-\n"<<ctx.tx_fr2world*ctx.tx_world2fr<<"\n";
	}
	//-------------------------------------------------------------------------

	Eigen::Vector4f c0(0,0,0,1);

	ctx.cam_fr =  (ctx.tx_world2fr*c0).hnormalized();

	//-------------------------------------------------------------------------
	// for getting PointXYZ use dim=3, stride=4 and offset=0 
	// 3xN
	//Eigen::MatrixXf xmap =ctx.fr_xyzPcd->getMatrixXfMap(3,4,0);
	//Eigen::MatrixXf fr_xyz = ctx.tx_world2fr * xmap;

	// 4xN
	//Eigen::MatrixXf xmap =ctx.fr_xyzPcd->getMatrixXfMap(4,4,0);
	//Eigen::MatrixXf fr_xyz = ctx.tx_world2fr * xmap; 
	// initial fr pcd
	pcl::copyPointCloud(*ctx.ini_xyzPcd,*ctx.fr_xyzPcd); 


	auto & emap  =ctx.fr_xyzPcd->getMatrixXfMap(4,4,0);
	emap = ctx.tx_world2fr * emap;  

	//-------------------------------------------------------------------------
	// calculate fr normal vector 
	estimateNE(ctx.fr_xyzPcd,ctx.fr_nvPcd);

}

void Tirth::FCGLPanel::exFloor()
{ 
	int FL_LID = 1; 


	planeRANSAC_floor(FL_LID ,ctx.roomImg , ctx.ini_xyzPcd,Eigen::Vector3f(0,0,0),ctx.floor_ini);

}

void Tirth::FCGLPanel::iniBoxVoxelDS()
{
	bool verbase_pcd=0;

	//==========================================================================================
	// [Point Cloud] down sampling boxes
	//*
	std::vector<int> tarIds;
	std::vector<int> filted_res; 
	pcl::PointCloud<pcl::PointXYZ>::Ptr debugPCD (new pcl::PointCloud<pcl::PointXYZ>());

	std::cout<<"voxel down sampling start.\n";

	for( int ib=0 ; ib<ctx.boxDatas.size() ;ib++ ){

		int uid=ctx.boxDatas[ib].getUID();

		tarIds.clear();
		filted_res.clear();

		// found boxes index
		findCVIMGIdx(uid,ctx.gtsegCvMat_16u,tarIds);

		if( tarIds.size() ==0 ){
			throw "invalid -- tarIds=0 -- voxel down sampling ";
		}

		pcl::PointCloud<pcl::PointXYZ>::Ptr cloud_filtered (new pcl::PointCloud<pcl::PointXYZ>());
		pcl::PointCloud<pcl::PointXYZ>::Ptr clound_in (new pcl::PointCloud<pcl::PointXYZ>());

		// filter-out pts via 'map'
		pcl::copyPointCloud(*ctx.ini_xyzPcd , tarIds , *clound_in);  

		//do down sampling 
		bool res = voxelFiltering( clound_in , 0.05, cloud_filtered);

		// [SET result pts]
		if( res ){
			// result is good 
			ctx.boxDatas[ib].set3dPcdW(cloud_filtered); 
		}else{
			// result is bad
			ctx.boxDatas[ib].set3dPcdW(clound_in); 
		} 

	}

	if( verbase_pcd ){
		pcl::io::savePCDFileBinary("test_filted.pcd",*debugPCD);
		std::cout<<"voxel down sampling END\n";
	} 
	//*/

}

void Tirth::FCGLPanel::calculateBox3Error()
{



}

void Tirth::FCGLPanel::iniboxAfterLoading()
{
	iniBoxVoxelDS();
}


void Tirth::FCGLPanel::updateBoxPoly2D()
{

	//========================================================================================== 
	// [2D] update BOX POLYGON 2D 
	//*
	ctx.all2dBoxPolygon.clear();
	ctx.all2dBoxPolygon.resize(ctx.boxDatas.size());

	ctx.all2dBoxCVPoly.clear();
	ctx.all2dBoxCVPoly.resize(ctx.boxDatas.size());

	for( int ib=0; ib<ctx.boxDatas.size() ;ib++ ){

		Eigen::MatrixXf b2d;

		// 2d re-projection
		proj_world2img( ctx.boxDatas[ib].getBox3d_world_n3() , ctx.TX_world2img , b2d );

		ctx.boxDatas[ib].setBox2d_img(b2d);

		//------------------------------------------------------------------------
		// get boost geometry for [BOX 2d]
		BGPolygon boxPly;
		for( int iv=0 ; iv<8 ; iv++ ){
			boxPly.outer().push_back(BGPoint(b2d(iv,0),b2d(iv,1))); 
		} 

		// re-take CONVEX HULL
		boost::geometry::convex_hull(boxPly, ctx.all2dBoxPolygon[ib]);

		//------------------------------------------------------------------------
		// get cv polygon for [BOX 2d]

		std::vector< cv::Point > box2d_cv;

		for( int iv=0 ; iv< b2d.rows() ;iv++ ){
			box2d_cv.push_back(cv::Point(b2d.row(iv).x(),b2d.row(iv).y() ) );
		}

		// take convex hull

		ctx.all2dBoxCVPoly[ib].clear();

		cv::convexHull(box2d_cv,ctx.all2dBoxCVPoly[ib]);

	}// loop

	//========================================================================================== 


	box2dCenUpdate();


}


// need to call after iniCoutour and updateBoxPoly2D
void Tirth::FCGLPanel::updateBox2DSeg()
{ 
	int verbase=0;
	int verbase2=0;
	int verbase_pcd=0;
	int verbase_occ=0;


	//========================================================================================== 


	//==========================================================================================
	// 2D segmentation MASK
	for( int ib=0; ib<ctx.boxDatas.size() ;ib++ ){

		int uid = ctx.boxDatas[ib].getUID();

		cv::Mat boxSegMask;
		cv::Mat uidMat = cv::Mat(ctx.gtsegCvMat_16u.size(),CV_16UC1,uid);

		boxSegMask = uidMat==ctx.gtsegCvMat_16u; 
		//int numofpts=cv::countNonZero(boxSegMask);
		ctx.boxDatas[ib].setSegMask(boxSegMask);

	}

	// so how to test box 2d overlapping ratio ?
	// 1. get the convex of box2d
	// 2. mark all pts inside the box2d

	// initial box2d mat mask
	// cv::Mat debugMat = cv::Mat::zeros(ctx.gtsegCvMat_16u.size(),CV_8UC4);

	//===========================
	// INI BOX 2D polygon and BG
	for( int ib=0  ; ib < ctx.boxDatas.size() ;ib++ ){

		std::vector< cv::Point > const & BOX2d_CV_COVHULL=ctx.all2dBoxCVPoly[ib]; 

		// push box 2d polygon
		std::vector< std::vector<cv::Point> > all_cc;
		all_cc.push_back(BOX2d_CV_COVHULL);

		// initial mask
		cv::Mat box2d_Mask = cv::Mat::zeros(ctx.gtsegCvMat_16u.size(),CV_16UC1);

		// [FILL this 2d polygon]
		cv::drawContours(box2d_Mask, all_cc,-1,cv::Scalar(255),CV_FILLED);

		//save
		ctx.boxDatas[ib].set_box2dMask(box2d_Mask);

		if( verbase_occ ){
			cv::Mat const & m1=ctx.boxDatas[ib].get_box2dMask();
			cv::Mat const & m2=ctx.boxDatas[ib].getSegMask();

			m1.size();

			cv::Mat effBoxReg = (m1>0) & (m2>0);

			//std::cout<<"box."<<ib<<" - eff pixels:"
			//		 <<cv::countNonZero(effBoxReg)<<",ratio="
			//		 <<cv::countNonZero(effBoxReg)*1.0 /cv::countNonZero(m1)<<std::endl;
			//cv::imwrite("debug_cvh.png",debugMat);
		}

	}



	//==========================================================================================
	// 2D  
	/*
	cv::Mat pts3d_repj;
	Eigen::Vector3f v3f;

	for( int ib=0 ; ib<ctx.boxDatas.size() ;ib++ ){

	// down-sampling points
	pcl::PointCloud<pcl::PointXYZ>::Ptr pcdWptr=ctx.boxDatas[ib].getPcdW();

	Eigen::MatrixXf boxPcd3N_world =pcdWptr->getMatrixXfMap(3,4,0);
	// Nx3
	boxPcd3N_world.transposeInPlace();

	Eigen::MatrixXf pts_img;

	proj_world2img(boxPcd3N_world,ctx.TX_world2img,pts_img);

	// convert to mat
	}
	*/
	//==========================================================================================
}

void Tirth::FCGLPanel::updateBoxPlanes()
{



	// [BOX] construct box plane
	static int FACE_VIDX[][3]={		
		{0,1,2},
		{0,4,5}, //1
		{1,5,6}, //2
		{2,6,7}, //3
		{3,7,4}, //4
		{4,5,6}
	};	

	//FR
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){

		Eigen::MatrixXf boxfrn3=ctx.boxDatas[ib].getBox3d_fr_n3();
		Eigen::Vector3f boxc0 = boxfrn3.colwise().mean();

		std::vector<PlaneData> box_planes(6);

		// FOR EACH FACE -- create a plane 
		for( int k=0 ; k < 6 ; k++ ){

			Eigen::Vector3f e1=(boxfrn3.row(FACE_VIDX[k][1])-boxfrn3.row(FACE_VIDX[k][0]));
			Eigen::Vector3f e2=boxfrn3.row(FACE_VIDX[k][1])-boxfrn3.row(FACE_VIDX[k][2]);

			Eigen::Vector3f nv = e1.cross(e2);

			nv.normalize();

			Eigen::Vector3f v2 = boxc0 - ctx.cam_fr ;

			// flip out
			if( sameDirC0(nv,boxc0) ){
				nv=nv*-1;
			}

			float coeff_d = -1*nv.dot(boxfrn3.row(FACE_VIDX[k][1]));
			box_planes[k].model.resize(4,1);
			box_planes[k].model<<nv,coeff_d;
			box_planes[k].pts[0]=boxfrn3.row(FACE_VIDX[k][0]);
			box_planes[k].pts[1]=boxfrn3.row(FACE_VIDX[k][1]);
			box_planes[k].pts[2]=boxfrn3.row(FACE_VIDX[k][2]);
		}

		ctx.boxDatas[ib].setBoxPlane_fr(box_planes);
	}

	// world
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){

		Eigen::MatrixXf box_n3=ctx.boxDatas[ib].getBox3d_world_n3();
		Eigen::Vector3f boxc0 = box_n3.colwise().mean();

		std::vector<PlaneData> box_planes(6);

		// FOR EACH FACE -- create a plane 
		for( int k=0 ; k < 6 ; k++ ){

			Eigen::Vector3f e1=(box_n3.row(FACE_VIDX[k][1])-box_n3.row(FACE_VIDX[k][0]));
			Eigen::Vector3f e2=box_n3.row(FACE_VIDX[k][1])-box_n3.row(FACE_VIDX[k][2]);

			Eigen::Vector3f nv = e1.cross(e2);

			nv.normalize();

			Eigen::Vector3f v2 = boxc0 - ctx.cam_fr ;

			// flip out
			if( sameDirC0(nv,boxc0) ){
				nv=nv*-1;
			}

			float coeff_d = -1*nv.dot(box_n3.row(FACE_VIDX[k][1]));
			box_planes[k].model.resize(4,1);
			box_planes[k].model<<nv,coeff_d;
			box_planes[k].pts[0]=box_n3.row(FACE_VIDX[k][0]);
			box_planes[k].pts[1]=box_n3.row(FACE_VIDX[k][1]);
			box_planes[k].pts[2]=box_n3.row(FACE_VIDX[k][2]);
		}

		ctx.boxDatas[ib].setBoxPlane_world(box_planes);
	}

	//==========================================================================================
	// check OCCustate
	for( int ib=0 ; ib < ctx.boxDatas.size() ;ib++ ){

		checkBoxOccuState(ib);
	}
}

int Tirth::FCGLPanel::cal2DPixelOverlap_sim(const int IDX )
{
	int s1,s2,num_over;
	float s4;
	cal2DPixelOverlapp(IDX,s1,s2,num_over,s4);

	return num_over;
}

void Tirth::FCGLPanel::cal2DPixelOverlapp(const int IDX ,
										  int & num_seg , int & num_box , int & num_over, float & overRatio )
{

	bool verbase=0;

	cv::Mat const & box2d_m1=ctx.boxDatas[IDX].get_box2dMask();
	cv::Mat const & seg_m2=ctx.boxDatas[IDX].getSegMask();

	box2d_m1.size();

	cv::Mat effBoxReg = (box2d_m1>0) & (seg_m2>0);

	num_seg=cv::countNonZero(seg_m2);
	num_box=cv::countNonZero(box2d_m1);

	num_over=cv::countNonZero(effBoxReg);

	overRatio = num_over*1.0/num_box;

	if(verbase){
		std::cout<<"box."<<IDX
			<<" - eff pixels:"
			<<num_over<<",ratio="
			<<overRatio<<std::endl; 
	}

}

void Tirth::FCGLPanel::cal2DPixelOverlapp(Eigen::MatrixXf const& BOX3Dn3_WORLD ,
										  cv::Mat const & BOX_SEG_MASK,
										  int & num_seg , int & num_box , int & num_over, float & overRatio )
{

	Eigen::MatrixXf b2d;

	proj_world2img( BOX3Dn3_WORLD , ctx.TX_world2img , b2d );

	// create cv polygon
	std::vector< cv::Point > box2d_cv;

	for( int iv=0 ; iv< b2d.rows() ;iv++ ){
		box2d_cv.push_back(cv::Point(b2d.row(iv).x(),b2d.row(iv).y() ) );
	}

	// take convex hull	 
	std::vector< cv::Point > box2d_cvh;
	cv::convexHull(box2d_cv,  box2d_cvh );

	// generate box_2d mask
	// push box 2d polygon
	std::vector< std::vector<cv::Point> > all_cc;
	all_cc.push_back(box2d_cvh);

	// initial mask
	cv::Mat box2d_Mask = cv::Mat::zeros(ctx.gtsegCvMat_16u.size(),CV_16UC1);

	// [FILL this 2d polygon]
	cv::drawContours(box2d_Mask, all_cc,-1,cv::Scalar(255),CV_FILLED);

	//-------------------------------------------------------------------------

	cv::Mat const & BOX2D_MASK=box2d_Mask;
	cv::Mat const & SEG_MASK=BOX_SEG_MASK;

	BOX2D_MASK.size();

	cv::Mat effBoxReg = (BOX2D_MASK>0) & (SEG_MASK>0);

	num_seg=cv::countNonZero(SEG_MASK);
	num_box=cv::countNonZero(BOX2D_MASK); 
	num_over=cv::countNonZero(effBoxReg);

	overRatio = num_over*1.0/num_box;

}

int Tirth::FCGLPanel::cal2DPixelOverlap_sim(Eigen::MatrixXf const& BOX3Dn3_WORLD , cv::Mat const & BOX_SEG_MASK  )
{
	int s1,s2,num_over;
	float s4;
	cal2DPixelOverlapp(BOX3Dn3_WORLD,BOX_SEG_MASK,s1,s2,num_over,s4);

	return num_over;
}

// CALL After prediction is made
void Tirth::FCGLPanel::calculate_box_conf()
{
	bool verbase=0;
	// after creating box planes

	//==========================================================================================
	// calculate occlusion state

	// test on all plane

	// collect all Eigen plane
	Eigen::Hyperplane<float,3>* allboxPlane=new Eigen::Hyperplane<float,3>[ctx.boxDatas.size()*6];

	Eigen::Hyperplane<float,3>();

	for( int ib=0 ; ib<ctx.boxDatas.size() ;ib++ ){

		auto & boxPls=ctx.boxDatas[ib].getBoxPlane_fr();

		for( int k=0 ; k<6 ; k++ ){
			allboxPlane[ib*6+k]=Eigen::Hyperplane<float,3>( boxPls[k].model.head(3) , boxPls[k].model(4-1) );
		}
	}

	// test intersection state
	for( int ib=0 ; ib<ctx.boxDatas.size() ; ib++ ){

		Eigen::MatrixXf boxfrn3=ctx.boxDatas[ib].getBox3d_fr_n3();

		for( int ix=0 ; ix<ctx.boxDatas.size() ;ix++ ){

			for( int k=0 ; k<6 ; k++ ){

			}
		}
	}

	//==========================================================================================
	// calculate min distance to plane
	/*
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){
	// 4xN                                                              dim,stride,offset
	Eigen::MatrixXf boxPcd3N = ctx.boxDatas[ib].getPcdW()->getMatrixXfMap(4,4,0);

	// 4xN
	boxPcd3N = ctx.tx_world2fr*boxPcd3N;

	boxPcd3N.row(0)=boxPcd3N.row(0).array() / boxPcd3N.row(3).array() ;
	boxPcd3N.row(1)=boxPcd3N.row(1).array() / boxPcd3N.row(3).array() ;
	boxPcd3N.row(2)=boxPcd3N.row(2).array() / boxPcd3N.row(3).array() ;

	Eigen::MatrixXf boxPcd3N_fr= boxPcd3N.block(0,0,3,boxPcd3N.cols());

	auto const & boxPlane3N_fr = ctx.boxDatas[ib].getBoxPlane_fr();

	Eigen::MatrixXf all_dist;
	all_dist.resize(6,boxPcd3N_fr.cols());

	for( int k=0 ; k < 6 ; k++ ){
	//                 1xN
	all_dist.row(k)=pointPlaneABSDist_pcd(boxPcd3N_fr,boxPlane3N_fr[k] );
	}

	Eigen::MatrixXf minDist = all_dist.colwise().minCoeff();

	double mean_allMINDist = minDist.array().sum() / all_dist.size();

	ctx.boxDatas[ib].quality.meanPlane2VXPcdErr=mean_allMINDist;

	if(verbase){
	std::cout<<"box."<<ib<<" , err_dist = "<<std::setprecision(3)<<mean_allMINDist<<std::endl;
	//std::cerr<<"box."<<ib<<" , err_dist = "<<std::setprecision(3)<<mean_allMINDist<<std::endl;
	}
	}
	*/

	//==========================================================================================
	// recheck screen space clipped flag
	double remainArea=0;

	for( int ib=0; ib<ctx.all2dBoxPolygon.size() ;ib++ ){

		remainArea=screenSpaceCuted(ctx.all2dBoxPolygon[ib],ctx.panelWidth,ctx.panelHeight,ctx.viewport_tx,ctx.viewport_ty);

		double boxArea = boxAbsArea(ctx.all2dBoxPolygon[ib]);
		double remRatio =  remainArea/boxArea ;

		//[save]
		ctx.boxDatas[ib].quality.box2d_inScreenArea=remainArea;
		ctx.boxDatas[ib].quality.box2d_inScreen_ratio=remRatio;

		if(verbase){
			std::cout<<"box-"<<ib<<", occ- rem box2d ratio = "<<remRatio<<std::endl;
		}
	}

	//==========================================================================================
	//2d box-seg overlapping 
	for( int ib=0; ib<ctx.boxDatas.size() ;ib++ ){

		int numseg=0;
		int numbox=0;
		int num_over=0;
		float seg_over_ratio;

		cal2DPixelOverlapp(ib,numseg,numbox,num_over,seg_over_ratio);

		// [save]
		ctx.boxDatas[ib].quality.boxSeg2d_overlapArea=num_over;
		ctx.boxDatas[ib].quality.boxSeg2d_overlapRatio=seg_over_ratio; 
		ctx.boxDatas[ib].quality.segImg_Ratio=numseg / (ctx.panelHeight*ctx.panelWidth);

	}

	//==========================================================================================
	// count relationship
	std::vector<int> isparCount(ctx.boxDatas.size());

	int totalEdge=0;
	for( int ib=0 ; ib<ctx.boxDatas.size() ; ib++ ){

		int relCount=0;

		if( ctx.boxDatas[ib].isSupByGround() ){
			relCount=relCount+1;
		}

		if( ctx.boxDatas[ib].isSupByWall()){
			relCount=relCount+1;
		}

		if( ctx.boxDatas[ib].isSupByObj()){
			int plidx=ctx.boxDatas[ib].getSupporterLIDX();

			relCount=relCount-1;
			isparCount[plidx]=isparCount[plidx]+1;
		}   

		//ctx.boxDatas[ib].quality.num_ctxEdges=relCount;
		totalEdge += relCount;
	}

	// add support parent count and initial richCtxRatio
	double supPar_weight = 8;
	for( int ib=0 ; ib<ctx.boxDatas.size() ; ib++ ){

		// ctx.boxDatas[ib].quality.richCtxRatio = ctx.boxDatas[ib].quality.num_ctxEdges*1.0/totalEdge;
		ctx.boxDatas[ib].quality.richCtxRatio = 0;

		if( ctx.boxDatas[ib].isSupByGround() ){
			ctx.boxDatas[ib].quality.richCtxRatio += 1;
		}

		Eigen::MatrixXf b3d = ctx.boxDatas[ib].getBox3d_fr_n3();

		float len_1 = (b3d.row(0)-b3d.row(1)).norm();
		float len_2 = (b3d.row(1)-b3d.row(2)).norm();
		float len_h = (b3d.row(0)-b3d.row(4)).norm();

		ctx.boxDatas[ib].quality.vol = len_1 * len_2 * len_h ;

		if( isparCount[ib] ){
			//ctx.boxDatas[ib].quality.richCtxRatio += isparCount[ib] ;
		}
	}
	//==========================================================================================
	// # of neighboring boxes
	//==========================================================================================

}

void Tirth::FCGLPanel::makeNextBoxSuggestion(BoxStateLog const & BS_LOG)
{
	// check we have ctx obj or not
	bool found_ctxobj=false;
	for( int ib=0 ; ib<ctx.boxDatas.size() ; ib++ ){
		if( BS_LOG.boxState[ib] == BoxStateLog::BSTATE_UNK ){
			if( ctx.boxDatas[ib].quality.richCtxRatio  > 0){
				found_ctxobj=true;
			}
		}
	}

	// [SUM THEM ALL] 
	std::vector<BoxQualityTerm> allcost;
	allcost;
	for( int ib=0 ; ib<ctx.boxDatas.size() ; ib++ ){

		if( BS_LOG.boxState[ib] == BoxStateLog::BSTATE_UNK ){


			if( true ){
				if( found_ctxobj ){

					if( ctx.boxDatas[ib].quality.richCtxRatio  > 0 ){
						double a_cost = ctx.boxDatas[ib].quality.vol;
						BoxQualityTerm bs;
						bs.prob=a_cost;
						bs.boxIdx=ib;
						allcost.push_back(bs);
					}

				}else{
					double a_cost = ctx.boxDatas[ib].quality.vol ;
					BoxQualityTerm bs;
					bs.prob=a_cost;
					bs.boxIdx=ib;
					allcost.push_back(bs);
				}
			}else{

				double a_cost=ctx.boxDatas[ib].quality.menu_belif; 
				BoxQualityTerm bs;
				bs.prob=a_cost;
				bs.boxIdx=ib;
				allcost.push_back(bs);
			}

			std::cout<<"box-"<<ib<<","<<ctx.boxDatas[ib].quality.menu_belif<<"\n"; 
		}
	}

	// 'descend' sorting
	std::sort(allcost.begin(),allcost.end(),boxQTerm_desComp);

	//for( int i=0 ; i<allcost.size() ; i++ ){ 
	//	std::cout<<allcost[i].boxIdx<<" ,"<<allcost[i].prob<<"\n";
	//}

	// the first one should be the best one;
	if( allcost.size()>0 ){
		ctx.suggestBOX_LID=allcost[0].boxIdx;

		// request update texture
		requireUpdateContourTex=1;
	}else{
		ctx.suggestBOX_LID=-1;

		// request update texture
		requireUpdateContourTex=1; 
	}

}

void Tirth::FCGLPanel::ini_afterObjseg()
{

	exFloor();

	calFRPts();

	std::cout<<"start exWalls..\n"; 
	exWalls();
	std::cout<<"exWalls done..\n";

	//-------------------------------------------------------------------------

	ctx.boxDatas.clear();

	genBoxByGT(); 

	convOGLPlane();

	iniContour();


	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes();

	requireUpdateContourTex=1;
}

//-------------------------------------------------------------------------


void Tirth::FCGLPanel::load_finerSeg(const int IMG_ID)
{

	// finer seg PATH

	std::string segpath=loader.get_finer_PATH(IMG_ID);

	if (!fileisExisted(segpath))
	{
		std::cout<<"[FINER_SEG LOAD FAILED] at:"<< segpath <<std::endl;
		return;
	}

	// finer seg id map
	ctx.segDraw_finerseg=cv::imread((segpath.c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	ctx.segDraw_finerseg.convertTo(ctx.segDraw_finerseg,CV_16UC1);

	// initial visualization map
	ctx.segDraw_paper = cv::Mat(ctx.segDraw_finerseg.rows,ctx.segDraw_finerseg.cols,CV_8UC4, cv::Scalar(0,0,0,0)); 
	// user result
	ctx.segDraw_idmap = cv::Mat(ctx.segDraw_finerseg.rows,ctx.segDraw_finerseg.cols,CV_16UC1, cv::Scalar(0));

}

//loadCase_v2
void Tirth::FCGLPanel::loadCase_uDrawMode( const int IMG_ID)
{
	bool verbase=false;

	clock_t t = clock();

	ctx.imid = IMG_ID; 
	
	//-------------------------------------------------------------------------
	// bk img
	std::string impath=loader.getImagePath(IMG_ID);
	if( !fileisExisted(impath ) ){
		std::cout<<"[IMG LOAD FAILED] at:"<<loader.getImagePath(IMG_ID)<<std::endl;
		return;
	} 

	ctx.inputImg.load( impath.c_str() );

	//-------------------------------------------------------------------------
	// load room map
	//ctx.roomImg=cv::imread((loader.get_autoroom_PATH(IMG_ID).c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	
	ctx.roomImg=cv::imread((loader.getRoomSegPath(IMG_ID).c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	ctx.roomImg.convertTo(ctx.roomImg,CV_32SC1);

	// load finer seg
	load_finerSeg(IMG_ID);

	requireUpdateDrawPaperTex=1;

	//-------------------------------------------------------------------------

	// load ini pts
	std::cout<<loader.getIni_XYZPCDPath(IMG_ID).c_str() <<std::endl;
	pcl::io::loadPCDFile( loader.getIni_XYZPCDPath(IMG_ID).c_str() , *ctx.ini_xyzPcd);

	//-------------------------------------------------------------------------
	ctx.worldCen=ctx.ini_xyzPcd->getMatrixXfMap(3,4,0).rowwise().mean();


	t = clock() - t;
	printf ("LOADING took (%f seconds).\n",((float)t)/CLOCKS_PER_SEC);

}

void Tirth::FCGLPanel::loadCase( const int IMG_ID, bool useAutoSeg /*=false*/ )
{
	bool verbase=false;

	clock_t t = clock();

	ctx.imid = IMG_ID; 
	//-------------------------------------------------------------------------

	std::string impath=loader.getImagePath(IMG_ID);
	if( !fileisExisted(impath ) ){
		std::cout<<"[IMG LOAD FAILED] at:"<<loader.getImagePath(IMG_ID)<<std::endl;
		return;
	} 

	ctx.inputImg.load( impath.c_str() );
	//-------------------------------------------------------------------------

	// load gt seg map

	std::string segpath;

	if (useAutoSeg)
	{
		segpath=loader.getAutoSegPath(IMG_ID);

		std::cout<<"use AUTO seg \n";
		if( !fileisExisted(segpath) ){
			std::cout<<"[SEG LOAD FAILED] at:"<<segpath<<std::endl;
			return;
		} 
	}else{

		segpath=loader.getSegPath(IMG_ID);
	}

	ctx.gtsegCvMat_16u=cv::imread(segpath,CV_LOAD_IMAGE_ANYDEPTH);

	ctx.gtsegCvMat_16u.convertTo(ctx.gtsegCvMat_16u,CV_16UC1);

	if( 0==ctx.gtsegCvMat_16u.total() ){
		std::cout<<"[IMG LOAD FAILED] at:"<<loader.getSegPath(IMG_ID)<<std::endl;
		return;
	}

	printOPENCVType(ctx.gtsegCvMat_16u);
	//-------------------------------------------------------------------------

	ctx.gtsegCoutourImg.load(segpath.c_str());

	//-------------------------------------------------------------------------

	// load ini
	std::cout<<loader.getIni_XYZPCDPath(IMG_ID).c_str() <<std::endl;
	pcl::io::loadPCDFile( loader.getIni_XYZPCDPath(IMG_ID).c_str() , *ctx.ini_xyzPcd);

	// load room map
	ctx.roomImg=cv::imread((loader.getRoomSegPath(IMG_ID).c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	ctx.roomImg.convertTo(ctx.roomImg,CV_32SC1);

	//-------------------------------------------------------------------------
	bool sizeIsGood = ctx.roomImg.rows == ctx.gtsegCvMat_16u.rows  &&
		ctx.gtsegCvMat_16u.rows == ctx.inputImg.height();

	myassert(sizeIsGood,"size should be same");

	if( verbase ){
		std::cout<<"room img :"<<ctx.roomImg.cols <<"x"<<ctx.roomImg.rows<<"\n"
			<<"gtseg img :"<<ctx.gtsegCvMat_16u.cols <<"x"<<ctx.gtsegCvMat_16u.rows<<"\n"
			<<"input img :"<<ctx.inputImg.width() <<"x"<<ctx.inputImg.height()<<"\n";
	}

	//-------------------------------------------------------------------------
	ctx.worldCen=ctx.ini_xyzPcd->getMatrixXfMap(3,4,0).rowwise().mean();

	exFloor();

	calFRPts();

	exWalls();

	//-------------------------------------------------------------------------
	// load pre-defined boxes list
	// ***
	genBoxByGT(); 

	convOGLPlane();

	iniContour();


	t = clock() - t;
	printf ("It took (%f seconds).\n",((float)t)/CLOCKS_PER_SEC);

}

void Tirth::FCGLPanel::fast_reloadCase( const int IMG_ID, bool useAutoSeg /*=false*/)
{
	ctx.imid = IMG_ID;

	bool verbase = 1;
	//-------------------------------------------------------------------------

	if( !ctx.inputImg.load( loader.getImagePath(IMG_ID).c_str()) ){
		std::cout<<"[IMG LOAD FAILED] at:"<<loader.getImagePath(IMG_ID)<<std::endl;
	}

	// load gt seg map  
	//std::cout<<loader.getSegPath(IMG_ID)<<std::endl;
	//------------------------------------------------------------------------- 
	std::string segpath;

	if (useAutoSeg)
	{
		segpath=loader.getAutoSegPath(IMG_ID);

		std::cout<<"use AUTO seg \n";

	}else{

		segpath=loader.getSegPath(IMG_ID);
	}

	ctx.gtsegCvMat_16u=cv::imread(segpath,CV_LOAD_IMAGE_ANYDEPTH);

	ctx.gtsegCvMat_16u.convertTo(ctx.gtsegCvMat_16u,CV_16UC1);

	if( 0==ctx.gtsegCvMat_16u.total() ){
		std::cout<<"[IMG LOAD FAILED] at:"<<segpath<<std::endl;
	}

	ctx.gtsegCoutourImg.load(segpath.c_str());

	//-------------------------------------------------------------------------

	// load room map
	ctx.roomImg=cv::imread((loader.getRoomSegPath(IMG_ID).c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	ctx.roomImg.convertTo(ctx.roomImg,CV_32SC1);

	//-------------------------------------------------------------------------

	// load ini
	std::cout<<loader.getIni_XYZPCDPath(IMG_ID).c_str() <<std::endl;

	loadPCDAndCheck(loader.getIni_XYZPCDPath(IMG_ID).c_str() , *ctx.ini_xyzPcd);

	loadPCDAndCheck(loader.getProc_FrXYZ_Path(IMG_ID).c_str() , *ctx.fr_xyzPcd);

	loadPCDAndCheck(loader.getProc_FrNV_Path(IMG_ID).c_str() , *ctx.fr_nvPcd);

	//-------------------------------------------------------------------------
	bool sizeIsGood = ctx.roomImg.rows == ctx.gtsegCvMat_16u.rows  &&
		ctx.gtsegCvMat_16u.rows == ctx.inputImg.height();

	myassert(sizeIsGood,"size should be same");

	if( verbase ){
		std::cout<<"room img :"<<ctx.roomImg.cols <<"x"<<ctx.roomImg.rows<<"\n"
			<<"gtseg img :"<<ctx.gtsegCvMat_16u.cols <<"x"<<ctx.gtsegCvMat_16u.rows<<"\n"
			<<"input img :"<<ctx.inputImg.width() <<"x"<<ctx.inputImg.height()<<"\n";
	}


	//-------------------------------------------------------------------------
	// [load scene and boxes list]
	NaiveSceneCTX nnctx;

	std::string sbin = loader.get_sceini_bin_path(IMG_ID,tctx.input_bin_dir);

	if( !fileisExisted(sbin) ){
		std::cout<<"fail to found scene.bin :"<<sbin<<std::endl;
	}

	loadSceneANDBoxes( 
		sbin.c_str(),
		nnctx,
		ctx.floor_ini,
		ctx.floor_fr,
		ctx.walls_fr,
		ctx.boxDatas
		);

	if( verbase ){
		std::cout<<"loadSceneANDBoxes DONE."<<std::endl;

	}

	conv_NaiveSCTX_to_CTX(nnctx);


	//-------------------------------------------------------------------------

	convOGLPlane();

	//-------------------------------------------------------------------------
	if( verbase ){
		std::cout<<"iniContour start."<<std::endl;

	}
	iniContour();
	if( verbase ){
		std::cout<<"iniContour Done."<<std::endl;

	} 

}

void Tirth::FCGLPanel::fast_loadifexist( const int IMG_ID , bool autoSave)
{
	bool fileExisted=true;

	fileExisted &= fileisExisted(loader.getProc_FrXYZ_Path(IMG_ID).c_str());
	fileExisted &= fileisExisted(loader.getProc_FrNV_Path(IMG_ID).c_str());
	fileExisted &= fileisExisted(loader.get_sceini_bin_path(IMG_ID,tctx.input_bin_dir).c_str()); 

	if( fileExisted ){
		fast_reloadCase(IMG_ID , tctx.use_auto_seg );

	}else{
		loadCase(IMG_ID , tctx.use_auto_seg );

		if( autoSave ){
			std::cout<<"Auto save scene data.\n";
			saveProcessedIniCase();
		}
	}
}


void Tirth::FCGLPanel::fast_reloadCase_processed( const int IMG_ID, bool useAutoSeg /*=false*/ )
{
	ctx.imid = IMG_ID;

	bool verbase = 1;
	//-------------------------------------------------------------------------

	if( !ctx.inputImg.load( loader.getImagePath(IMG_ID).c_str()) ){
		std::cout<<"[IMG LOAD FAILED] at:"<<loader.getImagePath(IMG_ID)<<std::endl;
	}

	// load gt seg map  
	//-------------------------------------------------------------------------
	std::string segpath;

	if (useAutoSeg)
	{
		segpath=loader.getAutoSegPath(IMG_ID);

		std::cout<<"use AUTO seg \n";
	}else{

		segpath=loader.getSegPath(IMG_ID);
	}
	std::cout<<segpath<<std::endl;

	ctx.gtsegCvMat_16u=cv::imread(segpath,CV_LOAD_IMAGE_ANYDEPTH);

	ctx.gtsegCvMat_16u.convertTo(ctx.gtsegCvMat_16u,CV_16UC1);

	if( 0==ctx.gtsegCvMat_16u.total() ){
		std::cout<<"[IMG LOAD FAILED] at:"<<segpath<<std::endl;
	}

	ctx.gtsegCoutourImg.load(segpath.c_str());
	//-------------------------------------------------------------------------

	// load room map
	ctx.roomImg=cv::imread((loader.getRoomSegPath(IMG_ID).c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	ctx.roomImg.convertTo(ctx.roomImg,CV_32SC1);

	//-------------------------------------------------------------------------

	// load ini
	std::cout<<loader.getIni_XYZPCDPath(IMG_ID).c_str() <<std::endl;

	loadPCDAndCheck(loader.getIni_XYZPCDPath(IMG_ID).c_str() , *ctx.ini_xyzPcd);

	loadPCDAndCheck(loader.getProc_FrXYZ_Path(IMG_ID).c_str() , *ctx.fr_xyzPcd);

	loadPCDAndCheck(loader.getProc_FrNV_Path(IMG_ID).c_str() , *ctx.fr_nvPcd);

	//-------------------------------------------------------------------------
	bool sizeIsGood = ctx.roomImg.rows == ctx.gtsegCvMat_16u.rows  &&
		ctx.gtsegCvMat_16u.rows == ctx.inputImg.height();

	myassert(sizeIsGood,"size should be same");

	if( verbase ){
		std::cout<<"room img :"<<ctx.roomImg.cols <<"x"<<ctx.roomImg.rows<<"\n"
			<<"gtseg img :"<<ctx.gtsegCvMat_16u.cols <<"x"<<ctx.gtsegCvMat_16u.rows<<"\n"
			<<"input img :"<<ctx.inputImg.width() <<"x"<<ctx.inputImg.height()<<"\n";
	}


	//-------------------------------------------------------------------------
	// [load scene and boxes list]
	NaiveSceneCTX nnctx;

	std::string sbin = loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir);

	if( !fileisExisted(sbin) ){
		std::cout<<"fail to found scene.bin :"<<sbin<<std::endl;
	}

	loadSceneANDBoxes( 
		sbin.c_str(),
		nnctx,
		ctx.floor_ini,
		ctx.floor_fr,
		ctx.walls_fr,
		ctx.boxDatas
		);

	if( verbase ){
		std::cout<<"loadSceneANDBoxes DONE."<<std::endl;

	}

	conv_NaiveSCTX_to_CTX(nnctx);


	//-------------------------------------------------------------------------

	convOGLPlane();

	//-------------------------------------------------------------------------
	if( verbase ){
		std::cout<<"iniContour start."<<std::endl;

	}
	iniContour();
	if( verbase ){
		std::cout<<"iniContour Done."<<std::endl;

	} 

}


void Tirth::FCGLPanel::fast_reloadCase_processed( const int IMG_ID, const std::string LOADBIN_DIR ,bool useAutoSeg /*=false*/ )
{
	ctx.imid = IMG_ID;

	bool verbase = 1;
	//-------------------------------------------------------------------------

	if( !ctx.inputImg.load( loader.getImagePath(IMG_ID).c_str()) ){
		std::cout<<"[IMG LOAD FAILED] at:"<<loader.getImagePath(IMG_ID)<<std::endl;
	}

	// load gt seg map  
	//-------------------------------------------------------------------------
	std::string segpath;

	if (useAutoSeg)
	{
		segpath=loader.getAutoSegPath(IMG_ID);

		std::cout<<"use AUTO seg \n";
	}else{

		segpath=loader.getSegPath(IMG_ID);
	}
	std::cout<<segpath<<std::endl;

	ctx.gtsegCvMat_16u=cv::imread(segpath,CV_LOAD_IMAGE_ANYDEPTH);

	ctx.gtsegCvMat_16u.convertTo(ctx.gtsegCvMat_16u,CV_16UC1);

	if( 0==ctx.gtsegCvMat_16u.total() ){
		std::cout<<"[IMG LOAD FAILED] at:"<<segpath<<std::endl;
	}

	ctx.gtsegCoutourImg.load(segpath.c_str());
	//-------------------------------------------------------------------------

	// load room map
	ctx.roomImg=cv::imread((loader.getRoomSegPath(IMG_ID).c_str()),CV_LOAD_IMAGE_ANYDEPTH);
	ctx.roomImg.convertTo(ctx.roomImg,CV_32SC1);

	//-------------------------------------------------------------------------

	// load ini
	std::cout<<loader.getIni_XYZPCDPath(IMG_ID).c_str() <<std::endl;

	loadPCDAndCheck(loader.getIni_XYZPCDPath(IMG_ID).c_str() , *ctx.ini_xyzPcd);

	loadPCDAndCheck(loader.getProc_FrXYZ_Path(IMG_ID).c_str() , *ctx.fr_xyzPcd);

	loadPCDAndCheck(loader.getProc_FrNV_Path(IMG_ID).c_str() , *ctx.fr_nvPcd);

	//-------------------------------------------------------------------------
	bool sizeIsGood = ctx.roomImg.rows == ctx.gtsegCvMat_16u.rows  &&
		ctx.gtsegCvMat_16u.rows == ctx.inputImg.height();

	myassert(sizeIsGood,"size should be same");

	if( verbase ){
		std::cout<<"room img :"<<ctx.roomImg.cols <<"x"<<ctx.roomImg.rows<<"\n"
			<<"gtseg img :"<<ctx.gtsegCvMat_16u.cols <<"x"<<ctx.gtsegCvMat_16u.rows<<"\n"
			<<"input img :"<<ctx.inputImg.width() <<"x"<<ctx.inputImg.height()<<"\n";
	}


	//-------------------------------------------------------------------------
	// [load scene and boxes list]
	NaiveSceneCTX nnctx;

	std::string sbin = loader.getResultSceneBin_SAVEPath(IMG_ID, LOADBIN_DIR );

	if( !fileisExisted(sbin) ){
		std::cout<<"fail to found scene.bin :"<<sbin<<std::endl;
	}

	loadSceneANDBoxes( 
		sbin.c_str(),
		nnctx,
		ctx.floor_ini,
		ctx.floor_fr,
		ctx.walls_fr,
		ctx.boxDatas
		);

	if( verbase ){
		std::cout<<"loadSceneANDBoxes DONE."<<std::endl;

	}

	conv_NaiveSCTX_to_CTX(nnctx);


	//-------------------------------------------------------------------------

	convOGLPlane();

	//-------------------------------------------------------------------------
	if( verbase ){
		std::cout<<"iniContour start."<<std::endl;

	}
	iniContour();
	if( verbase ){
		std::cout<<"iniContour Done."<<std::endl;

	} 

}



void Tirth::FCGLPanel::saveProcessedIniCase( )
{
	NaiveSceneCTX scectx;

	conv_CTX_to_NaiveSCTX(scectx);

	saveSceneANDBoxes(
		loader.get_sceini_bin_path(ctx.imid , tctx.input_bin_dir ).c_str(),
		&scectx,
		ctx.floor_ini,
		ctx.floor_fr,
		ctx.walls_fr,
		ctx.boxDatas
		);

	// CHECK WALLS
	if( ctx.walls_fr.size() ){

	}else{

		std::cout<<"** NO WALL DATA - skip \n";
	}	

	// save processed PCD
	pcl::io::savePCDFileBinary( loader.getProc_FrXYZ_Path(ctx.imid), *ctx.fr_xyzPcd );
	pcl::io::savePCDFileBinary( loader.getProc_FrNV_Path(ctx.imid) , *ctx.fr_nvPcd );



	//-------------------------------------------------------------------------

}


TextCTX const Tirth::FCGLPanel::loadUIConf( const char* FPATH)
{
	resetCtx();   

	TextCtxLoader tl;

	tl.load(FPATH);

	return tl.getTCTX(); 
} 

#pragma endregion LOGIC

//-------------------------------------------------------------------------
//DISPATCH function
void Tirth::FCGLPanel::dispatch( FCStateMag::State fromS1 , FCStateMag::UISignal usignal )
{
	// check transition function
	auto stepHandler = updateTable[fromS1][usignal];

	if( stepHandler ){

		//perform action
		FCStateMag::State nextState = stepHandler(*this);

		//check update state or not
		if( ctx.currentState != nextState ){
			// change to the new state
			ctx.currentState = nextState;
			emit stateStrChange( getCurStateStr() );
		}

	}else{
		if( usignal !=FCStateMag::U_MMove ){
			//std::cout<<getCurStateStr().toStdString()<<": empty step , signal="<<usignal<<"\n";
		}
	}

	this->update();
}

//-------------------------------------------------------------------------
#pragma region DRAW_UTILITY

void Tirth::FCGLPanel::paint( QPainter * painter )
{
	painter->setRenderHint(QPainter::Antialiasing, true);


}

void Tirth::FCGLPanel::paint_ogl_bef()
{  

	//DWORD dwID = GetCurrentThreadId();
	//std::cout<<"paint_ogl_bef , TID="<<dwID<<"\n";

	glPushAttrib(GL_ENABLE_BIT);

	glClearColor(0, 0, 0, 0); 
	glViewport(0,0, window()->width(), window()->height()); 
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT ); 

	// do real drawing in after OGL call
	if(ctx.isReady){

		if (ctx.currentState == FCStateMag::S_BOXMANI )
		{
			if( showBK ){
				render2d_seg_contour();	
			}

			if (ctx.bxmiCtx.maniMode==BxmiCtx::M_ROT_Y)
			{
				renderManiBox_Rot();

			}else{
				renderManiBox_Vex();
			}

		}else if(ctx.currentState == FCStateMag::S_BOX_SEL ){

			render2d_seg_contour();	

			renderBox3d_v2_boxsel();	


		}else if(ctx.currentState == FCStateMag::S_SUP_EDITIDLE || ctx.currentState == FCStateMag::S_SUP_ASSIG ){

			// 2d 
			// input img as bk
			render2d_bk_supMode();	

			// 2d -> use 'updateCVSupAdjTex'
			// arrow & seg contour
			render2d_ui_supMode();

			// 3d 
			// box
			renderBox3d_v2_supadj();


		}else if(ctx.currentState == FCStateMag::S_DRAW_OBJSEG || ctx.currentState == FCStateMag::S_DRAW_IDLE){

			render2d_draw_objseg();	

			//[focus and block]
			// 2d -> use 'updateCVSupAdjTex'
			// arrow & seg contour
			render2d_ui_supMode();


		}else{

			if( showBK ){
				render2d_seg_contour();	
			}

			renderBox3d_v2();			

			if (showSupport)
			{
				//renderSceneStruct();
			}
		}

	}



	glPopAttrib();
}

// dedicated called by GT signal handler
void Tirth::FCGLPanel::paint_ogl_aft()
{ 


}

void Tirth::FCGLPanel::ogl_cleanup()
{ 
	// this function should be called by OPENGL context

	std::cout<<"ogl_cleanup\n";

	if( ctx.inputImgTex!=nullptr ){
		delete ctx.inputImgTex;
		ctx.inputImgTex=nullptr;
	}
	if( ctx.labelImgTex!=nullptr ){
		delete ctx.labelImgTex;
		ctx.labelImgTex=nullptr;
	}
	if( ctx.gtsegContourTex!=nullptr ){
		delete ctx.gtsegContourTex;
		ctx.gtsegContourTex=nullptr;
	}

	if( m_program_3d!=nullptr ){
		delete m_program_3d;
		m_program_3d = nullptr;
	}

	if (m_program_2d!=nullptr)
	{	
		delete m_program_2d;
		m_program_2d = nullptr;
	}

	if (m_program_bxmi_vex!=nullptr)
	{	
		delete m_program_bxmi_vex;
		m_program_bxmi_vex = nullptr;
	}

	if (m_program_bxmi_rot!=nullptr)
	{	
		delete m_program_bxmi_rot;
		m_program_bxmi_rot = nullptr;
	}

	if (m_program_supadj!=nullptr)
	{	
		delete m_program_supadj;
		m_program_supadj = nullptr;
	}


}

void Tirth::FCGLPanel::stateSYNC_3drendering()
{
	// before SYNC 
	//DWORD dwID = GetCurrentThreadId();
	//std::cout<<"SYNC_3d render , TID="<<dwID<<"\n";

}

void Tirth::FCGLPanel::render2d()
{
	if (!m_program_2d) {
		iniShader2d();
	} 

	if( !ctx.inputImgTex || requireUpdateBKTex ){
		iniBKTex();
		requireUpdateBKTex=0;
	}

	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )
	// GL_INVALID_VALUE is generated if either width or height is negative. 
	glViewport( ctx.viewport_tx , ctx.viewport_ty , ctx.panelWidth ,ctx.panelHeight);  		

	glEnable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//====================================================================
	// draw 2D

	//-------------------------------------------------------------------------
	// BK vertices

	/*
	4----3
	|    |
	1----2 

	0,s ---- s,s
	|       |
	|       |
	0,0 ---- s,0

	00----10
	|  T  |
	01----11 
	*/ 

	static GLfloat bkVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLfloat texVexs[]={  0,0,  1,0,      1,1,     0,1 };//{ 0,1,  1,1,      1,0,     0,0 };
	static GLubyte ind2[] = { 
		1,2,4,
		2,3,4
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp; 
	mvp.setToIdentity();

	//		 left right,  bot, top,
	mvp.ortho(0,  1,	1,   0,  0.1, 50 );

	QMatrix4x4 txMat;
	txMat.setToIdentity();
	txMat.translate(0,0,-20);	

	mvp=mvp*txMat;

	//-------------------------------------------------------------------------
	m_program_2d->bind();	
	static int mvpLoc = m_program_2d->uniformLocation("mvp_matrix");
	int vexAttrSlot = m_program_2d->attributeLocation("a_position");  
	int texCoordSlot = m_program_2d->attributeLocation("texCoord");

	m_program_2d->setUniformValue(mvpLoc, mvp); 
	m_program_2d->enableAttributeArray(vexAttrSlot); 
	m_program_2d->enableAttributeArray(texCoordSlot); 

	m_program_2d->setAttributeArray(vexAttrSlot, GL_FLOAT , bkVexs ,2 ); 
	m_program_2d->setAttributeArray(texCoordSlot, GL_FLOAT , texVexs ,2 ); 

	//bind tex
	oglEntry->glActiveTexture(GL_TEXTURE0+0); // use texture image unit 0
	m_program_2d->setUniformValue("texUid", 0 ); // tell to shader to use texture image unit 0
	ctx.inputImgTex->bind();

	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	ctx.inputImgTex->release();

	//-------------------------------------------------------------------------
	m_program_2d->disableAttributeArray(vexAttrSlot); 
	m_program_2d->disableAttributeArray(texCoordSlot); 
	m_program_2d->release();

}


void Tirth::FCGLPanel::render2d_draw_objseg()
{
	if (!m_program_2d) {
		iniShader2d_seg();
	} 

	//-------------------------------------------------------------------------
	// background
	if( !ctx.inputImgTex || requireUpdateBKTex ){
		iniBKTex();
		requireUpdateBKTex=0;
	}

	//-------------------------------------------------------------------------
	// contour Tex
	if( requireUpdateDrawPaperTex ){
		updateCVDraw_Tex();
		requireUpdateDrawPaperTex=0;
	}
	//-------------------------------------------------------------------------

	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )
	// GL_INVALID_VALUE is generated if either width or height is negative. 
	glViewport( ctx.viewport_tx , ctx.viewport_ty , ctx.panelWidth ,ctx.panelHeight);  		

	glEnable(GL_BLEND);			
	glEnable(GL_DEPTH_TEST); 	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//====================================================================
	// draw 2D

	//-------------------------------------------------------------------------
	// BK vertices

	/*
	4----3
	|    |
	1----2 

	0,s ---- s,s
	|       |
	|       |
	0,0 ---- s,0

	00----10
	|  T  |
	01----11 
	*/ 

	static GLfloat bkVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLfloat texVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLubyte ind2[] = { 
		1,2,4,
		2,3,4
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp; 
	mvp.setToIdentity();

	//		 left, right,  bot,  top,
	mvp.ortho(0,       1,    1,     0,  0.1, 50 );

	QMatrix4x4 txMat;
	txMat.setToIdentity();
	txMat.translate(0,0,-20);	

	mvp=mvp*txMat;

	//	"uniform sampler2D texUid; \n"
	//	"uniform sampler2D segTexUid; \n"
	//	"varying mediump vec2 texCoordOut; \n"  
	//	"uniform float    targetUID;\n"
	//-------------------------------------------------------------------------
	m_program_2d->bind();	
	static int mvpLoc = m_program_2d->uniformLocation("mvp_matrix");
	int vexAttrSlot  = m_program_2d->attributeLocation("a_position");  
	int texCoordSlot = m_program_2d->attributeLocation("texCoord");
	int segTexSlot = m_program_2d->attributeLocation("segTexUid");
	int targetUID  = m_program_2d->attributeLocation("targetUID");

	m_program_2d->setUniformValue(targetUID, ctx.focus_box_uid); 

	m_program_2d->setUniformValue(mvpLoc, mvp); 
	m_program_2d->enableAttributeArray(vexAttrSlot); 
	m_program_2d->enableAttributeArray(texCoordSlot); 

	m_program_2d->setAttributeArray(vexAttrSlot, GL_FLOAT , bkVexs ,2 ); 
	m_program_2d->setAttributeArray(texCoordSlot, GL_FLOAT , texVexs ,2 );  

	//bind tex
	oglEntry->glActiveTexture(GL_TEXTURE0); // use texture image unit 0
	m_program_2d->setUniformValue("texUid", 0 ); // tell to shader to use texture image unit 0

	ctx.inputImgTex->bind();

	//[BK]
	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	//oglEntry->glActiveTexture(GL_TEXTURE2);
	//m_program_2d->setUniformValue("segTexUid", 2 ); 
	ctx.segDraw_paperTex->bind();

	//[Contour]
	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	ctx.inputImgTex->release();
	ctx.segDraw_paperTex->release();

	oglEntry->glActiveTexture(GL_TEXTURE0);
	//-------------------------------------------------------------------------
	m_program_2d->disableAttributeArray(vexAttrSlot); 
	m_program_2d->disableAttributeArray(texCoordSlot); 
	m_program_2d->release();

}


void Tirth::FCGLPanel::render2d_seg_contour()
{
	if (!m_program_2d) {
		iniShader2d_seg();
	} 

	if( !ctx.inputImgTex || requireUpdateBKTex ){
		iniBKTex();
		requireUpdateBKTex=0;
	}

	if( requireUpdateContourTex ){
		updateCVSegTex();
		requireUpdateContourTex=0;
	}

	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )
	// GL_INVALID_VALUE is generated if either width or height is negative. 
	glViewport( ctx.viewport_tx , ctx.viewport_ty , ctx.panelWidth ,ctx.panelHeight);  		

	glEnable(GL_BLEND);			
	glEnable(GL_DEPTH_TEST); 	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//====================================================================
	// draw 2D

	//-------------------------------------------------------------------------
	// BK vertices

	/*
	4----3
	|    |
	1----2 

	0,s ---- s,s
	|       |
	|       |
	0,0 ---- s,0

	00----10
	|  T  |
	01----11 
	*/ 

	static GLfloat bkVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLfloat texVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLubyte ind2[] = { 
		1,2,4,
		2,3,4
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp; 
	mvp.setToIdentity();

	//		 left, right,  bot,  top,
	mvp.ortho(0,       1,    1,     0,  0.1, 50 );

	QMatrix4x4 txMat;
	txMat.setToIdentity();
	txMat.translate(0,0,-20);	

	mvp=mvp*txMat;

	//	"uniform sampler2D texUid; \n"
	//	"uniform sampler2D segTexUid; \n"
	//	"varying mediump vec2 texCoordOut; \n"  
	//	"uniform float    targetUID;\n"
	//-------------------------------------------------------------------------
	m_program_2d->bind();	
	static int mvpLoc = m_program_2d->uniformLocation("mvp_matrix");
	int vexAttrSlot  = m_program_2d->attributeLocation("a_position");  
	int texCoordSlot = m_program_2d->attributeLocation("texCoord");
	int segTexSlot = m_program_2d->attributeLocation("segTexUid");
	int targetUID  = m_program_2d->attributeLocation("targetUID");

	m_program_2d->setUniformValue(targetUID, ctx.focus_box_uid); 

	m_program_2d->setUniformValue(mvpLoc, mvp); 
	m_program_2d->enableAttributeArray(vexAttrSlot); 
	m_program_2d->enableAttributeArray(texCoordSlot); 

	m_program_2d->setAttributeArray(vexAttrSlot, GL_FLOAT , bkVexs ,2 ); 
	m_program_2d->setAttributeArray(texCoordSlot, GL_FLOAT , texVexs ,2 );  

	//bind tex
	oglEntry->glActiveTexture(GL_TEXTURE0); // use texture image unit 0
	m_program_2d->setUniformValue("texUid", 0 ); // tell to shader to use texture image unit 0

	ctx.inputImgTex->bind();

	//[BK]
	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	//oglEntry->glActiveTexture(GL_TEXTURE2);
	//m_program_2d->setUniformValue("segTexUid", 2 ); 
	ctx.gtsegContourTex->bind();

	//[Contour]
	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	ctx.inputImgTex->release();
	ctx.gtsegContourTex->release();

	oglEntry->glActiveTexture(GL_TEXTURE0);
	//-------------------------------------------------------------------------
	m_program_2d->disableAttributeArray(vexAttrSlot); 
	m_program_2d->disableAttributeArray(texCoordSlot); 
	m_program_2d->release();

}


void Tirth::FCGLPanel::render2d_bk_supMode()
{
	// only draw bk image


	if (!m_program_2d) {
		iniShader2d_seg();
	} 

	// bk image
	if( !ctx.inputImgTex || requireUpdateBKTex ){
		iniBKTex();
		requireUpdateBKTex=0;
	}

	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )
	// GL_INVALID_VALUE is generated if either width or height is negative. 
	glViewport( ctx.viewport_tx , ctx.viewport_ty , ctx.panelWidth ,ctx.panelHeight);  		

	glEnable(GL_BLEND);			
	glEnable(GL_DEPTH_TEST); 	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//====================================================================
	// draw 2D

	//-------------------------------------------------------------------------
	// BK vertices

	/*
	4----3
	|    |
	1----2 

	0,s ---- s,s
	|       |
	|       |
	0,0 ---- s,0

	00----10
	|  T  |
	01----11 
	*/ 

	static GLfloat bkVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLfloat texVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLubyte ind2[] = { 
		1,2,4,
		2,3,4
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp; 
	mvp.setToIdentity();

	//		 left, right,  bot,  top,
	mvp.ortho(0,       1,    1,     0,  0.1, 50 );

	QMatrix4x4 txMat;
	txMat.setToIdentity();
	txMat.translate(0,0,-20);	

	mvp=mvp*txMat;

	//	"uniform sampler2D texUid; \n"
	//	"uniform sampler2D segTexUid; \n"
	//	"varying mediump vec2 texCoordOut; \n"  
	//	"uniform float    targetUID;\n"
	//-------------------------------------------------------------------------
	m_program_2d->bind();	
	static int mvpLoc = m_program_2d->uniformLocation("mvp_matrix");
	int vexAttrSlot  = m_program_2d->attributeLocation("a_position");  
	int texCoordSlot = m_program_2d->attributeLocation("texCoord");
	int segTexSlot = m_program_2d->attributeLocation("segTexUid");
	int targetUID  = m_program_2d->attributeLocation("targetUID");

	m_program_2d->setUniformValue(targetUID, ctx.focus_box_uid); 

	m_program_2d->setUniformValue(mvpLoc, mvp); 
	m_program_2d->enableAttributeArray(vexAttrSlot); 
	m_program_2d->enableAttributeArray(texCoordSlot); 

	m_program_2d->setAttributeArray(vexAttrSlot, GL_FLOAT , bkVexs ,2 ); 
	m_program_2d->setAttributeArray(texCoordSlot, GL_FLOAT , texVexs ,2 );  

	//bind tex
	oglEntry->glActiveTexture(GL_TEXTURE0); // use texture image unit 0
	m_program_2d->setUniformValue("texUid", 0 ); // tell to shader to use texture image unit 0

	ctx.inputImgTex->bind();

	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	ctx.inputImgTex->release(); 

	oglEntry->glActiveTexture(GL_TEXTURE0);
	//-------------------------------------------------------------------------
	m_program_2d->disableAttributeArray(vexAttrSlot); 
	m_program_2d->disableAttributeArray(texCoordSlot); 
	m_program_2d->release();

}

void Tirth::FCGLPanel::render2d_ui_supMode()
{
	if (nullptr==m_program_supadj) {
		iniShader2d_supadj();
	} 

	if( ctx.supVis_requireUpdateTex || ctx.supVisTex == nullptr ){

		if (ctx.currentState == FCStateMag::S_SUP_EDITIDLE )
		{
			updateCVSupSelectTex();
		}else{
			updateCVSupSetTex();
		}

		ctx.supVis_requireUpdateTex=0;
	}

	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )
	// GL_INVALID_VALUE is generated if either width or height is negative. 
	glViewport( ctx.viewport_tx , ctx.viewport_ty , ctx.panelWidth ,ctx.panelHeight);  		

	glEnable(GL_BLEND);			
	glEnable(GL_DEPTH_TEST); 	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//====================================================================
	// draw 2D

	//-------------------------------------------------------------------------
	// BK vertices

	/*
	4----3
	|    |
	1----2 

	0,s ---- s,s
	|       |
	|       |
	0,0 ---- s,0

	00----10
	|  T  |
	01----11 
	*/ 

	static GLfloat bkVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLfloat texVexs[]={  0,0,  1,0,      1,1,     0,1 };
	static GLubyte ind2[] = { 
		1,2,4,
		2,3,4
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp; 
	mvp.setToIdentity();

	//		  left, right,  bot,  top,
	mvp.ortho(   0,     1,    1,     0,  0.1, 50 );

	QMatrix4x4 txMat;
	txMat.setToIdentity();
	txMat.translate(0,0,-15);	

	mvp=mvp*txMat;

	//	"uniform sampler2D texUid; \n"
	//	"uniform sampler2D segTexUid; \n"
	//	"varying mediump vec2 texCoordOut; \n"  
	//	"uniform float targetUID;\n"
	//-------------------------------------------------------------------------
	m_program_supadj->bind();	

	static int mvpLoc = m_program_supadj->uniformLocation("mvp_matrix");
	int vexAttrSlot  = m_program_supadj->attributeLocation("a_position");  
	int texCoordSlot = m_program_supadj->attributeLocation("texCoord");
	int segTexSlot = m_program_supadj->attributeLocation("segTexUid"); 

	m_program_supadj->setUniformValue(mvpLoc, mvp); 
	m_program_supadj->enableAttributeArray(vexAttrSlot); 
	m_program_supadj->enableAttributeArray(texCoordSlot); 

	m_program_supadj->setAttributeArray(vexAttrSlot, GL_FLOAT , bkVexs ,2 ); 
	m_program_supadj->setAttributeArray(texCoordSlot, GL_FLOAT , texVexs ,2 );  

	//bind tex
	oglEntry->glActiveTexture(GL_TEXTURE0); // use texture image unit 0
	m_program_supadj->setUniformValue("texUid", 0 ); // tell to shader to use texture image unit 0


	// drawing arrow

	ctx.supVisTex->bind();

	//draw call
	glDrawElements(GL_TRIANGLES , sizeof(ind2)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,ind2); 

	ctx.supVisTex->release(); 


	oglEntry->glActiveTexture(GL_TEXTURE0);
	//-------------------------------------------------------------------------
	m_program_supadj->disableAttributeArray(vexAttrSlot); 
	m_program_supadj->disableAttributeArray(texCoordSlot); 
	m_program_supadj->release();


	checkGLError("render2d - sup adj ");

}

void Tirth::FCGLPanel::renderBox3d_v2()
{
	if (!m_program_3d) {
		iniShader3d();
	} 
	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )

	glPushAttrib(GL_DEPTH_BUFFER_BIT);

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	
	//glViewport(0, ctx.panelHeight, ctx.panelWidth , -ctx.panelHeight);  	
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 
	glDepthMask(true); 

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//-------------------------------------------------------------------------
	// indexes and vertices 
	static GLubyte boxIdx[] = { 
		1-1,2-1,   2-1,3-1,  3-1,4-1,  4-1,1-1,  
		1-1,5-1,   2-1,6-1,  3-1,7-1,  4-1,8-1, 
		5-1,6-1,   6-1,7-1,  7-1,8-1,  8-1,5-1 
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp;
	/*
	QMatrix4x4 rmat;
	rmat.rotate(ctx.y_theta,0,1,0);

	QMatrix4x4 txmat; 
	txmat.translate(ctx.worldCen.x(),ctx.worldCen.y(),ctx.worldCen.z());

	QMatrix4x4 ztxmat;
	ztxmat.translate(0,0, ctx.tx_scale);
	*/
	mvp=ctx.oglMVP;//*ztxmat*rmat;

	//-------------------------------------------------------------------------
	m_program_3d->bind();

	static int mvpLoc = m_program_3d->uniformLocation("mvp_matrix");
	static int lineColorLoc = m_program_3d->uniformLocation("lineColor");

	int vexAttrSlot = m_program_3d->attributeLocation("a_position");   

	m_program_3d->setUniformValue(lineColorLoc,1,1,1,1);
	m_program_3d->setUniformValue(mvpLoc, mvp); 

	m_program_3d->enableAttributeArray(vexAttrSlot);  

	if( showSG ){

		glLineWidth(2.5);
		for( int k=0; k < ctx.boxDatas.size() ; k++ ){

			if( ctx.boxDatas[k].isSupByObj() && ctx.boxDatas[k].isSupByWall()  ){
				m_program_3d->setUniformValue(lineColorLoc,1,76.0/255.0,0,1 );

			}else if( ctx.boxDatas[k].isSupByObj() && ctx.boxDatas[k].isSupByGround()  ){
				m_program_3d->setUniformValue(lineColorLoc,0.3,0.3,0.3,1  );

			}else if( ctx.boxDatas[k].isSupByGround() && ctx.boxDatas[k].isSupByWall()  ){
				m_program_3d->setUniformValue(lineColorLoc,0.8,0.5,0.8,1 );

			}else if( ctx.boxDatas[k].isSupByWall()   ){
				m_program_3d->setUniformValue(lineColorLoc,0,1,1,1);

			}else if( ctx.boxDatas[k].isSupByObj() ){ 
				m_program_3d->setUniformValue(lineColorLoc,0,1,0,1);

			}else if( ctx.boxDatas[k].isSupByGround()   ){
				m_program_3d->setUniformValue(lineColorLoc,0,0,1,1); 

			}else if( ctx.boxDatas[k].isFloat()  ){
				m_program_3d->setUniformValue(lineColorLoc,1,0,0,1);

			}else{
				m_program_3d->setUniformValue(lineColorLoc,0.5,0.5,0.5,1);

			}

			m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
			//draw call
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  
		}	

		glLineWidth(1);



	}else if(showBox){


		for( int k=0; k < ctx.boxDatas.size() ; k++ ){

			glLineWidth(3);
			m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
			m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
			//draw call
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  

		}// for

	}else{

		if( ctx.currentState == FCStateMag::S_PRE_PAUSE  
			|| ctx.currentState == FCStateMag::S_PREDICT )
		{
			for( int k=0; k < ctx.boxDatas.size() ; k++ ){

				if( ctx.focus_box_uid == ctx.boxDatas[k].getUID() ){
					glLineWidth(3);
					m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
					m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
					//draw call
					glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  
				}else{
					// skip
				}

			}// for


		}else if(ctx.currentState == FCStateMag::S_PRE_MENU_FOLD ){

			for( int k=0; k < ctx.boxDatas.size() ; k++ ){
				if( ctx.focus_box_uid == ctx.boxDatas[k].getUID() ){
					glLineWidth(3);
					m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
					m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
					//draw call
					glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  
				}  
			}

		}

		//-------------------------------------------------------------------------
		/*
		if( showConfAllBox ){
		for( int k=0; k < ctx.boxDatas.size() ; k++ ){ 

		if( ctx.boxDatas[k].getConfALL() ){
		glLineWidth(2.5);
		m_program_3d->setUniformValue( lineColorLoc , 0, 0.75 , 0, 1 ); 
		m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
		//draw call
		glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  
		}
		} 
		}
		*/
	}	 

	//-------------------------------------------------------------------------

	glPopAttrib();

	m_program_3d->disableAttributeArray(vexAttrSlot);  
	m_program_3d->release();

	checkGLError("render3d");
}

void Tirth::FCGLPanel::renderBox3d_v2_supadj()
{
	if (!m_program_3d) {
		iniShader3d();
	} 
	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )

	glPushAttrib(GL_DEPTH_BUFFER_BIT);

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	
	//glViewport(0, ctx.panelHeight, ctx.panelWidth , -ctx.panelHeight);  	
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 
	glDepthMask(true); 

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//-------------------------------------------------------------------------
	// indexes and vertices 
	static GLubyte boxIdx[] = { 
		1-1,2-1,   2-1,3-1,  3-1,4-1,  4-1,1-1,  
		1-1,5-1,   2-1,6-1,  3-1,7-1,  4-1,8-1, 
		5-1,6-1,   6-1,7-1,  7-1,8-1,  8-1,5-1 
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp;

	mvp=ctx.oglMVP;

	//-------------------------------------------------------------------------
	m_program_3d->bind();

	static int mvpLoc = m_program_3d->uniformLocation("mvp_matrix");
	static int lineColorLoc = m_program_3d->uniformLocation("lineColor");

	int vexAttrSlot = m_program_3d->attributeLocation("a_position");   

	m_program_3d->setUniformValue(lineColorLoc,1,1,1,1);
	m_program_3d->setUniformValue(mvpLoc, mvp); 

	m_program_3d->enableAttributeArray(vexAttrSlot);  

	bool supadj_drawBox=ctx.supVis_showBox;

	if( supadj_drawBox && ctx.currentState == FCStateMag::S_SUP_EDITIDLE ){

		if( ctx.supAdj_focus_box_idx != -1 && ctx.supAdj_focus_box_idx  < ctx.boxDatas.size() ){

			int k =ctx.supAdj_focus_box_idx;

			if( ctx.boxDatas[k].isSupByObj() ){ 
				m_program_3d->setUniformValue(lineColorLoc,0,1,0,1);

				glLineWidth(3);
				m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
				m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
				//draw call
				glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  

				int parIdx = ctx.boxDatas[k].getSupporterLIDX();

				//parent
				glLineWidth(3);
				m_program_3d->setUniformValue(lineColorLoc,0.7,0.7,0.7,1); 
				m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[parIdx].getBox3d_world(),3 ); 
				//draw call
				glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  


			}else{

				if( ctx.boxDatas[k].isSupByGround()   ){
					m_program_3d->setUniformValue(lineColorLoc,0,0,1,1); 

				}else if( ctx.boxDatas[k].isSupByWall()   ){
					m_program_3d->setUniformValue(lineColorLoc,0,0,1,1); 

				}else if( ctx.boxDatas[k].isFloat()  ){
					m_program_3d->setUniformValue(lineColorLoc,1,0,0,1);

				}else{

					myassert("ERR* impossible state - renderBox3d_v2_supadj");

				}

				glLineWidth(3);
				m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
				m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
				//draw call
				glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  

			}

		}

	}else if( ctx.currentState == FCStateMag::S_SUP_ASSIG ){
		// assign relationship mode

		int k =ctx.supAdj_focus_box_idx;

		glLineWidth(1.5);
		/*
		m_program_3d->setUniformValue(lineColorLoc,0,1,0,0.6); 
		m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
		//draw call
		glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  
		*/
		//-------------------------------------------------------------------------
		// parent candidate
		if( ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_OBJ )
		{
			int cid = ctx.setSupCtx.supLocalIdx;

			m_program_3d->setUniformValue(lineColorLoc,0,1,0,0.6); 
			m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[cid].getBox3d_world(),3 ); 
			//draw call
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  

		}

	}

	//-------------------------------------------------------------------------
	// show all box
	if( showBox ){
		for( int k=0; k < ctx.boxDatas.size() ; k++ ){

			glLineWidth(2);
			m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
			m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[k].getBox3d_world(),3 ); 
			//draw call
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  

		}
	} 
	//-------------------------------------------------------------------------

	glPopAttrib();

	m_program_3d->disableAttributeArray(vexAttrSlot);  
	m_program_3d->release();

	checkGLError("render3d");
}

void Tirth::FCGLPanel::renderBox3d_v2_boxsel()
{
	if (!m_program_3d) {
		iniShader3d();
	} 
	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )

	glPushAttrib(GL_DEPTH_BUFFER_BIT);

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	
	//glViewport(0, ctx.panelHeight, ctx.panelWidth , -ctx.panelHeight);  	
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 
	glDepthMask(true); 

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//-------------------------------------------------------------------------
	// indexes and vertices 
	static GLubyte boxIdx[] = { 
		1-1,2-1,   2-1,3-1,  3-1,4-1,  4-1,1-1,  
		1-1,5-1,   2-1,6-1,  3-1,7-1,  4-1,8-1, 
		5-1,6-1,   6-1,7-1,  7-1,8-1,  8-1,5-1 
	}; 

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp;

	mvp=ctx.oglMVP;//*ztxmat*rmat;

	//-------------------------------------------------------------------------
	m_program_3d->bind();

	static int mvpLoc = m_program_3d->uniformLocation("mvp_matrix");
	static int lineColorLoc = m_program_3d->uniformLocation("lineColor");

	int vexAttrSlot = m_program_3d->attributeLocation("a_position");   

	m_program_3d->setUniformValue(lineColorLoc,1,1,1,1);
	m_program_3d->setUniformValue(mvpLoc, mvp); 

	m_program_3d->enableAttributeArray(vexAttrSlot);  

	//if( showBox ){
	glLineWidth(2);
	m_program_3d->setUniformValue(lineColorLoc,.4,.4,.4,.6); 

	// all box
	for (int i=0; i < ctx.boxDatas.size() ; i++)
	{
		if (i != ctx.bkseg_focus_box_idx)
		{
			m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[i].getBox3d_world(),3 ); 
			//draw call
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  

		}
	}
	//}

	//focus box
	if (ctx.bkseg_focus_box_idx !=-1)
	{
		glLineWidth(3);
		m_program_3d->setUniformValue(lineColorLoc,0,1,0,1); 
		m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[ctx.bkseg_focus_box_idx].getBox3d_world(),3 ); 
		//draw call
		glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);  
	}

	//-------------------------------------------------------------------------

	glPopAttrib();

	m_program_3d->disableAttributeArray(vexAttrSlot);  
	m_program_3d->release();

	checkGLError("render3d");
}

void Tirth::FCGLPanel::renderManiBox_Vex()
{
	if (!m_program_bxmi_vex) {
		iniShaderBxmi_vex();
	} 

	glPushAttrib(GL_DEPTH_BUFFER_BIT);
	//-------------------------------------------------------------------------

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	

	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 
	glEnable(GL_PROGRAM_POINT_SIZE);

	glDepthMask(true); 

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//-------------------------------------------------------------------------
	// indexes and vertices 
	static GLubyte boxIdx[] = { 
		1-1,2-1,   2-1,3-1,  3-1,4-1,  4-1,1-1,  
		1-1,5-1,   2-1,6-1,  3-1,7-1,  4-1,8-1, 
		5-1,6-1,   6-1,7-1,  7-1,8-1,  8-1,5-1 
	}; 
	static GLubyte boxVexIdx[] = { 
		0,1,2,3,4,5,6,7
	}; 

	static GLfloat colorTable[][3]={
		{1,1,1},
		{1,1,1},
		{1,1,1},
		{1,1,1}, //4

		{0,0,1},
		{0,0,1},
		{0,0,1},
		{0,0,1}, //4
		//--------------------
		{1,1,1},
		{1,0,0},
		{0,1,0},
		{0,0,1}, //4

		{1,1,1},
		{1,0,0},
		{0,1,0},
		{0,0,1} //4
	};

	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp=ctx.oglMVP; 

	//-------------------------------------------------------------------------
	m_program_bxmi_vex->bind();

	static int mvpLoc = m_program_bxmi_vex->uniformLocation("mvp_matrix");
	static int lineColorLoc = m_program_bxmi_vex->uniformLocation("lineColor");
	static int pointSizeLoc = m_program_bxmi_vex->uniformLocation("point_size");

	int vexAttrSlot = m_program_bxmi_vex->attributeLocation("a_position");   

	m_program_bxmi_vex->setUniformValue(lineColorLoc,1,1,1,1);
	m_program_bxmi_vex->setUniformValue(mvpLoc, mvp); 

	m_program_bxmi_vex->enableAttributeArray(vexAttrSlot);  
	checkGLError("renderManiBox_vex - before entry");

	if( ctx.bxmiCtx.bxmi_focus_boxIdx >= 0){

		int tid = ctx.bxmiCtx.bxmi_focus_boxIdx;

		glLineWidth(2);

		//draw call

		// box vertices
		//*
		GLubyte tmpIdx=0;		 
		m_program_bxmi_vex->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[tid].getBox3d_world(), 3 ); 

		for(int i=0 ; i < 8 ; i++){ 

			//m_program_bxmi_vex->setUniformValue(lineColorLoc,0.0f,1.0f,0.0f,1.0f); 		
			m_program_bxmi_vex->setUniformValue(lineColorLoc, colorTable[i][0],colorTable[i][1],colorTable[i][2]  ,1.0f); 		

			m_program_bxmi_vex->setUniformValue(pointSizeLoc, 5.0f); // must use float
			tmpIdx=i;
			glDrawElements(GL_POINTS , 1 , GL_UNSIGNED_BYTE , &tmpIdx );   

		}

		checkGLError("renderManiBox_vex - box vertices");


		// selected vertex
		if(ctx.bxmiCtx.bxmi_sel_vidx>=0)
		{
			m_program_bxmi_vex->setUniformValue(lineColorLoc,1.0f,0.0f,0.0f,1.0f); 		
			m_program_bxmi_vex->setUniformValue(pointSizeLoc, 12.0f); // must use float
			GLubyte selIdx= ctx.bxmiCtx.bxmi_sel_vidx ; 
			GLfloat * vertices =  ctx.boxDatas[tid].getBox3d_world();
			m_program_bxmi_vex->setAttributeArray(vexAttrSlot, GL_FLOAT , vertices , 3 ); 

			glDrawElements(GL_POINTS , 1 , GL_UNSIGNED_BYTE ,&selIdx);   
		}
		checkGLError("renderManiBox_vex - selected");


		// moving vertex -- [3D]
		if( ctx.bxmiCtx.bxmi_pressed && ctx.bxmiCtx.drag_isgood ){

			m_program_bxmi_vex->setUniformValue(lineColorLoc,1,0.5,0,1); 		

			// vertex
			m_program_bxmi_vex->setUniformValue(pointSizeLoc, 8.0f); 
			GLubyte tvidx[]= {0}; 
			m_program_bxmi_vex->setAttributeArray(vexAttrSlot, GL_FLOAT , ctx.bxmiCtx.drag_pts , 3 ); 
			glDrawElements(GL_POINTS , 1 , GL_UNSIGNED_BYTE ,&tvidx);


			// new box 
			m_program_bxmi_vex->setUniformValue(pointSizeLoc, 1.0f); 
			m_program_bxmi_vex->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.bxmiCtx.box.getBox3d_world(),3 ); 
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);   

		}
		checkGLError("renderManiBox_vex - moving vertex");

		// original box outline
		m_program_bxmi_vex->setUniformValue(pointSizeLoc, 1.0f); 
		m_program_bxmi_vex->setUniformValue(lineColorLoc,0,1,0,1); 
		m_program_bxmi_vex->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[tid].getBox3d_world(),3 ); 
		glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);   
		checkGLError("renderManiBox_vex - outline");

	}

	//-------------------------------------------------------------------------

	glPopAttrib();
	glDisable(GL_PROGRAM_POINT_SIZE);

	m_program_bxmi_vex->disableAttributeArray(vexAttrSlot);  
	m_program_bxmi_vex->release();

	checkGLError("renderManiBox_vex");
}

void Tirth::FCGLPanel::renderManiBox_Rot()
{
	if (!m_program_bxmi_rot) {
		iniShaderBxmi_Rot();
	} 

	glPushAttrib(GL_DEPTH_BUFFER_BIT);
	//-------------------------------------------------------------------------

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	

	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 
	glEnable(GL_PROGRAM_POINT_SIZE);

	glDepthMask(true); 

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//-------------------------------------------------------------------------
	// indexes and vertices 
	static GLubyte boxIdx[] = { 
		1-1,2-1,   2-1,3-1,  3-1,4-1,  4-1,1-1,  
		1-1,5-1,   2-1,6-1,  3-1,7-1,  4-1,8-1, 
		5-1,6-1,   6-1,7-1,  7-1,8-1,  8-1,5-1 
	}; 
	static GLubyte boxVexIdx[] = { 
		0,1,2,3,4,5,6,7
	}; 
	//-------------------------------------------------------------------------
	// MVP
	static QMatrix4x4 mvp=ctx.oglMVP;

	//-------------------------------------------------------------------------
	QOpenGLShaderProgram * shader = m_program_bxmi_rot;
	shader->bind();

	static int mvpLoc = shader->uniformLocation("mvp_matrix");
	static int lineColorLoc = shader->uniformLocation("lineColor");
	static int pointSizeLoc = shader->uniformLocation("point_size");

	int vexAttrSlot = shader->attributeLocation("a_position");   

	shader->setUniformValue(lineColorLoc,1,1,1,1);
	shader->setUniformValue(mvpLoc, mvp); 

	shader->enableAttributeArray(vexAttrSlot);  

	if( ctx.bxmiCtx.bxmi_focus_boxIdx >= 0){

		int tid = ctx.bxmiCtx.bxmi_focus_boxIdx;

		glLineWidth(3);

		checkGLError("renderManiBox rot - pre");
		/*
		//-----------------------------------
		// circle center
		{
		//RGBA 
		shader->setUniformValue(lineColorLoc, 1,0,0 , 1); 		
		//point size
		shader->setUniformValue(pointSizeLoc, 15 ); 

		Eigen::Vector3f boxCen3d=ctx.boxDatas[tid].getBox3d_world_n3().colwise().mean();
		GLfloat cirVex[3]={ boxCen3d.x()  , boxCen3d.y() , boxCen3d.z() };
		GLubyte cirIdx[]={0}; 

		shader->setAttributeArray(vexAttrSlot, GL_FLOAT ,  cirVex, 3 ); 

		glDrawElements(GL_POINTS , 1, GL_UNSIGNED_BYTE , cirIdx);   
		}

		checkGLError("renderManiBox rot - circle center");
		*/
		//-----------------------------------
		// sphere on top face

		Eigen::Vector3f boxCen3d=ctx.boxDatas[tid].getBox3d_world_n3().colwise().mean();
		Eigen::MatrixXf mboxVexWorld=ctx.boxDatas[tid].getBox3d_world_n3();

		auto const & wpls = ctx.boxDatas[tid].getBoxPlane_world();

		Eigen::Vector3f fc0 = prjPts2Plane(wpls[0],boxCen3d);

		PlaneData const & topface = wpls[0];

		// cosine theta
		float dotTheta = topface.model.head(3).normalized().dot( Eigen::Vector3f(0,1,0) );

		if (dotTheta<0)
		{
			dotTheta=-1*dotTheta;
		}

		//float theta = M_PI/2 - acos(dotTheta);
		float theta = M_PI/2 ;

		float sinTheta = sin(theta);
		float cosTheta = cos(theta);

		const int VNUM=100;
		const float PHI_STEP = M_PI*2.0f/VNUM;


		static float sph_pts[(VNUM+2)*3]={0};
		float * fc0_data = fc0.data();
		float s_r = 0.4;
		float s_phi = 0;

		for (int i = 0; i < VNUM; i++)
		{
			sph_pts[i*3]  = s_r * sinTheta * cos(s_phi) +fc0_data[0];
			sph_pts[i*3+1]= s_r * cosTheta              +fc0_data[1];
			sph_pts[i*3+2]= s_r * sinTheta * sin(s_phi) +fc0_data[2];

			s_phi= s_phi+PHI_STEP;

		}

		{
			//RGBA 
			shader->setUniformValue(lineColorLoc, 1,0,0 , 1); 		
			//point size
			shader->setUniformValue(pointSizeLoc, 3.0f); 

			GLuint cirIdx[VNUM]={0};

			for (int i=0;i<VNUM ;i++)
			{
				cirIdx[i]=i;
			}

			shader->setAttributeArray(vexAttrSlot, GL_FLOAT ,  sph_pts, 3 ); 
			glDrawElements(GL_LINE_STRIP , VNUM , GL_UNSIGNED_INT , cirIdx);   
		}
		checkGLError("renderManiBox rot - sphere vertex");
		//-----------------------------------
		// box outline

		//*

		if (ctx.bxmiCtx.bxmi_pressed)
		{		
			// moving boxes
			shader->setUniformValue(pointSizeLoc, 1.0f); 

			shader->setUniformValue(lineColorLoc,1,0.5,0.4,1); 
			shader->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.bxmiCtx.box.getBox3d_world(),3 ); 
			glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);   

		}

		// origin box
		shader->setUniformValue(lineColorLoc,0,1,0,1); 
		shader->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.boxDatas[tid].getBox3d_world(),3 ); 
		glDrawElements(GL_LINES , sizeof(boxIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,boxIdx);   

		//*/

		checkGLError("renderManiBox rot - outline");
	}

	//-------------------------------------------------------------------------

	glPopAttrib();
	glDisable(GL_PROGRAM_POINT_SIZE);

	shader->disableAttributeArray(vexAttrSlot);  
	shader->release();

	checkGLError("renderManiBox rot");
}

void Tirth::FCGLPanel::renderSceneStruct()
{
	if (!m_program_3d) {
		iniShader3d();
	} 
	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )

	glPushAttrib(GL_DEPTH_BUFFER_BIT);

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	

	glEnable(GL_DEPTH_TEST); 					
	glDepthMask(true);
	glEnable(GL_BLEND);

	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 

	//=========================================================================

	// MVP
	static QMatrix4x4 mvp;
	mvp=ctx.oglMVP;

	mvp=ctx.oglMVP;//*ztxmat*rmat;
	//-------------------------------------------------------------------------
	m_program_3d->bind();

	static int mvpLoc = m_program_3d->uniformLocation("mvp_matrix");
	static int lineColorLoc = m_program_3d->uniformLocation("lineColor");

	int vexAttrSlot = m_program_3d->attributeLocation("a_position");   

	m_program_3d->setUniformValue(mvpLoc, mvp); 
	m_program_3d->enableAttributeArray(vexAttrSlot);  

	const int MAXCNUM=20;
	static float cTable[MAXCNUM][3]={
		{    0,     1,     0},
		{    0,     0,     1},
		{    1,     0,     1},
		{    1,     1,     0},
		{ 0.25,  0.25,  0.25},
		{    0,  0.25,     0},
		{ 0.75,     0,     0},
		{    1,     0,     0},
		{  0.5,     0,     0},
		{    0,     1,     1},
		{ 0.25,     0,     0},
		{    0,   0.5,     0},
		{    0,  0.75,     0},
		{    0,     0,  0.25},
		{    0,     0,   0.5},
		{    0,     0,  0.75},
		{    0,     0,     0},
		{  0.5,   0.5,   0.5},
		{ 0.75,  0.75,  0.75},
		{    1 ,    1,     1}
	};

	//-------------------------------------------------------------------------

	for (int k=0 ; k < ctx.walls_fr.size() ; k++)
	{
		if( k < MAXCNUM ){
			m_program_3d->setUniformValue(lineColorLoc,cTable[k][0],cTable[k][1],cTable[k][2],0.5);
		}else{
			m_program_3d->setUniformValue(lineColorLoc,0,0,1,0.5);
		}

		m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.oglWallPls[k].planeTriangles ,3 ); 
		glDrawElements(GL_TRIANGLES , OGLPlaneData::NUM_TRI_IDX  , GL_UNSIGNED_BYTE , ctx.oglWallPls[k].planeIndex );  

		m_program_3d->setUniformValue(lineColorLoc,1,0,0,1);
		m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  ctx.oglWallPls[k].planeNV ,3 ); 
		glDrawElements(GL_LINES , OGLPlaneData::NUM_LVEX_IDX  , GL_UNSIGNED_BYTE , ctx.oglWallPls[k].planeNVIdx );  
	}

	//-------------------------------------------------------------------------
	glPopAttrib();

	m_program_3d->disableAttributeArray(vexAttrSlot);  
	m_program_3d->release();

	checkGLError("render structure");

}

void Tirth::FCGLPanel::renderSupport()
{
	if (!m_program_3d) {
		iniShader3d();
	} 
	// The (0,0) of NDC would located at the center screen ( (l+r)/2 , (t+b)/2 )

	glPushAttrib(GL_DEPTH_BUFFER_BIT);

	glViewport(0,0, ctx.panelWidth , ctx.panelHeight);  	
	//glViewport(0, ctx.panelHeight, ctx.panelWidth , -ctx.panelHeight);  	
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST); 
	glDepthMask(true); 

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//-------------------------------------------------------------------------
	// indexes and vertices 

	// MVP
	static QMatrix4x4 mvp;
	/*
	QMatrix4x4 rmat;
	rmat.rotate(ctx.y_theta,0,1,0);

	QMatrix4x4 txmat; 
	txmat.translate(ctx.worldCen.x(),ctx.worldCen.y(),ctx.worldCen.z());

	QMatrix4x4 ztxmat;
	ztxmat.translate(0,0, ctx.tx_scale);
	*/
	mvp=ctx.oglMVP;//*ztxmat*rmat;

	//-------------------------------------------------------------------------
	m_program_3d->bind();

	static int mvpLoc = m_program_3d->uniformLocation("mvp_matrix");
	static int lineColorLoc = m_program_3d->uniformLocation("lineColor");

	int vexAttrSlot = m_program_3d->attributeLocation("a_position");   

	m_program_3d->setUniformValue(lineColorLoc,1,1,1,1);
	m_program_3d->setUniformValue(mvpLoc, mvp); 

	m_program_3d->enableAttributeArray(vexAttrSlot);  

	// indexes and vertices 
	static GLubyte lineIdx[] = { 
		1-1,2-1
	}; 

	//-------------------------------------------------------------------------

	glLineWidth(2.5);

	// ---> , c0,c1,c1,c_left,c1,c_right 
	float c0c1[3*2*3]={0};

	for( int k=0; k < ctx.boxDatas.size() ; k++ ){

		Eigen::Vector3f cen = ctx.boxDatas[k].getBox3d_world_n3().colwise().mean();

		c0c1[0]=cen.x();
		c0c1[1]=cen.y();
		c0c1[2]=cen.z();

		if( ctx.boxDatas[k].isSupByWall()   ){
			m_program_3d->setUniformValue(lineColorLoc,0,1,1,1);
			c0c1[3]=cen.x()+0.5;
			c0c1[4]=cen.y();
			c0c1[5]=cen.z();

		}else if( ctx.boxDatas[k].isSupByObj() ){ 
			m_program_3d->setUniformValue(lineColorLoc,0,1,0,1);

			int plidx = ctx.boxDatas[k].getSupporterLIDX();

			Eigen::Vector3f cen2 = ctx.boxDatas[plidx].getBox3d_world_n3().colwise().mean(); 

			c0c1[3]=cen2.x();
			c0c1[4]=cen2.y();
			c0c1[5]=cen2.z();

		}else if( ctx.boxDatas[k].isSupByGround()   ){
			m_program_3d->setUniformValue(lineColorLoc,0,0,1,1); 

			c0c1[3]=cen.x();
			c0c1[4]=cen.y()-1;
			c0c1[5]=cen.z();

		}else if( ctx.boxDatas[k].isFloat()  ){
			m_program_3d->setUniformValue(lineColorLoc,1,0,0,1);

			c0c1[3]=cen.x();
			c0c1[4]=cen.y();
			c0c1[5]=cen.z();

		}else{
			m_program_3d->setUniformValue(lineColorLoc,0.5,0.5,0.5,1); 
		} 

		// drawing
		m_program_3d->setAttributeArray(vexAttrSlot, GL_FLOAT ,  c0c1 , 3 ); 

		glDrawElements(GL_LINES , sizeof(lineIdx)/sizeof(GLubyte) , GL_UNSIGNED_BYTE ,lineIdx);  	

	}	
	glLineWidth(1);


	//-------------------------------------------------------------------------

	glPopAttrib();

	m_program_3d->disableAttributeArray(vexAttrSlot);  
	m_program_3d->release(); 

}

void Tirth::FCGLPanel::iniShader2d_seg()
{ 
	oglEntry = window()->openglContext()->functions(); 
	oglEntry->initializeOpenGLFunctions();

	connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
		this, SLOT(ogl_cleanup()), Qt::DirectConnection);

	//=============================================================================
	m_program_2d = new QOpenGLShaderProgram();
	m_program_2d->addShaderFromSourceCode(QOpenGLShader::Vertex, 
		//"#version 330\n"
		"uniform  highp mat4 mvp_matrix; \n"
		"attribute highp vec4 a_position; \n"
		"attribute mediump vec2 texCoord; \n"
		"varying  mediump vec2 texCoordOut; \n"
		""
		"void main() { \n"
		"    gl_Position = mvp_matrix * a_position; \n"
		"    texCoordOut = texCoord;    \n"
		"	 \n"
		"}\n");

	//lowp mediump highp
	m_program_2d->addShaderFromSourceCode(QOpenGLShader::Fragment, 
		//"#version 330\n"
		"uniform sampler2D    texUid; \n"
		"uniform sampler2D    segTexUid; \n"
		"varying mediump vec2 texCoordOut; \n"  
		"uniform float        targetUID;\n"
		""
		"void main() { \n" 
		"  highp vec4 color = texture2D(texUid, texCoordOut ); \n" 
		"  highp vec4 segColor = texture2D(segTexUid, texCoordOut ); \n" 
		""
		//"	if( targetUID!= 0 && targetUID==segColor.r ){   \n"
		//"     color.r=1;\n"
		//"     color.a=0.5;\n"
		"     gl_FragColor = color;   \n"
		//"	}else {"
		//"     gl_FragColor = color; "
		//"	 }"	
		"}"
		); 

	m_program_2d->link(); 

	//-------------------------------------------------------------------------
	//textures 
	iniBKTex();
	
	//updateCVSegTex();

	//-------------------------------------------------------------------------

	std::cout<<"-------------------\n";
	std::cout
		<<glGetString(GL_VENDOR)<<"\n"
		<<glGetString(GL_RENDERER)<<"\n" 
		<<glGetString(GL_VERSION)<<"\n"
		<<glGetString(GL_SHADING_LANGUAGE_VERSION)<<"\n";

}

void Tirth::FCGLPanel::iniShaderBxmi_vex()
{ 
	oglEntry = window()->openglContext()->functions(); 
	oglEntry->initializeOpenGLFunctions();

	connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
		this, SLOT(ogl_cleanup()), Qt::DirectConnection);

	//-------------------------------------------------------------------------
	// [ Vertex ]
	m_program_bxmi_vex = new QOpenGLShaderProgram();
	m_program_bxmi_vex->addShaderFromSourceCode(QOpenGLShader::Vertex, 
		//"#version 330\n"
		"uniform highp mat4 mvp_matrix; \n"
		"attribute highp vec4 a_position; \n" 
		"uniform lowp float point_size; \n" 
		"\n"
		"\n"
		"void main() { \n"
		"gl_PointSize = point_size; \n"
		"    gl_Position = mvp_matrix * a_position; \n" 
		"}\n");

	// [ Fragment ]
	//lowp mediump highp
	// [3D]
	m_program_bxmi_vex->addShaderFromSourceCode(QOpenGLShader::Fragment,  
		//"#version 330\n" 
		"uniform highp vec4 lineColor;\n"
		"void main() { \n" 
		"\n"
		//"  gl_FragColor = vec4(1,0,0,1);   \n"
		"  gl_FragColor = lineColor;   \n"
		"}"); 

	m_program_bxmi_vex->link(); 


}

void Tirth::FCGLPanel::iniShaderBxmi_Rot(){
	oglEntry = window()->openglContext()->functions(); 
	oglEntry->initializeOpenGLFunctions();

	connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
		this, SLOT(ogl_cleanup()), Qt::DirectConnection);

	//-------------------------------------------------------------------------
	// [ Vertex ]
	m_program_bxmi_rot = new QOpenGLShaderProgram();
	m_program_bxmi_rot->addShaderFromSourceCode(QOpenGLShader::Vertex, 
		//"#version 330\n"
		"uniform highp mat4 mvp_matrix; \n"
		"attribute highp vec4 a_position; \n" 
		"uniform lowp float point_size; \n" 
		"\n"
		"\n"
		"void main() { \n"
		"gl_PointSize = point_size; \n"
		"    gl_Position = mvp_matrix * a_position; \n" 
		"}\n");

	// [ Fragment ]
	//lowp mediump highp
	// [3D]
	m_program_bxmi_rot->addShaderFromSourceCode(QOpenGLShader::Fragment,  
		//"#version 330\n" 
		"uniform highp vec4 lineColor;\n" //RGBA 
		"void main() { \n" 
		"\n"
		//"  gl_FragColor = vec4(1,0,0,1);   \n"
		"  gl_FragColor = lineColor;   \n"
		"}"); 


	m_program_bxmi_rot->link(); 
}

void Tirth::FCGLPanel::iniShader3d()
{ 
	oglEntry = window()->openglContext()->functions(); 
	oglEntry->initializeOpenGLFunctions();

	connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
		this, SLOT(ogl_cleanup()), Qt::DirectConnection);

	//-------------------------------------------------------------------------

	m_program_3d = new QOpenGLShaderProgram();
	m_program_3d->addShaderFromSourceCode(QOpenGLShader::Vertex, 
		//"#version 330\n"
		"uniform highp mat4 mvp_matrix; \n"
		"attribute highp vec4 a_position; \n" 
		""
		"void main() { \n"
		"    gl_Position = mvp_matrix * a_position; \n" 
		"}\n");

	//lowp mediump highp
	// [3D]
	m_program_3d->addShaderFromSourceCode(QOpenGLShader::Fragment,  
		//"#version 330\n" 
		"uniform highp vec4 lineColor;\n"
		"void main() { \n" 
		"\n"
		//"  gl_FragColor = vec4(1,0,0,1);   \n"
		"  gl_FragColor = lineColor;   \n"
		"}"); 

	m_program_3d->link(); 


}

void Tirth::FCGLPanel::iniShader2d()
{ 
	oglEntry = window()->openglContext()->functions(); 
	oglEntry->initializeOpenGLFunctions();

	connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
		this, SLOT(ogl_cleanup()), Qt::DirectConnection);

	//-------------------------------------------------------------------------

	//=============================================================================
	m_program_2d = new QOpenGLShaderProgram();
	m_program_2d->addShaderFromSourceCode(QOpenGLShader::Vertex, 
		//"#version 330\n"
		"uniform highp mat4 mvp_matrix; \n"
		"attribute highp vec4 a_position; \n"
		"attribute mediump vec2 texCoord; \n"
		"varying mediump vec2 texCoordOut; \n"
		""
		"void main() { \n"
		"    gl_Position = mvp_matrix * a_position; \n"
		"    texCoordOut = texCoord;    \n"
		"	 "
		"}\n");

	//lowp mediump highp
	m_program_2d->addShaderFromSourceCode(QOpenGLShader::Fragment, 
		//"#version 330\n"
		"uniform sampler2D texUid; \n"
		"uniform sampler2D segTexUid; \n"
		"varying mediump vec2 texCoordOut; \n" 
		"void main() { \n" 
		"  mediump vec4 color = texture2D(texUid, texCoordOut ); \n" 
		//"  mediump vec4 color = texture2D(texUid, texCoordOut ); \n" 
		"  \n" 
		"  gl_FragColor = color;   \n"
		"}"); 

	m_program_2d->link(); 

	//-------------------------------------------------------------------------
	//textures 
	iniBKTex();
	updateCVSegTex();
	//ctx.labelImgTex = new QOpenGLTexture(ctx.labelImg);
	//ctx.labelImgTex->setMinificationFilter(QOpenGLTexture::LinearMipMapLinear);
	//ctx.labelImgTex->setMagnificationFilter(QOpenGLTexture::Linear);

	//-------------------------------------------------------------------------

	std::cout<<"-------------------\n";
	std::cout
		<<glGetString(GL_VENDOR)<<"\n"
		<<glGetString(GL_RENDERER)<<"\n" 
		<<glGetString(GL_VERSION)<<"\n"
		<<glGetString(GL_SHADING_LANGUAGE_VERSION)<<"\n";

}


void Tirth::FCGLPanel::iniShader2d_supadj()
{
	oglEntry = window()->openglContext()->functions(); 
	oglEntry->initializeOpenGLFunctions();

	connect(window()->openglContext(), SIGNAL(aboutToBeDestroyed()),
		this, SLOT(ogl_cleanup()), Qt::DirectConnection);

	//-------------------------------------------------------------------------

	//=============================================================================
	m_program_supadj = new QOpenGLShaderProgram();
	m_program_supadj->addShaderFromSourceCode(QOpenGLShader::Vertex, 
		//"#version 330\n"
		"uniform highp mat4 mvp_matrix; \n"
		"attribute highp vec4 a_position; \n"
		"attribute mediump vec2 texCoord; \n"
		"varying mediump vec2 texCoordOut; \n"
		""
		"void main() { \n"
		"    gl_Position = mvp_matrix * a_position; \n"
		"    texCoordOut = texCoord;    \n"
		"	 "
		"}\n");

	//lowp mediump highp
	m_program_supadj->addShaderFromSourceCode(QOpenGLShader::Fragment, 
		//"#version 330\n"
		"uniform sampler2D texUid; \n"
		"uniform sampler2D segTexUid; \n"
		"varying mediump vec2 texCoordOut; \n" 
		"void main() { \n" 
		"  mediump vec4 color = texture2D(texUid, texCoordOut ); \n"  
		"  \n" 
		"  gl_FragColor = color;   \n"
		"}"); 

	m_program_supadj->link(); 


	//-------------------------------------------------------------------------

}


void Tirth::FCGLPanel::setupTestBox()
{
	// BOX
	float boxv0 [] =	{
		-0.084755422386375789,-0.58780937927252097, 3.2089460713498426,
		0.20932154841967021   ,-0.72949636927588213, 2.7036784098535942,
		1.4343163408142383    ,-0.55079229375870764, 3.3665401913215329, 
		1.1402393700081923    ,-0.40910530375534648,3.8718078528177813,
		-0.084684930970890582 ,-0.57198473717738096,3.2045495567160316,
		0.20939203983515542	  ,-0.71367172718074212,2.6992818952197832,
		1.4343868322297235	  ,-0.53496765166356763,3.362143676687722,
		1.1403098614236775    ,-0.39328066166020648,3.8674113381839703		
	};

	float boxv1[]={
		-2.2057694323391459,-0.26320820607449469,4.3432956887421028,-1.9250973882029534,-0.39843667025088791,3.8610596707385128,-1.2541639945895717,-0.300559901644462,4.2241110953633836,-1.5348360387257642,-0.16533143746806878,4.7063471133669736,-2.2025438678368321,0.4608998779036998,4.1421188299840352,-1.9218718237006396,0.32567141372730657,3.6598828119804452,-1.2509384300872579,0.42354818233373248,4.022934236605316,-1.5316104742234504,0.55877664651012571,4.5051702546089061
	};

	///*
	BoxDataV2 b1;
	b1.setBox3d_world(boxv0);
	BoxDataV2 b2;
	b2.setBox3d_world(boxv1);

	ctx.boxDatas.push_back(b1); 
	ctx.boxDatas.push_back(b2); 
	//*/

}

#pragma endregion DRAW_UTILITY

//------------------------------------------------------------------------------
#pragma region UI_SLOT 

void Tirth::FCGLPanel::mouseMoveEvent( int x, int y )
{
	//update log info
	ctx.lastPos.setX(x);
	ctx.lastPos.setY(y); 

	//update major logic
	dispatch(ctx.currentState , FCStateMag::U_MMove );
}

void Tirth::FCGLPanel::mouseReleaseEvent( int x, int y ){

	//update log info
	ctx.lastPos.setX(x);
	ctx.lastPos.setY(y);

	//update major logic
	dispatch(ctx.currentState ,FCStateMag::U_MRelease );
}

void Tirth::FCGLPanel::mousePressEvent( int x, int y, int btu )
{  
	bool verbase=0;

	//update log info
	ctx.lastPos.setX(x);
	ctx.lastPos.setY(y);
	ctx.lastBtu = static_cast<Qt::MouseButton>(btu);

	if( verbase ){
		std::cout<<"[focus uid]="<<ctx.focus_box_uid<<"(x,y)"<<x<<","<<y<<"\n";
	}
	//update major logic
	dispatch(ctx.currentState , FCStateMag::U_MPress );
}

void Tirth::FCGLPanel::mouseEnter()
{
	//std::cout<<"mouseEnter\n";
}

void Tirth::FCGLPanel::mouseLeave()
{
	//std::cout<<"mouseLeave\n"; 
}

void Tirth::FCGLPanel::textLoadBtuPress()
{
	dispatch(ctx.currentState , FCStateMag::U_BtuLoadBtu );
}

void Tirth::FCGLPanel::inipredModeBtuPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_BtuIniPredBtu );
}

void Tirth::FCGLPanel::confALLBtuPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_BtuConfAllBtu );
}

void Tirth::FCGLPanel::pauseBtuPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_BtuPauseTimeBtu );
}

void Tirth::FCGLPanel::actionDoneBtuPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_BtuActionDoneBtu );
}

void Tirth::FCGLPanel::saveLabelBtuPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_BtuSaveLabelBtu );
}

void Tirth::FCGLPanel::qmlRequestRePred()
{

	std::cout<<"[SLOT - Re-Prediction qmlRequestRePred ]\n";
	dispatch(ctx.currentState , FCStateMag::U_ReqRepredictBtu );
}

void Tirth::FCGLPanel::qmlMenuCloseRaise()
{
	dispatch(ctx.currentState , FCStateMag::U_QML_MenuCloseSignal ); 
}

void Tirth::FCGLPanel::collectDataSlot()
{
	// load model
	//TextCTX tctx=loadUIConf("..\\testData\\uiconf.txt");

	if( ctx.currentState != FCStateMag::S_PRE_INI ){
		std::cout<<"start loading ..at:"<<tctx.annoresSavePath<<std::endl;

		// test collect data
		collectAnnoData_time_v3(tctx.annoresSavePath , tctx.log_savePath );
		collectAnnoData__v3(tctx.annoresSavePath , tctx.log_savePath );

	}else{
		std::cout<<"require ini config .7\n";
	}

}

void Tirth::FCGLPanel::fastOpenSlot(int imid)
{
	if( imid >=0 && imid < trail_sidList.size() ){
		trail_cur_k=imid;
		std::cout<<"set K ="<<imid<<"\n";
	}



}

void Tirth::FCGLPanel::toggleInstTest()
{
	enableInstTest=!enableInstTest;

	std::cout<<"enableInstTest ="<<enableInstTest<<std::endl;
}

void Tirth::FCGLPanel::toggleShowWall()
{
	showSG=!showSG;

	std::cout<<"toggleShowWall ="<<showSG<<std::endl;
}

void Tirth::FCGLPanel::debugSlot()
{
	//_test_refBox();

	/*if(0){
		std::cout<<"collect res.\n";
		collectAnnoData(tctx.input_bin_dir, tctx.log_savePath );

	}
	*/
	//_runBatch();

	//forceReRunTCF();

	//testRefine();

	//testBoxOpt();

	//debugCheck();

	export_ini_batch();


}

void Tirth::FCGLPanel::de_rerun_refineSlot()
{

	// reloading 
	if( ctx.currentState==FCStateMag::S_INI ){

		//-------------------------------------------------------------------------
		// special re-run 
		system("echo %CD%");

		loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );

		// load svm model 
		ini_svm(tctx);  

		//-------------------------------------------------------------------------

		std::string ppath=tctx.rerun_dir;
		// load all anno
		std::vector<std::string> flist=getFileList(ppath.c_str(),"*.anno");
		std::cout<<"collect :"<<flist.size()<<" files\n";

		//-------------------------------------------------------------------------
		std::cout<<"SPECAL --RERUN MODE--\n"
			<<"-----------------------------------------------\n"
			<<"anno res log : "<<ppath<<"\n"
			<<"case #="<<flist.size()<<"\n"
			<<"re-save at:"<<tctx.rerun_save_dir<<"\n"
			<<"-----------------------------------------------\n";
		//-------------------------------------------------------------------------


		auto const & LID_NAMES = loader.getLidList();

		// [for each scene cases]
		for( int i=0 ; i < flist.size() ; i++ ){

			try
			{
				std::string fpath = ppath+'/'+flist[i];

				AnnoRes anno;
				loadAnnoFile(fpath,anno);
				auto const & FINAL_LID =anno.action_log.back().predRes;

				// fast reload 
				ctx.imid = anno.sce_id;

				fast_loadifexist(ctx.imid, true );  


				updateBoxPoly2D();
				updateBox2DSeg();
				updateBoxPlanes();
				update_sceneSupState();
				re_estiBoxFeatures();

				requireUpdateBKTex=1;
				requireUpdateContourTex=1;
				//-------------------------------------------------------------------------

				_anno_initialPred();

				//-------------------------------------------------------------------------
				ctx.isReady=true;

				//-------------------------------------------------------------------------
				// auto re-fined and confirmed


				//[for each BOX]
				for( int ib=0; ib< ctx.boxDatas.size() ; ib++ ){

					auto & preTagLID = ctx.boxDatas[ib].getPredTagLIDs_link();
					auto & preTag = ctx.boxDatas[ib].getPredTags_link();

					preTagLID[0]=FINAL_LID[ib];
					preTag[0]=QString::fromStdString(LID_NAMES[preTagLID[0]]);
					ctx.boxDatas[ib].setEdited(1);
					ctx.boxDatas[ib].setIsLocalRefined(0);

				}

				// make 'all-confirmed' log
				BoxStateLog alog;

				alog.boxState.clear();
				alog.boxState.resize(ctx.boxDatas.size()); 

				for (int i = 0; i < ctx.boxDatas.size() ; i++)
				{ 
					if( ctx.boxDatas[i].getUserModified() ){
						alog.boxState[i]=BoxStateLog::BSTATE_EDITED;
					}else{
						alog.boxState[i]=BoxStateLog::BSTATE_UNK;
					}
				} 

				// re-do REFINEMENT
				local_refine(alog.boxState);
				update_sceneSupState();

				re_estiBoxFeatures();

				global_refine_v2(alog.boxState);
				update_sceneSupState();

				re_estiBoxFeatures();

				// disable suggestion
				ctx.suggestBOX_LID=-1;
				//requireUpdateContourTex=1; 
				//request UPDATe contour texture
				//requireUpdateContourTex=1;

				//-------------------------------------------------------------------------
				// 
				// [SAVING]
				// save mymat..and bin

				NaiveAnnoBox* nabox=conv_BoxDataV2_to_AnooBox(ctx.boxDatas);

				std::vector< NaiveAnnoBox > annobox;
				for( int i=0 ;i<ctx.boxDatas.size() ;i++ ){
					annobox.push_back(nabox[i]);
				}

				export_sce2matlab( loader.getExportMatBin_SAVEPath(ctx.imid , tctx.rerun_save_dir), annobox , ctx.walls_fr , anno  );

				delete [] nabox;

				//-------------------------------------------------------------------------
				// save result bin
				NaiveSceneCTX scectx;

				conv_CTX_to_NaiveSCTX(scectx); 
				saveSceneANDBoxes(
					loader.getResultSceneBin_SAVEPath( ctx.imid , tctx.rerun_save_dir ).c_str() ,
					&scectx,
					ctx.floor_ini,
					ctx.floor_fr,
					ctx.walls_fr,
					ctx.boxDatas
					); 


				//-------------------------------------------------------------------------
				printf("sce.[%d] -- re-save at [%s] \n",ctx.imid,tctx.rerun_save_dir.c_str());


			}catch (const char* msg){

				std::cout<<"==================================================\n";
				std::cout<<"[EXCP] :"<<msg<<"\n";
				std::cout<<"==================================================\n";

			}catch (std::string msg){
				std::cout<<"==================================================\n";
				std::cout<<"[EXCP] :"<<msg<<"\n";
				std::cout<<"==================================================\n";
			}

			//-------------------------------------------------------------------------
			resetCtx();
			ctx.currentState=FCStateMag::S_INI;
		}

	}// if 

	std::cout<<"ALLL done\n";
	ctx.currentState=FCStateMag::S_PRE_INI;

}

void Tirth::FCGLPanel::directExportSlot() 
{

	static int iter=0;
	iter=iter+1;

	AnnoRes res;
	res.sce_id=ctx.imid;
	res.action_log=ctx.predLog;
	res.total_time=ctx.timer.getTotalSecond();

	NaiveAnnoBox* nabox=conv_BoxDataV2_to_AnooBox(ctx.boxDatas);

	std::vector< NaiveAnnoBox > annobox;
	for( int i=0 ;i<ctx.boxDatas.size() ;i++ ){
		annobox.push_back(nabox[i]);
	}

	export_sce2matlab( loader.getSxportMatAs_Path(ctx.imid , tctx.dirExportSAVPath , iter ), annobox , ctx.walls_fr ,res );

	delete [] nabox;

	//-------------------------------------------------------------------------

	printf("[%d] save at:[%s]\n",iter,loader.getSxportMatAs_Path(ctx.imid , tctx.dirExportSAVPath , iter ));
};

void Tirth::FCGLPanel::testBoxOpt()
{
	if( ctx.imid == 1308  ){
		optimalBoxSize(0);

	}else if( ctx.imid == 1275 ){
		optimalBoxSize(3);

	}else if( ctx.imid == 1244 ){
		optimalBoxSize(0);

	}else if( ctx.imid == 1060 ){
		optimalBoxSize(1);
	}
}

void Tirth::FCGLPanel::testRefine()
{
	// context extending 
	// scaling
	// rotation

	int box_id_list[]={8,7,4,6};

	calculate_box_conf(); 
	std::cout<<"=================================\n";
	std::cout<<"BEFORE\n"; 
	for( int i=0 ; i< 4  ; i++ ){ 
		//double a_cost=
		//	ctx.boxDatas[ib].quality.box2d_inScreen_ratio + 
		//	ctx.boxDatas[ib].quality.boxSeg2d_overlapRatio + 
		//	ctx.boxDatas[ib].quality.segImg_Ratio + 
		//	ctx.boxDatas[ib].quality.richCtxRatio ;

		int bid=box_id_list[i];

		std::cout<<"box."<<bid<<" :\n";
		std::cout<<"\t"<<std::setw(15)
			<<"seg2d_overlapRatio ="<<std::setprecision(3)
			<<ctx.boxDatas[bid].quality.boxSeg2d_overlapRatio<<"  \n"; 
		std::cout<<"\t"<<std::setw(15)
			<<"3d error ="<<std::setprecision(3)
			<<ctx.boxDatas[bid].quality.meanPlane2VXPcdErr<<"  \n"; 
		std::cout<<"\t"<<std::setw(15)
			<<"size belief ="<<std::setprecision(3)
			<<"n.a. "<<"  \n"; 
		std::cout<<"\t"<<std::setw(15)
			<<"num_voxel_pts ="<<std::setprecision(3)
			<<ctx.boxDatas[bid].quality.num_voxel_pts<<"  \n"; 
	}

	if( ctx.imid == 1030 ){

		// extend box.8 to floor
		//int ib=8;
		//mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.floor_fr,ctx.tx_fr2world);

		// extend box.7 with wall
		//int ib=7;
		//mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.walls_fr[ctx.boxDatas[ib].getClosedWallLIdx()],ctx.tx_fr2world);

		// align box.4 with wall
		int ip=7;
		int ic=4;
		mBox_enforceParentSupport(ctx.boxDatas[ip],ctx.boxDatas[ic],ctx.tx_fr2world);

		mBox_enforceChildSupTouch(ctx.boxDatas[ip],ctx.boxDatas[ic],ctx.tx_fr2world);
		
		//-------------------------------------------------------------------------
		box2dCenUpdate();

	}

	updateBoxPoly2D();
	updateBox2DSeg();

	// recalculate support state
	update_sceneSupState(); 

	re_estiBoxFeatures();

	calculate_box_conf();

	std::cout<<"=================================\n";
	std::cout<<"AFTER\n";
	for( int i=0 ; i< 4  ; i++ ){ 
		//double a_cost=
		//	ctx.boxDatas[ib].quality.box2d_inScreen_ratio + 
		//	ctx.boxDatas[ib].quality.boxSeg2d_overlapRatio + 
		//	ctx.boxDatas[ib].quality.segImg_Ratio + 
		//	ctx.boxDatas[ib].quality.richCtxRatio ;

		int bid=box_id_list[i];

		std::cout<<"box."<<bid<<" :\n";
		std::cout<<"\t"<<std::setw(15)
			<<"seg2d_overlapRatio ="<<std::setprecision(3)
			<<ctx.boxDatas[bid].quality.boxSeg2d_overlapRatio<<"  \n"; 
		std::cout<<"\t"<<std::setw(15)
			<<"3d error ="<<std::setprecision(3)
			<<ctx.boxDatas[bid].quality.meanPlane2VXPcdErr<<"  \n"; 
		std::cout<<"\t"<<std::setw(15)
			<<"size belief ="<<std::setprecision(3)
			<<"n.a. "<<"  \n"; 
		std::cout<<"\t"<<std::setw(15)
			<<"num_voxel_pts ="<<std::setprecision(3)
			<<ctx.boxDatas[bid].quality.num_voxel_pts<<"  \n"; 
	}

}

void Tirth::FCGLPanel::keyPressEvent( QKeyEvent *event )
{
	bool verbase =1;

	if(verbase)
	{
		std::cout<<"[key pressed]="<<event->text().toStdString()<<std::endl;
	}

	ctx.lastKeyCode=event->key();

	//update major logic
	dispatch(ctx.currentState , FCStateMag::U_KeyPress );
}

void Tirth::FCGLPanel::anno_startPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoStartBtu );
}

void Tirth::FCGLPanel::anno_resetPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoResetBtu );
}

void Tirth::FCGLPanel::anno_allDonePressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoALLDoneBtu );
}

void Tirth::FCGLPanel::anno_nextCasePressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoNextBtu );
}

void Tirth::FCGLPanel::anno_iniListPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoIniListBtu );
} 

void Tirth::FCGLPanel::anno_saveResPressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoSaveBtu );
}

void Tirth::FCGLPanel::anno_prevCasePressed()
{
	dispatch(ctx.currentState , FCStateMag::U_AnnoPrevBtu );
}

void Tirth::FCGLPanel::file_drop_slot( QString fpath )
{
	lastFileDropPath=fpath.toStdString();
	dispatch(ctx.currentState , FCStateMag::U_DropFileSignal );

}

void Tirth::FCGLPanel::addObjSegSlot()
{
	dispatch(ctx.currentState , FCStateMag::U_AddObjPressed );

}
void Tirth::FCGLPanel::bxmi_enterBoxMiModePressed()
{
	dispatch(ctx.currentState , FCStateMag::U_EnterBoxManiMode );
}

void Tirth::FCGLPanel::supadj_enterSupAdjModePressed()
{
	dispatch(ctx.currentState , FCStateMag::U_EnterSupAdjMode );

}


void Tirth::FCGLPanel::handle_bxmiXPainValChanged()
{
	dispatch(ctx.currentState , FCStateMag::U_BoxSpinValueChange );

}

#pragma endregion UI_SLOT

//-------------------------------------------------------------------------
#pragma region MISC

// handle custom rendering connection
void Tirth::FCGLPanel::handleWindowChanged( QQuickWindow *win )
{ 
	if (win) {

		//! [1]
		// Connect the beforeRendering signal to our paint function.
		// Since this call is executed on the rendering thread it must be
		// a Qt::DirectConnection

		//! [2]
		//connect(win, SIGNAL(afterRendering()), this, SLOT(paint_ogl_aft()), Qt::DirectConnection);
		connect(win, SIGNAL(beforeRendering()), this, SLOT(paint_ogl_bef()), Qt::DirectConnection);
		connect(win, SIGNAL(beforeSynchronizing()), this, SLOT(stateSYNC_3drendering()), Qt::DirectConnection);

		// If we allow QML to do the clearing, they would clear what we paint
		// and nothing would show.
		//! [3]
		win->setClearBeforeRendering(false);

		//std::cout<<"window changed\n";
	}
}

void Tirth::FCGLPanel::checkGLError(const char* hint/*=""*/)
{
	GLenum glErr = glGetError();
	int    retCode = 0;

	if (glErr != GL_NO_ERROR)
	{
		switch (glErr)
		{
		case GL_INVALID_ENUM :
			printf("***[GLERR] - GL_INVALID_ENUM - %s\n",hint);
			break;
		case GL_INVALID_VALUE :
			printf("***[GLERR] - GL_INVALID_VALUE - %s \n",hint);
			break;
		case GL_INVALID_OPERATION :
			printf("***[GLERR] - GL_INVALID_OPERATION - %s\n",hint);
			break;
		case GL_INVALID_FRAMEBUFFER_OPERATION :
			printf("***[GLERR] - GL_INVALID_FRAMEBUFFER_OPERATION \n - %s",hint);
			break;
		case GL_OUT_OF_MEMORY :
			printf("***[GLERR] - GL_OUT_OF_MEMORY- %s \n",hint);
			break;
		default:
			printf("***[GLERR] - UNKNOWNS - %s \n",hint);
			break;
		}
	}else
	{

		//printf(" pass check [%s]\n",hint);
	}

}

QList<QObject*> Tirth::FCGLPanel::getBoxData()
{
	ctx.qmlBoxDatas.clear();

	for( int k=0 ; k<ctx.boxDatas.size() ; k++ ){

		ctx.qmlBoxDatas.push_back( &ctx.boxDatas[k] );
	}

	return ctx.qmlBoxDatas;
}

void Tirth::FCGLPanel::convert2segLoc(int & wx , int &wy){

	 
	int dy =window()->height() - ctx.panelHeight;
	int sy=wy-dy;

	if (ctx.gtsegCvMat_16u.empty())
	{
		//check valid
		if( wx < 0 || wx >= ctx.segDraw_finerseg.cols || wy < 0 || sy < 0 || sy >= ctx.segDraw_finerseg.rows ){
			// INVALID mode 
			//std::cout<<"out : wy="<<wy<<", sy="<<sy<<std::endl;

			if (ctx.currentState==FCStateMag::S_DRAW_OBJSEG)
			{

				if(wx >= ctx.segDraw_finerseg.cols){
					wx =  ctx.segDraw_finerseg.cols-1;
				}
				if (wx<0)
				{
					wx=0;
				}

				if (sy<0)
				{
					sy=0;
				}

				if(sy>=ctx.segDraw_finerseg.rows ){
					sy=ctx.segDraw_finerseg.rows -1;
				}

			}else{
				wx=-1;
				wy=-1;
			}

		}else{
			// VALID 

			wy=sy;
		}

	}else{
		//check valid
		if( wx < 0 || wx >= ctx.gtsegCvMat_16u.cols || wy < 0 || sy < 0 || sy >= ctx.gtsegCvMat_16u.rows ){
			//std::cout<<"out : wy="<<wy<<", sy="<<sy<<std::endl;
			wx=-1;
			wy=-1;
		}else{
			wy=sy;
		}
	}

}

#pragma endregion MISC

//-------------------------------------------------------------------------
#pragma region SCENEBOX_STATE

void Tirth::FCGLPanel::calBoxSupState_v2()
{
	bool verbase=0;

	// re-initial
	for (int ib=0; ib<ctx.boxDatas.size() ; ib++)
	{
		ctx.boxDatas[ib].setSupporterLIDX(-1);
		ctx.boxDatas[ib].setSupToIni();
	}

	// calculate box 
	// the supporting state of boxes 
	// [found GROUND support]
	float GSUP_TH = 0.2;
	float bdist=1000;
	for (int ib=0; ib<ctx.boxDatas.size() ; ib++)
	{
		// box2plane dist
		bdist = box2PlaneDist_fr(ctx.boxDatas[ib] , ctx.floor_fr);

		if (bdist<GSUP_TH)
		{
			ctx.boxDatas[ib].setSupToFloor();
		} 
	}

	// [found OBJECT support]
	// N^N-1 
	for (int ib=0; ib<ctx.boxDatas.size() ; ib++)
	{ 
		float maxBelif = -1;
		int pidx = -1;

		if(ctx.boxDatas[ib].isSupByGround()){
			// skip isSupByGround
			continue; 
		}

		// try to find a BEST parent
		for ( int k=0 ; k < ctx.boxDatas.size() ; k++)
		{
			if(k==ib){
				// skip self
				continue; 
			}

			// avoid cycle
			if( ctx.boxDatas[k].isSupByObj() &&  ctx.boxDatas[k].getSupporterLIDX() == ib ){
				// skip this case
				continue;
			}else if(ctx.boxDatas[k].isSupByObj() ){
				// two step checking 
				int ppid = ctx.boxDatas[k].getSupporterLIDX();

				if(   ctx.boxDatas[ppid].getSupporterLIDX() == ib ){

					continue;
				}else{
					// normal case
				}
			}


			double belief=0;
			bool isSup = uIsSupportV_v2(ctx.boxDatas[k],ctx.boxDatas[ib],belief);

			if ( isSup && belief>maxBelif)
			{
				maxBelif=belief;
				pidx=k;
			}
		}

		//assign maximum liking parent
		if (pidx!=-1)
		{
			// only box2box use LIDX recorder
			ctx.boxDatas[ib].setSupporterLIDX(pidx);
			ctx.boxDatas[ib].setSupToObj();
		} 

	}

	// [found WALL support]
	float WSUP_TH = 0.15;
	for (int ib=0; ib<ctx.boxDatas.size() ; ib++)
	{

		float minDist=std::numeric_limits<float>::infinity();

		int mwallIdx=-1;
		ctx.boxDatas[ib].setClosedWallLIdx(-1);

		//box 2 wall distance
		for (int iw=0 ; iw < ctx.walls_fr.size() ; iw++ )
		{
			// box2plane dist
			float wdist = box2PlaneDist_fr(ctx.boxDatas[ib] , ctx.walls_fr[iw]);

			if (wdist < minDist)
			{
				minDist=wdist;
				mwallIdx=iw;
			}
		}

		if( mwallIdx!=-1 ){
			ctx.boxDatas[ib].setClosedWallLIdx(mwallIdx);
			// check min dist is pass or not
			if ( minDist < WSUP_TH )
			{
				//it's support by wall
				// only box2box use LIDX recorder
				//ctx.boxDatas[ib].setSupporterLIDX(mwallIdx);
				ctx.boxDatas[ib].setSupToWall();
				ctx.boxDatas[ib].setSupWallLIdx(mwallIdx);
			}
		}else{
			ctx.boxDatas[ib].setClosedWallLIdx(mwallIdx);

		}


	}

	// [mark remaining Floating object ]
	for (int ib=0; ib<ctx.boxDatas.size() ; ib++)
	{
		if (ctx.boxDatas[ib].isSupINI() )
		{
			ctx.boxDatas[ib].setSupToFloat();
		}
	} 


	//-------------------------------------------------------------------------
	// resolve support label

	for( int i=0 ; i < ctx.boxDatas.size() ; i++ ){

		resolveSupportLabel_v2(i);
	}

	//-------------------------------------------------------------------------

}

void Tirth::FCGLPanel::resolveSupportLabel( int const IDX )
{
	//   
	// we should use 2d features
	//   
	bool normalState = ctx.boxDatas[IDX].isSupByGround() +
		ctx.boxDatas[IDX].isSupByWall() +
		ctx.boxDatas[IDX].isSupByObj() +
		ctx.boxDatas[IDX].isFloat();

	if( ctx.boxDatas[IDX].isSupByGround() && ctx.boxDatas[IDX].isSupByWall() ){

		// ground vs wall ---> ground

		ctx.boxDatas[IDX].setSupToIni();
		ctx.boxDatas[IDX].setSupToFloor();

	}else if( ctx.boxDatas[IDX].isSupByObj() && ctx.boxDatas[IDX].isSupByWall() ){

		// 
		// obj vs wall --->  
		//

		int pidx = ctx.boxDatas[IDX].getSupporterLIDX();

		Eigen::MatrixXf u_frn3 = ctx.boxDatas[pidx].getBox3d_fr_n3();
		Eigen::MatrixXf v_frn3 = ctx.boxDatas[IDX].getBox3d_fr_n3();

		double u_ymax = u_frn3.col(2-1).maxCoeff();
		double v_ymin = v_frn3.col(2-1).minCoeff();
		bool useObj = 0;


		box_3D_distance_resolve_wall_obj(ctx.boxDatas[pidx],ctx.boxDatas[IDX],useObj);

		if( useObj  ){

			ctx.boxDatas[IDX].setSupToIni();
			ctx.boxDatas[IDX].setSupToObj();
		}else{
			ctx.boxDatas[IDX].setSupToIni();
			ctx.boxDatas[IDX].setSupToWall();
			ctx.boxDatas[IDX].setSupporterLIDX(-1);
		}


	}else if(ctx.boxDatas[IDX].isSupByGround() && ctx.boxDatas[IDX].isSupByObj() ){

		// ground vs obj ---> ground
		ctx.boxDatas[IDX].setSupToIni();
		ctx.boxDatas[IDX].setSupporterLIDX(-1);
		ctx.boxDatas[IDX].setSupToFloor(); 

	}else if(ctx.boxDatas[IDX].isFloat()){


	}else if(normalState){

		// single state -- nice

	}else{
		std::cout<<"img:"<<ctx.imid<<", wired support state :"<<IDX<<std::endl;
		std::cerr<<"img:"<<ctx.imid<<", wired support state :"<<IDX<<std::endl;
	}

}



void Tirth::FCGLPanel::resolveSupportLabel_v2( int const IDX )
{
	//   
	// we should use 2d features
	//   
	int normalState = (ctx.boxDatas[IDX].isSupByGround() +
		ctx.boxDatas[IDX].isSupByWall() +
		ctx.boxDatas[IDX].isSupByObj() );

	if( ctx.boxDatas[IDX].isSupByGround() && ctx.boxDatas[IDX].isSupByWall() ){

		// ground vs wall ---> ground

		ctx.boxDatas[IDX].setSupToIni();
		ctx.boxDatas[IDX].setSupToFloor();

	}else if( ctx.boxDatas[IDX].isSupByObj() && ctx.boxDatas[IDX].isSupByWall() ){

		// 
		// obj vs wall --->  
		//

		int pidx = ctx.boxDatas[IDX].getSupporterLIDX();

		Eigen::MatrixXf u_frn3 = ctx.boxDatas[pidx].getBox3d_fr_n3();
		Eigen::MatrixXf v_frn3 = ctx.boxDatas[IDX].getBox3d_fr_n3();

		double u_ymax = u_frn3.col(2-1).maxCoeff();
		double v_ymin = v_frn3.col(2-1).minCoeff();

		bool useObj = 0;
		//box_3D_distance_resolve_wall_obj(ctx.boxDatas[pidx],ctx.boxDatas[IDX],useObj);
		 
		float dist_2_wall = box2PlaneDist_fr(ctx.boxDatas[IDX]  ,  ctx.walls_fr[ctx.boxDatas[IDX].getClosedWallLIdx()]);
		float ydist_2_parent = box_fr_y_distance(ctx.boxDatas[pidx] , ctx.boxDatas[IDX] );
		
		float DIST_TH = 0.05;

		if (ydist_2_parent < DIST_TH && dist_2_wall < DIST_TH )
		{

			ctx.boxDatas[IDX].setSupToIni();
			ctx.boxDatas[IDX].setSupToObj();

		}else{

			useObj = ydist_2_parent <= dist_2_wall;

			if( useObj  ){

				ctx.boxDatas[IDX].setSupToIni();
				ctx.boxDatas[IDX].setSupToObj();
			}else{
				ctx.boxDatas[IDX].setSupToIni();
				ctx.boxDatas[IDX].setSupToWall();
				ctx.boxDatas[IDX].setSupporterLIDX(-1);
			}


		}


	

	}else if(ctx.boxDatas[IDX].isSupByGround() && ctx.boxDatas[IDX].isSupByObj() ){

		// ground vs obj ---> ground

		// rare case
		ctx.boxDatas[IDX].setSupToIni();
		ctx.boxDatas[IDX].setSupporterLIDX(-1);
		ctx.boxDatas[IDX].setSupToFloor(); 

	}else if(ctx.boxDatas[IDX].isFloat()){


	}else if(normalState == 1){

		// single state -- nice

	}else{
		std::cout<<"img:"<<ctx.imid<<", wired support state :"<<IDX<<std::endl;
		std::cerr<<"img:"<<ctx.imid<<", wired support state :"<<IDX<<std::endl;
	}

}



void Tirth::FCGLPanel::re_estiBoxFeatures()
{ 	
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){

		ctx.boxDatas[ib].estimateFeatures();
	}

}

// update all scene & box state
void Tirth::FCGLPanel::update_sceneSupState(){

	bool verbase=1;

	calBoxSupState_v2(); 

	if( verbase ){
		std::cout<<"update_sceneState\n";
	}
} 

void Tirth::FCGLPanel::gen_boxMenu_v2( std::vector<int> &unkFlag, int ib, Eigen::MatrixXd &fvecData, bool verbase, std::vector<std::string> lnames, const int NUM_MENU )
{
	// ALL SVM PROPOSALs
	std::vector<SVMProxy::PLog> proposals;
	std::vector<std::vector<std::string> const *>  propLNames;

	// [ predict by SUPPORT type ]
	if( ctx.boxDatas[ib].isSupByGround() ){

		// this support multiple cases
		ctx.floor_svmProxy.pred(fvecData.row(ib));

		// case X class_prob [ sorted ]
		SVMProxy::PLogVector const & lastResProb_sorted = ctx.floor_svmProxy.getLastResProbSorted();

		// use label order
		auto const & svmClassName = ctx.floor_svmProxy.getSVMClassNameList();

		// [save SVM proposals]
		proposals.push_back(lastResProb_sorted[0]);
		propLNames.push_back(&svmClassName);
		//---------------------------------------------
	}

	if( ctx.boxDatas[ib].isSupByWall() ){

		// this support multiple cases
		ctx.wall_svmProxy.pred(fvecData.row(ib));

		// case X class_prob [ sorted ]
		SVMProxy::PLogVector const & lastResProb_sorted = ctx.wall_svmProxy.getLastResProbSorted();

		// use label order
		auto const & svmClassName = ctx.wall_svmProxy.getSVMClassNameList();

		// [save SVM proposals]
		proposals.push_back(lastResProb_sorted[0]);
		propLNames.push_back(&svmClassName);
		//-------------------------------------------------------------------------
	}

	if( ctx.boxDatas[ib].isFloat() ){ 

		// this support multiple cases
		ctx.all_svmProxy.pred(fvecData.row(ib));

		// case X class_prob [ sorted ]
		SVMProxy::PLogVector const & lastResProb_sorted = ctx.all_svmProxy.getLastResProbSorted();

		// use label order
		auto const & svmClassName = ctx.all_svmProxy.getSVMClassNameList();

		// [save SVM proposals]
		proposals.push_back(lastResProb_sorted[0]);
		propLNames.push_back(&svmClassName);
		//-------------------------------------------------------------------------
	}

	if( ctx.boxDatas[ib].isSupByObj() ){

		// sup parent id
		int idx =ctx.boxDatas[ib].getSupporterLIDX(); 
		int plid = ctx.boxDatas[idx].getPredTagLIDs()[0]; 

		// frequency model 
		auto const & SUP_PRIOR_MODEL = ctx.freModel.prob_USupV_preSorted[plid];

		// ans
		SVMProxy::PLog freq_ans;

		// IF we have support info.
		if( SUP_PRIOR_MODEL.size() > 0 ){

			for( int k=0 ; k < SUP_PRIOR_MODEL.size() ; k++){

				SVMPResElement pred_k;
				pred_k.label=SUP_PRIOR_MODEL[k].v_label;
				pred_k.labelLIdx=SUP_PRIOR_MODEL[k].v_label;
				pred_k.prob=SUP_PRIOR_MODEL[k].prob;

				freq_ans.push_back(pred_k);

				if(verbase){
					std::cout<<"freq:"<< SUP_PRIOR_MODEL[k].v_label <<"("
						<<SUP_PRIOR_MODEL[k].prob<<"),"<<std::endl;
				}
			}

			// [save SVM proposals]
			proposals.push_back(freq_ans);
			propLNames.push_back(&lnames);

		}else{
			// we don't have support freq info. 
			ctx.obj_svmProxy.pred(fvecData.row(ib));

			// case X class_prob [ sorted ]
			SVMProxy::PLogVector const & lastResProb_sorted = ctx.obj_svmProxy.getLastResProbSorted();

			// use label order
			auto const & svmClassName = ctx.obj_svmProxy.getSVMClassNameList();

			// [save SVM proposals]
			proposals.push_back(lastResProb_sorted[0]);
			propLNames.push_back(&svmClassName);
		}

	}

	bool wiredState = !(ctx.boxDatas[ib].isSupByObj() || ctx.boxDatas[ib].isSupByGround() || ctx.boxDatas[ib].isSupByWall() || ctx.boxDatas[ib].isFloat());
	if(wiredState){
		std::cout<<"wired support state : "<<ctx.boxDatas[ib].getSupType()<<std::endl;
		throw "wire support state";
	}

	//-------------------------------------------------------------------------
	// [--combine menu--]
	//    FOR this boxes 

	QStringList res_menu;
	QList<int> res_lids;

	// NUM_MENU
	int numOfProp = proposals.size();
	int propIdx=0;

	std::vector<int> usedIdx;
	usedIdx.resize(numOfProp,0);

	std::vector<double> in_order_prob;

	double rejTH = 0.2;
	for( int ia=0 ; ia < NUM_MENU ; ia++ ){

		if( proposals[propIdx].size() > usedIdx[propIdx] ){

			int ansLID = proposals[propIdx][usedIdx[propIdx]].label;
			double ansProb = proposals[propIdx][usedIdx[propIdx]].prob;

			// check this LID is already push in ans bag or not
			bool thisIsRedundant=false;
			for( int k=0 ; k < res_lids.size() ; k++){
				if(res_lids[k]==ansLID){
					thisIsRedundant=true;
					break;
				}
			}

			if( thisIsRedundant ){
				// update used index
				usedIdx[propIdx]=usedIdx[propIdx]+1;
				// update interleaving idx
				propIdx=(propIdx+1)%numOfProp; 
				continue;
			}

			int lnameLIDX = proposals[propIdx][usedIdx[propIdx]].labelLIdx;
			std::string ansLName = (*propLNames[propIdx])[lnameLIDX] ;

			res_menu.push_back(QString::fromStdString(ansLName));
			res_lids.push_back( ansLID );

			// update used index
			usedIdx[propIdx]=usedIdx[propIdx]+1;
			// update interleaving idx
			propIdx=(propIdx+1)%numOfProp;

			//-------------------------------------------------
			// save prob.
			in_order_prob.push_back(ansProb);
		}
	}			 

	// re-parsing prob.
	ctx.boxDatas[ib].quality.menu_belif = in_order_prob[0];

	// save
	ctx.boxDatas[ib].setPredTags(res_menu);
	ctx.boxDatas[ib].setPredTagLIDs(res_lids);
}

void Tirth::FCGLPanel::gen_boxMenu_v3( std::vector<int> &unkFlag, int ib, Eigen::MatrixXd &fvecData, bool verbase, std::vector<std::string> lnames, const int NUM_MENU )
{
	// ALL SVM PROPOSALs
	std::vector<SVMProxy::PLog> proposals;
	std::vector<std::vector<std::string> const *>  propLNames;

	double TH = 0.7;

	// [ predict by SUPPORT type ]
	if( ctx.boxDatas[ib].isSupByGround() ){

		// this support multiple cases
		ctx.floor_svmProxy.pred(fvecData.row(ib));

		// case X class_prob [ sorted ]
		SVMProxy::PLogVector const & lastResProb_sorted = ctx.floor_svmProxy.getLastResProbSorted();

		// use label order
		auto const & svmClassName = ctx.floor_svmProxy.getSVMClassNameList();

		//-------------------------------------------------------------------------
		SVMProxy::PLog lastprob =  ctx.floor_svmProxy.getLastResProb()[0];

		for (int i=0 ; i < lastprob.size() ; i++)
		{
			float sw_p = ctx.freModel.prob_u_floor(lastprob[i].label);
			lastprob[i].prob = lastprob[i].prob*TH + (1-TH)*sw_p;
		}
		// resorting
		std::sort(lastprob.begin(),lastprob.end(),SVMPResEle_desComp);

		// [save SVM proposals]
		proposals.push_back(lastprob);
		propLNames.push_back(&svmClassName);
	}


	if( ctx.boxDatas[ib].isSupByWall() ){

		// this support multiple cases
		ctx.wall_svmProxy.pred(fvecData.row(ib));

		// case X class_prob [ sorted ]
		SVMProxy::PLogVector const & lastResProb_sorted = ctx.wall_svmProxy.getLastResProbSorted();

		// use label order
		auto const & svmClassName = ctx.wall_svmProxy.getSVMClassNameList();


		//-------------------------------------------------------------------------
		SVMProxy::PLog lastprob =  ctx.wall_svmProxy.getLastResProb()[0];

		for (int i=0 ; i < lastprob.size() ; i++)
		{
			float sw_p = ctx.freModel.prob_supByWall(lastprob[i].label);
			lastprob[i].prob = lastprob[i].prob*TH + (1-TH)*sw_p;
		}
		// resorting
		std::sort(lastprob.begin(),lastprob.end(),SVMPResEle_desComp);

		// [save SVM proposals]
		proposals.push_back(lastprob);
		propLNames.push_back(&svmClassName);
	}

	if( ctx.boxDatas[ib].isFloat() ){ 

		// this support multiple cases
		ctx.all_svmProxy.pred(fvecData.row(ib));

		// case X class_prob [ sorted ]
		SVMProxy::PLogVector const & lastResProb_sorted = ctx.all_svmProxy.getLastResProbSorted();


		// use label order
		auto const & svmClassName = ctx.all_svmProxy.getSVMClassNameList();

		// [save SVM proposals]
		proposals.push_back(lastResProb_sorted[0]);
		propLNames.push_back(&svmClassName);
		//-------------------------------------------------------------------------
	}

	if( ctx.boxDatas[ib].isSupByObj() ){


		// sup parent id
		int idx =ctx.boxDatas[ib].getSupporterLIDX(); 
		int plid = ctx.boxDatas[idx].getPredTagLIDs()[0]; 

		// frequency model 

		// if parent id is valid
		bool parIsValidAndINFO = (plid>0) &&   ctx.freModel.prob_USupV_preSorted[plid].size()>0;
		 

		// IF we have support info.
		if(  parIsValidAndINFO ){

			auto const & SUP_PRIOR_MODEL = ctx.freModel.prob_USupV_preSorted[plid];


			ctx.obj_svmProxy.pred(fvecData.row(ib));

			// case X class_prob [ sorted ]
			SVMProxy::PLogVector const & lastResProb_sorted = ctx.obj_svmProxy.getLastResProbSorted();

			// use label order
			auto const & svmClassName = ctx.obj_svmProxy.getSVMClassNameList();

			SVMProxy::PLog lastprob =  ctx.obj_svmProxy.getLastResProb()[0];

			// ans
			SVMProxy::PLog freq_ans;

			//-----------
			for( int k=0 ; k < SUP_PRIOR_MODEL.size() ; k++){

				SVMPResElement pred_k;
				pred_k.label=SUP_PRIOR_MODEL[k].v_label;
				pred_k.labelLIdx=SUP_PRIOR_MODEL[k].v_label;
				pred_k.prob=SUP_PRIOR_MODEL[k].prob;

				bool found=0;
				double geo_pr=0;
				// check size model
				for (int i=0 ; i < lastprob.size() ; i++)
				{
					if (lastprob[i].label == pred_k.label)
					{
						found=1;
						geo_pr = lastprob[i].prob;
						break;
					}
				}

				if (found)
				{
					pred_k.prob = pred_k.prob*(1-TH) + TH*geo_pr; 
				}

				freq_ans.push_back(pred_k);
			}

			//re-sorting
			sort(freq_ans.begin(),freq_ans.end(),SVMPResEle_desComp);

			// [save SVM proposals]
			proposals.push_back(freq_ans);
			propLNames.push_back(&lnames);

		}else{
			// we don't have support freq info. 
			ctx.obj_svmProxy.pred(fvecData.row(ib));

			// case X class_prob [ sorted ]
			SVMProxy::PLogVector const & lastResProb_sorted = ctx.obj_svmProxy.getLastResProbSorted();

			// use label order
			auto const & svmClassName = ctx.obj_svmProxy.getSVMClassNameList();

			// [save SVM proposals]
			proposals.push_back(lastResProb_sorted[0]);
			propLNames.push_back(&svmClassName);

		}



	}

	bool wiredState = !(ctx.boxDatas[ib].isSupByObj() || ctx.boxDatas[ib].isSupByGround() || ctx.boxDatas[ib].isSupByWall() || ctx.boxDatas[ib].isFloat());

	if(wiredState){
		std::cout<<"wired support state : "<<ctx.boxDatas[ib].getSupType()<<std::endl;
		throw "wire support state";
	}

	//-------------------------------------------------------------------------
	// [--combine menu--]
	//    FOR this boxes 

	QStringList res_menu;
	QList<int> res_lids;

	// NUM_MENU
	int numOfProp = proposals.size();
	int propIdx=0;

	std::vector<int> usedIdx;
	usedIdx.resize(numOfProp,0);

	std::vector<double> in_order_prob;

	double rejTH = 0.2;
	for( int ia=0 ; ia < NUM_MENU ; ia++ ){

		if( proposals[propIdx].size() > usedIdx[propIdx] ){

			int ansLID = proposals[propIdx][usedIdx[propIdx]].label;
			double ansProb = proposals[propIdx][usedIdx[propIdx]].prob;

			// check this LID is already push in ans bag or not
			bool thisIsRedundant=false;
			for( int k=0 ; k < res_lids.size() ; k++){
				if(res_lids[k]==ansLID){
					thisIsRedundant=true;
					break;
				}
			}

			if( thisIsRedundant ){
				// update used index
				usedIdx[propIdx]=usedIdx[propIdx]+1;
				// update interleaving idx
				propIdx=(propIdx+1)%numOfProp; 
				continue;
			}

			int lnameLIDX = proposals[propIdx][usedIdx[propIdx]].labelLIdx;
			std::string ansLName = (*propLNames[propIdx])[lnameLIDX] ;

			res_menu.push_back(QString::fromStdString(ansLName));
			res_lids.push_back( ansLID );

			// update used index
			usedIdx[propIdx]=usedIdx[propIdx]+1;
			// update interleaving idx
			propIdx=(propIdx+1)%numOfProp;

			//-------------------------------------------------
			// save prob.
			in_order_prob.push_back(ansProb);
		}
	}			 

	// re-parsing prob.
	ctx.boxDatas[ib].quality.menu_belif = in_order_prob[0];

	// save
	ctx.boxDatas[ib].setPredTags(res_menu);
	ctx.boxDatas[ib].setPredTagLIDs(res_lids);
}

void Tirth::FCGLPanel::gen_boxMenu_v2_5_allsvm( std::vector<int> &unkFlag, int ib, Eigen::MatrixXd &fvecData, bool verbase, std::vector<std::string> lnames, const int NUM_MENU )
{
	// ALL SVM PROPOSALs
	std::vector<SVMProxy::PLog> proposals;
	std::vector<std::vector<std::string> const *>  propLNames;


	ctx.all_svmProxy.pred(fvecData.row(ib));

	// case X class_prob [ sorted ]
	SVMProxy::PLogVector const & lastResProb_sorted = ctx.all_svmProxy.getLastResProbSorted();

	// use label order
	auto const & svmClassName = ctx.all_svmProxy.getSVMClassNameList();

	// [save SVM proposals]
	proposals.push_back(lastResProb_sorted[0]);
	propLNames.push_back(&svmClassName);

	bool wiredState = !(ctx.boxDatas[ib].isSupByObj() || ctx.boxDatas[ib].isSupByGround() || ctx.boxDatas[ib].isSupByWall() || ctx.boxDatas[ib].isFloat());

	if(wiredState){
		std::cout<<"wired support state : "<<ctx.boxDatas[ib].getSupType()<<std::endl;
		throw "wire support state";
	}

	//-------------------------------------------------------------------------
	// [--combine menu--]
	//    FOR this boxes 

	QStringList res_menu;
	QList<int> res_lids;

	// NUM_MENU
	int numOfProp = proposals.size();
	int propIdx=0;

	std::vector<int> usedIdx;
	usedIdx.resize(numOfProp,0);

	std::vector<double> in_order_prob;

	double rejTH = 0.2;
	for( int ia=0 ; ia < NUM_MENU ; ia++ ){

		if( proposals[propIdx].size() > usedIdx[propIdx] ){

			int ansLID = proposals[propIdx][usedIdx[propIdx]].label;
			double ansProb = proposals[propIdx][usedIdx[propIdx]].prob;

			// check this LID is already push in ans bag or not
			bool thisIsRedundant=false;
			for( int k=0 ; k < res_lids.size() ; k++){
				if(res_lids[k]==ansLID){
					thisIsRedundant=true;
					break;
				}
			}

			if( thisIsRedundant ){
				// update used index
				usedIdx[propIdx]=usedIdx[propIdx]+1;
				// update interleaving idx
				propIdx=(propIdx+1)%numOfProp; 
				continue;
			}

			int lnameLIDX = proposals[propIdx][usedIdx[propIdx]].labelLIdx;
			std::string ansLName = (*propLNames[propIdx])[lnameLIDX] ;

			res_menu.push_back(QString::fromStdString(ansLName));
			res_lids.push_back( ansLID );

			// update used index
			usedIdx[propIdx]=usedIdx[propIdx]+1;
			// update interleaving idx
			propIdx=(propIdx+1)%numOfProp;

			//-------------------------------------------------
			// save prob.
			in_order_prob.push_back(ansProb);
		}
	}			 

	// re-parsing prob.
	//ctx.boxDatas[ib].quality.menu_belif = in_order_prob[0]+in_order_prob[1];
	ctx.boxDatas[ib].quality.menu_belif = in_order_prob[0];

	// save
	ctx.boxDatas[ib].setPredTags(res_menu);
	ctx.boxDatas[ib].setPredTagLIDs(res_lids);
}

// make a prediction
void Tirth::FCGLPanel::make_a_pred_v2( BoxStateLog & stateLog )
{
	bool verbase = 0;

	// collect feature vector as MatrixXd 
	const int F_DIM = 2;
	Eigen::MatrixXd fvecData;
	fvecData.resize(ctx.boxDatas.size(),F_DIM);

	// [Prepare Features]
	// NOTE THAT the order matter !!!
	// [f_h,f_xz,f_stype]
	for (int i = 0; i < ctx.boxDatas.size(); i++)
	{
		fvecData.row(i)<< ctx.boxDatas[i].fvec_fr.height , ctx.boxDatas[i].fvec_fr.xz_area ;
	} 

	const int NUM_MENU = 6;

	auto const & lnames = loader.getLidList();

	// Collect SKIP flag
	std::vector<int> unkFlag(ctx.boxDatas.size());

	//-------------------------------------------------------------------------
	// found a inferring order
	std::vector<int> infOrder;
	std::vector<int> added_flag;
	added_flag.resize(ctx.boxDatas.size(),0);
	int wl_iter=0;

	// ground, wall
	for (int ib = 0; ib < ctx.boxDatas.size(); ib++)
	{
		if ( added_flag[ib]==0 && ctx.boxDatas[ib].isSupByGround() || ctx.boxDatas[ib].isSupByWall())
		{
			infOrder.push_back(ib);
			added_flag[ib]=1;
		}
	}

	// sup_by_ground,sup_by_wall
	for (int ib = 0; ib < ctx.boxDatas.size(); ib++)
	{
		if ( added_flag[ib]==0 &&  ctx.boxDatas[ib].isSupByObj() )
		{
			// check it's parent id 
			int par_lidx = ctx.boxDatas[ib].getSupporterLIDX();
			if( par_lidx != -1 && added_flag[par_lidx] != 0  ){
				infOrder.push_back(ib);
				added_flag[ib]=1;
			}
		}
	}

	// floating 
	for (int ib = 0; ib < ctx.boxDatas.size(); ib++)
	{
		if ( added_flag[ib]==0 && ctx.boxDatas[ib].isFloat() )
		{
			infOrder.push_back(ib);
			added_flag[ib]=1;
		}
	}

	// other objects
	for (int ib = 0; ib < ctx.boxDatas.size(); ib++)
	{
		if ( added_flag[ib]==0 && ctx.boxDatas[ib].isSupByObj() )
		{

			std::vector<int> chain;
			int tid=ib;

			int loop_iter=0;
			while (true)
			{
				int par_lidx = ctx.boxDatas[tid].getSupporterLIDX();

				if (par_lidx == -1)
				{ // impossible case
					throw "ERR: par_lidx == -1.\n";
				}

				if( added_flag[par_lidx]  ){
					// reach the node has added parent 
					chain.push_back(tid);
					break;
				}else{
					chain.push_back(tid);
				}

				// keep walking
				tid = par_lidx;

				loop_iter=loop_iter+1;

				if (loop_iter > 1000)
				{
					throw "inferring LOOP ITER > 1000" ;
				}
			}

			// inverse add nodes
			for (int i=chain.size()-1 ; i>=0 ; i--)
			{
				infOrder.push_back(chain[i]);
				added_flag[chain[i]]=1;
			}

		}

	}

	myassert(infOrder.size()==added_flag.size(),"inorder size == added_flag size");


	//-------------------------------------------------------------------------

	for (int k = 0; k < infOrder.size(); k++)
	{ 
		int ib= infOrder[k];

		// ONLY do prediction on UNKOWN boxes
		if( stateLog.boxState[ib]==BoxStateLog::BSTATE_UNK ){
			unkFlag[ib]=1;	

			// also setup the box menu confident
			gen_boxMenu_v3(unkFlag, ib, fvecData, verbase, lnames, NUM_MENU); 
			//gen_boxMenu_v2_5_allsvm(unkFlag, ib, fvecData, verbase, lnames, NUM_MENU);

		}else{ 
			// known box -- 
			unkFlag[ib]=0;
		}


	} //looping inf order

	//------------------------------------------------------------------------- 
	updateBoxPoly2D();
	updateBox2DSeg();

	calculate_box_conf();
	makeNextBoxSuggestion(stateLog);

	//-------------------------------------------------------------------------

	if( verbase ){
		std::cout<<"pred res [curTopLID] :\n";
		for (int i = 0; i < ctx.boxDatas.size(); i++){
			std::cout<<"["<<i<<"] - "<<ctx.boxDatas[i].getPredTagLIDs()[0]<<std::endl;
		}
	}


} 

int Tirth::FCGLPanel::box_checkInst(const int IDX )
{
	bool verbase=0;

	int instNum=0;
	bool res=0;

	for( int ib=0 ;ib< ctx.boxDatas.size(); ib++ ){

		if( ib==IDX ){
			continue;
		} 
		res=isBoxIntersected(ctx.boxDatas[IDX],ctx.boxDatas[ib]);

		if( res ){
			instNum=instNum+1;
		}
	}


	if( verbase ){
		std::cout<<IDX<<":instNum"<<instNum<<std::endl;
	}

	return instNum;
}

int Tirth::FCGLPanel::box_checkInst(const int IDX , BoxDataV2 const & refinedBox )
{
	bool verbase=0;

	int instNum=0;
	bool res=0;

	for( int ib=0 ;ib< ctx.boxDatas.size(); ib++ ){

		if( ib==IDX ){
			continue;
		} 
		res = isBoxIntersected( refinedBox ,ctx.boxDatas[ib]);

		if( res ){
			instNum=instNum+1;
		}
	}


	if( verbase ){
		std::cout<<IDX<<": instNum"<<instNum<<std::endl;
	}

	return instNum;
}

int Tirth::FCGLPanel::box_checkInst(const int SKIP_IDX1 , const int SKIP_IDX2 , BoxDataV2 const & refinedBox )
{
	bool verbase=true;

	int instNum=0;
	bool res=0;
	for( int ib=0 ;ib< ctx.boxDatas.size(); ib++ ){

		if( ib==SKIP_IDX1 || ib == SKIP_IDX2 ){
			continue;
		} 
		res = isBoxIntersected( refinedBox ,ctx.boxDatas[ib]);

		if( res ){
			instNum=instNum+1;
		}
	}


	if( verbase ){
		std::cout<<": instNum"<<instNum<<std::endl;
	}

	return instNum;
}

int Tirth::FCGLPanel::box_checkGroundInst(const int SKIP_IDX1 , const int SKIP_IDX2 , BoxDataV2 const & refinedBox )
{
	bool verbase=true;

	int instNum=0;
	bool res=0;
	for( int ib=0 ;ib< ctx.boxDatas.size(); ib++ ){

		if( ib==SKIP_IDX1 || ib == SKIP_IDX2 || !ctx.boxDatas[ib].isSupByGround() ){
			continue;
		} 
		res = isBoxIntersected( refinedBox ,ctx.boxDatas[ib]);

		if( res ){
			instNum=instNum+1;
		}
	}


	if( verbase ){
		std::cout<<": instNum"<<instNum<<std::endl;
	}

	return instNum;
}

void Tirth::FCGLPanel::checkBoxOccuState( const int IDX ){
	//
	// call after box plane is initialized
	// also require ctx.cam_fr
	//
	using namespace Eigen;

	bool verbase=0;

	// check whether box i is occluded or not

	//get the FR vertices 
	MatrixXf frn3 = ctx.boxDatas[IDX].getBox3d_fr_n3();
	MatrixXf wn3 = ctx.boxDatas[IDX].getBox3d_world_n3();

	int tarbox_uid = ctx.boxDatas[IDX].getUID(); 

	// p0 to p1
	ParametrizedLine<float,3> box_line_fr[8]; 
	float box_line_fr_t1[8]; 

	for( int iv=0 ; iv < wn3.rows() ; iv++ ){
		box_line_fr[iv]= ParametrizedLine<float,3>::Through(ctx.cam_fr,frn3.row(iv));

		box_line_fr_t1[iv]=(frn3.row(iv).transpose()-ctx.cam_fr).norm() / box_line_fr[iv].direction().norm();
	}


	// for other boxes
	for(int ib=0 ; ib < ctx.boxDatas.size() ;ib++  ){

		if( ib==IDX ){
			continue;
		}

		auto & boxAllPlane_fr =ctx.boxDatas[ib].getBoxPlane_fr();
		int candbox_uid = ctx.boxDatas[ib].getUID();


		Eigen::Vector3f p3d,p2d;

		int inter_count=0;

		float t0 = -1;
		float min_t0 = std::numeric_limits<float>::infinity(); 
		int seg_uid =-1;		 

		// check all planes
		for( int ip=0 ; ip < boxAllPlane_fr.size() ; ip++ ){

			Hyperplane<float,3> boxPlane_fr(boxAllPlane_fr[ip].model.head(3),boxAllPlane_fr[ip].model.w() );

			for( int iv=0 ; iv< wn3.rows() ; iv++ ){

				// world space
				t0=intersected_t0( boxPlane_fr , box_line_fr[iv]);

				// the intersection is inside the line segment
				if( t0 >0 && t0 < 0.95*box_line_fr_t1[iv] ){

					// found a real intersection
					p3d=intersectedPoint( boxPlane_fr , box_line_fr[iv]);

					// check projected point is lying on the box[ib] seg or not
					p2d = proj_fr2img(p3d , ctx.TX_world2img , ctx.tx_fr2world );

					if( p2d.y()>=0 && p2d.x()>=0 &&
						p2d.y() < ctx.gtsegCvMat_16u.rows &&
						p2d.x() < ctx.gtsegCvMat_16u.cols ){

							seg_uid = ctx.gtsegCvMat_16u.at<unsigned short>((int)p2d.y(),(int)p2d.x());

							if( seg_uid == candbox_uid ){
								// there should have a intersection
								inter_count=inter_count+1;
								if( min_t0 > t0 ){
									min_t0=t0; 
								}
							} 
					} 
				}

			}// all vertices of the target box 

		}// all planes of the target box

		if(verbase){
			if( inter_count > 0 ){
				std::cout<<"[INTE]: box."<<IDX<<" - intersected with box."<<ib<<" , #="<<inter_count<<std::endl;
			}
		}

	}// for all other boxes 

}

void Tirth::FCGLPanel::local_refine( std::vector<int> const& BOX_STATES )
{
	bool verbase = 0; 
	bool verbase2 = 0; 
	bool use_instTest= this->enableInstTest;

	myassert(BOX_STATES.size()==ctx.boxDatas.size(),"UNK_FLAG.size()==ctx.boxDatas.size()");

	for( int ib=0 ; ib < BOX_STATES.size() ; ib++ ){

		if( (BoxStateLog::BSTATE_UNK != BOX_STATES[ib]) && (!ctx.boxDatas[ib].getIsLocalRefined()) ){
			// found a fixed and unrefined boxes

			int lid = ctx.boxDatas[ib].getPredTagLIDs()[0];
			int uid = ctx.boxDatas[ib].getUID();

			//===================================================================================
			if (lid <0)
			{
				//by-pass special case
				ctx.boxDatas[ib].setIsLocalRefined(1);
				continue;
			}
			//===================================================================================


			int bef_num_over = cal2DPixelOverlap_sim(ctx.boxDatas[ib].getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

			// According to frequency model(local model)
			// we should also know it would align/touch wall or not. 
			int wlid = ctx.boxDatas[ib].getClosedWallLIdx();

			if( wlid!=-1 ){
				//===========================================

				// ALIGN WALL
				double alignWall_prob=ctx.freModel.prob_u_alignWall(lid); 

				if( alignWall_prob > 0.5 ){

					BoxDataV2 tmp=ctx.boxDatas[ib]; 
					mBox_Align2Wall_retake(tmp,ctx.walls_fr[wlid],ctx.fr_xyzPcd,ctx.fr_nvPcd,ctx.tx_fr2world);

					int after = box_checkInst(ib,tmp);
					int aft_num_over = cal2DPixelOverlap_sim(tmp.getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

					if(use_instTest){

						int boxInst_bef = box_checkInst(ib);
						if( ( after <= boxInst_bef+1 ) && bef_num_over*0.9 < aft_num_over ){
							// no more inst
							// do real

							//mBox_Align2Wall(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.tx_fr2world);
							mBox_Align2Wall_retake(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.fr_xyzPcd,ctx.fr_nvPcd,ctx.tx_fr2world);

							//std::cout<<"disable align to wall\n";

							//checkBox(ctx.boxDatas[ib],ctx.tx_fr2world);
						}else{
							std::cout<<"box-"<<ib<<". reject align to wall.\n";
						}

					}else{

						//self segmentation overlapping ratio
						if( bef_num_over*0.9 < aft_num_over ){
							// no more inst
							// do real

							//mBox_Align2Wall(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.tx_fr2world);
							mBox_Align2Wall_retake(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.fr_xyzPcd,ctx.fr_nvPcd,ctx.tx_fr2world);

							//std::cout<<"disable align to wall\n";

							//checkBox(ctx.boxDatas[ib],ctx.tx_fr2world);

						}else{
							std::cout<<"box-"<<ib<<". reject align to wall.\n";
						}

					} 

				} 
				//==============================================================
				// TOUCH WALL
				double touch_wall_prob=ctx.freModel.prob_u_touchWall(lid);


				if( touch_wall_prob > 0.5 ){

					BoxDataV2 tmp=ctx.boxDatas[ib];

					mBoxEntend2Plane_Side(tmp,ctx.walls_fr[wlid],ctx.tx_fr2world);

					int after = box_checkInst(ib,tmp);
					int aft_num_over = cal2DPixelOverlap_sim(tmp.getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

					if(use_instTest){

						int boxInst_bef = box_checkInst(ib);
						if( after <= boxInst_bef && bef_num_over*0.9 < aft_num_over ){
							// no more inst
							mBoxEntend2Plane_Side(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.tx_fr2world);
						}else{
							std::cout<<ib<<". reject extend to wall.\n";
						}

					}else{
						if( bef_num_over*0.9 < aft_num_over ){
							// no more inst
							mBoxEntend2Plane_Side(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.tx_fr2world);
						}else{
							std::cout<<ib<<". reject extend to wall.\n";
						}
					}

				}

			}
			//===================================================================================


			// update before overlapping number
			bef_num_over = cal2DPixelOverlap_sim(ctx.boxDatas[ib].getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

			//===================================================================================
			// check it's support state 
			if( ctx.boxDatas[ib].isSupByGround() ){

				// extend to the floor

				BoxDataV2 abox =ctx.boxDatas[ib];
				mBoxEntend2Plane_BotVex(abox,ctx.floor_fr,ctx.tx_fr2world); 

				int aft_num_over = cal2DPixelOverlap_sim(abox.getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

				// reject testing 
				if( bef_num_over*0.9 < aft_num_over ){ 
					// we do this
					mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.floor_fr,ctx.tx_fr2world); 

					if( verbase2 ){
						std::cout<<"box."<<ib<<" - extend to floor.\n"; 
					}
				}else{
					if( verbase2 ){
						std::cout<<"box."<<ib<<" - reject extend to floor.\n"; 
					}
				}



			}else if( ctx.boxDatas[ib].isSupByWall() ){

				// extend to the wall
				int wlid = ctx.boxDatas[ib].getClosedWallLIdx();
				if( wlid != -1 ){

					BoxDataV2 abox =ctx.boxDatas[ib];

					mBoxEntend2Plane_Side(abox,ctx.walls_fr[wlid],ctx.tx_fr2world);

					int aft_num_over = cal2DPixelOverlap_sim(abox.getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());
					// reject testing 
					if( bef_num_over*0.9 < aft_num_over ){ 
						// we do this
						mBoxEntend2Plane_Side(ctx.boxDatas[ib],ctx.walls_fr[wlid],ctx.tx_fr2world);


					}else{
						std::cout<<ib<<". reject extend to wall.\n";
					}

				}


			}else if( ctx.boxDatas[ib].isSupByObj() ){
				// skip this cases

			}else if( ctx.boxDatas[ib].isFloat() ){

				// TOUCH FLOOR 
				double supbyFloor_prob = ctx.freModel.prob_u_floor(lid);
				if( supbyFloor_prob > 0.5 ){

					int boxInst_bef = box_checkInst(ib);

					BoxDataV2 tmp=ctx.boxDatas[ib];	 
					mBoxEntend2Plane_BotVex(tmp,ctx.floor_fr,ctx.tx_fr2world); 

					int after = box_checkInst(ib,tmp);
					int aft_num_over = cal2DPixelOverlap_sim(tmp.getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

					if( after <= boxInst_bef ){//&& bef_num_over < aft_num_over+100  ){
						// no more inst
						// do real
						mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.floor_fr,ctx.tx_fr2world); 

					}else{

						std::cout<<ib<<". reject extend to floor.\n";

					}

				}
			}//float
			//===================================================================================


			//===================================================================================
			{ // extend to floor prob.
				double supbyFloor_prob = ctx.freModel.prob_u_floor(lid);
				if( supbyFloor_prob > 0.5 ){

					int boxInst_bef = box_checkInst(ib);

					BoxDataV2 tmp=ctx.boxDatas[ib];	 
					mBoxEntend2Plane_BotVex(tmp,ctx.floor_fr,ctx.tx_fr2world); 

					int after = box_checkInst(ib,tmp);
					int aft_num_over = cal2DPixelOverlap_sim(tmp.getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

					if( after <= boxInst_bef &&  bef_num_over*0.9  < aft_num_over  ){
						// no more inst
						// do real
						mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.floor_fr,ctx.tx_fr2world); 

					}else{
						std::cout<<ib<<". reject extend to floor.\n";
					}
				}
			}
			//===================================================================================



			// set local refined
			ctx.boxDatas[ib].setIsLocalRefined(1);

		}// if box is fixed

	}// loop all box

}

void Tirth::FCGLPanel::global_refine( std::vector<int> const& BOX_STATES )
{
	// all boxes should be fixed and local refined
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){
		if( BoxStateLog::BSTATE_UNK == BOX_STATES[ib] ){
			myassert("global_refine -- all boxes should be fixed");
		}
	}

	bool verbase=1;

	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){

		// found a floating boxes
		if( ctx.boxDatas[ib].isFloat()  ){
			// check nearby parent..

			int ib_lid = ctx.boxDatas[ib].getPredTagLIDs_link()[0];

			double xz_dist=0 ;
			double xz_overarea_ratio = 0;
			double y_diff =0;
			int good_y_cen=false;
			double const Y_TH = 0.2; // 20 cm

			std::vector<int> parIds;
			std::vector<float> par_energy;

			std::vector<BoxQualityTerm> parentMinEnergy;

			float p_mincost=0;
			float uSupv_prob=0;

			// calculate XZ distance and Y distance  
			for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

				if( k==ib ){
					continue;
				} 
				//--------------------
				p_mincost = 0; 
				// check feature of possible parent
				box_3D_distance( ctx.boxDatas[k] , ctx.boxDatas[ib] , xz_dist , xz_overarea_ratio , y_diff , good_y_cen );

				int par_lid = ctx.boxDatas[k].getPredTagLIDs_link()[0];

				// sup prob.
				if( par_lid > 0 && par_lid < 896 && ib_lid > 0 && ib_lid< 896 ){

					uSupv_prob=ctx.freModel.prob_USupV(par_lid,ib_lid);

					// -1 ~ 1
					uSupv_prob=(uSupv_prob*2)-1;

					// or if( uSupv_prob <-0.3 )
					if( uSupv_prob <0 ){
						// no data
						uSupv_prob=0;
					}

				}else{
					// no data
					uSupv_prob=0;
				}

				if( xz_dist < 0.6  && good_y_cen ){ 
					//-------------------------------------------------------------------
					// pre-extending (parent) test  

					bool inst_not_increase=false;

					//check parent box
					BoxDataV2 tmp_par=ctx.boxDatas[k]; 
					BoxDataV2 tmp_child=ctx.boxDatas[ib]; 

					//                      skid1,skid2,extended_box
					int bef_par   = box_checkInst(ib, k, tmp_par);
					int bef_child = box_checkInst(ib, k, tmp_child);

					//do refinement
					mBox_enforceChildSupTouch(ctx.boxDatas[k],tmp_child,ctx.tx_fr2world);
					mBox_enforceParentSupportV2(tmp_par,ctx.boxDatas[ib],ctx.tx_fr2world);

					int after_par = box_checkGroundInst(ib,k,tmp_par);
					int after_child = box_checkGroundInst(ib,k,tmp_child);

					
					//-------------------------------------------------------------------

					//  small or no XZ intersection
					p_mincost = 2*xz_dist + 2-uSupv_prob + xz_overarea_ratio ;

					BoxQualityTerm bq;
					bq.boxIdx=k;
					bq.prob=p_mincost;

					parentMinEnergy.push_back(bq); 



				}else{
					// too far  -- skip (constraint)
				}	

			}// loop to find a parent

			// if we have candidate
			if( parentMinEnergy.size() ){
				// sort 
				// descend sorting
				std::sort(parentMinEnergy.begin(),parentMinEnergy.end(),boxQTerm_desComp);

				int parIDX = parentMinEnergy.back().boxIdx;

				// do refinement
				mBox_enforceChildSupTouch(ctx.boxDatas[parIDX],ctx.boxDatas[ib],ctx.tx_fr2world);
				mBox_enforceParentSupport(ctx.boxDatas[parIDX],ctx.boxDatas[ib],ctx.tx_fr2world);

			}else{

				// if we cannot find a possible parent ...

				// test extending to floor or extending to wall 

				BoxDataV2 tmp=ctx.boxDatas[ib]; 
				int bef = box_checkInst(ib,tmp);

				mBoxEntend2Plane_BotVex(tmp,ctx.floor_fr,ctx.tx_fr2world);

				int after = box_checkInst(ib,tmp);

				if( after <= bef ){
					// no more inst
					// do real
					mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.floor_fr,ctx.tx_fr2world);					 
				}else{ 


				}

				//-------------------------------------------------------------------
			}

		}else if( ctx.boxDatas[ib].isSupByObj() ){


			bool inst_not_increase=false;

			int par_k = ctx.boxDatas[ib].getSupporterLIDX();

			// do refinement
			mBox_enforceChildSupTouch(ctx.boxDatas[par_k],ctx.boxDatas[ib],ctx.tx_fr2world);
			mBox_enforceParentSupport(ctx.boxDatas[par_k],ctx.boxDatas[ib],ctx.tx_fr2world);

		}

	}


}


void Tirth::FCGLPanel::global_refine_v2( std::vector<int> const& BOX_STATES )
{
	// all boxes should be fixed and local refined
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){
		if( BoxStateLog::BSTATE_UNK == BOX_STATES[ib] ){
			myassert("global_refine v2 -- all boxes should be fixed");
		}
	}

	bool verbase=1;
	for( int ib=0 ; ib < ctx.boxDatas.size() ; ib++ ){

		// found a floating boxes
		if( ctx.boxDatas[ib].isFloat()  ){
			// check nearby parent..

			int ib_lid = ctx.boxDatas[ib].getPredTagLIDs_link()[0];

			double xz_dist=0 ;
			double xz_overarea_ratio = 0;
			double y_diff =0;
			int good_y_cen=false;
			double const Y_TH = 0.2; // 20 cm

			std::vector<int> parIds;
			std::vector<float> par_energy;

			std::vector<BoxQualityTerm> parentMinEnergy;

			float p_mincost=0;
			float uSupv_prob=0;

			// calculate XZ distance and Y distance  
			for( int k=0 ; k < ctx.boxDatas.size() ; k++ ){

				if( k==ib ){
					continue;
				} 
				//--------------------
				p_mincost = 0; 
				// check feature of possible parent
				box_3D_distance( ctx.boxDatas[k] , ctx.boxDatas[ib] , xz_dist , xz_overarea_ratio , y_diff , good_y_cen );

				int par_lid = ctx.boxDatas[k].getPredTagLIDs_link()[0];

				// sup prob.
				if( par_lid > 0 && par_lid < 896 && ib_lid > 0 && ib_lid< 896 ){

					uSupv_prob=ctx.freModel.prob_USupV(par_lid,ib_lid);

					// -1 ~ 1
					uSupv_prob=(uSupv_prob*2)-1;

					// or if( uSupv_prob <-0.3 )
					if( uSupv_prob <0 ){
						// no data
						uSupv_prob=0;
					}

				}else{
					// no data
					uSupv_prob=0;
				}

				if( xz_dist < 0.6  && good_y_cen ){ 
					
					
					//-------------------------------------------------------------------

					//  small or no XZ intersection
					p_mincost = 2*xz_dist + 2-uSupv_prob + xz_overarea_ratio ;

					BoxQualityTerm bq;
					bq.boxIdx=k;
					bq.prob=p_mincost;

					parentMinEnergy.push_back(bq); 

				}else{
					// too far  -- skip (constraint)
				}	

			}// loop to find a parent

			// if we have candidate
			if( parentMinEnergy.size() ){
				// sort 
				// descend sorting
				std::sort(parentMinEnergy.begin(),parentMinEnergy.end(),boxQTerm_desComp);

				// do support refinement

				//-------------------------------------------------------------------------

				int par_k = parentMinEnergy.back().boxIdx;

				BoxDataV2 child_tmp=ctx.boxDatas[ib]; 
				BoxDataV2 parent_tmp=ctx.boxDatas[ib]; 

				int bef_num_over = cal2DPixelOverlap_sim(ctx.boxDatas[ib].getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());

				// try refinement
				mBox_enforceChildSupTouch(ctx.boxDatas[par_k], child_tmp ,ctx.tx_fr2world);

				int aft_num_over = cal2DPixelOverlap_sim(child_tmp.getBox3d_world_n3(),child_tmp.getSegMask());

				if( bef_num_over*0.9 < aft_num_over ){
					// apply refinement
					mBox_enforceChildSupTouch(ctx.boxDatas[par_k],ctx.boxDatas[ib],ctx.tx_fr2world);

					mBox_enforceParentSupport(ctx.boxDatas[par_k],ctx.boxDatas[ib],ctx.tx_fr2world);
				}

				//------------------------


			}else{
				// if we cannot find a possible parent ...

				// test extending to floor or extending to wall 

				BoxDataV2 tmp=ctx.boxDatas[ib]; 
				int bef = box_checkInst(ib,tmp);

				mBoxEntend2Plane_BotVex(tmp,ctx.floor_fr,ctx.tx_fr2world);

				int after = box_checkInst(ib,tmp);

				if( after <= bef ){
					// no more inst
					// do real
					mBoxEntend2Plane_BotVex(ctx.boxDatas[ib],ctx.floor_fr,ctx.tx_fr2world);					 
				}else{ 


				}

				//-------------------------------------------------------------------
			}

			// IF its XZ projection is overlapped -- found a potentials parent via Y distance 
			// and check the extension would not increase the intersection of OTHER boxes
			// also the prior should > X

			// IF XZ projection is under some range TH and the Y differ is very small
			// we try to extend the parent and make sure no new intersection is happened.
			// also the prior should > X

		}else if( ctx.boxDatas[ib].isSupByObj() ){


			bool inst_not_increase=false;

			//-------------------------------------------------------------------------
			
			int par_k = ctx.boxDatas[ib].getSupporterLIDX();

			BoxDataV2 child_tmp=ctx.boxDatas[ib]; 
			BoxDataV2 parent_tmp=ctx.boxDatas[ib]; 

			int bef_num_over = cal2DPixelOverlap_sim(ctx.boxDatas[ib].getBox3d_world_n3(),ctx.boxDatas[ib].getSegMask());
			
			// try refinement
			mBox_enforceChildSupTouch(ctx.boxDatas[par_k], child_tmp ,ctx.tx_fr2world);

			int aft_num_over = cal2DPixelOverlap_sim(child_tmp.getBox3d_world_n3(),child_tmp.getSegMask());

			if( bef_num_over*0.9 < aft_num_over ){
				// apply refinement
				mBox_enforceChildSupTouch(ctx.boxDatas[par_k],ctx.boxDatas[ib],ctx.tx_fr2world);

				mBox_enforceParentSupport(ctx.boxDatas[par_k],ctx.boxDatas[ib],ctx.tx_fr2world);
			}
			//-------------------------------------------------------------------------
			 
		}

	}



}


void Tirth::FCGLPanel::export_ini_batch()
{
	//TextCTX tctx=loadUIConf("..\\testData\\uiconf.txt");

	loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );

	// get batching ids 
	std::fstream fin(tctx.batchFPath , std::fstream::in ); 
	myassert(fin.is_open() ,"batch file open fail");

	std::vector<int> idlist;
	int tmpid=0;
	while(fin>>tmpid)
	{
		idlist.push_back(tmpid);
	}  
	fin.close();


	ini_svm(tctx);

	std::string tmpName;
	std::vector< NaiveAnnoBox > annobox;

	//-------------------------------------------------------------------------
	for(int k=0 ; k < idlist.size() ; k++ ){

		ctx.imid=idlist[k];

		ctx.annosavePath=tctx.annoresSavePath;

		try
		{
			if(tctx.batch_force_rerun){

				loadCase(ctx.imid , tctx.use_auto_seg );
				saveProcessedIniCase();

			}else if(tctx.batch_skip_exist){

				bool fileExisted=true;

				fileExisted &= fileisExisted(loader.getProc_FrXYZ_Path(ctx.imid).c_str());
				fileExisted &= fileisExisted(loader.getProc_FrNV_Path(ctx.imid).c_str());
				fileExisted &= fileisExisted(loader.get_sceini_bin_path(ctx.imid,tctx.input_bin_dir).c_str()); 
				if( fileExisted ){
					//fast_loadifexist(ctx.imid,1);
					std::cout<<"BTACH SKIP- "<<k<<"/"<<idlist.size()<<std::endl;
					continue;
				}else{ 
					loadCase(ctx.imid , tctx.use_auto_seg );
					saveProcessedIniCase();
				}

			}else{

				fast_loadifexist(ctx.imid,1);
			}

			updateBoxPoly2D();
			updateBox2DSeg();
			updateBoxPlanes();
			update_sceneSupState();
			re_estiBoxFeatures();

			_anno_initialPred__forexport();
			//-------------------------------------------------------------------------

			NaiveAnnoBox* nabox=conv_BoxDataV2_to_AnooBox(ctx.boxDatas);
			annobox.clear();
			annobox.reserve(ctx.boxDatas.size());
			for( int i=0 ;i<ctx.boxDatas.size() ;i++ ){
				annobox.push_back(nabox[i]);
			}

			AnnoRes res;
			res.sce_id=ctx.imid;
			tmpName=loader.getExportMatBin_SAVEPath(ctx.imid , ctx.annosavePath);
			export_sce2matlab( tmpName , annobox ,ctx.walls_fr , res );

			delete [] nabox;
			//-------------------------------------------------------------------------
			std::cout<<"BTACH - "<<k+1<<"/"<<idlist.size()<<std::endl;

		}catch (std::string msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (const char * msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (int i){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<i<<"]\n";

		}catch (...){
			std::cout<<"**ERR "<<ctx.imid<<"case - [UNKOWN]\n";
		}

		resetCtx();
	}


	std::cout<<"=========================================================\n";
	std::cout<<"BTACH MODE -- ALL DONE --"<<std::endl;
	//-------------------------------------------------------------------------
	return ;
}


void Tirth::FCGLPanel::auto_rerun_gtlabel()
{
	// load a batching list

	// initial prediction
	// auto_fill
	// run re_Pred

	// save out

	loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );


	// load a batching list
	//------------------------------------------------------------------------- 
	std::fstream fin(tctx.batchFPath , std::fstream::in ); 
	myassert(fin.is_open() ,"batch file open fail");

	std::vector<int> idlist;
	int tmpid=0;
	while(fin>>tmpid)
	{
		idlist.push_back(tmpid);
	}  
	fin.close();


	ini_svm(tctx);

	std::string tmpName;
	std::vector< NaiveAnnoBox > annobox;

	//-------------------------------------------------------------------------
	for(int k=0 ; k < idlist.size() ; k++ ){

		ctx.imid=idlist[k];


		ctx.annosavePath=tctx.annoresSavePath;

		try
		{
			if(tctx.batch_force_rerun){

				loadCase(ctx.imid , tctx.use_auto_seg );
				saveProcessedIniCase();

			}else if(tctx.batch_skip_exist){

				bool fileExisted=true;

				fileExisted &= fileisExisted(loader.getProc_FrXYZ_Path(ctx.imid).c_str());
				fileExisted &= fileisExisted(loader.getProc_FrNV_Path(ctx.imid).c_str());
				fileExisted &= fileisExisted(loader.get_sceini_bin_path(ctx.imid,tctx.input_bin_dir).c_str()); 
				if( fileExisted ){
					//fast_loadifexist(ctx.imid,1);
					std::cout<<"BTACH SKIP- "<<k<<"/"<<idlist.size()<<std::endl;
					continue;
				}else{ 
					loadCase(ctx.imid , tctx.use_auto_seg );
					saveProcessedIniCase();
				}

			}else{

				fast_loadifexist(ctx.imid,1);
			}

			updateBoxPoly2D();
			updateBox2DSeg();
			updateBoxPlanes();
			update_sceneSupState();
			re_estiBoxFeatures();

			//-------------------------------------------------------------------------
			_anno_initialPred();

			// load GT label 
			auto_fillAnswer();

			_anno_rePred();
			 
			//-------------------------------------------------------------------------

			_saveAnnotate();

			//-------------------------------------------------------------------------
			std::cout<<"BTACH - "<<k+1<<"/"<<idlist.size()<<std::endl;
			std::cerr<<"BTACH - "<<k+1<<"/"<<idlist.size()<<std::endl;

		}catch (std::string msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (const char * msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (int i){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<i<<"]\n";

		}catch (...){
			std::cout<<"**ERR "<<ctx.imid<<"case - [UNKOWN]\n";
		}

		resetCtx();
	}


	std::cout<<"=========================================================\n";
	std::cout<<"BTACH MODE -- ALL DONE --"<<std::endl;
	//-------------------------------------------------------------------------
	return ;
}

void Tirth::FCGLPanel::auto_rerun_gtsupport()
{
	 
	loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );


	// load a batching list
	//------------------------------------------------------------------------- 
	std::fstream fin(tctx.batchFPath , std::fstream::in ); 
	myassert(fin.is_open() ,"batch file open fail");

	std::vector<int> idlist;
	int tmpid=0;
	while(fin>>tmpid)
	{
		idlist.push_back(tmpid);
	}  
	fin.close();


	ini_svm(tctx);

	std::string tmpName;
	std::vector< NaiveAnnoBox > annobox;

	//-------------------------------------------------------------------------
	for(int k=0 ; k < idlist.size() ; k++ ){

		ctx.imid=idlist[k];


		ctx.annosavePath=tctx.annoresSavePath;

		try
		{
			 
			_load_preprocessed_case(ctx.imid);
			 
			updateBoxPoly2D();
			updateBox2DSeg();
			updateBoxPlanes();
			update_sceneSupState();
			re_estiBoxFeatures();

			//-------------------------------------------------------------------------
			_anno_initialPred();

			// load GT label 
			auto_fillAnswer();

			_anno_rePred();

			//-------------------------------------------------------------------------
			// load GT support 
			
			
			auto_fillSupport();

			//-------------------------------------------------------------------------
			// DO refinement
			//

			// create a refine flag
			BoxStateLog alog;
			alog.boxState.clear();
			alog.boxState.resize(ctx.boxDatas.size());

			for (int i = 0; i < ctx.boxDatas.size() ; i++)
			{
				if( ctx.boxDatas[i].getEdited()  ){
					alog.boxState[i]=BoxStateLog::BSTATE_EDITED; 

				}else if(ctx.boxDatas[i].getUserConfed()){
					alog.boxState[i]=BoxStateLog::BSTATE_LOCKED; 

				}else if(ctx.boxDatas[i].getSwtiched()){
					alog.boxState[i]=BoxStateLog::BSTATE_SWITCHED; 

				}else {
					// unknown case --> mark as confirmed
					alog.boxState[i]=BoxStateLog::BSTATE_CONF_ALL;
				}
			} 

			// change box refine flag according user adjustment
			for (int i = 0; i < ctx.boxDatas.size() ; i++){
				 
				ctx.boxDatas[i].setIsLocalRefined(false);

			}
			//-------------------------------------------------------------------------

			local_refine( alog.boxState );

			// update 2d info
			updateBoxPoly2D(); 
			updateBox2DSeg();
			updateBoxPlanes();
			re_estiBoxFeatures();
			 
			global_refine_v2( alog.boxState );

			// update 2d info
			updateBoxPoly2D(); 
			updateBox2DSeg();
			updateBoxPlanes();

			re_estiBoxFeatures();
			//-------------------------------------------------------------------------

			
			_saveAnnotate();

			//-------------------------------------------------------------------------
			std::cout<<"BTACH - "<<k+1<<"/"<<idlist.size()<<std::endl;

		}catch (std::string msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (const char * msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (int i){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<i<<"]\n";

		}catch (...){
			std::cout<<"**ERR "<<ctx.imid<<"case - [UNKOWN]\n";
		}

		resetCtx();
	}


	std::cout<<"=========================================================\n";
	std::cout<<"BTACH MODE -- ALL DONE --"<<std::endl;
	//-------------------------------------------------------------------------
	return ;
}


void Tirth::FCGLPanel::auto_fillSupport()
{
	//-------------------------------------------------------------------------
	// pre-loading answer
	// 
	std::string fpath = loader.getGTSUP_SAVEPath(ctx.imid);

	std::fstream fin(fpath,std::ios::in);

	if( fin.bad() ){
		std::cout<<"GT_SUP open failed: at ["<<fpath<<"]\n";
		throw "GT_SUP open failed";
	}


	int uid;
	int supType;
	int parUid;

	std::vector<int> uid_list;
	std::vector<int> supType_list;
	std::vector<int> parUid_list;

	while (fin>>uid>>supType>>parUid)
	{
		//save pair
		uid_list.push_back(uid);
		supType_list.push_back(supType);
		parUid_list.push_back(parUid);
	}

	//-------------------------------------------------------------------------
	auto const & LNAMES = loader.getLidList();

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		ctx.boxDatas[i].setSupToIni(); 
	}

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{

		/*% use gdef
		%     SUP_BY_FLOOR: 0
		%     SUP_BY_WALL:  1
		%     SUP_BY_OBJ:   2
		%     SUP_BY_CEIL:  3
		%     SUP_UNKNOWN: -1
		*/
		const int SUP_BY_FLOOR=0;
		const int SUP_BY_WALL=1;
		const int SUP_BY_OBJ=2;
		const int SUP_BY_CEIL=3;

		int box_gt_idx=-1;

		for( int k=0 ; k<uid_list.size() ; k++ ){
			if( uid_list[k] == ctx.boxDatas[i].getUID() ){
				box_gt_idx=k;
				break;
			}
		}
		//------------------------------------------------------------------------- 

		myassert(box_gt_idx!=-1,"box_gt_idx == -1");
		
		// assign support 

		if( supType_list[box_gt_idx] == SUP_BY_FLOOR ){

			ctx.boxDatas[i].setSupToFloor();
			ctx.boxDatas[i].setSupporterLIDX(-1);

		}else if(supType_list[box_gt_idx] == SUP_BY_WALL){

			ctx.boxDatas[i].setSupToWall();
			ctx.boxDatas[i].setSupporterLIDX(ctx.boxDatas[i].getClosedWallLIdx());

		}else if(supType_list[box_gt_idx] == SUP_BY_OBJ){

			ctx.boxDatas[i].setSupToObj();

			int parUID = parUid_list[box_gt_idx];
			int parLIdx = -1;

			for( int ib=0; ib<ctx.boxDatas.size();ib++ ){
				if( ctx.boxDatas[ib].getUID() ==  parUID){
					parLIdx=ib;
					break;
				}
			}

			if(parLIdx==-1){
				myassert(parLIdx!=-1,"parLIdx == -1");

			}


			ctx.boxDatas[i].setSupporterLIDX(parLIdx);

		}else{
			throw "unsupported type";

		} 

	}//loop
	//------------------------------------------------------------------------- 
	// go back to normal action flow

}

void Tirth::FCGLPanel::auto_fillAnswer()
{
	//-------------------------------------------------------------------------
	// pre-loading answer
	// 
	std::string fpath = loader.getANSLID_SAVEPath(ctx.imid);
	std::string userfpath = loader.getUserANSLID_SAVEPath(ctx.imid);

	std::fstream fin(fpath,std::ios::in);
	std::fstream fin_user(fpath,std::ios::in);

	if( fin.bad() ){
		std::cout<<"GTLID open failed: at ["<<fpath<<"]\n";
		throw "GTLID open failed";
	}
	if( fin_user.bad() ){
		std::cout<<"GTLID open failed: at ["<<userfpath<<"]\n";
		throw "GTLID open failed";
	}

	int uid;
	int lid;
	std::vector<int> uid_list;
	std::vector<int> lid_list;

	while (fin>>uid>>lid)
	{
		//save pair
		uid_list.push_back(uid);
		lid_list.push_back(lid);
	}
	//-------------------------------------------------------------------------

	std::vector<int> uid_list_user;
	std::vector<int> lid_list_user;

	while (fin>>uid>>lid)
	{
		//save pair
		uid_list_user.push_back(uid);
		lid_list_user.push_back(lid);
	}

	//-------------------------------------------------------------------------
	auto const & LNAMES = loader.getLidList();

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		bool touched =  ctx.boxDatas[i].getEdited()  || ctx.boxDatas[i].getUserConfed() || 
			ctx.boxDatas[i].getUserConfed() || ctx.boxDatas[i].getSwtiched();

		if( false == touched)
		{
			// auto fill the answer 
			// find gt lid by uid
			int ans_lid=-1;
			for( int ii=0 ; ii< uid_list_user.size() ;ii++ ){
				if( uid_list_user[ii] == ctx.boxDatas[i].getUID() ){
					ans_lid=lid_list_user[ii];
					break;
				}
			}

			// cannot found lid from user --> use gt lid
			if( ans_lid == -1 ){
				for( int ii=0 ; ii< uid_list.size() ;ii++ ){
					if( uid_list[ii] == ctx.boxDatas[i].getUID() ){
						ans_lid=lid_list[ii];
						break;
					}
				}
			}

			//------------------------------------------------------------------------- 
			// use editing API to set the gt ans

			if( ans_lid == -1 ){
				std::cout<<"sce-"<<ctx.imid<<" ,box."<<i<<", uid="<<ctx.boxDatas[i].getUID()<<"\n";
				myassert(ans_lid!=-1,"ans_lid == -1");
			}
			QString ss = QString::fromStdString(LNAMES[ans_lid]);

			ctx.boxDatas[i].setEditedTagStr(ss);

			//-------------------------------------------------------------------------

		}
	}
	//------------------------------------------------------------------------- 
	// go back to normal action flow

}


void Tirth::FCGLPanel::reload_recalSupport()
{

	loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );

	// get batching ids 
	std::fstream fin(tctx.batchFPath , std::fstream::in ); 
	myassert(fin.is_open() ,"batch file open fail");

	std::vector<int> idlist;
	int tmpid=0;
	while(fin>>tmpid)
	{
		idlist.push_back(tmpid);
	}  
	fin.close();


	std::string tmpName;
	std::vector< NaiveAnnoBox > annobox;

	//-------------------------------------------------------------------------
	for(int k=0 ; k < idlist.size() ; k++ ){

		ctx.imid=idlist[k];

		ctx.annosavePath=tctx.annoresSavePath;

		try
		{

			if(tctx.batch_force_rerun){

				loadCase(ctx.imid , tctx.use_auto_seg );
				saveProcessedIniCase();

			}else{
				_load_preprocessed_case(ctx.imid);
			}


			updateBoxPoly2D();
			updateBox2DSeg();
			updateBoxPlanes();

			update_sceneSupState();
			re_estiBoxFeatures();


			//-------------------------------------------------------------------------
			// SAVE
			//

			NaiveAnnoBox* nabox=conv_BoxDataV2_to_AnooBox(ctx.boxDatas);
			annobox.clear();
			annobox.reserve(ctx.boxDatas.size());
			for( int i=0 ;i<ctx.boxDatas.size() ;i++ ){
				annobox.push_back(nabox[i]);
			}

			AnnoRes res;
			res.sce_id=ctx.imid;
			tmpName=loader.getExportMatBin_SAVEPath(ctx.imid , ctx.annosavePath);
			export_sce2matlab( tmpName , annobox ,ctx.walls_fr , res );

			delete [] nabox;
			//-------------------------------------------------------------------------
			std::cout<<"BTACH - "<<k+1<<"/"<<idlist.size()<<std::endl;

		}catch (std::string msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (const char * msg){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<msg<<"]\n";

		}catch (int i){
			std::cout<<"**ERR "<<ctx.imid<<"case - [" <<i<<"]\n";

		}catch (...){
			std::cout<<"**ERR "<<ctx.imid<<"case - [UNKOWN]\n";
		}			

		resetCtx();
	}


	std::cout<<"=========================================================\n";
	std::cout<<"BTACH MODE -- ALL DONE --"<<std::endl;
	//-------------------------------------------------------------------------
	return ;
}



void Tirth::FCGLPanel::ini_svm(TextCTX const & TCTX)
{

	ctx.all_svmProxy.loadModel(TCTX.all_modelPath.c_str(),loader.getLidList());
	ctx.wall_svmProxy.loadModel(TCTX.wall_modelPath.c_str(),loader.getLidList());
	ctx.floor_svmProxy.loadModel(TCTX.floor_modelPath.c_str(),loader.getLidList());
	ctx.obj_svmProxy.loadModel(TCTX.obj_modelPath.c_str(),loader.getLidList());
	ctx.freModel.loadModel(TCTX.freqModelPath,TCTX.targetLIDList);

	std::cout<<"loaded svm\n";
}

void Tirth::FCGLPanel::iniBKTex()
{
	if( ctx.inputImgTex != nullptr){
		ctx.inputImgTex->release();
		delete ctx.inputImgTex;
	}

	ctx.inputImgTex = new QOpenGLTexture(ctx.inputImg);
	ctx.inputImgTex->setMinificationFilter(QOpenGLTexture::LinearMipMapLinear);
	ctx.inputImgTex->setMagnificationFilter(QOpenGLTexture::Linear);

}

void Tirth::FCGLPanel::iniContour()
{
	// record contour
	std::vector<int> uidlist;
	findCVMAP_State( ctx.gtsegCvMat_16u ,uidlist );

	cv::Mat bgMask = cv::Mat(ctx.gtsegCvMat_16u.size(), CV_8UC1, cv::Scalar::all(255));		
	cv::Mat tmpMat = cv::Mat::zeros(ctx.gtsegCvMat_16u.size(), CV_8UC4);

	// pre-loading
	//std::vector<  > > all_contours;
	ctx.all_contours.clear();
	ctx.all_contours.resize(ctx.boxDatas.size());
	ctx.contourUID.clear();

	// it's possible that boxes is not initialed.
	//myassert(uidlist.size()==ctx.boxDatas.size(),"uidlist size != boxData");	 
	std::vector<std::vector<cv::Point>> tmpContour;
	for( int ib=0 ;ib<ctx.boxDatas.size() ;ib++ ){

		int uid=ctx.boxDatas[ib].getUID();
		//tmpContour.clear();

		ctx.contourUID.push_back(uid);
		cv::Mat tmpMask = (ctx.gtsegCvMat_16u == uid );
		bgMask.setTo(cv::Scalar::zeros(), tmpMask);
		std::vector<cv::Vec4i> hierarchy;

		cv::findContours(tmpMask, ctx.all_contours[ib], hierarchy, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_TC89_L1  );

	}

	//-------------------------------------------------------------------------
	// initial room contour

	ctx.supVis_roomContour.clear();
	ctx.supVis_roomCTRUid.clear();

	std::vector<int> roomUidList;
	findCVMAP_State( ctx.roomImg ,roomUidList );

	ctx.supVis_roomContour.resize(roomUidList.size());

	for( int i=0 ; i < roomUidList.size() ; i++ ){
		// 1 is floor		     
		int uid=roomUidList[i];  
		if( uid >=1 ){
			cv::Mat tmpMask = (ctx.roomImg == uid );
			bgMask.setTo(cv::Scalar::zeros(), tmpMask);
			std::vector<cv::Vec4i> hierarchy;

			cv::findContours(tmpMask, ctx.supVis_roomContour[i], hierarchy, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_TC89_L1  );
		}		
	} 



}


void Tirth::FCGLPanel::draw_on_finerSeg( std::vector<int> const & SPTS,  const int OBJ_ID )
{
	static const int thickness = 14;
	static const int lineType = 8;

	static const int radius = (int)(thickness*1.0/4*1.41);

	float color[4]={0};

	colorCube(OBJ_ID,color); 
	cv::Scalar cvColor = cv::Scalar( static_cast<int>(color[1]*255),static_cast<int>(color[2]*255), static_cast<int>(color[0]*255) ,200 );
	cv::Scalar cvColor_light = cv::Scalar( static_cast<int>(color[1]*255),static_cast<int>(color[2]*255), static_cast<int>(color[0]*255) , 150 );
	cv::Scalar clearColor = cvScalar(0,0,0,0);

	if (use_eraser)
	{
		// USE Eraser
		
		// save non-current 
		cv::Mat other_mask = ctx.segDraw_idmap != OBJ_ID; 

		static cv::Mat rgb_mask_others = cv::Mat::zeros(ctx.segDraw_paper.rows,ctx.segDraw_paper.cols,CV_8UC4);
		static cv::Mat rgb_mask_cur = cv::Mat::zeros(ctx.segDraw_paper.rows,ctx.segDraw_paper.cols,CV_8UC4);
		
		static cv::Mat id_cur = cv::Mat::zeros(ctx.segDraw_idmap.rows,ctx.segDraw_idmap.cols,CV_16UC1);
		static cv::Mat id_other = cv::Mat::zeros(ctx.segDraw_idmap.rows,ctx.segDraw_idmap.cols,CV_16UC1);

		rgb_mask_others.setTo(cv::Scalar(0,0,0,0));
		rgb_mask_cur.setTo(cv::Scalar(0,0,0,0));
		id_cur.setTo(cv::Scalar(0));
		id_other.setTo(cv::Scalar(0));

		cv::Mat rgb_original = ctx.segDraw_paper.clone();
		cv::Mat idmap_original = ctx.segDraw_idmap.clone();

		rgb_mask_others.setTo(cv::Scalar(255,255,255,255),other_mask);
		rgb_mask_cur.setTo(cv::Scalar(255,255,255,255),~other_mask);

		id_other.setTo(cv::Scalar(255,255,255,255),other_mask);
		id_cur.setTo(cv::Scalar(255,255,255,255), ~other_mask);

		// clear state 
		if(SPTS.size()==1*2)
		{
			// Draw on RGB map 
			//
			int i=0;
			cv::line(
				ctx.segDraw_paper,
				cv::Point(SPTS[i*2],SPTS[i*2+1]),
				cv::Point(SPTS[(i)*2],SPTS[(i)*2+1]),
				clearColor	, // BGRA 8UC4
				thickness,
				lineType
				);

			// FFFF (mask) others & original OR cur & new 
			ctx.segDraw_paper=(rgb_mask_others & rgb_original) | (rgb_mask_cur & ctx.segDraw_paper);


			//------------
			// Draw on ID map ( clear id map )
			cv::line(
				ctx.segDraw_idmap,
				cv::Point(SPTS[i*2],SPTS[i*2+1]),
				cv::Point(SPTS[(i)*2],SPTS[(i)*2+1]),
				clearColor	, // 16UC1
				thickness,
				lineType
				);

			// Also do masking on IDMAP
			ctx.segDraw_idmap=(id_other & idmap_original) | (id_cur & ctx.segDraw_idmap);


		}else if(SPTS.size() > 2 ){

			for (int i=0 ; i <SPTS.size()-2 ; i+=2)
			{
				//			
				// Draw on RGB map 
				cv::line(
					ctx.segDraw_paper,
					cv::Point(SPTS[i],SPTS[i+1]),
					cv::Point(SPTS[(i+2)],SPTS[(i+2)+1]), 
					clearColor	, // BGRA 8UC4
					thickness,
					lineType
					);
				//-----------------
				// Draw on ID map ( clear id map ) 
				cv::line(
					ctx.segDraw_idmap,
					cv::Point(SPTS[i],SPTS[i+1]),
					cv::Point(SPTS[(i+2)],SPTS[(i+2)+1]), 
					clearColor	, // 16UC1
					thickness,
					lineType
					);
			}

			// FFFF (mask) others & original OR cur & new 
			ctx.segDraw_paper=(rgb_mask_others & rgb_original) | (rgb_mask_cur & ctx.segDraw_paper);

			// Also do masking on IDMAP
			// Also do masking on IDMAP
			ctx.segDraw_idmap=(id_other & idmap_original) | (id_cur & ctx.segDraw_idmap);

		} 

	//================================================================================
	}else{
		// normal state

		cv::Mat id_mask=cv::Mat::zeros(ctx.segDraw_finerseg.rows,ctx.segDraw_finerseg.cols,CV_8UC1);

		cv::Mat rgb_original = ctx.segDraw_paper.clone();

		cv::Mat rgb_free_mask = rgb_original==0;
		cv::Mat rgb_fix_mask = rgb_original!=0;

		rgb_free_mask.convertTo(rgb_free_mask,CV_8UC4);
		rgb_fix_mask.convertTo(rgb_fix_mask,CV_8UC4);


		if(SPTS.size()==1*2)
		{
			int i=0;
			cv::line(
				ctx.segDraw_paper,
				cv::Point(SPTS[i*2],SPTS[i*2+1]),
				cv::Point(SPTS[(i)*2],SPTS[(i)*2+1]),
				cvColor	, // BGRA 8UC4
				thickness,
				lineType
				);

			// draw on id mask
			cv::line(
				id_mask,
				cv::Point(SPTS[i*2],SPTS[i*2+1]),
				cv::Point(SPTS[(i)*2],SPTS[(i)*2+1]),
				cv::Scalar(255),
				thickness,
				lineType
				);


		}else if(SPTS.size() > 2 ){
			for (int i=0 ; i <SPTS.size()-2 ; i+=2)
			{
				cv::line(
					ctx.segDraw_paper,
					cv::Point(SPTS[i],SPTS[i+1]),
					cv::Point(SPTS[(i+2)],SPTS[(i+2)+1]), 
					cvColor	, // BGRA 8UC4
					thickness,
					lineType
					);

				//-----------------
				// Draw on ID mask 
				cv::line(
					id_mask,
					cv::Point(SPTS[i],SPTS[i+1]),
					cv::Point(SPTS[(i+2)],SPTS[(i+2)+1]), 
					cv::Scalar(255),
					thickness,
					lineType
					);

			}

		}


		//-------------------------------------------------------------------------
		// extract underly uid

		static int uid_flag[512]={0};
		memset(uid_flag,0,sizeof(uid_flag));

		static int mx_sign[8*2+1]={
			1,1,
			-1,1,
			-1,-1,
			1,-1,
			1,0,
			0,1,
			-1,0,
			0,-1
		};

		unsigned short uid=0;

		// find all nonzero uids by finer segmentation;
		for (int i=0 ; i <SPTS.size() ; i+=2)
		{
			int x=SPTS[i];
			int y=SPTS[i+1];

			if (x < ctx.segDraw_finerseg.cols  && x >=0 && ctx.segDraw_finerseg.rows > y && y>=0 )
			{

				uid = ctx.segDraw_finerseg.at<unsigned short>(y,x);

				// avoid duplicate fill
				if (uid!=0 && 0==uid_flag[uid])
				{
					cv::Mat ll  =(ctx.segDraw_finerseg == uid); 
					id_mask = id_mask | ll;
					uid_flag[uid]=1;
				}

				int corner_x=0;
				int corner_y=0;

				for (int ii=0 ; ii< 8 ; ii++)
				{
					corner_x= x+mx_sign[ii*2+0]*radius;
					corner_y= y+mx_sign[ii*2+1]*radius;

					//clamp
					if (corner_x<0)
					{
						corner_x=0;
					}
					if (corner_x >ctx.segDraw_finerseg.cols-1 )
					{
						corner_x= ctx.segDraw_finerseg.cols-1 ;
					}
					if (corner_y<0)
					{
						corner_y=0;
					}
					if (corner_y >ctx.segDraw_finerseg.rows-1 )
					{
						corner_y= ctx.segDraw_finerseg.rows-1 ;
					}

					// re-take 
					uid = ctx.segDraw_finerseg.at<unsigned short>(corner_y,corner_x);

					// avoid duplicate fill
					if (uid!=0 && 0==uid_flag[uid])
					{
						cv::Mat ll  =(ctx.segDraw_finerseg == uid); 
						id_mask = id_mask | ll;
						uid_flag[uid]=1;
					}
				}

			}

		}


		// make-sure only use the zero region to fill NEW_ID
		// not affect exist object
		// free_regino = true
		cv::Mat freeREG =  (ctx.segDraw_idmap == 0) ; 

		id_mask = id_mask & freeREG ;

		// fill on id map
		ctx.segDraw_idmap.setTo(OBJ_ID,id_mask);


		// fill on seg visible map (BGRA)
		ctx.segDraw_paper.setTo( cvColor_light, id_mask);

		/*imwrite("id_mask.png",id_mask);
		imwrite("rgb_free_mask.png",rgb_free_mask);
		imwrite("rgb_fix_mask.png",rgb_fix_mask);
		ctx.segDraw_paper=(rgb_free_mask & ctx.segDraw_paper) | (rgb_fix_mask & rgb_original);
		*/

	}

	 

} 


void Tirth::FCGLPanel::drawContour(int focusIdx ,cv::Mat rgba , std::vector< std::vector<std::vector<cv::Point> > > & all_coutours )
{
	// should be call when focusIdx is changed
	if( rgba.channels()!=4 ){
		myassert("rgba should be 4 channel");
	}

	if( ctx.boxDatas.size() > 0 ){

		myassert(ctx.boxDatas.size()==ctx.contourUID.size(),"ctx.boxDatas.size()==ctx.contourUID.size()");

		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){
			if( ctx.boxDatas[i].getUserModified() ){
				if( i==focusIdx ){
					cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,255,0,100), CV_FILLED); 
				} 
				cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(0,255,0,100),2 ); 

			}else{
				if( i==focusIdx ){
					cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
				} 
				cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,155),2 ); 
			}
		}


	}else{
		// normal draw
		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){
			if( i==focusIdx ){
				cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
			} 
			cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,155),2 ); 
		}
	}


}

void Tirth::FCGLPanel::drawContour_sug(int focusIdx,int sugIdx , 
									   cv::Mat rgba , std::vector< std::vector<std::vector<cv::Point> > > & all_coutours )
{
	// should be call when focusIdx is changed

	if( rgba.channels()!=4 ){
		myassert("rgba should be 4 channel");
	}

	if( ctx.boxDatas.size() > 0 ){

		myassert(ctx.boxDatas.size()==ctx.contourUID.size(),"ctx.boxDatas.size()==ctx.contourUID.size()");

		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){

			if( ctx.boxDatas[i].getUserModified() ){

				if( i==focusIdx ){
					cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,255,0,100), CV_FILLED); 
				}

				if(i==sugIdx){
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(35,140,255,210),2 ); 
				}else{
					//green BGR
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(0,255,0,100), 2); 
				}

			}else{

				if( i==focusIdx ){
					cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
				} 

				if(i==sugIdx){
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(35,140,255,210),2 ); 
				}else{
					// blue
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,210), 2); 
				}
			}

		}


	}else{
		// normal draw
		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){
			if( i==focusIdx ){
				cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
			} 
			cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,155),3 ); 
		}
	}

}

void Tirth::FCGLPanel::drawContour_supSet(int focusIdx,int sugIdx , 
										  cv::Mat rgba , std::vector< std::vector<std::vector<cv::Point> > > & all_coutours )
{
	// should be call when focusIdx is changed

	if( rgba.channels()!=4 ){
		myassert("rgba should be 4 channel");
	}

	if( ctx.boxDatas.size() > 0 ){

		myassert(ctx.boxDatas.size()==ctx.contourUID.size(),"ctx.boxDatas.size()==ctx.contourUID.size()");

		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){

			if( ctx.boxDatas[i].getUserModified() ){

				if( i==focusIdx ){
					cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,255,0,100), CV_FILLED); 
				}

				if(i==sugIdx){
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(35,140,255,210),2 ); 
				}else{
					//green BGR
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(0,255,0,100), 2); 
				}

			}else{

				if( i==focusIdx ){
					cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
				} 

				if(i==sugIdx){
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(35,140,255,210),2 ); 
				}else{
					// blue
					cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,210), 2); 
				}
			}

		}


	}else{
		// normal draw
		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){
			if( i==focusIdx ){
				cv::drawContours(rgba,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
			} 
			cv::drawContours(rgba, ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,155),3 ); 
		}
	}

}



void Tirth::FCGLPanel::drawSupport()
{

}

void Tirth::FCGLPanel::updateCVDraw_Tex()
{ 
	//-------------------------------------------------------------------------

	ctx.segDraw_paperQImg.detach();
	ctx.segDraw_paperQImg=QImage((uchar*) ctx.segDraw_paper.data, ctx.segDraw_paper.cols, ctx.segDraw_paper.rows, ctx.segDraw_paper.step, QImage::Format_RGBA8888);

	if( ctx.segDraw_paperTex != nullptr ){
		ctx.segDraw_paperTex->release();
		delete ctx.segDraw_paperTex;
	}

	ctx.segDraw_paperTex = new QOpenGLTexture(ctx.segDraw_paperQImg); 
	ctx.segDraw_paperTex->setMinificationFilter(QOpenGLTexture::Linear);
	ctx.segDraw_paperTex->setMagnificationFilter(QOpenGLTexture::Linear);

	//-------------------------------------------------------------------------

}
void Tirth::FCGLPanel::updateCVSegTex()
{
	ctx.gtsegCvMat_8uc4.release();
	ctx.gtsegCvMat_8uc4 = cv::Mat::zeros(ctx.gtsegCvMat_16u.size(),CV_8UC4);

	// draw to QImage
	/*
	int focusIdx=-1;
	for( int i=0;i<ctx.contourUID.size() ;i++ ){
	if( ctx.focus_box_uid==ctx.contourUID[i] ){
	focusIdx=i;
	}
	}
	*/
	int focusIdx=ctx.bkseg_focus_box_idx;

	//-------------------------------------------------------------------------
	// SEG Contour 	
	// focus, suggestion, and the others
	if( showSuggestion ){
		drawContour_sug( focusIdx ,ctx.suggestBOX_LID,ctx.gtsegCvMat_8uc4,ctx.all_contours);
	}else{
		drawContour_sug( focusIdx ,-1,ctx.gtsegCvMat_8uc4,ctx.all_contours);
	}

	cvtColor(ctx.gtsegCvMat_8uc4, ctx.gtsegCvMat_8uc4 ,CV_BGRA2RGBA);  

	if( showSupport ){
		//if( 1 ){ 

		int dy=window()->height()-ctx.panelHeight;

		for( int k=0; k < ctx.boxDatas.size() ; k++ ){

			int cx=ctx.boxDatas[k].getBoxCx();
			int cy=ctx.boxDatas[k].getBoxCy()-dy;

			if( ctx.boxDatas[k].isSupByWall() ){
				//m_program_3d->setUniformValue(lineColorLoc,0,1,1,1);

				drawArrow(ctx.gtsegCvMat_8uc4,cv::Point(cx+50,cy),cv::Point(cx,cy),5,cv::Scalar(255,22,188,255),2,8);
				//drawArrow(ctx.gtsegCvMat_8uc4,cv::Point(cy,cx-20),cv::Point(cy,cx),15,cv::Scalar(255,0,255,255),3,8);

			}else if( ctx.boxDatas[k].isSupByObj() ){ 
				//m_program_3d->setUniformValue(lineColorLoc,0,1,0,1);

				int plidx = ctx.boxDatas[k].getSupporterLIDX(); 

				int px=ctx.boxDatas[plidx].getBoxCx();
				int py=ctx.boxDatas[plidx].getBoxCy()-dy;

				drawArrow(ctx.gtsegCvMat_8uc4,cv::Point(px,py),cv::Point(cx,cy),5,cv::Scalar(255,255,0,255),2,8); 

			}else if( ctx.boxDatas[k].isSupByGround()   ){

				drawArrow(ctx.gtsegCvMat_8uc4,cv::Point(cx,cy+50),cv::Point(cx,cy),7,cv::Scalar(0,255,255,255),2,8); 

			}else if( ctx.boxDatas[k].isFloat()  ){

			}else{
			} 

		}	 

	}

	//-------------------------------------------------------------------------

	ctx.gtsegCoutourImg.detach();
	ctx.gtsegCoutourImg=QImage((uchar*) ctx.gtsegCvMat_8uc4.data, ctx.gtsegCvMat_8uc4.cols, ctx.gtsegCvMat_8uc4.rows, ctx.gtsegCvMat_8uc4.step, QImage::Format_RGBA8888);

	if( ctx.gtsegContourTex != nullptr ){
		ctx.gtsegContourTex->release();
		delete ctx.gtsegContourTex;
	}

	ctx.gtsegContourTex = new QOpenGLTexture(ctx.gtsegCoutourImg); 
	ctx.gtsegContourTex->setMinificationFilter(QOpenGLTexture::Linear);
	ctx.gtsegContourTex->setMagnificationFilter(QOpenGLTexture::Linear);

	//-------------------------------------------------------------------------

}

void Tirth::FCGLPanel::updateCVSupSelectTex()
{

	bool verbase=0;

	if (verbase)
	{
		std::cout<<"update : updateCVSupSelectTex\n";
	} 

	//-------------------------------------------------------------------------
	ctx.supVisMat.release();
	ctx.supVisArrIDMat.release();

	ctx.supVisMat = cv::Mat::zeros(ctx.inputImg.height(),ctx.inputImg.width(),CV_8UC4); 
	ctx.supVisArrIDMat = cv::Mat::zeros(ctx.inputImg.height(),ctx.inputImg.width(),CV_32SC1); 
	ctx.supVisArrIDMat = cv::Scalar(-1);

	cvtColor(ctx.supVisMat, ctx.supVisMat ,CV_BGRA2RGBA);   
	//-------------------------------------------------------------------------
	// CONTOUR
	int cout_thickness=2;
	for( int i=0 ; i < ctx.all_contours.size() ; i++ ){

		// focus
		if( ctx.supAdj_focus_box_idx != -1 && ctx.supAdj_focus_box_idx==i ){

			cv::drawContours( ctx.supVisMat , ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,180), cout_thickness ); 

			cv::drawContours( ctx.supVisMat ,ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,155), CV_FILLED);  
		}else{
			if (ctx.boxDatas[i].isFloat())
			{
				cv::drawContours( ctx.supVisMat , ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,210), cout_thickness ); 

			}else{
				// blue	
				cv::drawContours( ctx.supVisMat , ctx.all_contours[i] ,-1,cv::Scalar(0,0,255,180), cout_thickness ); 
			}

		}
	} 

	//-------------------------------------------------------------------------
	// Arrow
	int dy=window()->height()-ctx.panelHeight;

	int arrLen = 10;
	int thickness = 2;
	int lineType = 8;

	int fc_arrLen = 10;
	int fc_thickness = 7;
	int fc_lineType = 8;

	int hit_arrLen = 10;
	int hit_thickness = 20;
	int hit_lineType = 8;

	for( int k=0; k < ctx.boxDatas.size() ; k++ ){

		int cx=ctx.boxDatas[k].getBoxCx();
		int cy=ctx.boxDatas[k].getBoxCy()-dy;

		if( ctx.boxDatas[k].isSupByWall() ){ 

			// vis
			drawArrow(ctx.supVisMat,cv::Point(cx+50,cy),cv::Point(cx,cy), arrLen ,cv::Scalar(255,22,188,255), thickness , lineType ); 
			//record id 
			drawArrow(ctx.supVisArrIDMat,cv::Point(cx+50,cy),cv::Point(cx,cy), hit_arrLen ,cv::Scalar(k), hit_thickness , hit_lineType );


		}else if( ctx.boxDatas[k].isSupByObj() ){  

			int plidx = ctx.boxDatas[k].getSupporterLIDX(); 

			int px=ctx.boxDatas[plidx].getBoxCx();
			int py=ctx.boxDatas[plidx].getBoxCy()-dy;

			//vis
			drawArrow(ctx.supVisMat, cv::Point(px,py),cv::Point(cx,cy), arrLen ,cv::Scalar(255,255,0,255), thickness , lineType ); 
			//record id 
			drawArrow(ctx.supVisArrIDMat,cv::Point(px,py),cv::Point(cx,cy), hit_arrLen ,cv::Scalar(k), hit_thickness , hit_lineType );

		}else if( ctx.boxDatas[k].isSupByGround()){
			//vis
			drawArrow(ctx.supVisMat,cv::Point(cx,cy+50),cv::Point(cx,cy), arrLen ,cv::Scalar(0,255,255,255), thickness , lineType );			
			//record id 
			drawArrow(ctx.supVisArrIDMat,cv::Point(cx,cy+50),cv::Point(cx,cy), hit_arrLen ,cv::Scalar(k), hit_thickness , hit_lineType );

		}else if( ctx.boxDatas[k].isFloat()  ){

		}else{

		} 

		//-------------------------------------------------------------------------
		// handle Focus

		if( ctx.supAdj_focus_box_idx != -1 && ctx.supAdj_focus_box_idx==k ){

			if( ctx.boxDatas[k].isSupByWall() ){  
				// vis
				drawArrow(ctx.supVisMat,cv::Point(cx+50,cy),cv::Point(cx,cy), fc_arrLen ,cv::Scalar(255,0,0,255), fc_thickness , fc_lineType );  

			}else if( ctx.boxDatas[k].isSupByObj() ){   
				int plidx = ctx.boxDatas[k].getSupporterLIDX();  
				int px=ctx.boxDatas[plidx].getBoxCx();
				int py=ctx.boxDatas[plidx].getBoxCy()-dy;

				//vis
				drawArrow(ctx.supVisMat, cv::Point(px,py),cv::Point(cx,cy), fc_arrLen ,cv::Scalar(255,0,0,255), fc_thickness , fc_lineType );  
			}else if( ctx.boxDatas[k].isSupByGround()){
				//vis
				drawArrow(ctx.supVisMat,cv::Point(cx,cy+50),cv::Point(cx,cy), fc_arrLen ,cv::Scalar(255,0,0,255), fc_thickness , fc_lineType );	 
			}else if( ctx.boxDatas[k].isFloat()  ){

			}else{ 
			} 
		}
		//-------------------------------------------------------------------------

	}// loop box


	//-------------------------------------------------------------------------
	// BIND TEXTURES

	//cv::Mat temp; 
	//cvtColor(ctx.supVisImg, temp,CV_BGRA2RGBA); 

	//ctx.supVisQImg.detach();
	ctx.supVisQImg=QImage((uchar*) ctx.supVisMat.data, ctx.supVisMat.cols, ctx.supVisMat.rows, ctx.supVisMat.step, QImage::Format_RGBA8888);

	if( ctx.supVisTex != nullptr ){
		ctx.supVisTex->release();
		delete ctx.supVisTex;
	}

	ctx.supVisTex = new QOpenGLTexture(ctx.supVisQImg); 
	ctx.supVisTex->setMinificationFilter(QOpenGLTexture::Linear);
	ctx.supVisTex->setMagnificationFilter(QOpenGLTexture::Linear);

	//-------------------------------------------------------------------------

	checkGLError("update supadj tex");

	if (verbase)
	{
		std::cout<<"update done : updateCVSupAdjTex\n";
	} 

}

void Tirth::FCGLPanel::updateCVSupSetTex()
{
	bool verbase=0;

	if (verbase)
	{
		std::cout<<"update : updateCVSupAdjTex\n";
	} 

	ctx.supVisMat.release();
	//ctx.supVisArrIDMat.release();

	ctx.supVisMat = cv::Mat::zeros(ctx.inputImg.height(),ctx.inputImg.width(),CV_8UC4); 
	//ctx.supVisArrIDMat = cv::Mat::zeros(ctx.inputImg.height(),ctx.inputImg.width(),CV_32SC1); 
	//ctx.supVisArrIDMat = cv::Scalar(-1);

	cvtColor(ctx.supVisMat, ctx.supVisMat ,CV_BGRA2RGBA);  

	if( ctx.supAdj_focus_box_idx != -1 ){

		//-------------------------------------------------------------------------
		// CONTOUR

		// CONTOUR - current target
		int k = ctx.supAdj_focus_box_idx;
		cv::drawContours( ctx.supVisMat , ctx.all_contours[k] ,-1,cv::Scalar(0,255,0,100), 2); 
		cv::drawContours( ctx.supVisMat , ctx.all_contours[k] ,-1,cv::Scalar(100,100,100,100), CV_FILLED); 

		// CONTOUR - selected parent
		if( ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_OBJ)
		{ 
			cv::drawContours( ctx.supVisMat , ctx.all_contours[ctx.setSupCtx.supLocalIdx] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
			cv::drawContours( ctx.supVisMat , ctx.all_contours[ctx.setSupCtx.supLocalIdx] ,-1,cv::Scalar(0,255,0,100), 2); 

		}else if(ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_FLOOR ){

			cv::drawContours( ctx.supVisMat , ctx.supVis_roomContour[ctx.setSupCtx.supLocalIdx] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
			cv::drawContours( ctx.supVisMat , ctx.supVis_roomContour[ctx.setSupCtx.supLocalIdx] ,-1,cv::Scalar(0,255,0,100), 2); 

		}else if(ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_WALL ){

			cv::drawContours( ctx.supVisMat , ctx.supVis_roomContour[ctx.setSupCtx.supLocalIdx] ,-1,cv::Scalar(0,0,255,155), CV_FILLED); 
			cv::drawContours( ctx.supVisMat , ctx.supVis_roomContour[ctx.setSupCtx.supLocalIdx] ,-1,cv::Scalar(0,255,0,100), 2); 

		}else if(ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_FLOAT ){
			// pass

		}else{
			// impossible
		}
		/*
		// CONTOUR - others
		for( int i=0 ; i < ctx.all_contours.size() ; i++ ){

		if(i!=ctx.supAdj_focus_box_idx){ 
		// blue	
		cv::drawContours( ctx.supVisMat , ctx.all_contours[i] ,-1,cv::Scalar(255,0,0,210), 2); 
		} 
		}
		*/

		// CONTOUR  room
		for( int i=0 ; i< ctx.supVis_roomContour.size() ; i++ ){
			if( i == 0 ){
				// floor
				cv::drawContours( ctx.supVisMat , ctx.supVis_roomContour[i] ,-1,cv::Scalar(0,0,255,210),  1 ); 

			}else{
				// wall
				cv::drawContours( ctx.supVisMat , ctx.supVis_roomContour[i] ,-1,cv::Scalar(255,255,0,210), 1 ); 

			}
		}

		//-------------------------------------------------------------------------
		// moving ARROW
		int arrLen = 10;
		int thickness = 2;
		int lineType = 8;

		int dy=window()->height()-ctx.panelHeight;
		int cx=ctx.boxDatas[k].getBoxCx();
		int cy=ctx.boxDatas[k].getBoxCy()-dy;

		drawArrow(ctx.supVisMat, cv::Point(ctx.setSupCtx.drag_mx,ctx.setSupCtx.drag_my)  , cv::Point(cx,cy) , arrLen ,cv::Scalar(255,0,0,255), thickness , lineType );  

	} 

	//-------------------------------------------------------------------------
	// BIND TEXTURES

	//cv::Mat temp; 
	//cvtColor(ctx.supVisImg, temp,CV_BGRA2RGBA); 

	//ctx.supVisQImg.detach();
	ctx.supVisQImg=QImage((uchar*) ctx.supVisMat.data, ctx.supVisMat.cols, ctx.supVisMat.rows, ctx.supVisMat.step, QImage::Format_RGBA8888);

	if( ctx.supVisTex != nullptr ){
		ctx.supVisTex->release();
		delete ctx.supVisTex;
	}

	ctx.supVisTex = new QOpenGLTexture(ctx.supVisQImg); 
	ctx.supVisTex->setMinificationFilter(QOpenGLTexture::Linear);
	ctx.supVisTex->setMagnificationFilter(QOpenGLTexture::Linear);

	//-------------------------------------------------------------------------

	checkGLError("update supadj tex");

	if (verbase)
	{
		std::cout<<"update done : updateCVSupAdjTex\n";
	} 

}

#pragma endregion SCENEBOX_STATE

//-------------------------------------------------------------------------
#pragma region EVENT_HANDLER

Tirth::FCStateMag::State Tirth::FCGLPanel::_run_tctf_mode()
{
	resetCtx();   

	// load model
	//TextCTX tctx=loadUIConf("..\\testData\\uiconf.txt");


	// load case image
	ctx.imid = tctx.imid;
	ctx.annosavePath = tctx.annoresSavePath;
	ctx.showStructure = tctx.showStructure;

	fast_loadifexist(ctx.imid, true );  
	//-------------------------------------------------------------------------

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 
	//-------------------------------------------------------------------------
	ini_svm(tctx);

	//-------------------------------------------------------------------------
	ctx.isReady=true;


	//-------------------------------------------------------------------------
	return FCStateMag::S_IDLE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_runBatch()
{
	//TextCTX tctx=loadUIConf("..\\testData\\uiconf.txt");

	// get batching ids 
	std::fstream fin(tctx.batchFPath , std::fstream::in );

	myassert(fin.is_open() ,"batch file open fail");

	std::vector<int> idlist;
	int tmpid=0;
	while(fin>>tmpid)
	{
		idlist.push_back(tmpid);
	}  

	for(int k=0 ; k < idlist.size() ; k++ ){
		ctx.imid=idlist[k];

		bool fileExisted=true;

		fileExisted &= fileisExisted(loader.getProc_FrXYZ_Path(ctx.imid).c_str());
		fileExisted &= fileisExisted(loader.getProc_FrNV_Path(ctx.imid).c_str());
		fileExisted &= fileisExisted(loader.get_sceini_bin_path(ctx.imid,tctx.input_bin_dir).c_str()); 

		if( fileExisted ){
			std::cout<<"=========================================================\n";
			std::cout<<"[SKIP] im."<<ctx.imid<<" , "<<k+1<<"/"<<idlist.size()<<std::endl;
		}else{
			// load & save
			loadCase(ctx.imid , tctx.use_auto_seg );
			saveProcessedIniCase(); 
			std::cout<<"=========================================================\n";
			std::cout<<"[PASS] im."<<ctx.imid<<" , "<<k+1<<"/"<<idlist.size()<<std::endl;
		} 


		resetCtx();
	}
	std::cout<<"=========================================================\n";
	std::cout<<"BTACH MODE -- ALL DONE --"<<std::endl;
	//-------------------------------------------------------------------------
	return FCStateMag::S_IDLE;
}


Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_initialPred__forexport()
{
	// AT initial , we don't need to handle refinement

	// initial prediction
	BoxStateLog bs_log;
	bs_log.boxState.clear();
	bs_log.boxState.resize(ctx.boxDatas.size());

	for( int i=0 ; i < ctx.boxDatas.size() ; i++ ){
		bs_log.boxState[i]=BoxStateLog::BSTATE_UNK;	
	}

	// make prediction
	make_a_pred_v2(bs_log);

	// save prediction log
	bs_log.predRes.clear();
	bs_log.predRes.resize(ctx.boxDatas.size());
	for (int i = 0; i < ctx.boxDatas.size(); i++){
		bs_log.predRes[i] = ctx.boxDatas[i].getPredTagLIDs_link()[0];
	}

	// record this log
	ctx.predLog.clear();
	ctx.predLog.push_back(bs_log);

	//emit tagIsReady();

	//ctx.timer.startAtMode(MyTimer::T_LABEL);

	//-------------------------------------------------------------------------
	return FCStateMag::S_PREDICT;
}


Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_initialPred()
{
	// AT initial , we don't need to handle refinement

	// initial prediction
	BoxStateLog bs_log;
	bs_log.boxState.clear();
	bs_log.boxState.resize(ctx.boxDatas.size());

	for( int i=0 ; i < ctx.boxDatas.size() ; i++ ){
		bs_log.boxState[i]=BoxStateLog::BSTATE_UNK;	
	}

	// make prediction
	make_a_pred_v2(bs_log);

	// save prediction log
	bs_log.predRes.clear();
	bs_log.predRes.resize(ctx.boxDatas.size());
	for (int i = 0; i < ctx.boxDatas.size(); i++){
		bs_log.predRes[i] = ctx.boxDatas[i].getPredTagLIDs_link()[0];
	}

	// record this log
	ctx.predLog.clear();
	ctx.predLog.push_back(bs_log);

	emit tagIsReady();

	ctx.timer.startAtMode(MyTimer::T_LABEL);

	//-------------------------------------------------------------------------
	return FCStateMag::S_PREDICT;
}

// [Re-Predict]
Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_rePred()
{
	bool verbase=1;

	if( verbase ){
		std::cout<<"[RUN] re-predictions.\n";
	}

	// collect user response   
	BoxStateLog alog;

	alog.boxState.clear();
	alog.boxState.resize(ctx.boxDatas.size());

	bool isFULLConfirmed=true;

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		//ctx.boxDatas[i].getTouched(); 

		if( ctx.boxDatas[i].getEdited() ){
			alog.boxState[i]=BoxStateLog::BSTATE_EDITED;

			// UPDATE EDITED_LID
			std::string editedStr = ctx.boxDatas[i].getPredTags()[0].toStdString();

			int newLID = loader.queryLID(editedStr);

			auto & boxTLID  = ctx.boxDatas[i].getPredTagLIDs_link();
			boxTLID[0]=newLID;

		}else if(ctx.boxDatas[i].getUserConfed()){
			alog.boxState[i]=BoxStateLog::BSTATE_LOCKED;

		}else if(ctx.boxDatas[i].getSwtiched()){
			alog.boxState[i]=BoxStateLog::BSTATE_SWITCHED;

		}else{
			alog.boxState[i]=BoxStateLog::BSTATE_UNK;
			isFULLConfirmed=false;
		}

	} 

	//-------------------------------------------------------------------------

	if( isFULLConfirmed ){
		//return _anno_allConf_v2();
		return FCStateMag::S_PREDICT;
	}

	//-------------------------------------------------------------------------

	// First,do Refinement according to the user response.
	// [local refine]
	local_refine(alog.boxState);

	updateBoxPoly2D();
	updateBoxPlanes();

	//[predict]
	// update feature and support state
	update_sceneSupState();
	re_estiBoxFeatures();


	// re-predict with some flag and save pred result
	make_a_pred_v2(alog);

	// save prediction log
	alog.predRes.clear();
	alog.predRes.resize(ctx.boxDatas.size());
	for (int i = 0; i < ctx.boxDatas.size(); i++){
		alog.predRes[i] = ctx.boxDatas[i].getPredTagLIDs_link()[0];
	}

	//-------------------------------------------------------------------------

	// record this log  
	ctx.predLog.push_back(alog);

	//-------------------------------------------------------------------------

	emit tagIsReady();
	return FCStateMag::S_PREDICT;
}

// [ debug ]
Tirth::FCStateMag::State Tirth::FCGLPanel::_test_refBox()
{
	// random refine 

	std::cout<<"refine boxes\n";
	// 3,4,5

	mBoxEntend2Plane_BotVex(ctx.boxDatas[7],ctx.floor_fr,ctx.tx_fr2world); 

	mBoxEntend2Plane_Side(ctx.boxDatas[8-1],ctx.walls_fr[1],ctx.tx_fr2world);

	mBoxEntend2Plane_BotVex(ctx.boxDatas[9-1],ctx.floor_fr,ctx.tx_fr2world);

	//-------------------------------------------------------------------------
	// need to update feature and re-estimate features

	updateBoxPoly2D();
	updateBoxPlanes();

	update_sceneSupState();

	re_estiBoxFeatures();

	//-------------------------------------------------------------------------
	return FCStateMag::S_IDLE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_pauseTimer()
{
	throw "deprecated";
	//ctx.timer.pause();
	//-------------------------------------------------------------------------
	return FCStateMag::S_PRE_PAUSE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_resumeTimer()
{
	throw "deprecated";

	//ctx.timer.conti();
	//-------------------------------------------------------------------------
	return FCStateMag::S_PREDICT;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_allConf()
{ 
	throw " old function ";

	//------------------------------------------------------------------------- 
	// update state
	BoxStateLog alog;
	alog.boxState.clear();
	alog.boxState.resize(ctx.boxDatas.size());

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		if( ctx.boxDatas[i].getEdited()  ){
			alog.boxState[i]=BoxStateLog::BSTATE_EDITED; 
		}else if(ctx.boxDatas[i].getUserConfed()){
			alog.boxState[i]=BoxStateLog::BSTATE_LOCKED; 
		}else if(ctx.boxDatas[i].getSwtiched()){
			alog.boxState[i]=BoxStateLog::BSTATE_SWITCHED; 
		}else {
			// unknown case --> mark as confirmed
			alog.boxState[i]=BoxStateLog::BSTATE_CONF_ALL;
		} 
	} 

	// set all unknown box to confirmed
	for( int i=0;i<ctx.boxDatas.size() ;i++ ){
		if( !ctx.boxDatas[i].getUserModified() ){
			ctx.boxDatas[i].setConfALL(1);
		}
	}

	// collect current result 
	// final lids
	std::vector<int> curRes(ctx.boxDatas.size());
	curRes.resize(ctx.boxDatas.size());
	for (int i = 0; i < ctx.boxDatas.size(); i++)
	{
		curRes[i]=ctx.boxDatas[i].getPredTagLIDs()[0];
	} 
	alog.predRes=curRes;

	//record user switch rank
	alog.userSelectMenuIdx.clear();
	alog.userSelectMenuIdx.resize(ctx.boxDatas.size() );
	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{		 
		if(ctx.boxDatas[i].getSwtiched()){
			alog.userSelectMenuIdx[i]=ctx.boxDatas[i].getUserSelectRank();
		}else {
			alog.userSelectMenuIdx[i]=-1;
		}
	} 

	// record this log
	ctx.predLog.push_back(alog);

	// [FINAL refine]
	//-------------------------------------------------------------------------

	//local
	local_refine(alog.boxState);

	updateBoxPoly2D();
	updateBoxPlanes();
	update_sceneSupState();

	re_estiBoxFeatures();

	// global
	global_refine_v2(alog.boxState);

	updateBoxPoly2D();
	updateBoxPlanes();
	update_sceneSupState();

	re_estiBoxFeatures();

	//timer stop
	ctx.timer.done(); 

	// disable suggestion
	ctx.suggestBOX_LID=-1;
	requireUpdateContourTex=1;

	// request UPDATe contour texture

	// render state
	showConfAllBox=1; 
	setShowSupport(1);

	requireUpdateContourTex=1;

	std::cout<<"============================================\n";
	std::cout<<"[DONE] Total timing:"<<ctx.timer.getTotalSecond()<<"\n";

	std::cout<<"============================================\n";
	std::cerr<<"[DONE] Total timing:"<<ctx.timer.getTotalSecond()<<"\n";


	_saveAnnotate();


	return FCStateMag::S_FINAL;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_allConf_v2()
{
	// update state
	BoxStateLog alog;
	alog.boxState.clear();
	alog.boxState.resize(ctx.boxDatas.size());

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		if( ctx.boxDatas[i].getEdited()  ){
			alog.boxState[i]=BoxStateLog::BSTATE_EDITED; 

		}else if(ctx.boxDatas[i].getUserConfed()){
			alog.boxState[i]=BoxStateLog::BSTATE_LOCKED; 
			 
		}else if(ctx.boxDatas[i].getSwtiched()){
			alog.boxState[i]=BoxStateLog::BSTATE_SWITCHED; 

		}else {
			// unknown case --> mark as confirmed
			alog.boxState[i]=BoxStateLog::BSTATE_CONF_ALL;
		}
	} 


	// set all unknown box to confirmed
	for( int i=0;i<ctx.boxDatas.size() ;i++ ){
		if( !ctx.boxDatas[i].getUserModified() ){
			ctx.boxDatas[i].setConfALL(1);
		}
	}

	// collect current result 
	// final lids
	std::vector<int> curRes(ctx.boxDatas.size());
	curRes.resize(ctx.boxDatas.size());
	for (int i = 0; i < ctx.boxDatas.size(); i++)
	{
		curRes[i]=ctx.boxDatas[i].getPredTagLIDs()[0];
	} 
	alog.predRes=curRes;

	//record user switch rank
	alog.userSelectMenuIdx.clear();
	alog.userSelectMenuIdx.resize(ctx.boxDatas.size() );
	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{		 
		if(ctx.boxDatas[i].getSwtiched()){
			alog.userSelectMenuIdx[i]=ctx.boxDatas[i].getUserSelectRank();
		}else {
			alog.userSelectMenuIdx[i]=-1;
		}
	} 

	// record this log
	ctx.predLog.push_back(alog);

	// [FINAL refine]
	local_refine(alog.boxState);

	// update 2d info
	updateBoxPoly2D();
	updateBoxPlanes();

	// update 3d info
	update_sceneSupState();
	re_estiBoxFeatures();

	global_refine_v2(alog.boxState);

	// update 2d info
	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes();

	// update 3d info
	update_sceneSupState();
	re_estiBoxFeatures();

	//-------------------------------------------------------------------------

	// disable suggestion
	ctx.suggestBOX_LID=-1;
	requireUpdateContourTex=1;

	// request UPDATe contour texture
	// render state
	showConfAllBox=1; 
	setShowSupport(1); 
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------

	// LABEL period stop 

	ctx.timer.done();

	std::cout<<"total time = "<<ctx.timer.getTotalSecond()<<"\n";
	std::cout<<"total label = "<<ctx.timer.getTotalLabelSec()<<"\n";
	std::cout<<"total sup = "<<ctx.timer.getTotalSupSec()<<"\n";
	std::cout<<"total box = "<<ctx.timer.getTotalBoxSec()<<"\n";

	_saveAnnotate();

	//return FCStateMag::S_FINAL;
	
	_supadj_enterMode();
	return _mode_sup_start();
}


void Tirth::FCGLPanel::_saveAnnotate()
{
	// not reload able

	AnnoRes res;

	// push data
	res.sce_id=ctx.imid;
	res.action_log=ctx.predLog;
	res.total_time=ctx.timer.getTotalSecond();
	res.time_label = ctx.timer.getTotalLabelSec();
	res.time_support = ctx.timer.getTotalSupSec();
	res.time_box = ctx.timer.getTotalBoxSec();
	// save
	saveAnno2File( loader.getAnnoBin_SAVEPath(ctx.imid , ctx.annosavePath) ,res);

	//-------------------------------------------------------------------------
	// also save scene data and boxes data

	// USEAGE :
	// for re-training 
	// for gt estimation
	//
	// include 
	//	Refined Boxes
	//	Labels
	//	Support tags
	//	GT-UIDs
	//	Parent Lid
	//

	NaiveAnnoBox* nabox=conv_BoxDataV2_to_AnooBox(ctx.boxDatas);

	std::vector< NaiveAnnoBox > annobox;
	for( int i=0 ;i<ctx.boxDatas.size() ;i++ ){
		annobox.push_back(nabox[i]);
	}

	export_sce2matlab( loader.getExportMatBin_SAVEPath(ctx.imid , ctx.annosavePath), annobox , ctx.walls_fr ,res );

	delete [] nabox;

	//-------------------------------------------------------------------------
	// save result bin
	NaiveSceneCTX scectx;

	conv_CTX_to_NaiveSCTX(scectx);

	saveSceneANDBoxes(
		loader.getResultSceneBin_SAVEPath(ctx.imid , ctx.annosavePath).c_str() ,
		&scectx,
		ctx.floor_ini,
		ctx.floor_fr,
		ctx.walls_fr,
		ctx.boxDatas
		); 

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_actionDoneBack2Idle()
{
	return FCStateMag::S_IDLE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_predMouseMove()
{

	if( ctx.isReady ){
		int x=ctx.lastPos.x();
		int y=ctx.lastPos.y();
		convert2segLoc(x,y);

		int prev_uid=ctx.focus_box_uid;

		if( x != -1 && y != -1 ){ 
			ctx.focus_box_uid=ctx.gtsegCvMat_16u.at<unsigned short>(y,x); 
		}else{
			ctx.focus_box_uid=0;
		}

		if(prev_uid!=ctx.focus_box_uid){
			// request update contour Texture
			requireUpdateContourTex=1;

			// check box uid
			int focus_box_idx = -1;
			for( int ib=0 ; ib< ctx.boxDatas.size() ; ib++ ){

				if( ctx.boxDatas[ib].getUID() == ctx.focus_box_uid ){
					focus_box_idx=ib;
					break;
				}
			}
			ctx.bkseg_focus_box_idx=focus_box_idx;

			emit segMMoveFocusChange(ctx.bkseg_focus_box_idx);
		}

	}


	return FCStateMag::S_PREDICT;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_predMenuCloseHandler(){
	// menu close

	return FCStateMag::S_PREDICT;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_menuOpen_MPressedHandler()
{
	if(ctx.focus_box_uid>0){

		int focus_lidx=-1;
		for( int ib=0 ; ib< ctx.boxDatas.size() ; ib++ ){
			if( ctx.boxDatas[ib].getUID()==ctx.focus_box_uid){
				focus_lidx=ib;
				break;
			}
		}

		if( focus_lidx!=-1 ){
			// forward to current modal handler
			emit segClick(focus_lidx,ctx.lastBtu);
			return FCStateMag::S_PREDICT;

		}else{
			throw "impossible - _menuOpen_MPressedHandler";
		}
	}else{
		throw "impossible - _menuOpen_MPressedHandler"; 
	}
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_predSegMPressHandler()
{
	if(ctx.focus_box_uid>0){


		if( ctx.bkseg_focus_box_idx!=-1 ){
			emit segClick(ctx.bkseg_focus_box_idx,ctx.lastBtu);
			return FCStateMag::S_PRE_MENU_FOLD;
		}else{

			return FCStateMag::S_PREDICT;
		}

	}else{
		return FCStateMag::S_PREDICT; 
	}

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_load_config()
{
	// load config
	// 

	std::string fpath = lastFileDropPath; 

	tctx  = loadUIConf(fpath.substr(8).c_str());

	if (tctx.db_root.length() > 0 && tctx.mode.length() > 0)
	{
		std::cout
			<<"LOAD DONE:\n"
			<<"annoresSavePath="<<tctx.annoresSavePath<<std::endl
			<<"freqModelPath="<<tctx.freqModelPath<<std::endl
			<<"us_trial_sidlist="<<tctx.us_trial_sidlist<<std::endl
			<<"db_root="<<tctx.db_root<<std::endl
			<<"batchFPath="<<tctx.batchFPath<<std::endl
			<<"\nDONE."<<std::endl
			<<std::endl;


		this->_ini_mode = QString::fromStdString(tctx.mode);

		return FCStateMag::S_INI;

	}else{

		std::cout<<" ** config file loading FAILED ** at:"<<lastFileDropPath.substr(8).c_str()<<std::endl; 
		std::cout<<" invalid path or no specify annotation mode"<<std::endl;

		return FCStateMag::S_PRE_INI;
	}
}


Tirth::FCStateMag::State Tirth::FCGLPanel::_initial_entry()
{

	if( _ini_mode == "label" ){
		return _anno_initial();
	}else if(_ini_mode == "support" ){
		return _mode_sup_initial();
	}else if(_ini_mode == "box" ){
		return _mode_box_initial();
	}else if(_ini_mode == "draw"){

		return _draw_initial();
	}else{ 
		std::cout<<"mode ="<<_ini_mode.toStdString()<<"\n";
		throw("unknown mode");
	}
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_initial()
{
	//initial
	resetCtx();

	system("echo %CD%");

	loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );

	// get batching ids 
	std::fstream fin( tctx.us_trial_sidlist , std::fstream::in );
	std::cout<<" start at:\n\t "<<tctx.us_trial_sidlist<<std::endl; 

	myassert(fin.is_open() ,"us_trial_sidlist file open fail");

	std::vector<int> idlist;
	std::string aline;
	int tmpid=0;
	while(std::getline(fin,aline))
	{
		if( aline.length()>0 ){
			if(  sscanf(aline.c_str(),"%d%*[\n]",&tmpid) ){
				idlist.push_back(tmpid);
				tmpid=0;
			} 
		}
	}  
	fin.close();

	trail_sidList = idlist;

	trail_cur_k=0;

	ctx.annosavePath = tctx.annoresSavePath;
	annosavePath= tctx.annoresSavePath;

	anno_force_rerun=tctx.batch_force_rerun;

	std::cout<<"Trail case # = "<<trail_sidList.size()<<std::endl;

	try
	{
		//-------------------------------------------------------------------------
		// load SVM model 
		ini_svm(tctx);  

		//-------------------------------------------------------------------------
		ctx.imid=trail_sidList[trail_cur_k];

		//*
		if( anno_force_rerun ){
			loadCase(ctx.imid , tctx.use_auto_seg );
			saveProcessedIniCase();

		}else{
			fast_loadifexist(ctx.imid, true );  

		}
		//*/
		//_load_preprocessed_case(ctx.imid);

		requireUpdateBKTex=1;
		requireUpdateContourTex=1;

		std::cout<<"pre-update sce \n";

		updateBoxPoly2D();
		updateBox2DSeg();
		updateBoxPlanes();
		update_sceneSupState(); 
		re_estiBoxFeatures();
		//-------------------------------------------------------------------------

		ctx.isReady=true;
		return FCStateMag::S_IDLE;

	}catch (const char* msg){

		std::cout<<"==================================================\n";
		std::cout<<"[EXCP] :"<<msg<<"\n";
		std::cout<<"==================================================\n";

	}catch (std::string msg){
		std::cout<<"==================================================\n";
		std::cout<<"[EXCP] :"<<msg<<"\n";
		std::cout<<"==================================================\n";
	}

	return FCStateMag::S_INI;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_load_aCase()
{
	// [ prediction ]--timer start here
	_anno_initialPred();

	ctx.isReady=true; 

	return FCStateMag::S_PREDICT;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_save()
{
	std::cout<<"==============================================\n"
		<<"Total time(s):"<<ctx.timer.getTotalSecond()<<"\n";

	_saveAnnotate();

	std::cout<<"==============================================\n";

	// keep in S_FINAL
	return FCStateMag::S_FINAL;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_move2Next()
{
	if( trail_cur_k+1==trail_sidList.size() ){
		std::cout<<"reach end\n";
		return FCStateMag::S_IDLE; 
	}else{
		trail_cur_k=trail_cur_k+1;
	}

	// load model 
	//-------------------------------------------------------------------------
	resetCtx();

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------
	if( anno_force_rerun ){
		loadCase(ctx.imid , tctx.use_auto_seg );
		saveProcessedIniCase();
	}else{
		fast_loadifexist(ctx.imid, true );  
	}

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes();
	update_sceneSupState();
	re_estiBoxFeatures();

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------
	ctx.isReady=true;

	update();

	return FCStateMag::S_IDLE; 
	//return _anno_load_aCase();
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_move2Prev()
{
	if( trail_cur_k-1 < 0 ){
		std::cout<<"reach head\n";
		return FCStateMag::S_IDLE; 
	}else{
		trail_cur_k=trail_cur_k-1; 
	}
	//-------------------------------------------------------------------------
	resetCtx();

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------
	if( anno_force_rerun ){
		loadCase(ctx.imid , tctx.use_auto_seg );
		saveProcessedIniCase();
	}else{
		fast_loadifexist(ctx.imid, true );  
	}

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 
	update_sceneSupState();
	re_estiBoxFeatures();

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------
	ctx.isReady=true;

	update();

	return FCStateMag::S_IDLE; 
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_reset()
{

	resetCtx();  

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	fast_loadifexist(ctx.imid, true );   


	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 
	update_sceneSupState(); 
	re_estiBoxFeatures();

	//-------------------------------------------------------------------------

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;
	//-------------------------------------------------------------------------
	ctx.isReady=true;

	return FCStateMag::S_IDLE;  
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_anno_alldone()
{
	//_anno_allConf();
	//return FCStateMag::S_FINAL;

	return _anno_allConf_v2();
}

//-------------------------------------------------------------------------
bool Tirth::FCGLPanel::_initialLoad_without_supesti()
{
	//-------------------------------------------------------------------------
	//
	// no update support
	//
	//-------------------------------------------------------------------------

	//initial
	resetCtx();

	system("echo %CD%");

	loader.setRootAndIni(tctx.db_root , tctx.auto_seg_root );

	// get batching ids 
	std::fstream fin( tctx.us_trial_sidlist , std::fstream::in );
	std::cout<<" start at:\n\t "<<tctx.us_trial_sidlist<<std::endl; 

	myassert(fin.is_open() ,"batch file open fail");

	std::vector<int> idlist;
	std::string aline;
	int tmpid=0;
	while(std::getline(fin,aline))
	{
		if( aline.length()>0 ){
			if(  sscanf(aline.c_str(),"%d%*[\n]",&tmpid) ){
				idlist.push_back(tmpid);
				tmpid=0;
			} 
		}
	}  
	fin.close();

	trail_sidList = idlist;

	trail_cur_k=0;

	ctx.annosavePath = tctx.annoresSavePath;
	annosavePath= tctx.annoresSavePath;

	anno_force_rerun=tctx.batch_force_rerun;

	if (anno_force_rerun)
	{
		std::cout<<"WARNNING: no effect flag [anno_force_rerun]\n";
	}

	std::cout<<"Trail case # = "<<trail_sidList.size()<<std::endl;

	try
	{
		//-------------------------------------------------------------------------
		// load SVM model 
		ini_svm(tctx);  

		//-------------------------------------------------------------------------
		ctx.imid=trail_sidList[trail_cur_k];

		_load_preprocessed_case(ctx.imid);

		requireUpdateBKTex=1;
		requireUpdateContourTex=1;

		std::cout<<"pre-update sce \n";

		//-------------------------------------------------------------------------

		updateBoxPoly2D();
		updateBox2DSeg();
		updateBoxPlanes();

		re_estiBoxFeatures();
		//-------------------------------------------------------------------------

		ctx.isReady=true;
		return true;

	}catch (const char* msg){

		std::cout<<"==================================================\n";
		std::cout<<"[EXCP] :"<<msg<<"\n";
		std::cout<<"==================================================\n";

	}catch (std::string msg){
		std::cout<<"==================================================\n";
		std::cout<<"[EXCP] :"<<msg<<"\n";
		std::cout<<"==================================================\n";
	}

	return false;

}

void Tirth::FCGLPanel::_load_preprocessed_case(const int IMG_ID)
{

	bool fileExisted=1;
	fileExisted &= fileisExisted(loader.getProc_FrXYZ_Path(IMG_ID).c_str());
	fileExisted &= fileisExisted(loader.getProc_FrNV_Path(IMG_ID).c_str());
	fileExisted &= fileisExisted(loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str()); 

	if( fileExisted ){

		fast_reloadCase_processed(IMG_ID , tctx.use_auto_seg );

	}else{

		std::cout<<"[PreProcessed FILE NOT FOUND] at :"<<loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str()<<"\n";

		if( fileisExisted(loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str())){
			std::cout<<"[DB FILE NOT FOUND] at :"<<loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str()<<"\n";
		}
		if( fileisExisted(loader.getProc_FrNV_Path(IMG_ID).c_str())){
			std::cout<<"[DB FILE NOT FOUND] at :"<<loader.getProc_FrNV_Path(IMG_ID)<<"\n";
		}
		if( fileisExisted(loader.getProc_FrXYZ_Path(IMG_ID).c_str())){
			std::cout<<"[DB FILE NOT FOUND] at :"<<loader.getProc_FrXYZ_Path(IMG_ID)<<"\n";
		}
		 
		throw ("PreProcessed FILE NOT FOUND - _load_preprocessed_case");
	}

}

void Tirth::FCGLPanel::_load_preprocessed_case(const int IMG_ID, const std::string LOAD_BIN_DIR)
{

	bool fileExisted=1;
	fileExisted &= fileisExisted(loader.getProc_FrXYZ_Path(IMG_ID).c_str());
	fileExisted &= fileisExisted(loader.getProc_FrNV_Path(IMG_ID).c_str());
	fileExisted &= fileisExisted(loader.getResultSceneBin_SAVEPath(IMG_ID, LOAD_BIN_DIR ).c_str()); 

	if( fileExisted ){

		fast_reloadCase_processed(IMG_ID , LOAD_BIN_DIR , tctx.use_auto_seg );

	}else{

		std::cout<<"[PreProcessed FILE NOT FOUND] at :"<<loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str()<<"\n";

		if( fileisExisted(loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str())){
			std::cout<<"[DB FILE NOT FOUND] at :"<<loader.getResultSceneBin_SAVEPath(IMG_ID,tctx.input_bin_dir).c_str()<<"\n";
		}
		if( fileisExisted(loader.getProc_FrNV_Path(IMG_ID).c_str())){
			std::cout<<"[DB FILE NOT FOUND] at :"<<loader.getProc_FrNV_Path(IMG_ID)<<"\n";
		}
		if( fileisExisted(loader.getProc_FrXYZ_Path(IMG_ID).c_str())){
			std::cout<<"[DB FILE NOT FOUND] at :"<<loader.getProc_FrXYZ_Path(IMG_ID)<<"\n";
		}

		throw ("PreProcessed FILE NOT FOUND - _load_preprocessed_case");
	}

}


//-------------------------------------------------------------------------

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_sup_initial()
{

	if (_initialLoad_without_supesti())
	{
		return FCStateMag::S_SUPM_IDLE;
	}else{
		return FCStateMag::S_INI; 
	}

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_sup_start()
{
	// AFTER initial 

	ctx.timer.startAtMode(MyTimer::T_SUP);

	//-------------------------------------------------------------------------
	return FCStateMag::S_SUP_EDITIDLE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_sup_move2Next()
{
	if( trail_cur_k+1==trail_sidList.size() ){
		std::cout<<"reach end\n";
		return FCStateMag::S_SUPM_IDLE; 
	}else{
		trail_cur_k=trail_cur_k+1;
	}

	// load model 
	//-------------------------------------------------------------------------
	resetCtx();

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	_load_preprocessed_case(ctx.imid);


	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes();

	//update_sceneSupState();

	re_estiBoxFeatures();

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------
	ctx.isReady=true;

	update();

	return FCStateMag::S_SUPM_IDLE;  
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_sup_move2Prev()
{
	if( trail_cur_k-1 < 0 ){
		std::cout<<"reach head\n";
		return FCStateMag::S_SUPM_IDLE; 
	}else{
		trail_cur_k=trail_cur_k-1; 
	}
	//-------------------------------------------------------------------------
	resetCtx();

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	_load_preprocessed_case(ctx.imid);

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 

	//update_sceneSupState();

	re_estiBoxFeatures();

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------
	ctx.isReady=true;

	update();

	return FCStateMag::S_SUPM_IDLE; 
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_sup_reset()
{
	resetCtx();  

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	_load_preprocessed_case(ctx.imid); 

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 

	//update_sceneSupState(); 

	re_estiBoxFeatures();

	//-------------------------------------------------------------------------

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;
	//-------------------------------------------------------------------------
	ctx.isReady=true;

	return FCStateMag::S_SUPM_IDLE;  
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_sup_save()
{
	/*
	if( _ini_mode == "label"  ){
	}else if(_ini_mode == "structure" ){
	}else if(_ini_mode == "box" ){
	//}else if(_ini_mode == "all" ){
	}else{
	}
	*/

	//-------------------------------------------------------------------------

	ctx.timer.done();

	std::cout<<"==============================================\n"
		<<"Total time(s):"<<ctx.timer.getTotalSecond()<<"\n"
		<<"Total SUP time(s):"<<ctx.timer.getTotalSupSec()<<"\n";


	_saveAnnotate();

	std::cout<<"==============================================\n";

	// keep in S_FINAL
	return FCStateMag::S_SUPM_FINAL;
}

//-------------------------------------------------------------------------

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_box_initial()
{

	if (_initialLoad_without_supesti())
	{
		return FCStateMag::S_BOXM_IDLE;
	}else{

		return FCStateMag::S_INI; 
	}

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_box_start()
{
	// AFTER initial 

	ctx.timer.startAtMode(MyTimer::T_BOX);

	//-------------------------------------------------------------------------
	return FCStateMag::S_BOX_SEL;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_box_move2Next()
{
	if( trail_cur_k+1==trail_sidList.size() ){
		std::cout<<"reach end\n";
		return FCStateMag::S_BOXM_IDLE; 
	}else{
		trail_cur_k=trail_cur_k+1;
	}

	// load model 
	//-------------------------------------------------------------------------
	resetCtx();

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	_load_preprocessed_case(ctx.imid);

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes();

	//update_sceneSupState();

	re_estiBoxFeatures();

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------
	ctx.isReady=true;

	update();

	return FCStateMag::S_BOXM_IDLE;  
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_box_move2Prev()
{
	if( trail_cur_k-1 < 0 ){
		std::cout<<"reach head\n";
		return FCStateMag::S_BOXM_IDLE; 
	}else{
		trail_cur_k=trail_cur_k-1; 
	}
	//-------------------------------------------------------------------------
	resetCtx();

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	_load_preprocessed_case(ctx.imid);

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 

	//update_sceneSupState();

	re_estiBoxFeatures();

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;

	//-------------------------------------------------------------------------
	ctx.isReady=true;

	update();

	return FCStateMag::S_BOXM_IDLE;  
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_box_reset()
{
	resetCtx();  

	ctx.imid=trail_sidList[trail_cur_k];
	ctx.annosavePath = annosavePath;

	//-------------------------------------------------------------------------

	//_load_preprocessed_case(ctx.imid);
	_load_preprocessed_case(ctx.imid,ctx.annosavePath);

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes(); 

	re_estiBoxFeatures();

	//-------------------------------------------------------------------------

	requireUpdateBKTex=1;
	requireUpdateContourTex=1;
	//-------------------------------------------------------------------------
	ctx.isReady=true;

	//return FCStateMag::S_BOXM_IDLE;  
	return FCStateMag::S_BOX_SEL;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_mode_box_save()
{

	ctx.timer.done();


	std::cout<<"==============================================\n"
		<<"Total time(s):"<<ctx.timer.getTotalSecond()<<"\n"
		<<"Total BOX time(s):"<<ctx.timer.getTotalBoxSec()<<"\n";

	_saveAnnotate();

	std::cout<<"==============================================\n";

	// keep in S_FINAL
	return FCStateMag::S_BOXM_FINAL;
}

//-------------------------------------------------------------------------

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxmi_enterBoxManiMode()
{
	// do something..
	ctx.bxmiCtx.resetControl();
	ctx.bxmiCtx.bxmi_focus_boxIdx = ctx.bxsel_boxselIdx;

	ctx.bxmiCtx.box=ctx.boxDatas[ctx.bxsel_boxselIdx];

	//checkBox(ctx.boxDatas[ctx.bxsel_boxselIdx] , ctx.tx_fr2world);

	return FCStateMag::S_BOXMANI;
}


void Tirth::FCGLPanel::_bxmi_handle_y( int cv_x, int cv_y )
{ 
	int boxFocusIdx=ctx.bxmiCtx.bxmi_focus_boxIdx;
	int selVIdx = ctx.bxmiCtx.bxmi_sel_vidx;


	Eigen::MatrixXf box_2d = ctx.boxDatas[boxFocusIdx].getBox2d_img_n2();

	float y_delta = -1 * 0.1 * (cv_y - box_2d.row(selVIdx).y())/10.0 ;

	//RESET temp box
	ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];

	// only changing Y 
	maniBoxVex_height(ctx.bxmiCtx.box, ctx.bxmiCtx.bxmi_sel_vidx, y_delta ,ctx.tx_world2fr , ctx.tx_fr2world);

	//-------------------------------------------------------------------------
	float * boxworld = ctx.boxDatas[boxFocusIdx].getBox3d_world();

	ctx.bxmiCtx.drag_pts[0]= boxworld[ctx.bxmiCtx.bxmi_sel_vidx*3];
	ctx.bxmiCtx.drag_pts[1]=boxworld[ctx.bxmiCtx.bxmi_sel_vidx*3+1];
	ctx.bxmiCtx.drag_pts[2]= boxworld[ctx.bxmiCtx.bxmi_sel_vidx*3+2];

}

void Tirth::FCGLPanel::_bxmi_handle_xz( int mx, int my  )
{ 

	int boxFocusIdx=ctx.bxmiCtx.bxmi_focus_boxIdx;

	// suppose we use XZ planes
	auto const & wpl = ctx.boxDatas[boxFocusIdx].getBoxPlane_world();

	Eigen::Vector3f drag_pts;

	if (ctx.bxmiCtx.bxmi_sel_vidx < 4 )
	{

		drag_pts = constrDepthSensorV3(wpl[0].model , mx, my , ctx.oglMVP_e , ctx.panelWidth , ctx.panelHeight);										 

	}else{
		//last one 
		drag_pts = constrDepthSensorV3(wpl[5].model , mx, my , ctx.oglMVP_e , ctx.panelWidth , ctx.panelHeight);										 

	}

	//RESET temp box
	ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];

	maniBoxVex(ctx.bxmiCtx.box, ctx.bxmiCtx.bxmi_sel_vidx, drag_pts ,ctx.tx_world2fr , ctx.tx_fr2world);

	ctx.bxmiCtx.drag_pts[0]= drag_pts.x();
	ctx.bxmiCtx.drag_pts[1]= drag_pts.y();
	ctx.bxmiCtx.drag_pts[2]= drag_pts.z();
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxmi_mouseMove()
{ 
	bool verbase=1;
	bool verbase0=false;

	int cv_x=ctx.lastPos.x();
	int cv_y=ctx.lastPos.y();

	convert2segLoc(cv_x,cv_y);

	int mx = cv_x;
	int my = cv_y == -1 ? -1 : ctx.panelHeight-cv_y+1;

	//-------------------------------------------------------------------------
	if( ctx.isReady && ctx.bxmiCtx.bxmi_focus_boxIdx >=0 ){ 

		int boxFocusIdx=ctx.bxmiCtx.bxmi_focus_boxIdx;

		// Enter Drag mode or not
		bool dragModeOn =ctx.bxmiCtx.bxmi_pressed ;

		if( false == dragModeOn ){ 
			//Detect THE Closest Vertex 

			if( cv_x != -1 && cv_y != -1 ){  

				// 2D vertex
				Eigen::MatrixXf b2d = ctx.boxDatas[boxFocusIdx].getBox2d_img_n2();

				Eigen::RowVector2f mloc;
				mloc<< cv_x, cv_y;

				float minDist =std::numeric_limits<float>::max();
				float tmpDist =0;
				int minVIdx =-1;

				const float DIST2D_TH = 50;

				// constraint on top face
				//for (int iv=1 ; iv < b2d.rows() ; iv++)
				for (int iv=0 ; iv < 8 ; iv++)
				{  
					tmpDist =(b2d.row(iv) - mloc).norm();

					if (tmpDist < minDist && tmpDist < DIST2D_TH )
					{
						minDist = tmpDist;
						minVIdx = iv;
					} 
				}

				if(verbase0)
				{
					std::cout
						<<"---------------------\n"
						<<"b2d="<<b2d.row(0)
						<<"\n"<<mloc<<"\n"
						<<"dist="<<tmpDist<<"\n"
						<<"diff="<<(b2d.row(0) - mloc)<<"\n"
						<<"norm="<<(b2d.row(0) - mloc).norm()<<"\n\n";
				}
				//set ctx
				if (ctx.bxmiCtx.bxmi_sel_vidx!=minVIdx)
				{
					std::cout<<"vex focus = "<<minVIdx<<"\n";
					ctx.bxmiCtx.bxmi_sel_vidx=minVIdx;
				}

			}else{
				ctx.bxmiCtx.bxmi_sel_vidx=-1;
			}

			if(0){
				std::cout<<"m2d="<<cv_x<<','<<cv_y<<std::endl;
				std::cout<<"sidx="<<ctx.bxmiCtx.bxmi_sel_vidx<<std::endl;
				std::cout<<"\nb2d:\n"<< ctx.boxDatas[boxFocusIdx].getBox2d_img_n2()<<std::endl;
				std::cout<<"\n\n";
			}

		}else{
			// Dragging
			// ctx.bxmi_pressed 
			// vertex focus id would not change

			// Apply Box Changing 
			// check dragging pts is valid or not
			if( cv_x != -1 && cv_y != -1 && cv_x <ctx.ini_xyzPcd->width && cv_y < ctx.ini_xyzPcd->height ){ 

				if (ctx.bxmiCtx.maniMode==BxmiCtx::M_VEX_XZ ){
					// ADJUST XZ

					_bxmi_handle_xz(mx,my);

				}else if (ctx.bxmiCtx.maniMode==BxmiCtx::M_VEX_Y){
					// ADJUST Y(HEIGHT)

					_bxmi_handle_y(cv_x,cv_y);

				}else if(ctx.bxmiCtx.maniMode == BxmiCtx::M_ROT_Y){
					// ADJUST THETA(Orientation)

					int dx = cv_x-ctx.bxmiCtx.press_x;
					int dy = cv_y-ctx.bxmiCtx.press_y;

					const float Y_ROT_UNIT = M_PI/300;

					ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];

					if (dx>0){
						ctx.bxmiCtx.rot_theta-=Y_ROT_UNIT;
					}else{
						ctx.bxmiCtx.rot_theta+=Y_ROT_UNIT;
					} 

					mBoxRotate_Y(ctx.bxmiCtx.box, ctx.bxmiCtx.rot_theta ,ctx.tx_fr2world);

					std::cout<<"ROT MOVING THETA :(deg)"<< M_PI/180*ctx.bxmiCtx.rot_theta <<std::endl; 
				}  

				ctx.bxmiCtx.drag_isgood=1;

				//-----------------------------
				if(verbase){
					Eigen::MatrixXf vexw = ctx.boxDatas[boxFocusIdx].getBox3d_world_n3();

					std::cout<<ctx.bxmiCtx.box.getBox3d_world_n3()<<"\n\n";
				} 

			}else{
				// Bad Box
				ctx.bxmiCtx.drag_isgood=0;

				memset(ctx.bxmiCtx.drag_pts,0,sizeof(ctx.bxmiCtx.drag_pts));
			}

		} // dragging


	}// valid box
	return FCStateMag::S_BOXMANI;

}


Tirth::FCStateMag::State Tirth::FCGLPanel::_bxmi_mouseMove_vexEnt()
{ 
	myassert("deprecated");

	bool verbase=1;
	bool verbase0=false;

	int cv_x=ctx.lastPos.x();
	int cv_y=ctx.lastPos.y();

	convert2segLoc(cv_x,cv_y);

	int mx = cv_x;
	int my = cv_y == -1 ? -1 : ctx.panelHeight-cv_y+1;

	//-------------------------------------------------------------------------
	if( ctx.isReady && ctx.bxmiCtx.bxmi_focus_boxIdx >=0 ){ 

		int boxFocusIdx=ctx.bxmiCtx.bxmi_focus_boxIdx;

		// Enter Drag mode or not
		bool dragModeOn =ctx.bxmiCtx.bxmi_pressed ;

		if( false == dragModeOn ){ 
			//Detect Closest Vertex of Top face 

			if( cv_x != -1 && cv_y != -1 ){  

				// 2D vertex
				Eigen::MatrixXf b2d = ctx.boxDatas[boxFocusIdx].getBox2d_img_n2();

				Eigen::RowVector2f mloc;
				mloc<< cv_x, cv_y;

				float minDist =std::numeric_limits<float>::max();
				float tmpDist =0;
				int minVIdx =-1;

				const float DIST2D_TH = 50;

				// constraint on top face
				//for (int iv=1 ; iv < b2d.rows() ; iv++)
				for (int iv=0 ; iv < 4; iv++)
				{  
					tmpDist =(b2d.row(iv) - mloc).norm();

					if (tmpDist < minDist && tmpDist < DIST2D_TH )
					{
						minDist = tmpDist;
						minVIdx = iv;
					}


				}
				if(verbase0)
				{
					std::cout
						<<"---------------------\n"
						<<"b2d="<<b2d.row(0)
						<<"\n"<<mloc<<"\n"
						<<"dist="<<tmpDist<<"\n"
						<<"diff="<<(b2d.row(0) - mloc)<<"\n"
						<<"norm="<<(b2d.row(0) - mloc).norm()<<"\n\n";
				}
				//set ctx
				if (ctx.bxmiCtx.bxmi_sel_vidx!=minVIdx)
				{
					std::cout<<"vex focus = "<<minVIdx<<"\n";
					ctx.bxmiCtx.bxmi_sel_vidx=minVIdx;
				}

			}else{
				ctx.bxmiCtx.bxmi_sel_vidx=-1;
			}

			if(0){
				std::cout<<"m2d="<<cv_x<<','<<cv_y<<std::endl;
				std::cout<<"sidx="<<ctx.bxmiCtx.bxmi_sel_vidx<<std::endl;
				std::cout<<"\nb2d:\n"<< ctx.boxDatas[boxFocusIdx].getBox2d_img_n2()<<std::endl;
				std::cout<<"\n\n";
			}

		}else{
			// Dragging
			// ctx.bxmi_pressed 
			// vertex focus id would not change

			// Apply Box Changing 
			// check dragging pts is valid or not
			if( cv_x != -1 && cv_y != -1 && cv_x <ctx.ini_xyzPcd->width && cv_y < ctx.ini_xyzPcd->height ){ 

				// 3d pts of dragging pts
				Eigen::Vector3f drag_pts =ctx.ini_xyzPcd->at(cv_x,cv_y).getVector3fMap();

				Eigen::Vector3f p2;

				if (ctx.bxmiCtx.maniMode==BxmiCtx::M_VEX_XZ )
				{

					//-------------------------------------------------------------------------

					Eigen::MatrixXf box_world_n3 = ctx.boxDatas[boxFocusIdx].getBox3d_world_n3();
					Eigen::MatrixXf box_cvimg_n2 = ctx.boxDatas[boxFocusIdx].getBox2d_img_n2();

					Eigen::Vector2f cv_xy;
					cv_xy<< cv_x, cv_y;

					// take selected vertex
					int v1Idx = (ctx.bxmiCtx.bxmi_sel_vidx-1+4)%4;
					int v2Idx = (ctx.bxmiCtx.bxmi_sel_vidx+1)%4;

					Eigen::Vector2f v0 = box_cvimg_n2.row(ctx.bxmiCtx.bxmi_sel_vidx);
					Eigen::Vector2f v1 = box_cvimg_n2.row(v1Idx);
					Eigen::Vector2f v2 = box_cvimg_n2.row(v2Idx);

					Eigen::Vector2f dirV01 = (v0-v1).normalized();
					Eigen::Vector2f dirV02 = (v0-v2).normalized();
					Eigen::Vector2f dirMV0 = (cv_xy-v0).normalized();

					float deg1=abs(dirMV0.dot(dirV01));
					float deg2=abs(dirMV0.dot(dirV02));

					Eigen::Vector3f moveVec;

					float moveAmount = ((cv_xy-v0).norm()/10);
					// cos 
					if (deg1 <= deg2){
						// select v1 and v0

						//v0->v1
						moveVec = (box_world_n3.row(ctx.bxmiCtx.bxmi_sel_vidx) - box_world_n3.row(v1Idx)).normalized();

						moveVec = moveVec *0.05*moveAmount;

					}else{
						// select v2 and v0

						//v0->v2
						moveVec = (box_world_n3.row(ctx.bxmiCtx.bxmi_sel_vidx) - box_world_n3.row(v2Idx)).normalized();
						moveVec = moveVec *0.05*moveAmount;

					}

					//RESET temp box
					ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];
					maniBoxVex_Extend(ctx.bxmiCtx.box,ctx.bxmiCtx.bxmi_sel_vidx,moveVec ,ctx.tx_world2fr , ctx.tx_fr2world);

				}else if (ctx.bxmiCtx.maniMode==BxmiCtx::M_VEX_Y){

					// only changing Y 
					float * boxworld = ctx.boxDatas[boxFocusIdx].getBox3d_world();

					p2.x()=boxworld[ctx.bxmiCtx.bxmi_sel_vidx*3];
					p2.y()=drag_pts.y();
					p2.z()=boxworld[ctx.bxmiCtx.bxmi_sel_vidx*3+2];

					ctx.bxmiCtx.drag_pts[0]=p2.x();
					ctx.bxmiCtx.drag_pts[1]=p2.y();
					ctx.bxmiCtx.drag_pts[2]=p2.z(); 

					//RESET temp box
					ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];

					maniBoxVex(ctx.bxmiCtx.box, ctx.bxmiCtx.bxmi_sel_vidx, p2 ,ctx.tx_world2fr , ctx.tx_fr2world);

				}else if(ctx.bxmiCtx.maniMode == BxmiCtx::M_ROT_Y){

					int dx = cv_x-ctx.bxmiCtx.press_x;
					int dy = cv_y-ctx.bxmiCtx.press_y;

					const float Y_ROT_UNIT = M_PI/200;

					ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];

					if (dx>0){
						ctx.bxmiCtx.rot_theta-=Y_ROT_UNIT;
					}else{
						ctx.bxmiCtx.rot_theta+=Y_ROT_UNIT;
					} 

					mBoxRotate_Y(ctx.bxmiCtx.box, ctx.bxmiCtx.rot_theta ,ctx.tx_fr2world);

					std::cout<<"ROT MOVING THETA :(deg)"<< M_PI/180*ctx.bxmiCtx.rot_theta <<std::endl; 
				}  

				ctx.bxmiCtx.drag_isgood=1;

				//-----------------------------
				if(verbase){
					std::cout<<"vex_="<<p2.x()<<","<<p2.y()<<","<<p2.z()<<std::endl;
					Eigen::MatrixXf vexw = ctx.boxDatas[boxFocusIdx].getBox3d_world_n3();
					std::cout<<"ori="
						<<vexw(ctx.bxmiCtx.bxmi_sel_vidx,0)<<","
						<<vexw(ctx.bxmiCtx.bxmi_sel_vidx,1)<<","
						<<vexw(ctx.bxmiCtx.bxmi_sel_vidx,2)<<"\n\nbw3=";
					std::cout<<ctx.bxmiCtx.box.getBox3d_world_n3()<<"\n\n";
				} 

			}else{
				// Bad Box
				ctx.bxmiCtx.drag_isgood=0;

				memset(ctx.bxmiCtx.drag_pts,0,sizeof(ctx.bxmiCtx.drag_pts));
			}

		} // dragging


	}// valid box
	return FCStateMag::S_BOXMANI;

}


Tirth::FCStateMag::State Tirth::FCGLPanel::_bxmi_mousePressed()
{
	bool verbase=1;
	if (verbase)
	{
		std::cout<<"[bxMANI] _bxmi_mouse Pressed"<<std::endl;
	}


	if( ctx.isReady ){

		if (ctx.lastBtu == Qt::LeftButton )
		{
			// rotation mode no need to select a vertex

			if (ctx.bxmiCtx.maniMode == BxmiCtx::M_ROT_Y || ctx.bxmiCtx.bxmi_sel_vidx!=-1 ){

				int x=ctx.lastPos.x();
				int y=ctx.lastPos.y(); 
				convert2segLoc(x,y);

				ctx.bxmiCtx.press_x=x;
				ctx.bxmiCtx.press_y=y; 

				int boxFocusIdx=ctx.bxmiCtx.bxmi_focus_boxIdx;
				ctx.bxmiCtx.box=ctx.boxDatas[boxFocusIdx];

				ctx.bxmiCtx.bxmi_pressed=true;

			}

		}else if( ctx.lastBtu == Qt::RightButton ){

		}

	}


	return FCStateMag::S_BOXMANI;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxmi_mouseReleased()
{
	bool verbase=1;
	if (verbase)
	{
		std::cout<<"[bxMANI] _bxmi_mouse Released"<<std::endl;
	}

	// record the changing of the focus box
	int boxFocusIdx = ctx.bxmiCtx.bxmi_focus_boxIdx;

	if (boxFocusIdx != -1 && ctx.lastBtu == Qt::RightButton )
	{
		// action done
		ctx.boxDatas[boxFocusIdx]=ctx.bxmiCtx.box;

		ctx.boxDatas[boxFocusIdx].setBoxModified(true);

		updateBoxPoly2D();
		updateBox2DSeg();


		updateBoxPlanes(); 
		re_estiBoxFeatures();

		ctx.bxmiCtx.resetControl();


		// update textures
		requireUpdateContourTex=1;

		return FCStateMag::S_BOX_SEL;
	}else{

		ctx.boxDatas[boxFocusIdx]=ctx.bxmiCtx.box;

		// update textures
		updateBoxPoly2D();
		updateBox2DSeg();


		updateBoxPlanes(); 
		re_estiBoxFeatures();


		ctx.bxmiCtx.resetControl();
		ctx.bxmiCtx.bxmi_focus_boxIdx=boxFocusIdx;
		requireUpdateContourTex=1;

		return FCStateMag::S_BOXMANI;
	}


}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxmi_keyPressed()
{

	if( ctx.isReady ){

		int boxFocusIdx = ctx.bxmiCtx.bxmi_focus_boxIdx;

		if (boxFocusIdx >=0 )
		{

			Eigen::RowVector3f centerTX;

			float unit=0.2;

			bool validKey=false;

			Eigen::Vector3f cen = ctx.boxDatas[boxFocusIdx].getBox3d_world_n3().colwise().mean();

			Eigen::MatrixXf boxWorld = ctx.boxDatas[boxFocusIdx].getBox3d_world_n3();

			Eigen::RowVector3f d1=(boxWorld.row(0)-boxWorld.row(1));
			Eigen::RowVector3f d2=(boxWorld.row(0)-boxWorld.row(3));

			d1.normalize();
			d2.normalize();

			if( ctx.lastKeyCode==Qt::Key_A ){ 
				//left (z)
				centerTX << d1*-unit ;
				validKey=true;

			}else if( ctx.lastKeyCode==Qt::Key_D ){
				//right (z)
				centerTX << d1*unit ;
				validKey=true;

			}else if( ctx.lastKeyCode==Qt::Key_S ){
				//down (x)			
				centerTX << d2*-unit ;
				validKey=true;

			}else if( ctx.lastKeyCode==Qt::Key_W ){
				//up (x)
				centerTX << d2*unit ;
				validKey=true;
			}

			if (validKey)
			{
				mBoxTranslate(ctx.boxDatas[boxFocusIdx],centerTX,ctx.tx_fr2world);

				updateBoxPoly2D(); 
				updateBox2DSeg(); 

				updateBoxPlanes(); 
				re_estiBoxFeatures();

			}
		}
	}

	return FCStateMag::S_BOXMANI;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxsel_entermode()
{
	ctx.bxsel_boxselIdx=-1;

	updateBoxPoly2D(); 
	updateBox2DSeg();
	updateBoxPlanes();

	return FCStateMag::S_BOX_SEL;

}
Tirth::FCStateMag::State Tirth::FCGLPanel::_bxsel_actionDone()
{

	std::cout<<"Done. SAVE res \n"; 

	//return _mode_box_save();
	_mode_box_save();


	if (_ini_mode == "draw")
	{
		return FCStateMag::S_DRAW_FINAL;

	}else{
		return FCStateMag::S_FINAL;
	}
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxsel_mouseMove()
{ 
	int x=ctx.lastPos.x();
	int y=ctx.lastPos.y();

	convert2segLoc(x,y);

	//-------------------------------------------------------------------------
	// select a focus box
	if(ctx.isReady){
		// no focus box
		// try to find a focus box
		if( y < ctx.gtsegCvMat_16u.rows && x < ctx.gtsegCvMat_16u.cols && x >=0 && y>=0 ){

			int seg_uId = ctx.gtsegCvMat_16u.at<unsigned short>(y,x);

			// update "bxsel focus ID"
			if(seg_uId != 0){
				// use seg to select

				// no focus is -1
				ctx.bxsel_boxselIdx=-1;

				for ( int i=0 ; i < ctx.boxDatas.size() ; i++)
				{
					if(	ctx.boxDatas[i].getUID() == seg_uId ){

						// record focus idx
						ctx.bxsel_boxselIdx = i ; 
						break;
					}
				}

				myassert(ctx.bxsel_boxselIdx!=-1,"uid is not exist");

			}else{
				ctx.bxsel_boxselIdx = -1;
			}

			// update "bk focus ID" ( handle focus-in and focus-out )
			if (ctx.bkseg_focus_box_idx!=ctx.bxsel_boxselIdx)
			{
				// bk focus ID
				ctx.bkseg_focus_box_idx=ctx.bxsel_boxselIdx;
				requireUpdateContourTex=1;
			}

		}else{

			// update "bk focus ID" ( handle focus-in and focus-out )
			if (ctx.bkseg_focus_box_idx!=-1)
			{
				ctx.bxsel_boxselIdx=-1;
				ctx.bkseg_focus_box_idx=-1;
				requireUpdateContourTex=1;
			}
		}


	}

	//-------------------------------------------------------------------------
	return FCStateMag::S_BOX_SEL;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxsel_mousePressed()
{ 
	bool verbase=1;

	if (verbase)
	{
		std::cout<<"[bxSEL] _bxsel_mouse Pressed"<<std::endl;
	}


	//-------------------------------------------------------------------------
	return FCStateMag::S_BOX_SEL;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxsel_mouseReleased()
{ 
	bool verbase=1;

	if (verbase)
	{
		std::cout<<"[bxSEL] _bxsel_mouse Released"<<std::endl;
	}

	//-------------------------------------------------------------------------
	// enter manipulation mode
	if (ctx.bxsel_boxselIdx != -1 && Qt::LeftButton == ctx.lastBtu)
	{

		return _bxmi_enterBoxManiMode(); 

	}else{

		return FCStateMag::S_BOX_SEL;

	}
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_bxsel_keyPressed()
{ 
	return FCStateMag::S_BOX_SEL;
}


Tirth::FCStateMag::State Tirth::FCGLPanel::_supadj_enterMode()
{
	ctx.supVis_requireUpdateTex=true;

	ctx.supAdj_focus_box_idx=-1;

	//------------------------------------------------------------------------- 
	// pre-clear up

	for ( int i=0 ; i< ctx.boxDatas.size() ; i++)
	{
		ctx.boxDatas[i].setSupModified(false);

	}



	//-------------------------------------------------------------------------

	return FCStateMag::S_SUP_EDITIDLE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supadj_mouseMove()
{

	int x=ctx.lastPos.x();
	int y=ctx.lastPos.y(); 
	convert2segLoc(x,y); 

	if( ctx.supVisArrIDMat.elemSize() ){

		if( y < ctx.supVisArrIDMat.rows && x < ctx.supVisArrIDMat.cols && x >=0 && y>=0 ){

			int arr_id = ctx.supVisArrIDMat.at<int>(y,x);

			int seg_uId = ctx.gtsegCvMat_16u.at<unsigned short>(y,x);

			int hit_id=-1;

			if (arr_id !=-1 )
			{
				hit_id = arr_id;

			}else if(seg_uId != 0){
				// use seg to select

				for ( int i=0 ; i < ctx.boxDatas.size() ; i++)
				{
					if(	ctx.boxDatas[i].getUID() == seg_uId ){
						hit_id=i;
						break;
					}
				}
			}


			if( hit_id != -1 && ctx.supAdj_focus_box_idx != hit_id ){
				// focus
				ctx.supAdj_focus_box_idx = hit_id;
				ctx.supVis_requireUpdateTex=true;

				ctx.bkseg_focus_box_idx= hit_id;
				requireUpdateContourTex=true;

			}else if(hit_id == -1 && ctx.supAdj_focus_box_idx != hit_id){
				// loss focus

				ctx.supAdj_focus_box_idx = -1;
				ctx.supVis_requireUpdateTex=true;
				ctx.bkseg_focus_box_idx= -1;
				requireUpdateContourTex=true;
			}

		}
	}


	return FCStateMag::S_SUP_EDITIDLE;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supadj_mousePressed()
{ 
	std::cout<<"focus id="<<ctx.supAdj_focus_box_idx <<std::endl;

	return  FCStateMag::S_SUP_EDITIDLE;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supadj_mouseReleased()
{
	if( ctx.supAdj_focus_box_idx != -1){ 
		// move to assign relationship

		ctx.supVis_requireUpdateTex=true;

		ctx.bkseg_focus_box_idx= -1;
		requireUpdateContourTex=true;

		int x=ctx.lastPos.x();
		int y=ctx.lastPos.y(); 
		convert2segLoc(x,y); 
		ctx.setSupCtx.drag_mx=x;
		ctx.setSupCtx.drag_my=y;

		return FCStateMag::S_SUP_ASSIG; 		 
	}else{
		return FCStateMag::S_SUP_EDITIDLE;
	}
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supadj_keyPressed()
{
	return FCStateMag::S_SUP_EDITIDLE;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supSel_mouseMove()
{
	bool verbase = 1;


	int x=ctx.lastPos.x();
	int y=ctx.lastPos.y(); 
	convert2segLoc(x,y); 

	ctx.setSupCtx.drag_mx=x;
	ctx.setSupCtx.drag_my=y;

	// detect candidate
	if( x >=0 && y >=0 && x < ctx.gtsegCvMat_16u.cols && y < ctx.gtsegCvMat_16u.rows )
	{
		int boxUid=ctx.gtsegCvMat_16u.at<unsigned short>(y,x); 
		int roomUid=ctx.roomImg.at<int>(y,x);

		// valid and it's NOT self-support
		if( boxUid > 0 ){

			int boxLidx=-1;
			for (int i=0 ; i<ctx.boxDatas.size() ; i++)
			{
				if (ctx.boxDatas[i].getUID() == boxUid)
				{
					boxLidx = i;
					break;
				}
			}

			//NOT self-support
			if (boxLidx != ctx.supAdj_focus_box_idx )
			{
				ctx.setSupCtx.supParentType=SetSupCtx::SUPSET_PT_OBJ;
				ctx.setSupCtx.supLocalIdx = boxLidx;
			}else{
				// self-support -> invalid
				ctx.setSupCtx.supParentType=SetSupCtx::SUPSET_PT_FLOAT;
				ctx.setSupCtx.supLocalIdx=-1;

			}

			//----------------------------------


		}else if(roomUid == 1){

			ctx.setSupCtx.supParentType=SetSupCtx::SUPSET_PT_FLOOR;
			ctx.setSupCtx.supLocalIdx = 0;

		}else if(roomUid > 1 ){

			ctx.setSupCtx.supParentType=SetSupCtx::SUPSET_PT_WALL;
			ctx.setSupCtx.supLocalIdx = roomUid-1; // array idx start from 0

		}else{
			// not focus 
			ctx.setSupCtx.supParentType=SetSupCtx::SUPSET_PT_FLOAT;
			ctx.setSupCtx.supLocalIdx=-1;
		}

		ctx.supVis_requireUpdateTex=true;


		if (verbase)
		{
			std::cout<<"lidx = "<<ctx.setSupCtx.supLocalIdx<<"\n";
			std::cout<<"boxUid = "<<boxUid<<"\n";
		}

	}else{

	}

	return FCStateMag::S_SUP_ASSIG;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supSel_mousePressed()
{

	return FCStateMag::S_SUP_ASSIG; 
}


Tirth::FCStateMag::State Tirth::FCGLPanel::_supSel_mouseReleased()
{ 
	// clear up 

	int bidx = ctx.supAdj_focus_box_idx;

	if( bidx != -1 && ctx.setSupCtx.supLocalIdx != -1  && ctx.lastBtu == Qt::LeftButton ){ 

		// update support relationship
		ctx.boxDatas[bidx].setSupToIni();

		if ( ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_FLOOR ){
			ctx.boxDatas[bidx].setSupToFloor();
			ctx.boxDatas[bidx].setSupporterLIDX(ctx.setSupCtx.supLocalIdx);

		}else if ( ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_OBJ ){
			ctx.boxDatas[bidx].setSupToObj();
			ctx.boxDatas[bidx].setSupporterLIDX(ctx.setSupCtx.supLocalIdx);

		}else if ( ctx.setSupCtx.supParentType == SetSupCtx::SUPSET_PT_WALL ){

			ctx.boxDatas[bidx].setSupToWall();
			ctx.boxDatas[bidx].setSupporterLIDX(ctx.setSupCtx.supLocalIdx);

		}else{
			// invalid state
			std::cout<<"*ERR : new relationship is INVALID \n";
			throw "*ERR : new relationship is INVALID" ;
		}


		// set TOUCHED
		ctx.boxDatas[bidx].setSupModified(true);

		//-------------------------------------------------------------------------
		//clear up
		ctx.supAdj_focus_box_idx=-1;
		ctx.supVis_requireUpdateTex=true;
		requireUpdateContourTex=true;

		ctx.setSupCtx.resetControl();

		// back to select mode 
		return FCStateMag::S_SUP_EDITIDLE;

	}else if(ctx.lastBtu == Qt::RightButton ){
		//-------------------------------------------------------------------------
		//clear up
		ctx.supAdj_focus_box_idx=-1;
		ctx.supVis_requireUpdateTex=true;
		requireUpdateContourTex=true;

		ctx.setSupCtx.resetControl();

		return FCStateMag::S_SUP_EDITIDLE;
	}else{
		return FCStateMag::S_SUP_ASSIG; 	
	}

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_supSel_keyPressed()
{
	return FCStateMag::S_SUP_EDITIDLE;

}
Tirth::FCStateMag::State Tirth::FCGLPanel::_supSel_actionDone()
{
	//-------------------------------------------------------------------------
	// check no float
	bool isValid=1;
	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		if (ctx.boxDatas[i].isFloat())
		{
			isValid=0;
			break;
		}
	}

	if (0==isValid)
	{
		std::cout<<"exist a floating object. \n";
		std::cout<<"exist a floating object. \n";
		std::cout<<"exist a floating object. \n";
		return FCStateMag::S_SUP_EDITIDLE;
	}

	//-------------------------------------------------------------------------

	//-------------------------------------------------------------------------
	// start a 1-pass refine
	//-------------------------------------------------------------------------

	std::cout<<" auto refine start \n";

	// create a refine flag
	BoxStateLog alog;
	alog.boxState.clear();
	alog.boxState.resize(ctx.boxDatas.size());

	for (int i = 0; i < ctx.boxDatas.size() ; i++)
	{
		if( ctx.boxDatas[i].getEdited()  ){
			alog.boxState[i]=BoxStateLog::BSTATE_EDITED; 

		}else if(ctx.boxDatas[i].getUserConfed()){
			alog.boxState[i]=BoxStateLog::BSTATE_LOCKED; 

		}else if(ctx.boxDatas[i].getSwtiched()){
			alog.boxState[i]=BoxStateLog::BSTATE_SWITCHED; 

		}else {
			// unknown case --> mark as confirmed
			alog.boxState[i]=BoxStateLog::BSTATE_CONF_ALL;
		}
	} 

	// change box refine flag according user adjustment
	for (int i = 0; i < ctx.boxDatas.size() ; i++){

		if( ctx.boxDatas[i].getSupModeified() ){
			ctx.boxDatas[i].setIsLocalRefined(false);
		}
	}

	//-------------------------------------------------------------------------

	local_refine( alog.boxState );

	// update 2d info
	updateBoxPoly2D(); 
	updateBox2DSeg();

	updateBoxPlanes();

	re_estiBoxFeatures();


	global_refine_v2( alog.boxState );

	// update 2d info
	updateBoxPoly2D(); 
	updateBox2DSeg();
	updateBoxPlanes();

	re_estiBoxFeatures();
	//-------------------------------------------------------------------------


	//return _mode_sup_save();
	_mode_sup_save();
	return _mode_box_start();
}


//-------------------------------------------------------------------------
Tirth::FCStateMag::State Tirth::FCGLPanel::_drawobj_mouseMove()
{
	bool verbase = 1; 

	int x=ctx.lastPos.x();
	int y=ctx.lastPos.y(); 
	convert2segLoc(x,y); 

	if(  ctx.segDrawCtx.pressed )
	{ // pressed [dragging]

		// update segmentation
		// DRAWING  
		ctx.segDrawCtx.strokePts.push_back(x);
		ctx.segDrawCtx.strokePts.push_back(y);

		draw_on_finerSeg( ctx.segDrawCtx.strokePts , ctx.segDrawCtx.objID);
		requireUpdateDrawPaperTex=1;

		// convert ID to color ..

	}else{
		// no pressed -- skip

	}

	return FCStateMag::S_DRAW_OBJSEG;

}

//-------------------------------------------------------------------------
Tirth::FCStateMag::State Tirth::FCGLPanel::_draw_initial()
{
	//initial
	resetCtx();

	system("echo %CD%");

	loader.setRootAndIni( tctx.db_root , tctx.auto_seg_root);

	// get us_trial_sidlist 
	std::fstream fin( tctx.us_trial_sidlist , std::fstream::in );
	std::cout<<" start at:\n\t "<<tctx.us_trial_sidlist<<std::endl; 

	myassert(fin.is_open() ,"'us_trial_sidlist' file open fail");

	std::vector<int> idlist;
	std::string aline;
	int tmpid=0;
	while(std::getline(fin,aline))
	{
		if( aline.length()>0 ){
			if(  sscanf(aline.c_str(),"%d%*[\n]",&tmpid) ){
				idlist.push_back(tmpid);
				tmpid=0;
			} 
		}
	}  
	fin.close();

	trail_sidList = idlist;

	trail_cur_k=0;

	ctx.annosavePath = tctx.annoresSavePath;
	annosavePath = tctx.annoresSavePath;

	anno_force_rerun =tctx.batch_force_rerun;

	std::cout<<"Trail case # = "<<trail_sidList.size()<<std::endl;
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	// load SVM model 
	ini_svm(tctx);  
	//-------------------------------------------------------------------------
	ctx.imid=trail_sidList[trail_cur_k];

	loadCase_uDrawMode(ctx.imid); 

	return FCStateMag::S_DRAW_IDLE;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_draw_load_aCase()
{ 
	//-------------------------------------------------------------------------
	//-- timer start here 

	ctx.isReady=true;  

	ctx.timer.reset();
	ctx.timer.start();

	return FCStateMag::S_DRAW_OBJSEG;
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_draw_next()
{ 
	//-------------------------------------------------------------------------
	//-- timer start here 

	trail_cur_k = trail_cur_k +1;

	if( trail_cur_k<trail_sidList.size() ){
		resetCtx();

		ctx.imid=trail_sidList[trail_cur_k];

		loadCase_uDrawMode(ctx.imid);
		ctx.isReady=true;  

		return FCStateMag::S_DRAW_IDLE;
	}else{
		trail_cur_k=trail_cur_k-1;
		std::cout<<"reach end\n";
		return FCStateMag::S_DRAW_IDLE;
	}


}

Tirth::FCStateMag::State Tirth::FCGLPanel::_draw_previous()
{ 
	//-------------------------------------------------------------------------
	//-- timer start here 

	trail_cur_k = trail_cur_k - 1;

	if( trail_cur_k >=0  ){
		resetCtx();

		ctx.imid=trail_sidList[trail_cur_k];

		loadCase_uDrawMode(ctx.imid);
		ctx.isReady=true;  

		return FCStateMag::S_DRAW_IDLE;
	}else{
		trail_cur_k=0;
		std::cout<<"reach begin\n";
		return FCStateMag::S_DRAW_IDLE;
	}
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_drawobj_addObjPressed()
{
	// OBJECT - done 
	// increase next object id
	ctx.segDrawCtx.objID =ctx.segDrawCtx.objID+1;
	ctx.segDrawCtx.objectCount=ctx.segDrawCtx.objectCount+1;
	ctx.segDrawCtx.pressed = 0;
	ctx.segDrawCtx.strokePts.clear();
	std::cout<<"object created\n"<<"object ID ="<<ctx.segDrawCtx.objID<<"\n";

	return FCStateMag::S_DRAW_OBJSEG; 
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_drawobj_mousePressed()
{

	if( ctx.lastBtu == Qt::RightButton &&  use_eraser== false ){
		ctx.segDrawCtx.pressed = 1;
		use_eraser=1;

	}else if(ctx.lastBtu == Qt::LeftButton){

		// enter drawing state
		ctx.segDrawCtx.pressed = 1;

		// ERASE** using checkbox to implement

	}else{

	}


	return FCStateMag::S_DRAW_OBJSEG; 
}

Tirth::FCStateMag::State Tirth::FCGLPanel::_drawobj_mouseReleased()
{ 
	// clear up 

	if( ctx.lastBtu == Qt::RightButton  ){


		ctx.segDrawCtx.pressed = 0;
		use_eraser=0;
		ctx.segDrawCtx.strokePts.clear();

	}else if(ctx.lastBtu == Qt::LeftButton){


		ctx.segDrawCtx.pressed = 0;
		ctx.segDrawCtx.strokePts.clear();

	}else{

		ctx.segDrawCtx.strokePts.clear();
	} 

	return FCStateMag::S_DRAW_OBJSEG;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_drawobj_keyPressed()
{
	return FCStateMag::S_DRAW_OBJSEG;

}

Tirth::FCStateMag::State Tirth::FCGLPanel::_drawobj_actionDone()
{
	// save id map as ..
	ctx.gtsegCvMat_16u = ctx.segDraw_idmap.clone();
	// re-map this to QIMG
	ctx.gtsegCoutourImg.detach();
	ctx.gtsegCoutourImg=QImage((uchar*) ctx.gtsegCvMat_16u.data,
		ctx.gtsegCvMat_16u.cols, ctx.gtsegCvMat_16u.rows, ctx.gtsegCvMat_16u.step, QImage::Format_RGBA8888);


	char fname[1024]={0};
	sprintf(fname,"userseg_%d.png",ctx.imid);
	cv::imwrite(fname,ctx.gtsegCvMat_16u);

	std::cout<<"save - out\n";
	std::cout<<"start parsing..\n";

	ctx.timer.done();

	double scrible_time = ctx.timer.getTotalSecond();

	//-------------------------------------------------------------------------
	// start calculate plane fitting , room , and box
	ctx.timer.reset();
	ctx.timer.start();

	ini_afterObjseg();

	ctx.timer.done(); 

	double pre_process_time = ctx.timer.getTotalSecond(); 

	std::cout<<"done\n";

	//-------------------------------------------------------------------------
	// update support state
	update_sceneSupState();

	re_estiBoxFeatures();

	//-------------------------------------------------------------------------

	std::cout<<"[sce_id] "<<ctx.imid<<" [draw_time] "<<scrible_time<<" [pre_process_time] "<<pre_process_time<<"\n";

	std::fstream fout;
	fout.open("timing_log.txt",std::fstream::app);
	if (fout.bad())
	{
		//re-open 
		std::cout<<"open a new file\n";
		fout.open("timing_log.txt",std::fstream::out); 
	}

	fout<<"[sce_id] "<<ctx.imid<<" [draw_time] "<<scrible_time<<" [pre_process_time] "<<pre_process_time<<std::endl;


	//-------------------------------------------------------------------------
	return FCStateMag::S_AFTDRAW_IDLE;

}
 
//-------------------------------------------------------------------------

void Tirth::FCGLPanel::forceReRunTCF()
{
	resetCtx();   

	// load model
	//TextCTX tctx=loadUIConf("..\\testData\\uiconf.txt");

	// load case image
	ctx.imid = tctx.imid;
	ctx.annosavePath = tctx.annoresSavePath;

	loadCase(ctx.imid , tctx.use_auto_seg );	

	//-------------------------------------------------------------------------
	std::cout<<"calculate scene state.\n" ;

	updateBoxPoly2D();
	updateBox2DSeg();
	updateBoxPlanes();
	update_sceneSupState();
	re_estiBoxFeatures();

	ctx.all_svmProxy.loadModel(tctx.all_modelPath.c_str(),loader.getLidList());
	ctx.wall_svmProxy.loadModel(tctx.wall_modelPath.c_str(),loader.getLidList());
	ctx.floor_svmProxy.loadModel(tctx.floor_modelPath.c_str(),loader.getLidList());
	ctx.obj_svmProxy.loadModel(tctx.obj_modelPath.c_str(),loader.getLidList());

	ctx.freModel.loadModel(tctx.freqModelPath,tctx.targetLIDList);

	//-------------------------------------------------------------------------
	ctx.isReady=true;

}

void Tirth::FCGLPanel::conv_CTX_to_NaiveSCTX(NaiveSceneCTX & scectx){

	copyMatrix_CLM( ctx.tx_fr2world , scectx.tx_fr2world ,ctx.tx_fr2world.size());
	copyMatrix_CLM( ctx.tx_world2fr , scectx.tx_world2fr ,ctx.tx_fr2world.size() ); 
}

void Tirth::FCGLPanel::conv_NaiveSCTX_to_CTX(NaiveSceneCTX & SCTX)
{ 
	convCLM2EMat(SCTX.tx_world2fr,ctx.tx_world2fr,4,4);

	convCLM2EMat(SCTX.tx_fr2world,ctx.tx_fr2world,4,4);

	Eigen::Vector4f c0(0,0,0,1);

	ctx.cam_fr =  (ctx.tx_world2fr*c0).hnormalized();
}

#pragma endregion EVENT_HANDLER

//-------------------------------------------------------------------------

void Tirth::FCGLPanel::paintBox( bool enable )
{
	showBox=enable;
}

//-------------------------------------------------------------------------
void  Tirth::FCGLPanel::useEraser(bool enable){

	use_eraser=enable;
}
void Tirth::FCGLPanel::enableSuggest( bool enable )
{
	showSuggestion=enable;
	requireUpdateContourTex=1;
}

void Tirth::FCGLPanel::paintSeg( bool enable )
{

}

void Tirth::FCGLPanel::paintBK( bool enable )
{
	showBK=enable;

}

void Tirth::FCGLPanel::setBoxManiMode(QString modeStr)
{

	if (modeStr=="VEX_Y"){

		ctx.bxmiCtx.maniMode=BxmiCtx::M_VEX_Y;

	}else if(modeStr == "VEX_XZ"){
		ctx.bxmiCtx.maniMode=BxmiCtx::M_VEX_XZ;

	}else if(modeStr == "ROT_Y"){
		ctx.bxmiCtx.maniMode=BxmiCtx::M_ROT_Y;

	}else{
		std::cout<<"*ERR: BOX_TOOL-MODESTR :"<<modeStr.toStdString()<<std::endl;

	}
}


QString Tirth::FCGLPanel::getDisplayInfo()
{
	static char buf[2048];

	memset(buf,0,sizeof(buf));

	int pos=0;
	pos+=sprintf(buf+pos,"STATE = [%s]\n\n",FCMODESTRS[ctx.currentState]);

	pos+=sprintf(buf+pos,"No.%d(/%d)\n",trail_cur_k,trail_sidList.size()); 
	pos+=sprintf(buf+pos,"Image ID = %d\n",ctx.imid); 
	pos+=sprintf(buf+pos,"Box # = %d\n\n",ctx.boxDatas.size());

	return QString::fromStdString(std::string(buf)); 
}

QString Tirth::FCGLPanel::getAnnoInfo()
{
	static char buf[2048];

	memset(buf,0,sizeof(buf));

	int pos=0;
	if( ctx.currentState==FCStateMag::S_PREDICT || ctx.currentState==FCStateMag::S_PRE_MENU_FOLD || ctx.currentState==FCStateMag::S_FINAL ){

		// check unk
		int fix_num = 0;
		for( int ib=0 ; ib<ctx.boxDatas.size() ; ib++ ){
			if( ctx.boxDatas[ib].getUserModified() ){
				fix_num = fix_num+1;
			}
		} 
		pos+=sprintf(buf+pos,"Progress = %d / %d \n\n", fix_num ,ctx.boxDatas.size());
		pos+=sprintf(buf+pos,"Remaining # = %d \n", ctx.boxDatas.size()-fix_num);

	}else if(ctx.currentState==FCStateMag::S_BOX_SEL || ctx.currentState==FCStateMag::S_BOXMANI || ctx.currentState==FCStateMag::S_SUP_ASSIG
		|| ctx.currentState==FCStateMag::S_SUP_EDITIDLE	){

			pos+=sprintf(buf+pos,"LEFT click to select box\n");
			pos+=sprintf(buf+pos,"RIGHT click to save alteration\n");

	}else if(ctx.currentState == FCStateMag::S_PRE_INI){

		pos+=sprintf(buf+pos,"Pls drop config file to load\n");

	}else if(ctx.currentState == FCStateMag::S_INI){

		pos+=sprintf(buf+pos,"Press initial button to initial\n");

	}else if(ctx.currentState == FCStateMag::S_IDLE){

		pos+=sprintf(buf+pos,"Press start button to begin\n");

	}else{

		pos+=sprintf(buf+pos,"\n");
	}

	return QString::fromStdString(std::string(buf)); 
}

void Tirth::FCGLPanel::setSupMode_showBox( bool enable )
{

	ctx.supVis_showBox=enable;
}


//-------------------------------------------------------------------------
